SystemOrganization addCategory: #HTML!
SystemOrganization addCategory: #'HTML-CSS'!
SystemOrganization addCategory: #'HTML-CSS-Errors'!
SystemOrganization addCategory: #'HTML-DOM'!
SystemOrganization addCategory: #'HTML-DOM-Errors'!
SystemOrganization addCategory: #'HTML-PList'!
SystemOrganization addCategory: #'HTML-Validator'!

!String methodsFor: '*html' stamp: 'tb 1/17/2008 14:57'!
content

	^self! !

!String methodsFor: '*html' stamp: 'tb 1/17/2008 14:21'!
splitOn: aString

	| idx lastIdx |
	idx := lastIdx := 1.

	^Array streamContents: 
	[:s |
		[idx <= self size] whileTrue:
		[
			idx := self findString: aString startingAt: lastIdx.
			idx = 0 ifTrue: [idx := self size + 1].
			s nextPut: (self copyFrom: lastIdx to: idx-1).
			lastIdx := idx + aString size.
		]
	]
! !

!String methodsFor: '*html' stamp: 'tb 11/28/2005 18:14'!
unquoted

	^self withoutQuoting! !

!SequenceableCollection methodsFor: '*html' stamp: 'tb 9/14/2006 20:37'!
joinOn: aString

	^ String streamContents:
		[:s |
		self do: [:ea | s nextPutAll: ea asString] separatedBy: [s nextPutAll: aString]]
! !

!HttpUrl methodsFor: '*html' stamp: 'tb 1/9/2006 15:02'!
retrieveContentsArgs: args
	^self retrieveContentsArgs: args accept: (MIMEDocument guessTypeFromName: self)! !

Object subclass: #CSSPropertyDefinition
	instanceVariableNames: 'appliesTo propertyName initialValue media percentages valueString valueType'
	classVariableNames: 'Definitions'
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSPropertyDefinition class methodsFor: 'as yet unclassified' stamp: 'tb 1/18/2006 20:21'!
initialData

	^'( { 
   initialValue = "depends on user agent and writing direction" ; 
   media = ( visual); 
   appliesTo = "block-level elements" ; 
   valueString = "left | right | center | justify |  <string>  |  inherit" ; 
   percentages = no; 
   propertyName = text-align; 
}, { 
 initialValue = none; 
 media = ( visual); 
 appliesTo = "block-level elements" ; 
 valueString = "none | left | right | both |  inherit" ; 
 percentages = no; 
 propertyName = clear; 
}, { 
 initialValue = XX; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<padding-width> {1,4} |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = padding; 
}, { 
 initialValue = auto; 
 media = ( visual); 
 appliesTo = "\''table\''  and \''inline-table\'' elements" ; 
 valueString = "auto | fixed |  inherit" ; 
 percentages = no; 
 propertyName = table-layout; 
}, { 
 initialValue = "depends on user agent" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<color>  |  inherit" ; 
 percentages = no; 
 propertyName = color; 
}, 
{ 
 initialValue = auto; 
 media = ( visual); 
 appliesTo = "block-level and replaced elements" ; 
 valueString = "<shape>  | auto |  inherit" ; 
 percentages = no; 
 propertyName = clip; 
}, { 
 initialValue = normal; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "normal | small-caps |  inherit" ; 
 percentages = no; 
 propertyName = font-variant; 
}, { 
 initialValue = "see individual properties" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "[  \''border-top-width\''  ||  \''border-style\''  ||  <color>  ] |  inherit" ; 
 percentages = no; 
 propertyName = border-top; 
}, { 
 initialValue = 2; 
 media = ( visual, paged); 
 appliesTo = "block-level elements" ; 
 valueString = "<integer>  |  inherit" ; 
 percentages = no; 
 propertyName = widows; 
}, { 
 initialValue = XX; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "[ \''background-color\''  ||  \''background-image\''  ||  \''background-repeat\''  ||  \''background-attachment\''  ||  \''background-position\'' ] |  inherit" ; 
 percentages = "allowed on \''background-position\''" ; 
 propertyName = background; 
}, 
{ 
 initialValue = none; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<border-style>  |  inherit" ; 
 percentages = no; 
 propertyName = border-top-style; 
}, { 
 initialValue = ltr; 
 media = ( visual); 
 appliesTo = "all elements, but see prose" ; 
 valueString = "ltr | rtl |  inherit" ; 
 percentages = no; 
 propertyName = direction; 
}, { 
 initialValue = medium; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<absolute-size>  |  <relative-size>  |  <length>  |  <percentage>  |  inherit" ; 
 percentages = "refer to parent element\''s font size" ; 
 propertyName = font-size; 
}, { 
 initialValue = "see individual properties" ; 
 media = ( visual, interactive); 
 appliesTo = all; 
 valueString = "[  \''outline-color\''  ||  \''outline-style\''  ||  \''outline-width\''  ] |  inherit" ; 
 percentages = no; 
 propertyName = outline; 
}, { 
 initialValue = auto; 
 media = ( visual); 
 appliesTo = "all elements but non-replaced inline elements, table rows, and row groups" ; 
 valueString = "<length>  |  <percentage>  | auto |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = width; 
}, 
{ 
 initialValue = "see individual properties" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<color> {1,4} | transparent |  inherit" ; 
 percentages = no; 
 propertyName = border-color; 
}, { 
 initialValue = "see individual properties" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<border-width> {1,4} |  inherit" ; 
 percentages = no; 
 propertyName = border-width; 
}, { 
 initialValue = normal; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "normal | bold | bolder | lighter | 100 | 200 | 300 | 400 | 500 | 600 | 700 | 800 | 900 |  inherit" ; 
 percentages = no; 
 propertyName = font-weight; 
}, { 
 initialValue = normal; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "normal |  <number>  |  <length>  |  <percentage>  |  inherit" ; 
 percentages = "refer to the font size of the element itself" ; 
 propertyName = line-height; 
}, { 
 initialValue = 0; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<margin-width>  |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = margin-top; 
}, 
{ 
 initialValue = outside; 
 media = ( visual); 
 appliesTo = "elements with \''display: list-item\''" ; 
 valueString = "inside | outside |  inherit" ; 
 percentages = no; 
 propertyName = list-style-position; 
}, { 
 initialValue = normal; 
 media = ( visual); 
 appliesTo = "block-level elements" ; 
 valueString = "normal | pre | nowrap |  inherit" ; 
 percentages = no; 
 propertyName = white-space; 
}, { 
 initialValue = 0; 
 media = ( visual); 
 appliesTo = "all elements except non-replaced inline elements and table elements" ; 
 valueString = "<length>  |  <percentage>  |  inherit" ; 
 percentages = "refer to height of containing block" ; 
 propertyName = min-height; 
}, { 
 initialValue = "the value of the \''color\'' property" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<color>  |  inherit" ; 
 percentages = no; 
 propertyName = border-bottom-color; 
}, { 
 initialValue = medium; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<border-width>  |  inherit" ; 
 percentages = no; 
 propertyName = border-bottom-width; 
}, 
{ 
 initialValue = auto; 
 media = ( visual, interactive); 
 appliesTo = all; 
 valueString = "[ [ <uri>  ,]* [ auto | crosshair | default | pointer | move | e-resize | ne-resize | nw-resize | n-resize | se-resize | sw-resize | s-resize | w-resize| text | wait | help ] ] |  inherit" ; 
 percentages = no; 
 propertyName = cursor; 
}, { 
 initialValue = auto; 
 media = ( visual, paged); 
 appliesTo = "block-level elements" ; 
 valueString = "<identifier>  | auto" ; 
 percentages = no; 
 propertyName = page; 
}, { 
 initialValue = disc; 
 media = ( visual); 
 appliesTo = "elements with \''display: list-item\''" ; 
 valueString = "disc | circle | square | decimal | decimal-leading-zero |   lower-roman | upper-roman | lower-greek |  lower-alpha | lower-latin | upper-alpha | upper-latin |   hebrew | armenian | georgian |   cjk-ideographic | hiragana | katakana | hiragana-iroha | katakana-iroha |  none |  inherit" ; 
 percentages = no; 
 propertyName = list-style-type; 
}, { 
 initialValue = inline; 
 media = ( all); 
 appliesTo = all; 
 valueString = "inline | block | list-item | run-in | compact | marker | table | inline-table | table-row-group | table-header-group | table-footer-group | table-row | table-column-group | table-column | table-cell | table-caption | none |  inherit" ; 
 percentages = no; 
 propertyName = display; 
}, { 
 initialValue = auto; 
 media = ( visual, paged); 
 appliesTo = "block-level elements" ; 
 valueString = "auto | always | avoid | left | right |  inherit" ; 
 percentages = no; 
 propertyName = page-break-after; 
}, 
{ 
 initialValue = 0; 
 media = ( visual); 
 appliesTo = "\''table\'' and \''inline-table\'' elements" ; 
 valueString = "[<length> <length>?] |  inherit" ; 
 percentages = no; 
 propertyName = border-spacing; 
}, { 
 initialValue = "see individual properties" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<border-style> {1,4} |  inherit" ; 
 percentages = no; 
 propertyName = border-style; 
}, { 
 initialValue = none; 
 media = ( all); 
 appliesTo = all; 
 valueString = "[  <identifier> <integer> ? ]+ | none |  inherit" ; 
 percentages = no; 
 propertyName = counter-increment; 
}, { 
 initialValue = auto; 
 media = ( visual, paged); 
 appliesTo = "block-level elements" ; 
 valueString = "auto | always | avoid | left | right |  inherit" ; 
 percentages = no; 
 propertyName = page-break-before; 
}, { 
 initialValue = auto; 
 media = ( visual); 
 appliesTo = "positioned elements" ; 
 valueString = "<length>  |  <percentage>  | auto |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = right; 
}, 
{ 
 initialValue = "the value of the \''color\'' property" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<color>  |  inherit" ; 
 percentages = no; 
 propertyName = border-right-color; 
}, { 
 initialValue = medium; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<border-width>  |  inherit" ; 
 percentages = no; 
 propertyName = border-right-width; 
}, { 
 initialValue = show; 
 media = ( visual); 
 appliesTo = "\''table-cell\'' elements" ; 
 valueString = "show | hide |  inherit" ; 
 percentages = no; 
 propertyName = empty-cells; 
}, { 
 initialValue = none; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "<uri>  | none |  inherit" ; 
 percentages = no; 
 propertyName = cue-after; 
}, { 
 initialValue = none; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "code | none |  inherit" ; 
 percentages = no; 
 propertyName = speak-punctuation; 
}, 
{ 
 initialValue = XX; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<margin-width> {1,4} |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = margin; 
}, { 
 initialValue = none; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<number>  | none |  inherit" ; 
 percentages = no; 
 propertyName = font-size-adjust; 
}, { 
 initialValue = baseline; 
 media = ( visual); 
 appliesTo = "inline-level and \''table-cell\'' elements" ; 
 valueString = "baseline | sub | super | top | text-top | middle |     bottom | text-bottom |  <percentage>  |  <length>  |  inherit" ; 
 percentages = "refer to the \''line-height\'' of the element itself" ; 
 propertyName = vertical-align; 
}, { 
 initialValue = "see individual properties" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "[  \''border-top-width\''  ||  \''border-style\''  ||  <color>  ] |  inherit" ; 
 percentages = no; 
 propertyName = border-right; 
}, { 
 initialValue = 50; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "<number>  |  inherit" ; 
 percentages = no; 
 propertyName = pitch-range; 
}, 
{ 
 initialValue = inherit; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "visible | hidden | collapse |  inherit" ; 
 percentages = no; 
 propertyName = visibility; 
}, { 
 initialValue = medium; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "<number>  |  <percentage>  | silent | x-soft | soft | medium | loud | x-loud |  inherit" ; 
 percentages = "refer to inherited value" ; 
 propertyName = volume; 
}, { 
 initialValue = normal; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "normal | italic | oblique |  inherit" ; 
 percentages = no; 
 propertyName = font-style; 
}, { 
 initialValue = "depends on user agent" ; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "<time>  |  <percentage>  |  inherit" ; 
 percentages = "see prose" ; 
 propertyName = pause-after; 
}, { 
 initialValue = normal; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "normal |  <length>  |  inherit" ; 
 percentages = no; 
 propertyName = word-spacing; 
}, 
{ 
 initialValue = 0; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<margin-width>  |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = margin-bottom; 
}, { 
 initialValue = "the value of the \''color\'' property" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<color>  |  inherit" ; 
 percentages = no; 
 propertyName = border-top-color; 
}, { 
 initialValue = none; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<border-style>  |  inherit" ; 
 percentages = no; 
 propertyName = border-right-style; 
}, { 
 initialValue = "see individual properties" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "[  \''border-top-width\''  ||  \''border-style\''  ||  <color>  ] |  inherit" ; 
 percentages = no; 
 propertyName = border-bottom; 
}, { 
 initialValue = medium; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<border-width>  |  inherit" ; 
 percentages = no; 
 propertyName = border-top-width; 
}, 
{ 
 initialValue = none; 
 media = ( visual); 
 appliesTo = "all elements except non-replaced inline elements and table elements" ; 
 valueString = "<length>  |  <percentage>  | none |  inherit" ; 
 percentages = "refer to height of containing block" ; 
 propertyName = max-height; 
}, { 
 initialValue = 0; 
 media = ( visual); 
 appliesTo = "block-level elements" ; 
 valueString = "<length>  |  <percentage>  |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = text-indent; 
}, { 
 initialValue = normal; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "normal | wider | narrower | ultra-condensed | extra-condensed | condensed | semi-condensed  | semi-expanded | expanded | extra-expanded |     ultra-expanded |  inherit" ; 
 percentages = no; 
 propertyName = font-stretch; 
}, { 
 initialValue = XX; 
 media = ( visual); 
 appliesTo = "elements with \''display: list-item\''" ; 
 valueString = "[  \''list-style-type\''  ||  \''list-style-position\''  ||  \''list-style-image\''  ] |  inherit" ; 
 percentages = no; 
 propertyName = list-style; 
}, { 
 initialValue = auto; 
 media = ( visual, paged); 
 appliesTo = "the page context" ; 
 valueString = "<length> {1,2} | auto | portrait | landscape |  inherit" ; 
 percentages = no; 
 propertyName = size; 
}, 
{ 
 initialValue = 0; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<padding-width>  |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = padding-right; 
}, { 
 initialValue = normal; 
 media = ( visual); 
 appliesTo = "all elements, but see prose" ; 
 valueString = "normal | embed | bidi-override |  inherit" ; 
 percentages = no; 
 propertyName = unicode-bidi; 
}, { 
 initialValue = "the value of the \''color\'' property" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<color>  |  inherit" ; 
 percentages = no; 
 propertyName = border-left-color; 
}, { 
 initialValue = medium; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<border-width>  |  inherit" ; 
 percentages = no; 
 propertyName = border-left-width; 
}, { 
 initialValue = auto; 
 media = ( visual); 
 appliesTo = "all elements but non-replaced inline elements, table columns, and column groups" ; 
 valueString = "<length>  |  <percentage>  | auto |  inherit" ; 
 percentages = "see prose" ; 
 propertyName = height; 
}, 
{ 
 initialValue = center; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "<angle>  | [[ left-side | far-left | left | center-left | center | center-right | right | far-right | right-side ] || behind ] | leftwards | rightwards |  inherit" ; 
 percentages = no; 
 propertyName = azimuth; 
}, { 
 initialValue = collapse; 
 media = ( visual); 
 appliesTo = "\''table\'' and \''inline-table\'' elements" ; 
 valueString = "collapse | separate |  inherit" ; 
 percentages = no; 
 propertyName = border-collapse; 
}, { 
 initialValue = medium; 
 media = ( visual, interactive); 
 appliesTo = all; 
 valueString = "<border-width>  |  inherit" ; 
 percentages = no; 
 propertyName = outline-width; 
}, { 
 initialValue = medium; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "<frequency>  | x-low | low | medium | high | x-high |  inherit" ; 
 percentages = no; 
 propertyName = pitch; 
}, { 
 initialValue = static; 
 media = ( visual); 
 appliesTo = "all elements, but not to generated content" ; 
 valueString = "static | relative | absolute | fixed |  inherit" ; 
 percentages = no; 
 propertyName = position; 
}, 
{ 
 initialValue = none; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "none | [ <color>  || [ <length>{2,3} ,]]* [ <color>  ||  <length>{2,3}] |  inherit" ; 
 percentages = no; 
 propertyName = text-shadow; 
}, { 
 initialValue = none; 
 media = ( all); 
 appliesTo = all; 
 valueString = "[  <identifier> <integer> ? ]+ | none |  inherit" ; 
 percentages = no; 
 propertyName = counter-reset; 
}, { 
 initialValue = 0; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<margin-width>  |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = margin-right; 
}, { 
 initialValue = "depends on user agent" ; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "<time>  |  <percentage>  |  inherit" ; 
 percentages = "see prose" ; 
 propertyName = pause-before; 
}, { 
 initialValue = none; 
 media = ( visual); 
 appliesTo = "all elements except non-replaced inline elements and table  elements" ; 
 valueString = "<length>  |  <percentage>  | none |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = max-width; 
}, 
{ 
 initialValue = none; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<border-style>  |  inherit" ; 
 percentages = no; 
 propertyName = border-left-style; 
}, { 
 initialValue = scroll; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "scroll | fixed |  inherit" ; 
 percentages = no; 
 propertyName = background-attachment; 
}, { 
 initialValue = none; 
 media = ( visual, interactive); 
 appliesTo = all; 
 valueString = "<border-style>  |  inherit" ; 
 percentages = no; 
 propertyName = outline-style; 
}, { 
 initialValue = top; 
 media = ( visual); 
 appliesTo = "\''table-caption\'' elements" ; 
 valueString = "top | bottom | left | right |  inherit" ; 
 percentages = no; 
 propertyName = caption-side; 
}, { 
 initialValue = "depends on user agent" ; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "[[ <specific-voice>   |  <generic-voice>  ],]* [ <specific-voice>   |  <generic-voice>  ] |  inherit" ; 
 percentages = no; 
 propertyName = voice-family; 
}, 
{ 
 initialValue = auto; 
 media = ( visual); 
 appliesTo = "positioned elements" ; 
 valueString = "<length>  |  <percentage>  | auto |  inherit" ; 
 percentages = "refer to height of containing block" ; 
 propertyName = bottom; 
}, { 
 initialValue = normal; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "normal |  <length>  |  inherit" ; 
 percentages = no; 
 propertyName = letter-spacing; 
}, { 
 initialValue = "see individual properties" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "[ [  \''font-style\''  ||  \''font-variant\''  ||  \''font-weight\''  ]?  \''font-size\''  [ /  \''line-height\''  ]?  \''font-family\''  ] | caption | icon | menu | message-box | small-caption | status-bar |  inherit" ; 
 percentages = "allowed on \''font-size\'' and \''line-height\''" ; 
 propertyName = font; 
}, { 
 initialValue = 0; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<padding-width>  |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = padding-top; 
}, { 
 initialValue = 0; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<padding-width>  |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = padding-left; 
}, 
{ 
 initialValue = "see individual properties" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "[  \''border-top-width\''  ||  \''border-style\''  ||  <color>  ] |  inherit" ; 
 percentages = no; 
 propertyName = border-left; 
}, { 
 initialValue = 0; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<padding-width>  |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = padding-bottom; 
}, { 
 initialValue = none; 
 media = ( visual); 
 appliesTo = "all but positioned elements and generated content" ; 
 valueString = "left | right | none |  inherit" ; 
 percentages = no; 
 propertyName = float; 
}, { 
 initialValue = "empty string" ; 
 media = ( all); 
 appliesTo = ":before and :after pseudo-elements" ; 
 valueString = "[  <string>  |  <uri>  |  <counter>  | <attr-x> | open-quote | close-quote | no-open-quote | no-close-quote ]+ |  inherit" ; 
 percentages = no; 
 propertyName = content; 
}, { 
 initialValue = auto; 
 media = ( visual); 
 appliesTo = "positioned elements" ; 
 valueString = "<length>  |  <percentage>  | auto |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = left; 
}, 
{ 
 initialValue = once; 
 media = ( aural); 
 appliesTo = "elements that have table header information" ; 
 valueString = "once | always |  inherit" ; 
 percentages = no; 
 propertyName = speak-header; 
}, { 
 initialValue = auto; 
 media = ( visual); 
 appliesTo = "elements with \''display: marker\''" ; 
 valueString = "<length>  | auto |  inherit" ; 
 percentages = no; 
 propertyName = marker-offset; 
}, { 
 initialValue = level; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "<angle>   | below | level | above | higher | lower |  inherit" ; 
 percentages = no; 
 propertyName = elevation; 
}, { 
 initialValue = "depends on user agent" ; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "[ [ <time>  |  <percentage> ]{1,2} ] |  inherit" ; 
 percentages = "see descriptions of \''pause-before\'' and \''pause-after\''" ; 
 propertyName = pause; 
}, { 
 initialValue = auto; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "<uri>  mix? repeat? | auto | none |  inherit" ; 
 percentages = no; 
 propertyName = play-during; 
}, 
{ 
 initialValue = continuous; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "digits | continuous |  inherit" ; 
 percentages = no; 
 propertyName = speak-numeral; 
}, { 
 initialValue = none; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "none | [ underline || overline || line-through || blink ] |  inherit" ; 
 percentages = no; 
 propertyName = text-decoration; 
}, { 
 initialValue = invert; 
 media = ( visual, interactive); 
 appliesTo = all; 
 valueString = "<color>  | invert |  inherit" ; 
 percentages = no; 
 propertyName = outline-color; 
}, { 
 initialValue = "depends on user agent" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "[ <string> <string> ]+ | none |  inherit" ; 
 percentages = no; 
 propertyName = quotes; 
}, { 
 initialValue = repeat; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "repeat-x | repeat-y | no-repeat | repeat |  inherit" ; 
 percentages = no; 
 propertyName = background-repeat; 
}, 
{ 
 initialValue = "0% 0%" ; 
 media = ( visual); 
 appliesTo = "block-level and replaced elements" ; 
 valueString = "[ [ <percentage>  |  <length>  ]{1,2} |  [ [top | center | bottom] || [left | center | right] ] ] |  inherit" ; 
 percentages = "refer to the size of the box itself" ; 
 propertyName = background-position; 
}, { 
 initialValue = 0; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<margin-width>  |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = margin-left; 
}, { 
 initialValue = auto; 
 media = ( visual, paged); 
 appliesTo = "block-level elements" ; 
 valueString = "avoid | auto |  inherit" ; 
 percentages = no; 
 propertyName = page-break-inside; 
}, { 
 initialValue = 50; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "<number>  |  inherit" ; 
 percentages = no; 
 propertyName = stress; 
}, { 
 initialValue = auto; 
 media = ( visual); 
 appliesTo = "positioned elements" ; 
 valueString = "auto |  <integer>  |  inherit" ; 
 percentages = no; 
 propertyName = z-index; 
}, 
{ 
 initialValue = none; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<uri>  | none |  inherit" ; 
 percentages = no; 
 propertyName = background-image; 
}, { 
 initialValue = visible; 
 media = ( visual); 
 appliesTo = "block-level and replaced elements" ; 
 valueString = "visible | hidden | scroll | auto |  inherit" ; 
 percentages = no; 
 propertyName = overflow; 
}, { 
 initialValue = "see individual properties" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "[  \''border-width\''  ||  \''border-style\''  ||  <color>  ] |  inherit" ; 
 percentages = no; 
 propertyName = border; 
}, { 
 initialValue = none; 
 media = ( visual, paged); 
 appliesTo = "page context" ; 
 valueString = "[ crop || cross ] | none |  inherit" ; 
 percentages = no; 
 propertyName = marks; 
}, { 
 initialValue = none; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "capitalize | uppercase | lowercase | none |  inherit" ; 
 percentages = no; 
 propertyName = text-transform; 
}, 
{ 
 initialValue = none; 
 media = ( visual); 
 appliesTo = "elements with \''display: list-item\''" ; 
 valueString = "<uri>  | none |  inherit" ; 
 percentages = no; 
 propertyName = list-style-image; 
}, { 
 initialValue = none; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "<uri>  | none |  inherit" ; 
 percentages = no; 
 propertyName = cue-before; 
}, { 
 initialValue = "depends on user agent" ; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "[[  <family-name>   |  <generic-family>  ],]* [ <family-name>   |  <generic-family> ] |  inherit" ; 
 percentages = no; 
 propertyName = font-family; 
}, { 
 initialValue = transparent; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<color>  | transparent |  inherit" ; 
 percentages = no; 
 propertyName = background-color; 
}, { 
 initialValue = medium; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "<number>   | x-slow | slow | medium | fast | x-fast | faster | slower |  inherit" ; 
 percentages = no; 
 propertyName = speech-rate; 
}, 
{ 
 initialValue = none; 
 media = ( visual); 
 appliesTo = all; 
 valueString = "<border-style>  |  inherit" ; 
 percentages = no; 
 propertyName = border-bottom-style; 
}, { 
 initialValue = 50; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "<number>  |  inherit" ; 
 percentages = no; 
 propertyName = richness; 
}, { 
 initialValue = "UA dependent" ; 
 media = ( visual); 
 appliesTo = "all elements except non-replaced inline elements and table elements" ; 
 valueString = "<length>  |  <percentage>  |  inherit" ; 
 percentages = "refer to width of containing block" ; 
 propertyName = min-width; 
}, { 
 initialValue = auto; 
 media = ( visual); 
 appliesTo = "positioned elements" ; 
 valueString = "<length>  |  <percentage>  | auto |  inherit" ; 
 percentages = "refer to height of containing block" ; 
 propertyName = top; 
}, { 
 initialValue = XX; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "[  \''cue-before\''  ||  \''cue-after\''  ] |  inherit" ; 
 percentages = no; 
 propertyName = cue; 
}, 
{ 
 initialValue = 2; 
 media = ( visual, paged); 
 appliesTo = "block-level elements" ; 
 valueString = "<integer>  |  inherit" ; 
 percentages = no; 
 propertyName = orphans; 
}, { 
 initialValue = normal; 
 media = ( aural); 
 appliesTo = all; 
 valueString = "normal | none | spell-out |  inherit" ; 
 percentages = no; 
 propertyName = speak; 
})'! !

!CSSPropertyDefinition class methodsFor: 'as yet unclassified' stamp: 'tb 8/1/2006 17:58'!
initialize 

	| list dict |
	"CSSPropertyDefinition initialize"
	"Definitions notNil ifTrue: [^self]."
	
	HtmlPListSerializer initialize. "Solves order of initialization dependency"
	list := (HtmlPListSerializer on: (ReadStream on: self initialData)) next.
	dict := Dictionary new.

	list do: 
	[:ea |
		| def |
		def := CSSPropertyDefinition new.
		ea keysDo: [:k | def perform: ((k,':') asSymbol) with: (ea at: k)].
		dict at: def propertyName put: def
	].	
	Definitions := dict.
	dict values do:[:ea | ea valueType]
	! !

!CSSPropertyDefinition class methodsFor: 'instance creation' stamp: 'tb 12/29/2005 16:35'!
named: aString

	^Definitions at: aString ifAbsent: [nil]! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'tb 12/29/2005 16:02'!
appliesTo
	"Answer the value of appliesTo"

	^ appliesTo! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:17'!
appliesTo: anObject
	"Set the value of appliesTo"

	appliesTo := anObject! !

!CSSPropertyDefinition methodsFor: 'printing' stamp: 'tb 12/29/2005 16:54'!
asPList

	| dict |
	dict := Dictionary new.

	#('appliesTo' 'propertyName' 'initialValue' 'media' 'percentages' 'valueString')
	do:[:ea | dict at: ea put: (self perform: (ea asSymbol))].

	^dict! !

!CSSPropertyDefinition methodsFor: 'printing' stamp: 'tb 12/29/2005 16:26'!
definitionString

	| out |
	out := WriteStream on: String new.
	self printDefinitionOn: out.
	^out contents.! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'tb 12/29/2005 16:02'!
initialValue
	"Answer the value of initialValue"

	^ initialValue! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:17'!
initialValue: anObject
	"Set the value of initialValue"

	initialValue := anObject! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'tb 12/29/2005 16:02'!
media
	"Answer the value of media"

	^ media! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:17'!
media: anObject
	"Set the value of media"

	media := anObject! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'tb 12/29/2005 16:02'!
percentages
	"Answer the value of percentages"

	^ percentages! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:17'!
percentages: anObject
	"Set the value of percentages"

	percentages := anObject! !

!CSSPropertyDefinition methodsFor: 'printing' stamp: 'tb 12/29/2005 16:28'!
printDefinitionOn: aStream

	aStream nextPutAll: 'CSSPropertyDefinition new appliesTo: '. appliesTo printOn: aStream.
	aStream nextPutAll: ';'; cr;
	nextPutAll: 'propertyName: '. propertyName printOn: aStream.
	aStream nextPutAll: ';'; cr;
	nextPutAll: 'initialValue: '. initialValue printOn: aStream.
	aStream nextPutAll: ';'; cr;
	nextPutAll: 'media: '. media printOn: aStream.
	aStream nextPutAll: ';'; cr;
	nextPutAll: 'percentages: '. percentages printOn: aStream.
	aStream nextPutAll: ';'; cr;
	nextPutAll: 'valueString: '. valueString printOn: aStream.
	aStream nextPutAll: '.'; cr; cr.! !

!CSSPropertyDefinition methodsFor: 'printing' stamp: 'tb 12/29/2005 16:12'!
printOn: aStream

	aStream nextPutAll: self propertyName; nextPutAll: ': '; nextPutAll: valueString; nextPutAll: '; '! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'tb 12/29/2005 16:02'!
propertyName
	"Answer the value of propertyName"

	^ propertyName! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:17'!
propertyName: anObject
	"Set the value of propertyName"

	propertyName := anObject! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'tb 12/29/2005 16:02'!
valueString
	"Answer the value of valueString"

	^ valueString! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:17'!
valueString: anObject
	"Set the value of valueString"

	valueString := anObject! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'tb 12/29/2005 16:32'!
valueType
	"Answer the value of valueType"

	valueType isNil ifTrue: [self valueType: (CSSValueType fromString: self valueString)].
	^valueType! !

!CSSPropertyDefinition methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:18'!
valueType: anObject
	"Set the value of valueType"

	valueType := anObject! !

Object subclass: #CSSRuleSet
	instanceVariableNames: 'idSelectors classSelectors tagSelectors otherSelectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSRuleSet commentStamp: '<historical>' prior: 0!
(1) The selector uses an ID. (Example: #foo)
(2) The selector doesn't have an ID but uses a class. (Example: .foo)
(3) The selector has no class or ID but specifies a tag name. (Example: div)
(4) The selector specifies none of these things. (Example: *[disabled])!

!CSSRuleSet methodsFor: 'accessing' stamp: 'tb 1/18/2006 23:55'!
candidateRulesForNode: aNode

	| id classes list |

	id := aNode id.
	list := OrderedCollection new.
	list addAll: otherSelectors.
	aNode id isNil ifFalse:
	[
		list addAll: (idSelectors at: id ifAbsent:[#()]).
	].
	classes := aNode classes.
	(classes isNil or: [classes isEmpty]) ifFalse:
	[
		classes do: [:ea | list addAll: (classSelectors at: ea ifAbsent: [#()])]. 
	].
	list addAll: (tagSelectors at: aNode tag asLowercase ifAbsent: [#()]).
	^list! !

!CSSRuleSet methodsFor: 'accessing' stamp: 'tb 1/3/2006 02:42'!
classSelectors
	"Answer the value of classSelectors"

	^ classSelectors! !

!CSSRuleSet methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:19'!
classSelectors: anObject
	"Set the value of classSelectors"

	classSelectors := anObject! !

!CSSRuleSet methodsFor: 'accessing' stamp: 'tb 1/3/2006 02:39'!
idSelectors
	"Answer the value of idSelectors"

	^ idSelectors! !

!CSSRuleSet methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:20'!
idSelectors: anObject
	"Set the value of idSelectors"

	idSelectors := anObject! !

!CSSRuleSet methodsFor: 'initialize-release' stamp: 'tb 1/3/2006 03:22'!
initialize

	super initialize.
	idSelectors := Dictionary new.
	classSelectors := Dictionary new.
	tagSelectors := Dictionary new.
	otherSelectors := OrderedCollection new.! !

!CSSRuleSet methodsFor: 'accessing' stamp: 'tb 1/3/2006 02:39'!
otherSelectors
	"Answer the value of otherSelectors"

	^ otherSelectors! !

!CSSRuleSet methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:20'!
otherSelectors: anObject
	"Set the value of otherSelectors"

	otherSelectors := anObject! !

!CSSRuleSet methodsFor: 'accessing' stamp: 'tb 1/3/2006 02:39'!
tagSelectors
	"Answer the value of tagSelectors"

	^ tagSelectors! !

!CSSRuleSet methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:20'!
tagSelectors: anObject
	"Set the value of tagSelectors"

	tagSelectors := anObject! !

Object subclass: #CSSSelector
	instanceVariableNames: 'isValid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSSelector subclass: #CSSAttributeSelector
	instanceVariableNames: 'attribute value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSAttributeSelector subclass: #CSSAttributeBeginsWithSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSAttributeBeginsWithSelector methodsFor: 'as yet unclassified' stamp: 'tb 12/21/2005 08:31'!
matches: aNode

	| attr |

	attr := self privateAttributeKeyInNode: aNode.

	^attr isNil 
		ifTrue: [false]
		ifFalse: 
		[
			((aNode attributes at: attr) findTokens: '-') 
				first = self value unquoted
		]! !

CSSAttributeSelector subclass: #CSSAttributeEqualsSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSAttributeEqualsSelector methodsFor: 'as yet unclassified' stamp: 'tb 12/21/2005 08:32'!
matches: aNode

	| attr |

	attr := self privateAttributeKeyInNode: aNode.

	^attr isNil 
		ifFalse: [(aNode attributes at: attr) unquoted = self value unquoted]
		ifTrue: [false]! !

!CSSAttributeEqualsSelector methodsFor: 'as yet unclassified' stamp: 'tb 7/12/2007 12:13'!
printOn: aStream

	aStream nextPut: $[;
	 nextPutAll: self attribute;
	 nextPut: $=;	
	 nextPut: $";
	 nextPutAll: self value;
	 nextPut: $";
	 nextPut: $]! !

CSSAttributeEqualsSelector subclass: #CSSIDSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSIDSelector class methodsFor: 'as yet unclassified' stamp: 'tb 12/21/2005 14:28'!
readFrom: in

	| out | 
	
	out := WriteStream on: String new.
	in peek = $# ifTrue: [in next].
	[in atEnd not and:[in peek isAlphaNumeric or:['-_' includes: in peek]]] 
		whileTrue: [out nextPut: in next].
	^self new value: out contents.! !

!CSSIDSelector methodsFor: 'as yet unclassified' stamp: 'tb 12/20/2005 21:23'!
initialize

	super initialize.
	self attribute: 'id'! !

!CSSIDSelector methodsFor: 'as yet unclassified' stamp: 'tb 1/3/2006 05:13'!
printOn:aStream

	aStream nextPut: $#.
	aStream nextPutAll: self value.! !

CSSAttributeSelector subclass: #CSSAttributeExistsSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSAttributeExistsSelector methodsFor: 'as yet unclassified' stamp: 'tb 12/21/2005 08:24'!
matches: aNode

	^(self privateAttributeKeyInNode: aNode) notNil! !

CSSAttributeSelector subclass: #CSSAttributeHasPrefixSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSAttributeHasPrefixSelector methodsFor: 'as yet unclassified' stamp: 'tb 1/14/2006 21:34'!
isCSS3

	^true! !

!CSSAttributeHasPrefixSelector methodsFor: 'as yet unclassified' stamp: 'tb 1/14/2006 21:03'!
matches: aNode

	| attr |

	attr := self privateAttributeKeyInNode: aNode.

	^attr isNil 
		ifTrue: [false]
		ifFalse: 
		[
			(aNode attributes at: attr) beginsWith: self value unquoted
		]! !

CSSAttributeSelector subclass: #CSSAttributeHasSubstringSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSAttributeHasSubstringSelector methodsFor: 'as yet unclassified' stamp: 'tb 1/14/2006 21:34'!
isCSS3

	^true! !

!CSSAttributeHasSubstringSelector methodsFor: 'as yet unclassified' stamp: 'tb 1/14/2006 21:05'!
matches: aNode

	| attr |

	attr := self privateAttributeKeyInNode: aNode.

	^attr isNil 
		ifTrue: [false]
		ifFalse: 
		[
			((aNode attributes at: attr) findString: self value unquoted) > 0
		]! !

CSSAttributeSelector subclass: #CSSAttributeHasSuffixSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSAttributeHasSuffixSelector methodsFor: 'as yet unclassified' stamp: 'tb 1/14/2006 21:33'!
isCSS3

	^true! !

!CSSAttributeHasSuffixSelector methodsFor: 'as yet unclassified' stamp: 'tb 1/14/2006 21:04'!
matches: aNode

	| attr |

	attr := self privateAttributeKeyInNode: aNode.

	^attr isNil 
		ifTrue: [false]
		ifFalse: 
		[
			(aNode attributes at: attr) endsWith: self value unquoted
		]! !

CSSAttributeSelector subclass: #CSSAttributeIncludesSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSAttributeIncludesSelector methodsFor: 'as yet unclassified' stamp: 'tb 12/21/2005 08:30'!
matches: aNode

	| attr |

	attr := self privateAttributeKeyInNode: aNode.

	^attr isNil 
		ifTrue: [false]
		ifFalse: 
		[
			(((aNode attributes at: attr) findTokens: ' ') 
				collect: [:ea | ea unquoted])
					includes: self value unquoted
		]! !

CSSAttributeIncludesSelector subclass: #CSSClassSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSClassSelector class methodsFor: 'as yet unclassified' stamp: 'tb 1/3/2006 17:54'!
readFrom: in

	| out | 
	
	out := WriteStream on: String new.
	in peek = $. ifTrue: [in next].
	[in atEnd not and: [in peek isAlphaNumeric or:['-_' includes: in peek]]] 
		whileTrue: [out nextPut: in next].
	^self new value: out contents unquoted.! !

!CSSClassSelector methodsFor: 'as yet unclassified' stamp: 'tb 12/20/2005 21:22'!
initialize

	super initialize.
	self attribute: 'class'! !

!CSSClassSelector methodsFor: 'as yet unclassified' stamp: 'tb 1/3/2006 17:54'!
matches: aNode

	^aNode classes includes: self value! !

!CSSClassSelector methodsFor: 'as yet unclassified' stamp: 'tb 12/21/2005 14:16'!
printOn:aStream

	aStream nextPut: $..
	aStream nextPutAll: self value.! !

!CSSAttributeSelector class methodsFor: 'as yet unclassified' stamp: 'tb 1/14/2006 21:08'!
readFrom: in

	| out |
	in peek = $[ ifFalse: [self halt].
	in next.
	out := WriteStream on: String new.
	[in atEnd not and: [in peek isLetter or: [in peek isDigit or:['-_' includes: in peek]]]] 
		whileTrue:[out nextPut: in next].

	in skipSeparators.
	in peek = $] ifTrue:
	[
		in next.
		^CSSAttributeExistsSelector new attribute: out contents
	]
	ifFalse:
	[
		| sel val |
		sel := nil.
		in peek = $= ifTrue: [sel := CSSAttributeEqualsSelector new attribute: out contents]
		ifFalse: 
		[
		 	(in peek = $~ and: [in next. in peek = $=]) 
			ifTrue: [sel := CSSAttributeIncludesSelector new attribute: out contents]
			ifFalse: 
			[
				(in peek = $| and: [in next. in peek = $=]) 
				ifTrue:[sel := CSSAttributeBeginsWithSelector new attribute: out contents]
				ifFalse:
				[
					(in peek = $^ and: [in next. in peek = $=]) ifTrue:
					[sel := CSSAttributeHasPrefixSelector new attribute: out contents]
					ifFalse:
					[
						(in peek = $$ and: [in next. in peek = $=]) ifTrue:
						[
							sel := CSSAttributeHasSuffixSelector new attribute: out contents
						]
						ifFalse:
						[
							(in peek = $* and: [in next. in peek = $=]) ifTrue:
							[
								sel := CSSAttributeHasSubstringSelector new 
									attribute: out contents
							]
							ifFalse:
							[
								in upTo: $].
								^CSSInvalidAttributeSelector new attribute: out contents.
							]
						]
					]
				]
			]
		].
		in next. "Skip ="
		in skipSeparators.
		in peek = $" 
			ifTrue:[in next. val := in upTo: $"]
			ifFalse:
			[
				in peek = $' 
					ifTrue:[in next. val := in upTo: $']
					ifFalse:
					[
						out := WriteStream on: String new.
						[in peek isLetter or: [in peek isDigit or: ['-.' includes: in peek]]]
						whileTrue: [out nextPut: in next].
						val := out contents.
					]
			].
		in next. "Consume the last ]"
		^sel value: val.
	]
	! !

!CSSAttributeSelector methodsFor: 'comparing' stamp: 'tb 1/3/2006 04:20'!
= anObject

	^anObject class == self class and: 
		[anObject attribute = self attribute and: 
			[anObject value = self value]
		]! !

!CSSAttributeSelector methodsFor: 'accessing' stamp: 'tb 12/20/2005 21:21'!
attribute
	"Answer the value of attribute"

	^ attribute! !

!CSSAttributeSelector methodsFor: 'accessing' stamp: 'tb 7/12/2007 11:17'!
attribute: anObject
	"Set the value of attribute"

	attribute := anObject asLowercase asSymbol! !

!CSSAttributeSelector methodsFor: 'comparing' stamp: 'tb 1/3/2006 04:20'!
hash

	^self class hash + self attribute hash + self value hash! !

!CSSAttributeSelector methodsFor: 'testing' stamp: 'tb 1/3/2006 04:55'!
isAttributeSelector

	^true! !

!CSSAttributeSelector methodsFor: 'accessing' stamp: 'tb 7/12/2007 11:19'!
privateAttributeKeyInNode: aNode

	^(aNode dtd isXML 
		ifTrue: 
		[
			(aNode attributes includesKey: self attribute) 
				ifFalse: [nil] 
				ifTrue:[self attribute]
		] 
		ifFalse: 
		[
			(aNode attributes includesKey: self attribute asLowercase) 
				ifFalse: [nil] 
				ifTrue:[self attribute]
		]).
! !

!CSSAttributeSelector methodsFor: 'accessing' stamp: 'tb 12/21/2005 12:06'!
value

	^value! !

!CSSAttributeSelector methodsFor: 'accessing' stamp: 'sebastian.sastre 10/18/2010 11:56'!
value: anObject
	"Set the value of value"

	value := anObject! !

CSSAttributeSelector subclass: #CSSInvalidAttributeSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSInvalidAttributeSelector methodsFor: 'as yet unclassified' stamp: 'tb 1/14/2006 20:35'!
isValid

	^false! !

CSSSelector subclass: #CSSInvalidSelector
	instanceVariableNames: 'selectorString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSInvalidSelector methodsFor: 'accessing' stamp: 'tb 12/30/2005 19:19'!
isValid

	^false! !

!CSSInvalidSelector methodsFor: 'printing' stamp: 'tb 12/30/2005 19:34'!
printOn: aStream

	aStream nextPutAll: 'INVALID: '; nextPutAll: self selectorString! !

!CSSInvalidSelector methodsFor: 'accessing' stamp: 'tb 12/30/2005 19:30'!
selectorString
	"Answer the value of selectorString"

	^ selectorString! !

!CSSInvalidSelector methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:15'!
selectorString: anObject
	"Set the value of selectorString"

	selectorString := anObject! !

CSSSelector subclass: #CSSPseudoClassSelector
	instanceVariableNames: 'pseudoClassName arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSActiveSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSCheckedSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSDisabledSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSEnabledSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSFirstChildSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSFirstChildSelector class methodsFor: 'accessing' stamp: 'tb 12/22/2005 22:23'!
operator

	^'>'! !

CSSPseudoClassSelector subclass: #CSSFirstOfTypeSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSFirstSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSFocusSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSHoverSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSIndeterminateSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSInvalidPseudoClassSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSInvalidPseudoClassSelector methodsFor: 'testing' stamp: 'tb 1/18/2006 20:55'!
isValid

	^false! !

CSSPseudoClassSelector subclass: #CSSLangSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSLangSelector methodsFor: 'accessing' stamp: 'tb 1/18/2006 21:09'!
language
	"Answer the value of language"

	^ self arguments! !

CSSPseudoClassSelector subclass: #CSSLastChildSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSLastOfTypeSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSLinkSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSNotSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSNthChildSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSNthLastChildSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSNthLastOfTypeSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSNthOfTypeSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSPseudoClassSelector class methodsFor: 'as yet unclassified' stamp: 'tb 1/18/2006 21:08'!
readFrom: in

	| cls obj out |
	in next = $: ifFalse: [self halt].
	out := WriteStream on: String new.
	"out nextPutAll: 'CSS'."
	out nextPut: in next asUppercase.
	[in peek notNil and: [in peek isLetter or: [in peek = $-]]] whileTrue: 
	[
		in peek = $- 
			ifTrue: [in next. out nextPut: in next asUppercase] 
			ifFalse: [out nextPut: in next]
	].
	"out nextPutAll: 'Selector'."

	cls := (Smalltalk at: ('CSS',(out contents),'Selector') asSymbol ifAbsent: [self]).
	cls = self ifTrue: [obj := cls new pseudoClassName: out contents] ifFalse: [obj := cls new].
	in skipSeparators.
	in peek = $( ifTrue:[ in next. obj arguments: (in upTo: $) )].
	^obj! !

!CSSPseudoClassSelector methodsFor: 'accessing' stamp: 'tb 1/18/2006 21:08'!
arguments
	"Answer the value of arguments"

	^ arguments! !

!CSSPseudoClassSelector methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:18'!
arguments: anObject
	"Set the value of arguments"

	arguments := anObject! !

!CSSPseudoClassSelector methodsFor: 'as yet unclassified' stamp: 'tb 12/21/2005 15:14'!
matches: aNode

	^true! !

!CSSPseudoClassSelector methodsFor: 'as yet unclassified' stamp: 'tb 1/18/2006 23:33'!
printOn: aStream

	| s |

	s := self pseudoClassName asString.
	aStream nextPut: $: ; nextPutAll: s asLowercase! !

!CSSPseudoClassSelector methodsFor: 'accessing' stamp: 'tb 1/18/2006 21:06'!
pseudoClassName
	"Answer the value of pseudoClassName"

	^ pseudoClassName isNil 
		ifFalse: [pseudoClassName] 
		ifTrue: 
		[
			| nm in out |
			nm := self class name asString.
			nm := nm last: (nm size - ('CSS' size)).
			nm := nm first: (nm size - ('Selector' size)).
			out := WriteStream on: (String new: nm size *2).
			in := ReadStream on: nm.
			out nextPut: in next asLowercase.
			[in atEnd] whileFalse:
			[
				in peek isUppercase 
					ifTrue: [out nextPut: $-. out nextPut: in next asLowercase]
					ifFalse:[out nextPut: in next].
			].
			out contents
		]! !

!CSSPseudoClassSelector methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:18'!
pseudoClassName: anObject
	"Set the value of pseudoClassName"

	pseudoClassName := anObject! !

CSSPseudoClassSelector subclass: #CSSRootSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSTargetSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSPseudoClassSelector subclass: #CSSVisitedSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSSelector subclass: #CSSPseudoElementSelector
	instanceVariableNames: 'pseudoElementName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSSelector subclass: #CSSRelationshipSelector
	instanceVariableNames: 'selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSRelationshipSelector subclass: #CSSAdjacentSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSAdjacentSelector class methodsFor: 'accessing' stamp: 'tb 12/22/2005 22:23'!
operator

	^'+'! !

!CSSAdjacentSelector methodsFor: 'testing' stamp: 'tb 12/21/2005 12:44'!
isAdjacentSelector

	^true! !

!CSSAdjacentSelector methodsFor: 'testing' stamp: 'tb 12/22/2005 22:38'!
matches: aNode

	| node |
	node := aNode.
	selectors reverseDo: 
	[:ea | 
		(ea matches: node) 
			ifFalse: [^false] 
			ifTrue:
			[
				selectors first == ea ifFalse:
				[
					node := node parent children before: node ifAbsent:[^false]
				]
			]
	].
	^true! !

CSSRelationshipSelector subclass: #CSSChildSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSChildSelector class methodsFor: 'as yet unclassified' stamp: 'tb 1/13/2006 17:42'!
operator

	^'>'! !

!CSSChildSelector methodsFor: 'testing' stamp: 'tb 12/21/2005 12:44'!
isChildSelector

	^true! !

!CSSChildSelector methodsFor: 'testing' stamp: 'tb 12/21/2005 00:12'!
matches: aNode

	| node |

	node := aNode.
	selectors reverseDo:[:ea | (ea matches: node) ifFalse:[^false]. node := node parent].
	^true! !

CSSRelationshipSelector subclass: #CSSDescendantSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSDescendantSelector class methodsFor: 'accessing' stamp: 'tb 12/22/2005 22:22'!
operator

	^' '! !

!CSSDescendantSelector methodsFor: 'testing' stamp: 'tb 12/21/2005 12:45'!
isDescendantSelector

	^true! !

!CSSDescendantSelector methodsFor: 'testing' stamp: 'tb 12/21/2005 00:50'!
matches: aNode

	| node |

	(selectors last matches: aNode) ifFalse: [^false].

	node := aNode parent.
	selectors size -1 to: 1 by: -1 do:
	[:idx |
		| sel | 
		node isNil ifTrue:[^false].
		sel := selectors at: idx.
		[node isNil or: [sel matches: node]] whileFalse:[node := node parent]. 
	].
	^node notNil! !

!CSSDescendantSelector methodsFor: 'testing' stamp: 'tb 12/21/2005 15:26'!
printOn: aStream

	self selectors do: [:ea | ea printOn: aStream. aStream nextPut: $ ]! !

CSSRelationshipSelector subclass: #CSSOrSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSOrSelector class methodsFor: 'accessing' stamp: 'tb 1/18/2006 22:51'!
operator

	^''! !

!CSSOrSelector methodsFor: 'comparing' stamp: 'tb 1/3/2006 04:31'!
= anObject

	^self class = anObject class and: [self selectors asSet = anObject selectors asSet]! !

!CSSOrSelector methodsFor: 'comparing' stamp: 'tb 1/3/2006 04:32'!
hash

	^(self class hash) + (self selectors asSet hash)! !

!CSSOrSelector methodsFor: 'accessing' stamp: 'tb 1/3/2006 03:02'!
keySelectors

	| list |

	list := OrderedCollection new.
	self selectors do: [:ea | list addAll: ea keySelectors].
	^list! !

!CSSOrSelector methodsFor: 'testing' stamp: 'tb 12/21/2005 13:12'!
matches: aNode

	^(selectors detect:[:ea | ea matches: aNode] ifNone:[nil]) notNil! !

!CSSOrSelector methodsFor: 'testing' stamp: 'tb 12/21/2005 15:25'!
printOn: aStream

	self selectors do: [:ea | ea printOn: aStream. self selectors last == ea ifFalse: [aStream nextPutAll: ', ']]! !

!CSSRelationshipSelector class methodsFor: 'accessing' stamp: 'tb 1/18/2006 22:16'!
operator

	self subclassResponsibility! !

!CSSRelationshipSelector class methodsFor: 'accessing' stamp: 'tb 1/18/2006 22:48'!
operators

	| out |
	out := WriteStream on: String new.
	self subclasses do:[:ea | out nextPutAll: ea operator].
	^out contents! !

!CSSRelationshipSelector class methodsFor: 'instance creation' stamp: 'tb 1/18/2006 22:18'!
selectorForOperator: aString

	^(self subclasses detect:[:ea | ea operator = aString] ifNone: [CSSDescendantSelector]) new! !

!CSSRelationshipSelector methodsFor: 'comparing' stamp: 'tb 1/3/2006 04:29'!
= anObject

	self class = anObject class and: [self selectors = anObject selectors]! !

!CSSRelationshipSelector methodsFor: 'accessing' stamp: 'tb 12/21/2005 12:39'!
addSelector: aSelector

	self selectors: (self selectors copyWith: aSelector)! !

!CSSRelationshipSelector methodsFor: 'comparing' stamp: 'tb 1/3/2006 04:30'!
hash

	^(self class hash) + (selectors hash)! !

!CSSRelationshipSelector methodsFor: 'accessing' stamp: 'tb 1/14/2006 21:36'!
isCSS3

	^(self selectors detect:[:ea | ea isCSS3] ifNone: [nil]) notNil! !

!CSSRelationshipSelector methodsFor: 'testing' stamp: 'tb 1/18/2006 22:14'!
isRelationshipSelector

	^true! !

!CSSRelationshipSelector methodsFor: 'accessing' stamp: 'tb 1/14/2006 20:40'!
isValid

	^super isValid and: [(self selectors detect:[:ea | ea isValid not] ifNone: [nil]) isNil]! !

!CSSRelationshipSelector methodsFor: 'accessing' stamp: 'tb 1/3/2006 03:03'!
keySelectors

	^self selectors last keySelectors! !

!CSSRelationshipSelector methodsFor: 'accessing' stamp: 'tb 12/22/2005 22:22'!
operator

	^self class operator! !

!CSSRelationshipSelector methodsFor: 'accessing' stamp: 'tb 12/22/2005 22:26'!
printOn: aStream

	selectors do:
	[:ea | 
		ea printOn: aStream. 
		ea == selectors last 
			ifFalse: [aStream nextPutAll: self operator]
	]! !

!CSSRelationshipSelector methodsFor: 'accessing' stamp: 'tb 1/18/2006 22:41'!
removeLastSelector

	| last |
	last := selectors last.
	self selectors: (selectors first: (selectors size-1)).
	^last! !

!CSSRelationshipSelector methodsFor: 'accessing' stamp: 'tb 12/21/2005 15:16'!
selectors
	"Answer the value of selectors"

	^ selectors isNil ifTrue:[#()] ifFalse: [selectors]! !

!CSSRelationshipSelector methodsFor: 'accessing' stamp: 'sebastian.sastre 10/18/2010 11:56'!
selectors: anObject
	"Set the value of selectors"

	selectors := anObject! !

!CSSRelationshipSelector methodsFor: 'accessing' stamp: 'tb 12/30/2005 19:53'!
selectorsMatching: aBlock

	| col |
	col := OrderedCollection new.

	(aBlock value: self) ifTrue: [col add: self].
	self selectors do: [:ea | col addAll: (ea selectorsMatching: aBlock)].
	^col asArray! !

CSSRelationshipSelector subclass: #CSSSiblingSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSSiblingSelector class methodsFor: 'accessing' stamp: 'tb 1/18/2006 21:49'!
operator

	^'~'! !

!CSSSiblingSelector methodsFor: 'testing' stamp: 'tb 1/18/2006 21:52'!
isAdjacentSelector

	^false! !

!CSSSiblingSelector methodsFor: 'testing' stamp: 'tb 1/18/2006 22:04'!
matches: aNode

	| predecessors sels |

	(selectors last matches: aNode) ifTrue:
	[
		predecessors := aNode parent children.
		predecessors := predecessors first: (predecessors indexOf: aNode)-1.
		sels := selectors first: (selectors size -1).

		[predecessors isEmpty not] whileTrue:
		[
			(sels last matches: (predecessors last)) ifTrue:
			[
				sels size = 1 ifTrue: [^true] ifFalse: [sels := sels first: (sels size -1)]
			].
			predecessors := predecessors first: (predecessors size-1).
		]		
	].
	^false! !

!CSSSelector class methodsFor: 'as yet unclassified' stamp: 'tb 4/8/2006 20:45'!
fromString: aString

	(aString includes: $,) 
	ifTrue:
	[
		| in list |
		in := ReadStream on: (aString, ' ').
		list := OrderedCollection new.
		[in atEnd] whileFalse:
		[
			| sel |
			sel := CSSSelector oneSelectorFromString: (in upTo: $,).
			sel isNil ifTrue: [^CSSInvalidSelector new selectorString: aString].
			list add: sel.
		].
			
		^CSSOrSelector new selectors: list asArray.
	]
	ifFalse:
	[
		| sel |
		sel := CSSSelector oneSelectorFromString: aString.
		^sel isNil ifTrue: [CSSInvalidSelector new selectorString: aString] ifFalse: [sel]
	]! !

!CSSSelector class methodsFor: 'as yet unclassified' stamp: 'tb 4/8/2006 20:45'!
oneSelectorFromString: aString

	| in sel lastOperator pos operators |
	operators := CSSRelationshipSelector operators.
	in := ReadStream on: aString.
	sel := nil.
	lastOperator := ' '.
	in skipSeparators.
	pos := -5.
	[in atEnd] whileFalse:
	[
		| c |
		in position = pos ifTrue: [^CSSInvalidSelector new selectorString: aString]. "Infinite loop detection"
		pos := in position.
		c := in peek.
		('.[*#:' includes: c) 
			ifTrue: 
			[
				sel isNil 
					ifTrue: [sel := (CSSUniversalSelector readFrom: in)]
					ifFalse: 
					[
						sel isRelationshipSelector ifFalse:
						[
							sel := (CSSRelationshipSelector selectorForOperator: lastOperator) 
								addSelector: sel.
							sel addSelector: (CSSUniversalSelector readFrom: in)
						]
						ifTrue:
						[ 
							lastOperator = sel operator ifFalse:
							[
								| last comb | 		
								last := sel removeLastSelector.
								comb := CSSRelationshipSelector selectorForOperator: lastOperator.
								comb addSelector: last.
								sel selectors isEmpty 
									ifFalse: [sel addSelector: comb] 
									ifTrue: [sel := comb]. 
								comb addSelector: (self oneSelectorFromString: in upToEnd).
							]
							ifTrue:
							[
								sel addSelector: (CSSUniversalSelector readFrom: in).
							]
						]
					]
			]
			ifFalse:
			[
				((operators includes:c) and:[sel notNil]) ifTrue: 
				[
					lastOperator := in next asString.
					sel isRelationshipSelector ifFalse:
					[
						sel := (CSSRelationshipSelector selectorForOperator: lastOperator)
							addSelector: sel.
					]
					ifTrue:
					[
						sel operator = lastOperator ifFalse:
						[
							| last comb | 		
							last := sel removeLastSelector.
							comb := CSSRelationshipSelector selectorForOperator: lastOperator.
							comb addSelector: last.
							sel selectors isEmpty 
								ifFalse: [sel addSelector: comb] 
								ifTrue: [sel := comb]. 
							comb addSelector: (self oneSelectorFromString: in upToEnd)
						]
					]
				]
				ifFalse:
				[
					c isLetter ifTrue:
					[
						sel isNil ifTrue: 
						[
							sel := (CSSTypeSelector readFrom: in).
						]
						ifFalse:
						[
							sel isRelationshipSelector ifFalse:
							[
								sel := (CSSRelationshipSelector selectorForOperator: lastOperator) 
									addSelector: sel.
								sel addSelector: (CSSTypeSelector readFrom: in)
							]
							ifTrue:
							[ 
								lastOperator = sel operator ifFalse:
								[
									| last comb | 		
									last := sel removeLastSelector.
									comb := CSSTypeSelector selectorForOperator: lastOperator.
									comb addSelector: last.
									sel selectors isEmpty 
										ifFalse: [sel addSelector: comb] 
										ifTrue: [sel := comb]. 
									comb addSelector: (self oneSelectorFromString: in upToEnd).
								]
								ifTrue:
								[
									sel addSelector: (CSSTypeSelector readFrom: in).
								]
							]
						]
					]
					ifFalse: 
					[
						(c = $/) ifTrue:
						[
							in next. 
							in peek = $* ifTrue:
							[
								in back.
								CSSComment new parseContents: in.
							]
							ifFalse:
							[
								in back.
							]
						]
					].
				] 
		].
	].
	^sel! !

!CSSSelector methodsFor: 'testing' stamp: 'tb 12/21/2005 12:40'!
isAdjacentSelector

	^false! !

!CSSSelector methodsFor: 'testing' stamp: 'tb 1/3/2006 04:55'!
isAttributeSelector

	^false! !

!CSSSelector methodsFor: 'testing' stamp: 'tb 1/14/2006 21:34'!
isCSS3

	^false! !

!CSSSelector methodsFor: 'testing' stamp: 'tb 12/21/2005 12:40'!
isChildSelector

	^false! !

!CSSSelector methodsFor: 'testing' stamp: 'tb 12/21/2005 12:40'!
isDescendantSelector

	^false! !

!CSSSelector methodsFor: 'testing' stamp: 'tb 1/18/2006 22:14'!
isRelationshipSelector

	^false! !

!CSSSelector methodsFor: 'testing' stamp: 'tb 1/3/2006 02:47'!
isSimple

	^false! !

!CSSSelector methodsFor: 'testing' stamp: 'tb 12/30/2005 19:46'!
isTypeSelector

	^false! !

!CSSSelector methodsFor: 'accessing' stamp: 'tb 12/30/2005 19:09'!
isValid
	"Answer the value of isValid"

	^ isValid isNil or: [isValid]! !

!CSSSelector methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:21'!
isValid: anObject
	"Set the value of isValid"

	isValid := anObject! !

!CSSSelector methodsFor: 'accessing' stamp: 'tb 1/3/2006 02:58'!
keySelectors

	^#()! !

!CSSSelector methodsFor: 'testing' stamp: 'tb 12/21/2005 00:08'!
matches: aNode

	self subclassResponsibility! !

!CSSSelector methodsFor: 'accessing' stamp: 'tb 12/21/2005 14:21'!
printOn: aStream

	self subclassResponsibility! !

!CSSSelector methodsFor: 'testing' stamp: 'tb 12/30/2005 19:50'!
selectorsMatching: aBlock

	^(aBlock value: self) ifTrue: [Array with: self] ifFalse: [#()]! !

!CSSSelector methodsFor: 'testing' stamp: 'tb 12/30/2005 21:26'!
typeSelectors

	^self selectorsMatching: [:ea | ea isTypeSelector]! !

CSSSelector subclass: #CSSUniversalSelector
	instanceVariableNames: 'selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSUniversalSelector subclass: #CSSTypeSelector
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSTypeSelector class methodsFor: 'as yet unclassified' stamp: 'tb 12/22/2005 18:53'!
readFrom: in

	| out |
	out := WriteStream on: String new.
	(in atEnd not and: [in peek isLetter]) ifTrue: 
	[
		out nextPut: in next.
		[in atEnd not and: [in peek isLetter or: [in peek isDigit or:['-_' includes: in peek]]]] 
			whileTrue:[out nextPut: in next].
	]
	ifFalse: [self halt].
	^self new element: out contents; readAttributeSelectorsFrom: in! !

!CSSTypeSelector methodsFor: 'accessing' stamp: 'tb 12/20/2005 18:03'!
element
	"Answer the value of element"

	^ element! !

!CSSTypeSelector methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:24'!
element: anObject
	"Set the value of element"

	element := anObject! !

!CSSTypeSelector methodsFor: 'testing' stamp: 'tb 12/30/2005 19:56'!
isTypeSelector

	^true! !

!CSSTypeSelector methodsFor: 'accessing' stamp: 'tb 1/18/2006 23:46'!
matches: aNode

	aNode isCSS ifTrue: [^false].
	^(aNode dtd isXML 
		ifTrue:[element = aNode tag] 
		ifFalse: [element asLowercase = aNode tag]) and: [super matches: aNode]! !

!CSSTypeSelector methodsFor: 'accessing' stamp: 'tb 12/21/2005 14:39'!
printOn: aStream

	aStream nextPutAll: self element.
	self selectors do:[:ea | ea printOn: aStream]! !

!CSSUniversalSelector class methodsFor: 'as yet unclassified' stamp: 'tb 1/13/2006 18:28'!
readFrom: in

	in peek = $* ifTrue: [in next].
	^self new readAttributeSelectorsFrom: in! !

!CSSUniversalSelector methodsFor: 'comparing' stamp: 'tb 1/3/2006 04:24'!
= anObject

	^self class = anObject class and: [self selectors = anObject selectors and:[self element = anObject element]]! !

!CSSUniversalSelector methodsFor: 'accessing' stamp: 'tb 12/20/2005 18:04'!
addSelector: aSelector

	self selectors: (self selectors copyWith: aSelector) ! !

!CSSUniversalSelector methodsFor: 'accessing' stamp: 'tb 1/3/2006 05:18'!
classSelectors

	^self selectors select:[:ea | ea isAttributeSelector and: [ea attribute asLowercase = 'class']]! !

!CSSUniversalSelector methodsFor: 'accessing' stamp: 'tb 1/3/2006 02:50'!
element

	^nil! !

!CSSUniversalSelector methodsFor: 'comparing' stamp: 'tb 1/3/2006 04:24'!
hash

	^(self class hash) + (self selectors hash) + (self element hash)! !

!CSSUniversalSelector methodsFor: 'accessing' stamp: 'tb 1/3/2006 04:56'!
idSelector

	^self selectors detect:[:ea | ea isAttributeSelector and: [ea attribute asLowercase = 'id']] ifNone: [nil]! !

!CSSUniversalSelector methodsFor: 'testing' stamp: 'tb 1/14/2006 21:35'!
isCSS3

	^(self selectors detect:[:ea | ea isCSS3] ifNone: [nil]) notNil! !

!CSSUniversalSelector methodsFor: 'testing' stamp: 'tb 1/3/2006 02:47'!
isSimple

	^true! !

!CSSUniversalSelector methodsFor: 'testing' stamp: 'tb 1/14/2006 20:40'!
isValid

	^super isValid and: [(self selectors detect:[:ea | ea isValid not] ifNone: [nil]) isNil]! !

!CSSUniversalSelector methodsFor: 'accessing' stamp: 'tb 1/3/2006 03:03'!
keySelectors

	^Array with: self! !

!CSSUniversalSelector methodsFor: 'accessing' stamp: 'tb 12/21/2005 08:13'!
matches: aNode

	^(self selectors detect:[:ea | (ea matches: aNode) not] ifNone:[nil]) isNil! !

!CSSUniversalSelector methodsFor: 'accessing' stamp: 'tb 12/21/2005 14:39'!
printOn: aStream

	aStream nextPut: $*.
	self selectors do: [:ea | ea printOn: aStream]! !

!CSSUniversalSelector methodsFor: 'accessing' stamp: 'tb 1/3/2006 03:50'!
readAttributeSelectorsFrom: in

	| c |

	in skipSeparators.
	c := in peek.
	[c isNil or: [c isSeparator]] whileFalse:
	[
		c = $. ifTrue: [self addSelector: (CSSClassSelector readFrom: in)] ifFalse:[
		c = $# ifTrue: [self addSelector: (CSSIDSelector readFrom: in)] ifFalse:[
		c = $[ ifTrue: [self addSelector: (CSSAttributeSelector readFrom: in)] ifFalse:[
		c = $: ifTrue: [self addSelector: (CSSPseudoClassSelector readFrom: in)] ifFalse:[
		^self]]]].
		
		c := in peek.
	]! !

!CSSUniversalSelector methodsFor: 'accessing' stamp: 'tb 12/20/2005 18:03'!
selectors
	"Answer the value of selectors"

	^ selectors isNil ifTrue: [#()] ifFalse: [selectors]! !

!CSSUniversalSelector methodsFor: 'accessing' stamp: 'sebastian.sastre 10/18/2010 11:56'!
selectors: anObject
	"Set the value of selectors"

	selectors := anObject! !

Object subclass: #CSSValue
	instanceVariableNames: 'valueString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSValue subclass: #CSSAbsoluteSizeValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSAbsoluteSizeValue methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:37'!
isValid

	^#('xx-small' 'x-small' 'small' 'medium' 'large' 'x-large' 'xx-large') includes: self valueString trimBoth! !

CSSValue subclass: #CSSAttrXValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSAttrXValue class methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:38'!
readFrom: in

	|  pos |
	in skipSeparators.
	pos := in position.
	(in match: 'attr(') ifFalse: [in position: pos. ^nil].
	^self new valueString: (in upTo: $)) trimBoth
	
	! !

!CSSAttrXValue methodsFor: 'as yet unclassified' stamp: 'tb 12/29/2005 01:03'!
isValid

	^(self valueString beginsWith: 'attr(') and: [self valueString endsWith: ')']! !

CSSValue subclass: #CSSBorderStyleValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSBorderStyleValue methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:38'!
isValid

^#( 'none'
	'hidden'
	'dotted'
	'dashed'
	'solid'
	'double'
	'groove'
	'ridge'
	'inset'
	'outset') includes: self valueString trimBoth
! !

CSSValue subclass: #CSSBorderWidthValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSBorderWidthValue methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:38'!
isValid

	| val |
	val := self valueString trimBoth.
	^(#( 'thin' 'medium' 'thick' ) includes: val) or: [(CSSLengthValue fromString: val) isValid]! !

CSSValue subclass: #CSSColorValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSColorValue class methodsFor: 'as yet unclassified' stamp: 'tb 12/31/2005 02:54'!
readFrom: in

	| out |
	out := WriteStream on: String new.
	in skipSeparators.
	(in peek = $#) ifFalse: 
	[
		[in atEnd not and: [in peek isLetter]] whileTrue: [out nextPut: in next]
	]
	ifTrue: 
	[
		out nextPut: in next.
		[in atEnd not and: [in peek isAlphaNumeric]] whileTrue: [out nextPut: in next]
	].
	^self new valueString: out contents! !

!CSSColorValue methodsFor: 'as yet unclassified' stamp: 'tb 12/31/2005 02:33'!
isValid

	| s |

	s := valueString asLowercase.

	(#(	'black' 
		'silver' 
		'gray' 
		'white' 
		'maroon' 
		'red' 
		'purple' 
		'fuchsia' 
		'green' 
		'lime' 
		'olive' 
		'yellow' 
		'navy' 
		'blue' 
		'teal' 
		'aqua') includes: s) ifTrue:[^true].

		((s beginsWith: 'rgb(') and: [s endsWith: ')']) ifTrue:
		[ 
			| rgb |
			rgb := (s findTokens: '(), ') copyWithoutFirst.
			(rgb size = 3 and:
			[
				((rgb first endsWith: '%') ifTrue: 
				[(rgb detect:
					[:ea | 
						((ea endsWith: '%') and: 
						[
							((ea first: (ea size-1)) asNumber >=0) 
								and: [(ea first:(ea size-1)) asNumber <=100]
						]) not
					] ifNone:[nil]) isNil ifTrue: [^true]
				]
				ifFalse:
				[
					(rgb detect:
					[:ea |
						(ea asNumber >= 0 and: [ea asNumber <= 255]) not
					] ifNone:[nil]) isNil ifTrue: [^true]
				])
			])
		].
		((s beginsWith: '#') and: 
			[(s size = 7 or: [s size = 4]) and: 
				[(s copyWithoutFirst detect:
					[:ea| ('0123456789abcdef' includes: ea) not] ifNone:[nil]) isNil]
			]) ifTrue: [^true].

	^false
	! !

CSSValue subclass: #CSSCounterValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSCounterValue methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:38'!
isValid

	| s |
	s := self valueString trimBoth.
	((s beginsWith: 'counter(') and: [s endsWith: ')' ]) ifTrue:
	[
		| args |
		args := (s findTokens: '(,) ') copyWithoutFirst.
		^args size = 1 or:[args size = 2 and: [self isValidStyle: args last]]
	]
	ifFalse:
	[
		((s beginsWith: 'counters(') and: [s endsWith: ')']) ifTrue:
		[
			| args |
			args := (s findTokens: '(,) ') copyWithoutFirst.
			^args size = 2 or:[args size = 3 and: [self isValidStyle: args last]]
			
		]
	].
	^false! !

!CSSCounterValue methodsFor: 'as yet unclassified' stamp: 'tb 12/29/2005 17:13'!
isValidStyle: aString

	^(CSSPropertyDefinition named: 'list-style-type') valueType isValidValue: aString! !

CSSValue subclass: #CSSEnumeratedValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSEnumeratedValue class methodsFor: 'as yet unclassified' stamp: 'tb 12/30/2005 12:53'!
readFrom: in

	| out set |
	set := (Character separators, $;).
	out := WriteStream on: String new.
	[set includes: in peek] whileTrue: [out nextPut: in next].
	^self new valueString: out contents. 
	 

	! !

CSSValue subclass: #CSSGenericFamilyValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSGenericFamilyValue class methodsFor: 'instance creation' stamp: 'tb 1/6/2006 11:49'!
readFrom: in

	| out pos |
	
	pos := in position.
	out := WriteStream on: String new.
	in skipSeparators.
	(in peek = $') ifTrue: 
	[
		in next.
		[in peek = $'] whileFalse: 
		[
			in peek = $\ ifTrue: [in next].
			out nextPut: in next
		]
	] 
	ifFalse: "better be a double quote"
	[
		in peek = $" ifTrue:
		[
			in next.
			[in peek = $"] whileFalse: 
			[
				in peek = $\ ifTrue: [in next].
				out nextPut: in next
			]
		]
		ifFalse:
		[
			| seps |
			seps := (Character separators, ',;/').
			[in atEnd or: [seps includes: in peek]]whileFalse: [out nextPut: in next]
		]
	].

	^out contents size > 0 
		ifTrue: [self new valueString: out contents] 
		ifFalse: [in position: pos. nil]! !

!CSSGenericFamilyValue methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:38'!
isValid

	^#( 'serif' 'sans-serif' 'cursive' 'fantasy' 'monospace' ) includes: self valueString trimBoth! !

CSSValue subclass: #CSSGenericVoiceValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSGenericVoiceValue methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:38'!
isValid

	^#( 'male' 'female' 'child' ) includes: self valueString trimBoth! !

CSSValue subclass: #CSSIdentifierValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSIdentifierValue methodsFor: 'testing' stamp: 'SebastianSastre 1/15/2012 16:38'!
isValid

	| s |
	s := self valueString trimBoth.
	s first isLetter ifFalse:[^false].
	^(s detect:[:ea | (ea isAlphaNumeric or: ['_-' includes: ea]) not] ifNone: [nil]) isNil! !

CSSValue subclass: #CSSIntegerValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSIntegerValue class methodsFor: 'as yet unclassified' stamp: 'tb 12/30/2005 23:49'!
readFrom: in

	| out |
	out := WriteStream on: String new.
	('-+' includes: in peek) ifTrue: [out nextPut: in next].
	[in atEnd not and: [in peek isDigit]] whileTrue: [out nextPut: in next].
	^self new valueString: out contents ! !

!CSSIntegerValue methodsFor: 'as yet unclassified' stamp: 'tb 12/14/2005 23:38'!
isValid

	| str |

	str := ('+-' includes: valueString first)
		ifTrue: [valueString copyWithoutFirst]
		ifFalse:[valueString].

	^(str detect:[:ea | ea isDigit not] ifNone:[nil]) isNil! !

!CSSIntegerValue methodsFor: 'as yet unclassified' stamp: 'tb 12/14/2005 23:55'!
value

	^self isValid ifTrue: [valueString asNumber] ifFalse: [nil]! !

CSSIntegerValue subclass: #CSSNumberValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSNumberValue class methodsFor: 'instance creation' stamp: 'tb 12/31/2005 02:17'!
readFrom: in

	| out |
	out := WriteStream on: String new.
	('-+' includes: in peek) ifTrue: [out nextPut: in next].
	[in atEnd not and: [in peek isDigit]] whileTrue: [out nextPut: in next].
	(in peek = $.) ifTrue: 
	[
		out size = 0 ifTrue: [out nextPut: $0].
		out nextPut: in next.
		[in atEnd not and: [in peek isDigit]] whileTrue: [out nextPut: in next].
	].
	^(in peek isNil or: [(Character separators, ';, /') includes: in peek]) 
		ifFalse: [nil]
		ifTrue:[self new valueString: out contents] ! !

!CSSNumberValue methodsFor: 'as yet unclassified' stamp: 'tb 12/14/2005 23:48'!
isValid

	^([valueString asNumber] on: Exception do:[:ex | ex return: nil]) notNil! !

CSSNumberValue subclass: #CSSUnitizedNumberValue
	instanceVariableNames: 'units'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSUnitizedNumberValue subclass: #CSSAngleValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSAngleValue methodsFor: 'as yet unclassified' stamp: 'tb 12/15/2005 01:21'!
allowableUnits

	^#('deg' 'grad' 'rad')! !

CSSUnitizedNumberValue subclass: #CSSFrequencyValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSFrequencyValue methodsFor: 'as yet unclassified' stamp: 'tb 12/15/2005 01:24'!
allowableUnits

	^#( 'hz' 'khz')! !

!CSSFrequencyValue methodsFor: 'as yet unclassified' stamp: 'tb 12/15/2005 01:23'!
isValid

	^super isValid and: [valueString asNumber >= 0]! !

CSSUnitizedNumberValue subclass: #CSSLengthValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSLengthValue methodsFor: 'accessing' stamp: 'tb 12/15/2005 01:35'!
allowableUnits

	^#('em' 'ex' 'px' 'in' 'cm' 'mm' 'pt' 'pc') ! !

!CSSLengthValue methodsFor: 'accessing' stamp: 'tb 12/15/2005 00:06'!
isRelative

	^#( 'em' 'ex' 'px') includes: self units! !

!CSSLengthValue methodsFor: 'accessing' stamp: 'tb 12/15/2005 01:20'!
isValid

	^super isValid and:[units notNil or: [valueString asNumber = 0]]! !

CSSLengthValue subclass: #CSSPaddingWidthValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSPaddingWidthValue methodsFor: 'accessing' stamp: 'tb 12/28/2005 23:24'!
allowableUnits

	^super allowableUnits copyWith: '%'! !

CSSUnitizedNumberValue subclass: #CSSPercentageValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSPercentageValue methodsFor: 'as yet unclassified' stamp: 'tb 12/15/2005 01:37'!
allowableUnits

	^#( '%' )! !

!CSSPercentageValue methodsFor: 'as yet unclassified' stamp: 'tb 12/15/2005 01:37'!
isValid

	^super isValid and: [valueString asNumber >= 0]! !

CSSUnitizedNumberValue subclass: #CSSTimeValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSTimeValue methodsFor: 'as yet unclassified' stamp: 'tb 12/15/2005 01:22'!
allowableUnits

	^#( 's' 'ms')! !

!CSSTimeValue methodsFor: 'as yet unclassified' stamp: 'tb 12/15/2005 01:22'!
isValid

	^super isValid and: [valueString asNumber >= 0]! !

!CSSUnitizedNumberValue class methodsFor: 'as yet unclassified' stamp: 'tb 12/15/2005 01:36'!
allowableUnits

	^self new allowableUnits! !

!CSSUnitizedNumberValue class methodsFor: 'as yet unclassified' stamp: 'tb 1/5/2006 00:06'!
readFrom: in

	| out |
	out := WriteStream on: String new.
	in skipSeparators.
	('-+' includes: in peek) ifTrue: [out nextPut: in next].
	[in atEnd not and: [in peek isDigit]] whileTrue: [out nextPut: in next].
	(in peek = $.) ifTrue: 
	[
		out size = 0 ifTrue: [out nextPut: $0].
		out nextPut: in next.
		[in atEnd not and: [in peek isDigit]] whileTrue: [out nextPut: in next].
	].
	[in atEnd or: [in peek isSeparator or:[';/,' includes: in peek]]] 
		whileFalse: [out nextPut: in next].
	^out contents size > 0 ifTrue: [self new valueString: out contents] ifFalse: [nil]! !

!CSSUnitizedNumberValue methodsFor: 'accessing' stamp: 'tb 12/15/2005 01:18'!
allowableUnits

	self subclassResponsibility! !

!CSSUnitizedNumberValue methodsFor: 'accessing' stamp: 'tb 12/15/2005 01:15'!
units
	"Answer the value of units"

	^ units! !

!CSSUnitizedNumberValue methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:24'!
units: anObject
	"Set the value of units"

	units := anObject! !

!CSSUnitizedNumberValue methodsFor: 'accessing' stamp: 'tb 12/15/2005 01:17'!
valueString: aString

	| lc |

	lc := aString asLowercase.
	units := (self allowableUnits
			detect: [:ea | lc endsWith: ea] ifNone: [nil]).
	valueString := units notNil 
		ifTrue: [aString first: (aString size - units size)] 
		ifFalse: [aString].
! !

CSSValue subclass: #CSSMarginWidthValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSMarginWidthValue methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:38'!
isValid

	| s | 
	s := self valueString trimBoth.
	s = 'auto' ifTrue: [^true].
	(CSSLengthValue fromString: s) isValid ifTrue: [^true].
	(CSSPercentageValue fromString: s) isValid ifTrue: [^true].
	^false! !

CSSValue subclass: #CSSRelativeSizeValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSRelativeSizeValue methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:38'!
isValid

	^#( 'smaller' 'larger' ) includes: self valueString trimBoth! !

CSSValue subclass: #CSSShapeValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSShapeValue methodsFor: 'testing' stamp: 'SebastianSastre 1/15/2012 16:38'!
isValid

	| s items |

	s := valueString trimBoth asLowercase.

	((s beginsWith: 'rect(') and: [s endsWith: ')']) ifTrue:
	[
		s := s last: (s size) - ('rect(' size).
		s := s first: s size -1.
		items := s findTokens: ' '.
		^items size = 4 and: [(items detect:
			[:ea | (ea = 'auto' or: [(CSSLengthValue fromString: ea) isValid]) not] ifNone: [nil]) isNil]	
	].
	^false! !

CSSValue subclass: #CSSSpecificVoiceValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSSpecificVoiceValue methodsFor: 'as yet unclassified' stamp: 'tb 12/29/2005 00:20'!
isValid

	^true! !

CSSValue subclass: #CSSStringValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSStringValue subclass: #CSSFamilyNameValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSFamilyNameValue class methodsFor: 'instance creation' stamp: 'tb 1/6/2006 11:49'!
readFrom: in

	| out pos |

	pos := in position.
	out := WriteStream on: String new.
	in skipSeparators.
	(in peek = $') ifTrue: 
	[
		in next.
		[in peek = $'] whileFalse: 
		[
			in peek = $\ ifTrue: [in next].
			out nextPut: in next
		]
	] 
	ifFalse: "better be a double quote"
	[
		in peek = $" ifTrue:
		[
			in next.
			[in peek = $"] whileFalse: 
			[
				in peek = $\ ifTrue: [in next].
				out nextPut: in next
			].
			in next. "Clear the trailing quote"
		]
		ifFalse:
		[
			| seps |
			seps := (Character separators, ',;/').
			[in atEnd or: [seps includes: in peek]]whileFalse: [out nextPut: in next]
		]
	].
	(CSSGenericFamilyValue new valueString: out contents asLowercase) isValid 
		ifTrue: [in position: pos. ^nil].

	^out contents size > 0 
		ifTrue: [self new valueString: out contents] 
		ifFalse: [in position: pos. nil]! !

!CSSStringValue class methodsFor: 'as yet unclassified' stamp: 'tb 1/14/2006 17:26'!
readFrom: in

	| out |
	out := WriteStream on: String new.
	(in peek = $') ifTrue: 
	[
		in next.
		[in peek = $'] whileFalse: 
		[
			in peek = $\ ifTrue: [in next].
			out nextPut: in next
		].
		in next.
	] 
	ifFalse: "better be a double quote"
	[
		in peek = $" ifTrue:
		[
			in next.
			[in peek = $"] whileFalse: 
			[
				in peek = $\ ifTrue: [in next].
				out nextPut: in next
			].
			in next. "Read last quote"
		]
	].
	^out contents size > 0 ifTrue: [self new valueString: out contents] ifFalse: [nil]! !

!CSSStringValue methodsFor: 'testing' stamp: 'SebastianSastre 1/15/2012 16:39'!
isValid

	| s |

	s := valueString trimBoth.
	^s size > 0! !

!CSSStringValue methodsFor: 'accessing' stamp: 'tb 12/29/2005 00:09'!
value

	^self valueString unquoted! !

CSSValue subclass: #CSSUrlValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSUrlValue subclass: #CSSUriValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSUrlValue class methodsFor: 'as yet unclassified' stamp: 'tb 12/31/2005 19:28'!
readFrom: aStream

	| s pos |
	aStream skipSeparators.
	pos := aStream position.
	(aStream match: 'url(' ) ifTrue: [s := aStream upTo: $)]
	ifFalse:
	[
		aStream position: pos.
		aStream peek = $' ifTrue: [aStream next. s:= aStream upTo: $']
		ifFalse: 
		[
			aStream peek = $" ifTrue: [aStream next. s:= aStream upTo: $"]
			ifFalse:
			[
				^nil 
			]
		]
	].
	^self new valueString: s unquoted. 
	! !

!CSSUrlValue methodsFor: 'as yet unclassified' stamp: 'tb 12/31/2005 19:32'!
isValid

	^true.! !

!CSSUrlValue methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:39'!
value

	| s |

	s := valueString trimBoth.

	^self isValid ifTrue:
	[
		(s beginsWith: 'url(') ifTrue:
		[
			s := s last: s size - 4.
			s := s first: s size - 1.
			s := s trimBoth unquoted.
		]
		ifFalse: [ s unquoted ]
	]
	ifFalse: ['']! !

!CSSValue class methodsFor: 'as yet unclassified' stamp: 'tb 12/15/2005 01:57'!
forType: aType

	^self allSubclasses detect: [:ea | ea type = aType] ifNone: [nil].! !

!CSSValue class methodsFor: 'as yet unclassified' stamp: 'tb 12/30/2005 12:23'!
fromString: aString
	
	^self readFrom: (ReadStream on: aString)
! !

!CSSValue class methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:40'!
readFrom: in

	| out seps |
	out := WriteStream on: String new.
	seps := (Character separators, ';,').
	in skipSeparators.
	[in atEnd or:[seps includes: in peek]] whileFalse: [out nextPut: in next].
	out contents trimBoth size < 1 ifTrue: [^nil].
	^self new valueString: out contents! !

!CSSValue class methodsFor: 'as yet unclassified' stamp: 'tb 12/28/2005 22:15'!
type

	| s in out |
	s := self name.
	s := s last: s size - 'CSS' size.
	s := s first: s size - 'Value' size.
	out := WriteStream on: String new.
	in := ReadStream on: s.
	out nextPut: $<; nextPut: in next asLowercase.
	[in atEnd] whileFalse: 
	[
		in peek isUppercase ifTrue: [out nextPut: $-]. 
		out nextPut: in next asLowercase
	].
	out nextPut: $>.
	^out contents ! !

!CSSValue methodsFor: 'accessing' stamp: 'tb 1/5/2006 08:24'!
isProperty

	^false! !

!CSSValue methodsFor: 'accessing' stamp: 'tb 12/14/2005 23:24'!
isValid

	self subclassResponsibility! !

!CSSValue methodsFor: 'accessing' stamp: 'tb 12/14/2005 23:54'!
value

	self subclassResponsibility! !

!CSSValue methodsFor: 'accessing' stamp: 'tb 12/14/2005 23:23'!
valueString
	"Answer the value of valueString"

	^ valueString! !

!CSSValue methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:25'!
valueString: anObject
	"Set the value of valueString"

	valueString := anObject! !

Object subclass: #CSSValueType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSValueType class methodsFor: 'instance creation' stamp: 'tb 12/27/2005 10:44'!
fromString: aString

	| in | 

	in := ReadStream on: aString.

	^self readFrom: in.
	! !

!CSSValueType class methodsFor: 'instance creation' stamp: 'tb 1/3/2006 09:39'!
readFrom: aStream

	| in val pos operator |

	in := aStream. "in is easier to type"
	val := nil.
	operator := nil.
	pos := -100.	
	[in atEnd] whileFalse:
	[
		in skipSeparators.
		in position = pos ifTrue: [self halt].
		pos := in position.
		(in peek isAlphaNumeric or: [',/' includes: in peek]) ifTrue:
		[
			val isNil 
				ifTrue: [val := CSSValueTypeLiteral readFrom: aStream]
				ifFalse: 
				[
					((val respondsTo: #addType:) and: [val operator = operator])ifFalse: 
					[
						val := CSSValueTypeAND new addType: val.
						operator := val operator.
					].
					val addType: (CSSValueTypeLiteral readFrom: aStream)
				]
		]
		ifFalse:
		[
			in peek = $| ifTrue:
			[
				in next.
				in peek = $| ifTrue:
				[
					in next.
					operator isNil ifTrue:
					[
						val := CSSValueTypeANDOR new addType: val.
						operator := val operator.	
					]
				]
				ifFalse:
				[
					operator isNil ifTrue:
					[
						val := CSSValueTypeOR new addType: val.
						operator := val operator.
					]
				]
			]
			ifFalse:
			[
				in peek = $[ ifTrue:
				[
					in next.
					val isNil 
						ifTrue: [val := self readFrom: in]
						ifFalse: 
						[
							(val respondsTo: #addType:) ifFalse: 
							[
								val := CSSValueTypeAND new addType: val.
								operator = val operator.
							].
							val addType: (self readFrom: in)
						]					
				]
				ifFalse:
				[
					in peek = $] ifTrue:
					[
						in next.
						(CSSValueTypeConstraint allTypes includes: in peek) ifTrue:
						[
							val := (CSSValueTypeConstraint readFrom: in) type: val.
						].
						^val
					]
					ifFalse:
					[
						in peek = $< ifTrue:
						[
							val isNil 
								ifTrue: [val := CSSValueTypeValue readFrom: in]
								ifFalse: 
								[
									(val respondsTo: #addType:) ifFalse: 
									[
										val := CSSValueTypeAND new addType: val.
										operator := val operator.
									].
									val addType: (CSSValueTypeValue readFrom: in)
								]
						]
						ifFalse:
						[
							in peek = $' ifTrue:
							[
								val isNil 
									ifTrue: [val := CSSValueTypeProperty readFrom: in]
									ifFalse: 
									[
										(val respondsTo: #addType:) ifFalse: 
										[
											val := CSSValueTypeAND new addType: val.
											operator := val operator.
										].
										val addType: (CSSValueTypeProperty readFrom: in)
									]				
							]
						]
					]		
				]
			]
		]
	].
	^val! !

!CSSValueType methodsFor: 'testing' stamp: 'tb 12/30/2005 22:55'!
addValues: aCollection fromStream: in

	self subclassResponsibility! !

!CSSValueType methodsFor: 'testing' stamp: 'tb 12/27/2005 15:49'!
isTypeAND


	^false! !

!CSSValueType methodsFor: 'testing' stamp: 'tb 12/27/2005 15:26'!
isTypeANDOR


	^false! !

!CSSValueType methodsFor: 'testing' stamp: 'tb 12/27/2005 15:26'!
isTypeOR


	^false! !

!CSSValueType methodsFor: 'testing' stamp: 'tb 12/27/2005 10:20'!
isTypeOneOf


	^false! !

!CSSValueType methodsFor: 'testing' stamp: 'tb 12/27/2005 10:20'!
isTypeOneOrMoreOf


	^false! !

!CSSValueType methodsFor: 'testing' stamp: 'tb 12/27/2005 10:49'!
isValidValue: anObject

	self subclassResponsibility! !

CSSValueType subclass: #CSSValueTypeConstraint
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSValueTypeConstraint class methodsFor: 'accessing' stamp: 'tb 12/27/2005 15:44'!
allTypes

	^self subclasses collect:[:ea | ea type]! !

!CSSValueTypeConstraint class methodsFor: 'instance creation' stamp: 'tb 12/27/2005 15:36'!
forType: aCharacter

	^self subclasses detect: [:ea | ea type = aCharacter] 
		ifNone: [self error: ('Type not found ', (aCharacter asString))].
	! !

!CSSValueTypeConstraint class methodsFor: 'accessing' stamp: 'tb 12/27/2005 20:16'!
isSimple

	^true! !

!CSSValueTypeConstraint class methodsFor: 'instance creation' stamp: 'tb 12/27/2005 21:43'!
readFrom: in

	| cls |

	cls := self forType: in peek.
	^cls isSimple 
		ifTrue: [in next. cls new]
		ifFalse: [cls readFrom: in]! !

!CSSValueTypeConstraint methodsFor: 'printing' stamp: 'tb 12/27/2005 16:05'!
printOn: aStream

	self type printOn: aStream.
	aStream nextPut: self class type! !

!CSSValueTypeConstraint methodsFor: 'accessing' stamp: 'tb 12/27/2005 15:21'!
type
	"Answer the value of type"

	^ type! !

!CSSValueTypeConstraint methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:18'!
type: anObject
	"Set the value of type"

	type := anObject! !

CSSValueTypeConstraint subclass: #CSSValueTypeNToMOf
	instanceVariableNames: 'n m'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSValueTypeNToMOf class methodsFor: 'accessing' stamp: 'tb 12/27/2005 20:16'!
isSimple

	^false! !

!CSSValueTypeNToMOf class methodsFor: 'instance creation' stamp: 'tb 12/27/2005 20:18'!
readFrom: in

	in peek = ${ ifTrue:
	[
		| s n m |
		s := (in upTo: $}) findTokens: ', {}'.
		n := s first asNumber.
		m := s last asNumber.
		^((CSSValueTypeNToMOf new n: n) m: m).
	].
	^nil! !

!CSSValueTypeNToMOf class methodsFor: 'accessing' stamp: 'tb 12/27/2005 15:58'!
type

	^${! !

!CSSValueTypeNToMOf methodsFor: 'accessing' stamp: 'tb 12/31/2005 02:47'!
addValues: aCollection fromStream: in

	| pos |
	"At least n"
	n timesRepeat: 
	[
		pos := in position. 
		(self type addValues: aCollection fromStream: in) ifFalse: [in position: pos. ^false]
	].

	"Fulfilled the minimum - read up to m elements - result is success"
	m-n timesRepeat:
	[
		pos := in position.
		(self type addValues: aCollection fromStream: in) ifFalse: [in position: pos. ^true]
	].
	^true! !

!CSSValueTypeNToMOf methodsFor: 'accessing' stamp: 'tb 12/27/2005 14:35'!
m
	"Answer the value of m"

	^ m! !

!CSSValueTypeNToMOf methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:18'!
m: anObject
	"Set the value of m"

	m := anObject! !

!CSSValueTypeNToMOf methodsFor: 'accessing' stamp: 'tb 12/27/2005 14:35'!
n
	"Answer the value of n"

	^ n! !

!CSSValueTypeNToMOf methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:18'!
n: anObject
	"Set the value of n"

	n := anObject! !

!CSSValueTypeNToMOf methodsFor: 'printing' stamp: 'tb 12/27/2005 14:47'!
printOn: aStream

	type printOn: aStream.
	aStream nextPut: ${; 
		nextPutAll: self n asString; 
		nextPut: $,; 
		nextPutAll: self m asString; 
		nextPut: $}.! !

CSSValueTypeConstraint subclass: #CSSValueTypeOneOrMoreOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSValueTypeOneOrMoreOf class methodsFor: 'accessing' stamp: 'tb 12/27/2005 15:37'!
type

	^$+! !

!CSSValueTypeOneOrMoreOf methodsFor: 'as yet unclassified' stamp: 'tb 12/31/2005 01:30'!
addValues: aCollection fromStream: in

	| one pos |
	one := false.
	[
		pos := in position.
		type addValues: aCollection fromStream: in
	] whileTrue: [one := true].
	in position: pos.
	^one! !

CSSValueTypeConstraint subclass: #CSSValueTypeZeroOrMoreOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSValueTypeZeroOrMoreOf class methodsFor: 'accessing' stamp: 'tb 12/27/2005 15:37'!
type

	^$*! !

!CSSValueTypeZeroOrMoreOf methodsFor: 'as yet unclassified' stamp: 'tb 12/31/2005 01:28'!
addValues: aCollection fromStream: in

	| pos |
	[
		pos := in position.
		type addValues: aCollection fromStream: in
	] whileTrue:[].
	in position: pos.
	^true! !

CSSValueTypeConstraint subclass: #CSSValueTypeZeroOrOneOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSValueTypeZeroOrOneOf class methodsFor: 'accessing' stamp: 'tb 12/27/2005 15:36'!
type

	^$?! !

!CSSValueTypeZeroOrOneOf methodsFor: 'as yet unclassified' stamp: 'tb 12/31/2005 01:29'!
addValues: aCollection fromStream: in

	| pos |
	pos := in position.
	(type addValues: aCollection fromStream: in) ifFalse:[in position: pos].
	^true! !

CSSValueType subclass: #CSSValueTypeLiteral
	instanceVariableNames: 'literal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSValueTypeLiteral class methodsFor: 'instance creation' stamp: 'tb 12/29/2005 00:30'!
readFrom: in

	| out val |

	out := WriteStream on: String new.
	in peek isAlphaNumeric 
		ifTrue: 
		[ 
			out nextPut: in next.
			[in atEnd not and:[in peek isAlphaNumeric or: ['_-' includes: in peek]]] 
			whileTrue: [out nextPut: in next].
		] 
		ifFalse: 
		[
			('/,' includes: in peek) ifTrue: [out nextPut: in next]. 
		].
	val := self new literal: out contents.
	(CSSValueTypeConstraint allTypes includes: in peek) ifTrue:
	[
		val := (CSSValueTypeConstraint readFrom: in) type: val.
	].
	^val! !

!CSSValueTypeLiteral methodsFor: 'testing' stamp: 'tb 1/14/2006 00:28'!
addValues: aCollection fromStream: in

	| pos s out |

	pos := in position.
	in skipSeparators.
	out := WriteStream on: String new.
	[in atEnd not and: [literal includes: in peek]] 
		whileTrue: [out nextPut: in next].
	s := out contents.
	^(s asLowercase = literal) 
		ifFalse: [in position: pos. false] 
		ifTrue: [aCollection add: (CSSIdentifierValue new valueString: self literal). true]! !

!CSSValueTypeLiteral methodsFor: 'testing' stamp: 'tb 12/27/2005 10:52'!
isValueValid: anObject

	^anObject isString and: [self literal = anObject]! !

!CSSValueTypeLiteral methodsFor: 'accessing' stamp: 'tb 12/27/2005 09:53'!
literal
	"Answer the value of literal"

	^ literal! !

!CSSValueTypeLiteral methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:18'!
literal: anObject
	"Set the value of literal"

	literal := anObject! !

!CSSValueTypeLiteral methodsFor: 'printing' stamp: 'tb 12/27/2005 10:48'!
printOn: aStream

	aStream nextPutAll: self literal! !

CSSValueType subclass: #CSSValueTypeProperty
	instanceVariableNames: 'propertyName valueType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSValueTypeProperty class methodsFor: 'instance creation' stamp: 'tb 12/27/2005 20:13'!
readFrom: in

	| s val | 
	in skipSeparators.
	in peek = $' ifFalse: [self error: 'CSSValueTypeProperty must begin with "''"'].
	in next.
	s := in upTo: $'.
	val := self new propertyName: s.
	(CSSValueTypeConstraint allTypes includes: in peek) ifTrue:
	[
		val := (CSSValueTypeConstraint readFrom: in) type: val.
	].
	^val! !

!CSSValueTypeProperty methodsFor: 'accessing' stamp: 'tb 1/5/2006 21:23'!
addValues: aCollection fromStream: in

	| returnValue size |
	size := aCollection size.
	returnValue := self valueType addValues: aCollection fromStream: in.
	returnValue ifTrue:
	[
		| vals newSize |
		
		newSize := aCollection size.
		vals := aCollection last: newSize - size.
		[aCollection size > size ] whileTrue: [aCollection removeLast].
		aCollection add: 
			(((CSSProperty propertyNamed: self propertyName)
				isDerived: true) propertyValue: vals).
	].
	^returnValue! !

!CSSValueTypeProperty methodsFor: 'accessing' stamp: 'tb 12/29/2005 00:58'!
isValueValid: anObject

	^self valueType isValueValid: anObject! !

!CSSValueTypeProperty methodsFor: 'printing' stamp: 'tb 12/29/2005 00:59'!
printOn: aStream

	"self propertyName printOn: aStream"
	self valueType printOn: aStream! !

!CSSValueTypeProperty methodsFor: 'accessing' stamp: 'tb 12/27/2005 10:33'!
propertyName
	"Answer the value of propertyName"

	^ propertyName! !

!CSSValueTypeProperty methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:18'!
propertyName: anObject
	"Set the value of propertyName"

	propertyName := anObject! !

!CSSValueTypeProperty methodsFor: 'accessing' stamp: 'tb 12/29/2005 17:11'!
valueType

	valueType isNil 
		ifTrue: [valueType := (CSSPropertyDefinition named: self propertyName) valueType].
	^valueType! !

CSSValueType subclass: #CSSValueTypeRelation
	instanceVariableNames: 'types'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSValueTypeRelation subclass: #CSSValueTypeAND
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSValueTypeAND methodsFor: 'testing' stamp: 'tb 1/6/2006 11:29'!
addValues: aCollection fromStream: in

	| pos sz |
	pos := in position.
	sz := aCollection size.
	self types do: 	
	[:ea |
		(ea addValues: aCollection fromStream: in) ifFalse: 
		[
			in position: pos.
			[aCollection size > sz] whileTrue: [aCollection removeLast].
			^false
		]
	].
	^true! !

!CSSValueTypeAND methodsFor: 'testing' stamp: 'tb 12/27/2005 15:48'!
isTypeAND

	^true! !

!CSSValueTypeAND methodsFor: 'testing' stamp: 'tb 12/28/2005 22:57'!
operator

	^' '! !

!CSSValueTypeAND methodsFor: 'printing' stamp: 'tb 12/27/2005 16:04'!
printOn: aStream

	aStream nextPut: $[.
	self types do: [:ea | ea printOn: aStream.  ea == types last ifFalse: [ aStream nextPutAll: ' ']].
	aStream nextPut: $]! !

CSSValueTypeRelation subclass: #CSSValueTypeANDOR
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSValueTypeANDOR methodsFor: 'testing' stamp: 'tb 1/5/2006 00:07'!
addValues: aCollection fromStream: in

	| oneWorked gotOne |

	oneWorked := false.
	gotOne := false.
	[
		self types do:
		[:ea |
			(ea addValues: aCollection fromStream: in) 
				ifTrue: [gotOne := oneWorked := true]
		].
	(gotOne and: [in atEnd not])
	] whileTrue: [ gotOne := false ].

	^oneWorked! !

!CSSValueTypeANDOR methodsFor: 'testing' stamp: 'tb 12/27/2005 15:25'!
isTypeANDOR

	^true! !

!CSSValueTypeANDOR methodsFor: 'testing' stamp: 'tb 12/28/2005 22:58'!
operator

	^'||'! !

!CSSValueTypeANDOR methodsFor: 'printing' stamp: 'tb 12/27/2005 14:44'!
printOn: aStream

	aStream nextPut: $[.
	self types do: [:ea | ea printOn: aStream.  ea == types last ifFalse: [ aStream nextPutAll: ' || ']].
	aStream nextPut: $]! !

CSSValueTypeRelation subclass: #CSSValueTypeOR
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSValueTypeOR methodsFor: 'testing' stamp: 'tb 12/31/2005 01:50'!
addValues: aCollection fromStream: in

	| pos |
	pos := in position.
	self types do:
	[:ea |
		(ea addValues: aCollection fromStream: in) ifTrue: [^true].
		in position: pos.
	].
	^false! !

!CSSValueTypeOR methodsFor: 'testing' stamp: 'tb 12/27/2005 15:26'!
isTypeOR

	^true! !

!CSSValueTypeOR methodsFor: 'testing' stamp: 'tb 12/27/2005 10:51'!
isValueValid: anObject

	^(self types detect: [:ea | ea isValueValid: anObject] ifNone: [nil]) notNil! !

!CSSValueTypeOR methodsFor: 'testing' stamp: 'tb 12/28/2005 16:13'!
operator

	^'|'! !

!CSSValueTypeOR methodsFor: 'printing' stamp: 'tb 12/27/2005 14:44'!
printOn: aStream

	aStream nextPut: $[.
	self types do: [:ea | ea printOn: aStream.  ea == types last ifFalse: [ aStream nextPutAll: ' | ']].
	aStream nextPut: $]! !

!CSSValueTypeRelation methodsFor: 'accessing' stamp: 'tb 12/27/2005 09:56'!
addType: anObject

	self types: (self types copyWith: anObject)! !

!CSSValueTypeRelation methodsFor: 'accessing' stamp: 'tb 12/28/2005 16:12'!
operator

	self subclassResponsibility! !

!CSSValueTypeRelation methodsFor: 'accessing' stamp: 'tb 12/27/2005 09:55'!
types
	"Answer the value of types"

	^ types isNil ifTrue: [#()] ifFalse: [types]! !

!CSSValueTypeRelation methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:17'!
types: anObject
	"Set the value of types"

	types := anObject! !

CSSValueType subclass: #CSSValueTypeValue
	instanceVariableNames: 'valueClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSValueTypeValue class methodsFor: 'instance creation' stamp: 'tb 12/28/2005 23:45'!
readFrom: in

	| str vt val |

	in peek = $< ifFalse: [self error: 'CSSValueType must begin with ''<'''].

	str := (in upTo: $>),'>'.
	vt := CSSValue forType: str.
	val := vt notNil 
		ifTrue: [self new valueClass: vt] 
		ifFalse: [self error: ('Unknown CSS value type ',str)].
	in skipSeparators.
	(CSSValueTypeConstraint allTypes includes: in peek) ifTrue:
	[
		val := (CSSValueTypeConstraint readFrom: in) type: val.
	].
	^val! !

!CSSValueTypeValue methodsFor: 'testing' stamp: 'tb 12/30/2005 22:58'!
addValues: aCollection fromStream: in

	| pos val |
	pos := in position.
	val := self valueClass readFrom: in.
	^(val notNil and: [val isValid]) 
		ifTrue: [aCollection add: val. true] 
		ifFalse: [in position: pos. false].
	! !

!CSSValueTypeValue methodsFor: 'testing' stamp: 'tb 12/27/2005 14:07'!
isValueValid: anObject

	^(self valueClass new valueString: anObject asString) isValid! !

!CSSValueTypeValue methodsFor: 'printing' stamp: 'tb 12/27/2005 14:10'!
printOn: aStream

	aStream nextPutAll: self valueClass type! !

!CSSValueTypeValue methodsFor: 'accessing' stamp: 'tb 12/27/2005 09:58'!
valueClass
	"Answer the value of valueClass"

	^ valueClass! !

!CSSValueTypeValue methodsFor: 'accessing' stamp: 'sebastian.sastre 9/19/2010 11:17'!
valueClass: anObject
	"Set the value of valueClass"

	valueClass := anObject! !

Object subclass: #HtmlCache
	instanceVariableNames: 'urlToDocument url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlCache methodsFor: 'accessing' stamp: 'tb 1/17/2008 14:49'!
canonicalize: aStringOrUrl

	| href |

	href := aStringOrUrl asString.
	^((href beginsWith: 'http:') or: [(href beginsWith: 'https:') or:[(href beginsWith: 'ftp:') or: [href beginsWith: 'file:']]]) 
	ifFalse:
	[
		(Url combine: url asString withRelative: href).
	]
	ifTrue: [href].! !

!HtmlCache methodsFor: 'accessing' stamp: 'tb 1/10/2006 10:58'!
contentsForUrl: anUrl

	^(self documentForUrl: anUrl) contents! !

!HtmlCache methodsFor: 'accessing' stamp: 'tb 1/15/2006 19:46'!
documentForUrl: anUrl

	^(self queueUrl: anUrl) ! !

!HtmlCache methodsFor: 'initialize-release' stamp: 'tb 1/10/2006 19:35'!
initialize

	super initialize.
	urlToDocument := Dictionary new.! !

!HtmlCache methodsFor: 'accessing' stamp: 'tb 1/17/2008 14:55'!
queueUrl: anUrl

	| absoluteUrl |
	absoluteUrl := self canonicalize: anUrl.
	^urlToDocument at: absoluteUrl ifAbsentPut: 
	[
		"| request loader |
		loader := HTTPLoader default.
		request := HTTPLoader httpRequestClass for: absoluteUrl in: loader.
		loader addRequest: request.
		request"
		[absoluteUrl asUrl retrieveContents]
		on: Error
		do: ['']
	]	! !

!HtmlCache methodsFor: 'accessing' stamp: 'tb 1/10/2006 10:44'!
url
	"Answer the value of url"

	^ url! !

!HtmlCache methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:51'!
url: anObject
	"Set the value of url"

	url := anObject! !

Object subclass: #HtmlDTD
	instanceVariableNames: 'url document errors dom content comments elements attLists entities'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTD commentStamp: 'tb 11/30/2005 00:38' prior: 0!
I represent the knowledge in a DTD document regarding valid attributes and tag combinations.

After working with this format for awhile, I can honestly say the inventors of DVD have been taking way too much crack.!

HtmlDTD subclass: #Html401Frameset
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!Html401Frameset class methodsFor: 'as yet unclassified' stamp: 'tb 12/19/2005 21:53'!
defaultUrl

	^'http://www.w3.org/TR/html4/frameset.dtd' asUrl! !

!Html401Frameset class methodsFor: 'as yet unclassified' stamp: 'tb 12/19/2005 21:52'!
docType

	^'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">'! !

!Html401Frameset methodsFor: 'as yet unclassified' stamp: 'tb 1/14/2006 12:43'!
dtd
	^ '<!!--
    This is HTML 4.01 Strict DTD, which excludes the presentation 
    attributes and elements that W3C expects to phase out as 
    support for style sheets matures. Authors should use the Strict
    DTD when possible, but may use the Transitional DTD when support
    for presentation attribute and elements is required.
    
    HTML 4 includes mechanisms for style sheets, scripting,
    embedding objects, improved support for right to left and mixed
    direction text, and enhancements to forms for improved
    accessibility for people with disabilities.

          Draft: $Date: 1999/12/24 23:37:48 $

          Authors:
              Dave Raggett <dsr@w3.org>
              Arnaud Le Hors <lehors@w3.org>
              Ian Jacobs <ij@w3.org>

    Further information about HTML 4.01 is available at:

        http://www.w3.org/TR/1999/REC-html401-19991224


    The HTML 4.01 specification includes additional
    syntactic constraints that cannot be expressed within
    the DTDs.

-->
<!!--
    Typical usage:

    <!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
            "http://www.w3.org/TR/html4/strict.dtd">
    <html>
    <head>
    ...
    </head>
    <body>
    ...
    </body>
    </html>

    The URI used as a system identifier with the public identifier allows
    the user agent to download the DTD and entity sets as needed.

    The FPI for the Transitional HTML 4.01 DTD is:

        "-//W3C//DTD HTML 4.01 Transitional//EN"

    This version of the transitional DTD is:

        http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd

    If you are writing a document that includes frames, use 
    the following FPI:

        "-//W3C//DTD HTML 4.01 Frameset//EN"

    This version of the frameset DTD is:

        http://www.w3.org/TR/1999/REC-html401-19991224/frameset.dtd

    Use the following (relative) URIs to refer to 
    the DTDs and entity definitions of this specification:

    "strict.dtd"
    "loose.dtd"
    "frameset.dtd"
    "HTMLlat1.ent"
    "HTMLsymbol.ent"
    "HTMLspecial.ent"

-->

<!!--================== Imported Names ====================================-->
<!!-- Feature Switch for frameset documents -->
<!!ENTITY % HTML.Frameset "INCLUDE">

<!!ENTITY % ContentType "CDATA"
    -- media type, as per [RFC2045]
    -->

<!!ENTITY % ContentTypes "CDATA"
    -- comma-separated list of media types, as per [RFC2045]
    -->

<!!ENTITY % Charset "CDATA"
    -- a character encoding, as per [RFC2045]
    -->

<!!ENTITY % Charsets "CDATA"
    -- a space-separated list of character encodings, as per [RFC2045]
    -->

<!!ENTITY % LanguageCode "NAME"
    -- a language code, as per [RFC1766]
    -->

<!!ENTITY % Character "CDATA"
    -- a single character from [ISO10646] 
    -->

<!!ENTITY % LinkTypes "CDATA"
    -- space-separated list of link types
    -->

<!!ENTITY % MediaDesc "CDATA"
    -- single or comma-separated list of media descriptors
    -->

<!!ENTITY % URI "CDATA"
    -- a Uniform Resource Identifier,
       see [URI]
    -->

<!!ENTITY % Datetime "CDATA" -- date and time information. ISO date format -->


<!!ENTITY % Script "CDATA" -- script expression -->

<!!ENTITY % StyleSheet "CDATA" -- style sheet data -->



<!!ENTITY % Text "CDATA">


<!!-- Parameter Entities -->

<!!ENTITY % head.misc "SCRIPT|STYLE|META|LINK|OBJECT" -- repeatable head elements -->

<!!ENTITY % heading "H1|H2|H3|H4|H5|H6">

<!!ENTITY % list "UL | OL">

<!!ENTITY % preformatted "PRE">


<!!--================ Character mnemonic entities =========================-->

<!!ENTITY % HTMLlat1 PUBLIC
   "-//W3C//ENTITIES Latin1//EN//HTML"
   "HTMLlat1.ent">
%HTMLlat1;

<!!ENTITY % HTMLsymbol PUBLIC
   "-//W3C//ENTITIES Symbols//EN//HTML"
   "HTMLsymbol.ent">
%HTMLsymbol;

<!!ENTITY % HTMLspecial PUBLIC
   "-//W3C//ENTITIES Special//EN//HTML"
   "HTMLspecial.ent">
%HTMLspecial;
<!!--=================== Generic Attributes ===============================-->

<!!ENTITY % coreattrs
 "id          ID             #IMPLIED  -- document-wide unique id --
  class       CDATA          #IMPLIED  -- space-separated list of classes --
  style       %StyleSheet;   #IMPLIED  -- associated style info --
  title       %Text;         #IMPLIED  -- advisory title --"
  >

<!!ENTITY % i18n
 "lang        %LanguageCode; #IMPLIED  -- language code --
  dir         (ltr|rtl)      #IMPLIED  -- direction for weak/neutral text --"
  >

<!!ENTITY % events
 "onclick     %Script;       #IMPLIED  -- a pointer button was clicked --
  ondblclick  %Script;       #IMPLIED  -- a pointer button was double clicked--
  onmousedown %Script;       #IMPLIED  -- a pointer button was pressed down --
  onmouseup   %Script;       #IMPLIED  -- a pointer button was released --
  onmouseover %Script;       #IMPLIED  -- a pointer was moved onto --
  onmousemove %Script;       #IMPLIED  -- a pointer was moved within --
  onmouseout  %Script;       #IMPLIED  -- a pointer was moved away --
  onkeypress  %Script;       #IMPLIED  -- a key was pressed and released --
  onkeydown   %Script;       #IMPLIED  -- a key was pressed down --
  onkeyup     %Script;       #IMPLIED  -- a key was released --"
  >

<!!-- Reserved Feature Switch -->
<!!ENTITY % HTML.Reserved "IGNORE">

<!!-- The following attributes are reserved for possible future use -->
<!![ %HTML.Reserved; [
<!!ENTITY % reserved
 "datasrc     %URI;          #IMPLIED  -- a single or tabular Data Source --
  datafld     CDATA          #IMPLIED  -- the property or column name --
  dataformatas (plaintext|html) plaintext -- text or html --"
  >
]]>

<!!ENTITY % reserved "">

<!!ENTITY % attrs "%coreattrs; %i18n; %events;">


<!!--=================== Text Markup ======================================-->

<!!ENTITY % fontstyle
 "TT | I | B | BIG | SMALL">

<!!ENTITY % phrase "EM | STRONG | DFN | CODE |
                   SAMP | KBD | VAR | CITE | ABBR | ACRONYM" >

<!!ENTITY % special
   "A | IMG | OBJECT | BR | SCRIPT | MAP | Q | SUB | SUP | SPAN | BDO">

<!!ENTITY % formctrl "INPUT | SELECT | TEXTAREA | LABEL | BUTTON">

<!!-- %inline; covers inline or "text-level" elements -->
<!!ENTITY % inline "#PCDATA | %fontstyle; | %phrase; | %special; | %formctrl;">

<!!ELEMENT (%fontstyle;|%phrase;) - - (%inline;)*>
<!!ATTLIST (%fontstyle;|%phrase;)
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT (SUB|SUP) - - (%inline;)*    -- subscript, superscript -->
<!!ATTLIST (SUB|SUP)
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT SPAN - - (%inline;)*         -- generic language/style container -->
<!!ATTLIST SPAN
  %attrs;                              -- %coreattrs, %i18n, %events --
  %reserved;			       -- reserved for possible future use --
  >

<!!ELEMENT BDO - - (%inline;)*          -- I18N BiDi over-ride -->
<!!ATTLIST BDO
  %coreattrs;                          -- id, class, style, title --
  lang        %LanguageCode; #IMPLIED  -- language code --
  dir         (ltr|rtl)      #REQUIRED -- directionality --
  >


<!!ELEMENT BR - O EMPTY                 -- forced line break -->
<!!ATTLIST BR
  %coreattrs;                          -- id, class, style, title --
  >

<!!--================== HTML content models ===============================-->

<!!--
    HTML has two basic content models:

        %inline;     character level elements and text strings
        %block;      block-like elements e.g. paragraphs and lists
-->

<!!ENTITY % block
     "P | %heading; | %list; | %preformatted; | DL | DIV | NOSCRIPT |
      BLOCKQUOTE | FORM | HR | TABLE | FIELDSET | ADDRESS">

<!!ENTITY % flow "%block; | %inline;">

<!!--=================== Document Body ====================================-->

<!!ELEMENT BODY O O (%block;|SCRIPT)+ +(INS|DEL) -- document body -->
<!!ATTLIST BODY
  %attrs;                              -- %coreattrs, %i18n, %events --
  onload          %Script;   #IMPLIED  -- the document has been loaded --
  onunload        %Script;   #IMPLIED  -- the document has been removed --
  >

<!!ELEMENT ADDRESS - - (%inline;)* -- information on author -->
<!!ATTLIST ADDRESS
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT DIV - - (%flow;)*            -- generic language/style container -->
<!!ATTLIST DIV
  %attrs;                              -- %coreattrs, %i18n, %events --
  %reserved;                           -- reserved for possible future use --
  >


<!!--================== The Anchor Element ================================-->

<!!ENTITY % Shape "(rect|circle|poly|default)">
<!!ENTITY % Coords "CDATA" -- comma-separated list of lengths -->

<!!ELEMENT A - - (%inline;)* -(A)       -- anchor -->
<!!ATTLIST A
  %attrs;                              -- %coreattrs, %i18n, %events --
  charset     %Charset;      #IMPLIED  -- char encoding of linked resource --
  type        %ContentType;  #IMPLIED  -- advisory content type --
  name        CDATA          #IMPLIED  -- named link end --
  href        %URI;          #IMPLIED  -- URI for linked resource --
  hreflang    %LanguageCode; #IMPLIED  -- language code --
  rel         %LinkTypes;    #IMPLIED  -- forward link types --
  rev         %LinkTypes;    #IMPLIED  -- reverse link types --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  shape       %Shape;        rect      -- for use with client-side image maps --
  coords      %Coords;       #IMPLIED  -- for use with client-side image maps --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  >

<!!--================== Client-side image maps ============================-->

<!!-- These can be placed in the same document or grouped in a
     separate document although this isn''t yet widely supported -->

<!!ELEMENT MAP - - ((%block;) | AREA)+ -- client-side image map -->
<!!ATTLIST MAP
  %attrs;                              -- %coreattrs, %i18n, %events --
  name        CDATA          #REQUIRED -- for reference by usemap --
  >

<!!ELEMENT AREA - O EMPTY               -- client-side image map area -->
<!!ATTLIST AREA
  %attrs;                              -- %coreattrs, %i18n, %events --
  shape       %Shape;        rect      -- controls interpretation of coords --
  coords      %Coords;       #IMPLIED  -- comma-separated list of lengths --
  href        %URI;          #IMPLIED  -- URI for linked resource --
  nohref      (nohref)       #IMPLIED  -- this region has no action --
  alt         %Text;         #REQUIRED -- short description --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  >

<!!--================== The LINK Element ==================================-->

<!!--
  Relationship values can be used in principle:

   a) for document specific toolbars/menus when used
      with the LINK element in document head e.g.
        start, contents, previous, next, index, end, help
   b) to link to a separate style sheet (rel=stylesheet)
   c) to make a link to a script (rel=script)
   d) by stylesheets to control how collections of
      html nodes are rendered into printed documents
   e) to make a link to a printable version of this document
      e.g. a postscript or pdf version (rel=alternate media=print)
-->

<!!ELEMENT LINK - O EMPTY               -- a media-independent link -->
<!!ATTLIST LINK
  %attrs;                              -- %coreattrs, %i18n, %events --
  charset     %Charset;      #IMPLIED  -- char encoding of linked resource --
  href        %URI;          #IMPLIED  -- URI for linked resource --
  hreflang    %LanguageCode; #IMPLIED  -- language code --
  type        %ContentType;  #IMPLIED  -- advisory content type --
  rel         %LinkTypes;    #IMPLIED  -- forward link types --
  rev         %LinkTypes;    #IMPLIED  -- reverse link types --
  media       %MediaDesc;    #IMPLIED  -- for rendering on these media --
  >


<!!--=================== Images ===========================================-->

<!!-- Length defined in strict DTD for cellpadding/cellspacing -->
<!!ENTITY % Length "CDATA" -- nn for pixels or nn% for percentage length -->
<!!ENTITY % MultiLength "CDATA" -- pixel, percentage, or relative -->

<!![ %HTML.Frameset; [
<!!ENTITY % MultiLengths "CDATA" -- comma-separated list of MultiLength -->
]]>

<!!ENTITY % Pixels "CDATA" -- integer representing length in pixels -->


<!!-- To avoid problems with text-only UAs as well as 
   to make image content understandable and navigable 
   to users of non-visual UAs, you need to provide
   a description with ALT, and avoid server-side image maps -->
<!!ELEMENT IMG - O EMPTY                -- Embedded image -->
<!!ATTLIST IMG
  %attrs;                              -- %coreattrs, %i18n, %events --
  src         %URI;          #REQUIRED -- URI of image to embed --
  alt         %Text;         #REQUIRED -- short description --
  longdesc    %URI;          #IMPLIED  -- link to long description
                                          (complements alt) --
  name        CDATA          #IMPLIED  -- name of image for scripting --
  height      %Length;       #IMPLIED  -- override height --
  width       %Length;       #IMPLIED  -- override width --
  usemap      %URI;          #IMPLIED  -- use client-side image map --
  ismap       (ismap)        #IMPLIED  -- use server-side image map --
  >

<!!-- USEMAP points to a MAP element which may be in this document
  or an external document, although the latter is not widely supported -->

<!!--==================== OBJECT ======================================-->
<!!--
  OBJECT is used to embed objects as part of HTML pages 
  PARAM elements should precede other content. SGML mixed content
  model technicality precludes specifying this formally ...
-->

<!!ELEMENT OBJECT - - (PARAM | %flow;)*
 -- generic embedded object -->
<!!ATTLIST OBJECT
  %attrs;                              -- %coreattrs, %i18n, %events --
  declare     (declare)      #IMPLIED  -- declare but don''t instantiate flag --
  classid     %URI;          #IMPLIED  -- identifies an implementation --
  codebase    %URI;          #IMPLIED  -- base URI for classid, data, archive--
  data        %URI;          #IMPLIED  -- reference to object''s data --
  type        %ContentType;  #IMPLIED  -- content type for data --
  codetype    %ContentType;  #IMPLIED  -- content type for code --
  archive     CDATA          #IMPLIED  -- space-separated list of URIs --
  standby     %Text;         #IMPLIED  -- message to show while loading --
  height      %Length;       #IMPLIED  -- override height --
  width       %Length;       #IMPLIED  -- override width --
  usemap      %URI;          #IMPLIED  -- use client-side image map --
  name        CDATA          #IMPLIED  -- submit as part of form --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  %reserved;                           -- reserved for possible future use --
  >

<!!ELEMENT PARAM - O EMPTY              -- named property value -->
<!!ATTLIST PARAM
  id          ID             #IMPLIED  -- document-wide unique id --
  name        CDATA          #REQUIRED -- property name --
  value       CDATA          #IMPLIED  -- property value --
  valuetype   (DATA|REF|OBJECT) DATA   -- How to interpret value --
  type        %ContentType;  #IMPLIED  -- content type for value
                                          when valuetype=ref --
  >


<!!--=================== Horizontal Rule ==================================-->

<!!ELEMENT HR - O EMPTY -- horizontal rule -->
<!!ATTLIST HR
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--=================== Paragraphs =======================================-->

<!!ELEMENT P - O (%inline;)*            -- paragraph -->
<!!ATTLIST P
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--=================== Headings =========================================-->

<!!--
  There are six levels of headings from H1 (the most important)
  to H6 (the least important).
-->

<!!ELEMENT (%heading;)  - - (%inline;)* -- heading -->
<!!ATTLIST (%heading;)
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--=================== Preformatted Text ================================-->

<!!-- excludes markup for images and changes in font size -->
<!!ENTITY % pre.exclusion "IMG|OBJECT|BIG|SMALL|SUB|SUP">

<!!ELEMENT PRE - - (%inline;)* -(%pre.exclusion;) -- preformatted text -->
<!!ATTLIST PRE
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--===================== Inline Quotes ==================================-->

<!!ELEMENT Q - - (%inline;)*            -- short inline quotation -->
<!!ATTLIST Q
  %attrs;                              -- %coreattrs, %i18n, %events --
  cite        %URI;          #IMPLIED  -- URI for source document or msg --
  >

<!!--=================== Block-like Quotes ================================-->

<!!ELEMENT BLOCKQUOTE - - (%block;|SCRIPT)+ -- long quotation -->
<!!ATTLIST BLOCKQUOTE
  %attrs;                              -- %coreattrs, %i18n, %events --
  cite        %URI;          #IMPLIED  -- URI for source document or msg --
  >

<!!--=================== Inserted/Deleted Text ============================-->


<!!-- INS/DEL are handled by inclusion on BODY -->
<!!ELEMENT (INS|DEL) - - (%flow;)*      -- inserted text, deleted text -->
<!!ATTLIST (INS|DEL)
  %attrs;                              -- %coreattrs, %i18n, %events --
  cite        %URI;          #IMPLIED  -- info on reason for change --
  datetime    %Datetime;     #IMPLIED  -- date and time of change --
  >

<!!--=================== Lists ============================================-->

<!!-- definition lists - DT for term, DD for its definition -->

<!!ELEMENT DL - - (DT|DD)+              -- definition list -->
<!!ATTLIST DL
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT DT - O (%inline;)*           -- definition term -->
<!!ELEMENT DD - O (%flow;)*             -- definition description -->
<!!ATTLIST (DT|DD)
  %attrs;                              -- %coreattrs, %i18n, %events --
  >


<!!ELEMENT OL - - (LI)+                 -- ordered list -->
<!!ATTLIST OL
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!-- Unordered Lists (UL) bullet styles -->
<!!ELEMENT UL - - (LI)+                 -- unordered list -->
<!!ATTLIST UL
  %attrs;                              -- %coreattrs, %i18n, %events --
  >



<!!ELEMENT LI - O (%flow;)*             -- list item -->
<!!ATTLIST LI
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--================ Forms ===============================================-->
<!!ELEMENT FORM - - (%block;|SCRIPT)+ -(FORM) -- interactive form -->
<!!ATTLIST FORM
  %attrs;                              -- %coreattrs, %i18n, %events --
  action      %URI;          #REQUIRED -- server-side form handler --
  method      (get|post)     GET       -- HTTP method used to submit the form--
  enctype     %ContentType;  "application/x-www-form-urlencoded"
  accept      %ContentTypes; #IMPLIED  -- list of MIME types for file upload --
  name        CDATA          #IMPLIED  -- name of form for scripting --
  onsubmit    %Script;       #IMPLIED  -- the form was submitted --
  onreset     %Script;       #IMPLIED  -- the form was reset --
  accept-charset %Charsets;  #IMPLIED  -- list of supported charsets --
  >

<!!-- Each label must not contain more than ONE field -->
<!!ELEMENT LABEL - - (%inline;)* -(LABEL) -- form field label text -->
<!!ATTLIST LABEL
  %attrs;                              -- %coreattrs, %i18n, %events --
  for         IDREF          #IMPLIED  -- matches field ID value --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  >

<!!ENTITY % InputType
  "(text | password | checkbox |
    radio | submit | reset |
    file | hidden | image | button)"
   >

<!!-- attribute name required for all but submit and reset -->
<!!ELEMENT INPUT - O EMPTY              -- form control -->
<!!ATTLIST INPUT
  %attrs;                              -- %coreattrs, %i18n, %events --
  type        %InputType;    TEXT      -- what kind of widget is needed --
  name        CDATA          #IMPLIED  -- submit as part of form --
  value       CDATA          #IMPLIED  -- Specify for radio buttons and checkboxes --
  checked     (checked)      #IMPLIED  -- for radio buttons and check boxes --
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  readonly    (readonly)     #IMPLIED  -- for text and passwd --
  size        CDATA          #IMPLIED  -- specific to each type of field --
  maxlength   NUMBER         #IMPLIED  -- max chars for text fields --
  src         %URI;          #IMPLIED  -- for fields with images --
  alt         CDATA          #IMPLIED  -- short description --
  usemap      %URI;          #IMPLIED  -- use client-side image map --
  ismap       (ismap)        #IMPLIED  -- use server-side image map --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  onselect    %Script;       #IMPLIED  -- some text was selected --
  onchange    %Script;       #IMPLIED  -- the element value was changed --
  accept      %ContentTypes; #IMPLIED  -- list of MIME types for file upload --
  %reserved;                           -- reserved for possible future use --
  >

<!!ELEMENT SELECT - - (OPTGROUP|OPTION)+ -- option selector -->
<!!ATTLIST SELECT
  %attrs;                              -- %coreattrs, %i18n, %events --
  name        CDATA          #IMPLIED  -- field name --
  size        NUMBER         #IMPLIED  -- rows visible --
  multiple    (multiple)     #IMPLIED  -- default is single selection --
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  onchange    %Script;       #IMPLIED  -- the element value was changed --
  %reserved;                           -- reserved for possible future use --
  >

<!!ELEMENT OPTGROUP - - (OPTION)+ -- option group -->
<!!ATTLIST OPTGROUP
  %attrs;                              -- %coreattrs, %i18n, %events --
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  label       %Text;         #REQUIRED -- for use in hierarchical menus --
  >

<!!ELEMENT OPTION - O (#PCDATA)         -- selectable choice -->
<!!ATTLIST OPTION
  %attrs;                              -- %coreattrs, %i18n, %events --
  selected    (selected)     #IMPLIED
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  label       %Text;         #IMPLIED  -- for use in hierarchical menus --
  value       CDATA          #IMPLIED  -- defaults to element content --
  >

<!!ELEMENT TEXTAREA - - (#PCDATA)       -- multi-line text field -->
<!!ATTLIST TEXTAREA
  %attrs;                              -- %coreattrs, %i18n, %events --
  name        CDATA          #IMPLIED
  rows        NUMBER         #REQUIRED
  cols        NUMBER         #REQUIRED
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  readonly    (readonly)     #IMPLIED
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  onselect    %Script;       #IMPLIED  -- some text was selected --
  onchange    %Script;       #IMPLIED  -- the element value was changed --
  %reserved;                           -- reserved for possible future use --
  >

<!!--
  #PCDATA is to solve the mixed content problem,
  per specification only whitespace is allowed there!!
 -->
<!!ELEMENT FIELDSET - - (#PCDATA,LEGEND,(%flow;)*) -- form control group -->
<!!ATTLIST FIELDSET
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT LEGEND - - (%inline;)*       -- fieldset legend -->

<!!ATTLIST LEGEND
  %attrs;                              -- %coreattrs, %i18n, %events --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  >

<!!ELEMENT BUTTON - -
     (%flow;)* -(A|%formctrl;|FORM|FIELDSET)
     -- push button -->
<!!ATTLIST BUTTON
  %attrs;                              -- %coreattrs, %i18n, %events --
  name        CDATA          #IMPLIED
  value       CDATA          #IMPLIED  -- sent to server when submitted --
  type        (button|submit|reset) submit -- for use as form button --
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  %reserved;                           -- reserved for possible future use --
  >

<!!--======================= Tables =======================================-->

<!!-- IETF HTML table standard, see [RFC1942] -->

<!!--
 The BORDER attribute sets the thickness of the frame around the
 table. The default units are screen pixels.

 The FRAME attribute specifies which parts of the frame around
 the table should be rendered. The values are not the same as
 CALS to avoid a name clash with the VALIGN attribute.

 The value "border" is included for backwards compatibility with
 <TABLE BORDER> which yields frame=border and border=implied
 For <TABLE BORDER=1> you get border=1 and frame=implied. In this
 case, it is appropriate to treat this as frame=border for backwards
 compatibility with deployed browsers.
-->
<!!ENTITY % TFrame "(void|above|below|hsides|lhs|rhs|vsides|box|border)">

<!!--
 The RULES attribute defines which rules to draw between cells:

 If RULES is absent then assume:
     "none" if BORDER is absent or BORDER=0 otherwise "all"
-->

<!!ENTITY % TRules "(none | groups | rows | cols | all)">
  
<!!-- horizontal placement of table relative to document -->
<!!ENTITY % TAlign "(left|center|right)">

<!!-- horizontal alignment attributes for cell contents -->
<!!ENTITY % cellhalign
  "align      (left|center|right|justify|char) #IMPLIED
   char       %Character;    #IMPLIED  -- alignment char, e.g. char='':'' --
   charoff    %Length;       #IMPLIED  -- offset for alignment char --"
  >

<!!-- vertical alignment attributes for cell contents -->
<!!ENTITY % cellvalign
  "valign     (top|middle|bottom|baseline) #IMPLIED"
  >

<!!ELEMENT TABLE - -
     (CAPTION?, (COL*|COLGROUP*), THEAD?, TFOOT?, (TBODY|TR+))>
<!!ELEMENT CAPTION  - - (%inline;)*     -- table caption -->
<!!ELEMENT THEAD    - O (TR)+           -- table header -->
<!!ELEMENT TFOOT    - O (TR)+           -- table footer -->
<!!ELEMENT TBODY    O O (TR)+           -- table body -->
<!!ELEMENT COLGROUP - O (COL)*          -- table column group -->
<!!ELEMENT COL      - O EMPTY           -- table column -->
<!!ELEMENT TR       - O (TH|TD)+        -- table row -->
<!!ELEMENT (TH|TD)  - O (%flow;)*       -- table header cell, table data cell-->

<!!ATTLIST TABLE                        -- table element --
  %attrs;                              -- %coreattrs, %i18n, %events --
  summary     %Text;         #IMPLIED  -- purpose/structure for speech output--
  width       %Length;       #IMPLIED  -- table width --
  border      %Pixels;       #IMPLIED  -- controls frame width around table --
  frame       %TFrame;       #IMPLIED  -- which parts of frame to render --
  rules       %TRules;       #IMPLIED  -- rulings between rows and cols --
  cellspacing %Length;       #IMPLIED  -- spacing between cells --
  cellpadding %Length;       #IMPLIED  -- spacing within cells --
  %reserved;                           -- reserved for possible future use --
  datapagesize CDATA         #IMPLIED  -- reserved for possible future use --
  >


<!!ATTLIST CAPTION
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--
COLGROUP groups a set of COL elements. It allows you to group
several semantically related columns together.
-->
<!!ATTLIST COLGROUP
  %attrs;                              -- %coreattrs, %i18n, %events --
  span        NUMBER         1         -- default number of columns in group --
  width       %MultiLength;  #IMPLIED  -- default width for enclosed COLs --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  >

<!!--
 COL elements define the alignment properties for cells in
 one or more columns.

 The WIDTH attribute specifies the width of the columns, e.g.

     width=64        width in screen pixels
     width=0.5*      relative width of 0.5

 The SPAN attribute causes the attributes of one
 COL element to apply to more than one column.
-->
<!!ATTLIST COL                          -- column groups and properties --
  %attrs;                              -- %coreattrs, %i18n, %events --
  span        NUMBER         1         -- COL attributes affect N columns --
  width       %MultiLength;  #IMPLIED  -- column width specification --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  >

<!!--
    Use THEAD to duplicate headers when breaking table
    across page boundaries, or for static headers when
    TBODY sections are rendered in scrolling panel.

    Use TFOOT to duplicate footers when breaking table
    across page boundaries, or for static footers when
    TBODY sections are rendered in scrolling panel.

    Use multiple TBODY sections when rules are needed
    between groups of table rows.
-->
<!!ATTLIST (THEAD|TBODY|TFOOT)          -- table section --
  %attrs;                              -- %coreattrs, %i18n, %events --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  >

<!!ATTLIST TR                           -- table row --
  %attrs;                              -- %coreattrs, %i18n, %events --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  >


<!!-- Scope is simpler than headers attribute for common tables -->
<!!ENTITY % Scope "(row|col|rowgroup|colgroup)">

<!!-- TH is for headers, TD for data, but for cells acting as both use TD -->
<!!ATTLIST (TH|TD)                      -- header or data cell --
  %attrs;                              -- %coreattrs, %i18n, %events --
  abbr        %Text;         #IMPLIED  -- abbreviation for header cell --
  axis        CDATA          #IMPLIED  -- comma-separated list of related headers--
  headers     IDREFS         #IMPLIED  -- list of id''s for header cells --
  scope       %Scope;        #IMPLIED  -- scope covered by header cells --
  rowspan     NUMBER         1         -- number of rows spanned by cell --
  colspan     NUMBER         1         -- number of cols spanned by cell --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  >


<!!--================ Document Head =======================================-->
<!!-- %head.misc; defined earlier on as "SCRIPT|STYLE|META|LINK|OBJECT" -->
<!!ENTITY % head.content "TITLE & BASE?">

<!!ELEMENT HEAD O O (%head.content;) +(%head.misc;) -- document head -->
<!!ATTLIST HEAD
  %i18n;                               -- lang, dir --
  profile     %URI;          #IMPLIED  -- named dictionary of meta info --
  >

<!!-- The TITLE element is not considered part of the flow of text.
       It should be displayed, for example as the page header or
       window title. Exactly one title is required per document.
    -->
<!!ELEMENT TITLE - - (#PCDATA) -(%head.misc;) -- document title -->
<!!ATTLIST TITLE %i18n>


<!!ELEMENT BASE - O EMPTY               -- document base URI -->
<!!ATTLIST BASE
  href        %URI;          #REQUIRED -- URI that acts as base URI --
  >

<!!ELEMENT META - O EMPTY               -- generic metainformation -->
<!!ATTLIST META
  %i18n;                               -- lang, dir, for use with content --
  http-equiv  NAME           #IMPLIED  -- HTTP response header name  --
  name        NAME           #IMPLIED  -- metainformation name --
  content     CDATA          #REQUIRED -- associated information --
  scheme      CDATA          #IMPLIED  -- select form of content --
  >

<!!ELEMENT STYLE - - %StyleSheet        -- style info -->
<!!ATTLIST STYLE
  %i18n;                               -- lang, dir, for use with title --
  type        %ContentType;  #REQUIRED -- content type of style language --
  media       %MediaDesc;    #IMPLIED  -- designed for use with these media --
  title       %Text;         #IMPLIED  -- advisory title --
  >

<!!ELEMENT SCRIPT - - %Script;          -- script statements -->
<!!ATTLIST SCRIPT
  charset     %Charset;      #IMPLIED  -- char encoding of linked resource --
  type        %ContentType;  #REQUIRED -- content type of script language --
  src         %URI;          #IMPLIED  -- URI for an external script --
  defer       (defer)        #IMPLIED  -- UA may defer execution of script --
  event       CDATA          #IMPLIED  -- reserved for possible future use --
  for         %URI;          #IMPLIED  -- reserved for possible future use --
  >

<!!ELEMENT NOSCRIPT - - (%block;)+
  -- alternate content container for non script-based rendering -->
<!!ATTLIST NOSCRIPT
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--================ Document Structure ==================================-->
<!!ENTITY % html.content "HEAD, FRAMESET">

<!!ELEMENT HTML O O (%html.content;)    -- document root element -->
<!!ATTLIST HTML
  %i18n;                               -- lang, dir --
  >
'! !

!Html401Frameset methodsFor: 'as yet unclassified' stamp: 'tb 12/19/2005 21:50'!
initialize

	super initialize.
	self parse.! !

HtmlDTD subclass: #Html401Strict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!Html401Strict class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 09:54'!
defaultUrl

	^'http://www.w3.org/TR/REC-html40/strict.dtd' asUrl! !

!Html401Strict class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 09:32'!
docType

	^'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">'! !

!Html401Strict methodsFor: 'resources' stamp: 'tb 1/14/2006 12:41'!
dtd
	^ '<!!--
    This is HTML 4.01 Strict DTD, which excludes the presentation 
    attributes and elements that W3C expects to phase out as 
    support for style sheets matures. Authors should use the Strict
    DTD when possible, but may use the Transitional DTD when support
    for presentation attribute and elements is required.
    
    HTML 4 includes mechanisms for style sheets, scripting,
    embedding objects, improved support for right to left and mixed
    direction text, and enhancements to forms for improved
    accessibility for people with disabilities.

          Draft: $Date: 1999/12/24 23:37:48 $

          Authors:
              Dave Raggett <dsr@w3.org>
              Arnaud Le Hors <lehors@w3.org>
              Ian Jacobs <ij@w3.org>

    Further information about HTML 4.01 is available at:

        http://www.w3.org/TR/1999/REC-html401-19991224


    The HTML 4.01 specification includes additional
    syntactic constraints that cannot be expressed within
    the DTDs.

-->
<!!--
    Typical usage:

    <!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
            "http://www.w3.org/TR/html4/strict.dtd">
    <html>
    <head>
    ...
    </head>
    <body>
    ...
    </body>
    </html>

    The URI used as a system identifier with the public identifier allows
    the user agent to download the DTD and entity sets as needed.

    The FPI for the Transitional HTML 4.01 DTD is:

        "-//W3C//DTD HTML 4.01 Transitional//EN"

    This version of the transitional DTD is:

        http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd

    If you are writing a document that includes frames, use 
    the following FPI:

        "-//W3C//DTD HTML 4.01 Frameset//EN"

    This version of the frameset DTD is:

        http://www.w3.org/TR/1999/REC-html401-19991224/frameset.dtd

    Use the following (relative) URIs to refer to 
    the DTDs and entity definitions of this specification:

    "strict.dtd"
    "loose.dtd"
    "frameset.dtd"
    "HTMLlat1.ent"
    "HTMLsymbol.ent"
    "HTMLspecial.ent"

-->

<!!--================== Imported Names ====================================-->
<!!-- Feature Switch for frameset documents -->
<!!ENTITY % HTML.Frameset "IGNORE">

<!!ENTITY % ContentType "CDATA"
    -- media type, as per [RFC2045]
    -->

<!!ENTITY % ContentTypes "CDATA"
    -- comma-separated list of media types, as per [RFC2045]
    -->

<!!ENTITY % Charset "CDATA"
    -- a character encoding, as per [RFC2045]
    -->

<!!ENTITY % Charsets "CDATA"
    -- a space-separated list of character encodings, as per [RFC2045]
    -->

<!!ENTITY % LanguageCode "NAME"
    -- a language code, as per [RFC1766]
    -->

<!!ENTITY % Character "CDATA"
    -- a single character from [ISO10646] 
    -->

<!!ENTITY % LinkTypes "CDATA"
    -- space-separated list of link types
    -->

<!!ENTITY % MediaDesc "CDATA"
    -- single or comma-separated list of media descriptors
    -->

<!!ENTITY % URI "CDATA"
    -- a Uniform Resource Identifier,
       see [URI]
    -->

<!!ENTITY % Datetime "CDATA" -- date and time information. ISO date format -->


<!!ENTITY % Script "CDATA" -- script expression -->

<!!ENTITY % StyleSheet "CDATA" -- style sheet data -->



<!!ENTITY % Text "CDATA">


<!!-- Parameter Entities -->

<!!ENTITY % head.misc "SCRIPT|STYLE|META|LINK|OBJECT" -- repeatable head elements -->

<!!ENTITY % heading "H1|H2|H3|H4|H5|H6">

<!!ENTITY % list "UL | OL">

<!!ENTITY % preformatted "PRE">


<!!--================ Character mnemonic entities =========================-->

<!!ENTITY % HTMLlat1 PUBLIC
   "-//W3C//ENTITIES Latin1//EN//HTML"
   "HTMLlat1.ent">
%HTMLlat1;

<!!ENTITY % HTMLsymbol PUBLIC
   "-//W3C//ENTITIES Symbols//EN//HTML"
   "HTMLsymbol.ent">
%HTMLsymbol;

<!!ENTITY % HTMLspecial PUBLIC
   "-//W3C//ENTITIES Special//EN//HTML"
   "HTMLspecial.ent">
%HTMLspecial;
<!!--=================== Generic Attributes ===============================-->

<!!ENTITY % coreattrs
 "id          ID             #IMPLIED  -- document-wide unique id --
  class       CDATA          #IMPLIED  -- space-separated list of classes --
  style       %StyleSheet;   #IMPLIED  -- associated style info --
  title       %Text;         #IMPLIED  -- advisory title --"
  >

<!!ENTITY % i18n
 "lang        %LanguageCode; #IMPLIED  -- language code --
  dir         (ltr|rtl)      #IMPLIED  -- direction for weak/neutral text --"
  >

<!!ENTITY % events
 "onclick     %Script;       #IMPLIED  -- a pointer button was clicked --
  ondblclick  %Script;       #IMPLIED  -- a pointer button was double clicked--
  onmousedown %Script;       #IMPLIED  -- a pointer button was pressed down --
  onmouseup   %Script;       #IMPLIED  -- a pointer button was released --
  onmouseover %Script;       #IMPLIED  -- a pointer was moved onto --
  onmousemove %Script;       #IMPLIED  -- a pointer was moved within --
  onmouseout  %Script;       #IMPLIED  -- a pointer was moved away --
  onkeypress  %Script;       #IMPLIED  -- a key was pressed and released --
  onkeydown   %Script;       #IMPLIED  -- a key was pressed down --
  onkeyup     %Script;       #IMPLIED  -- a key was released --"
  >

<!!-- Reserved Feature Switch -->
<!!ENTITY % HTML.Reserved "IGNORE">

<!!-- The following attributes are reserved for possible future use -->
<!![ %HTML.Reserved; [
<!!ENTITY % reserved
 "datasrc     %URI;          #IMPLIED  -- a single or tabular Data Source --
  datafld     CDATA          #IMPLIED  -- the property or column name --
  dataformatas (plaintext|html) plaintext -- text or html --"
  >
]]>

<!!ENTITY % reserved "">

<!!ENTITY % attrs "%coreattrs; %i18n; %events;">


<!!--=================== Text Markup ======================================-->

<!!ENTITY % fontstyle
 "TT | I | B | BIG | SMALL">

<!!ENTITY % phrase "EM | STRONG | DFN | CODE |
                   SAMP | KBD | VAR | CITE | ABBR | ACRONYM" >

<!!ENTITY % special
   "A | IMG | OBJECT | BR | SCRIPT | MAP | Q | SUB | SUP | SPAN | BDO">

<!!ENTITY % formctrl "INPUT | SELECT | TEXTAREA | LABEL | BUTTON">

<!!-- %inline; covers inline or "text-level" elements -->
<!!ENTITY % inline "#PCDATA | %fontstyle; | %phrase; | %special; | %formctrl;">

<!!ELEMENT (%fontstyle;|%phrase;) - - (%inline;)*>
<!!ATTLIST (%fontstyle;|%phrase;)
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT (SUB|SUP) - - (%inline;)*    -- subscript, superscript -->
<!!ATTLIST (SUB|SUP)
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT SPAN - - (%inline;)*         -- generic language/style container -->
<!!ATTLIST SPAN
  %attrs;                              -- %coreattrs, %i18n, %events --
  %reserved;			       -- reserved for possible future use --
  >

<!!ELEMENT BDO - - (%inline;)*          -- I18N BiDi over-ride -->
<!!ATTLIST BDO
  %coreattrs;                          -- id, class, style, title --
  lang        %LanguageCode; #IMPLIED  -- language code --
  dir         (ltr|rtl)      #REQUIRED -- directionality --
  >


<!!ELEMENT BR - O EMPTY                 -- forced line break -->
<!!ATTLIST BR
  %coreattrs;                          -- id, class, style, title --
  >

<!!--================== HTML content models ===============================-->

<!!--
    HTML has two basic content models:

        %inline;     character level elements and text strings
        %block;      block-like elements e.g. paragraphs and lists
-->

<!!ENTITY % block
     "P | %heading; | %list; | %preformatted; | DL | DIV | NOSCRIPT |
      BLOCKQUOTE | FORM | HR | TABLE | FIELDSET | ADDRESS">

<!!ENTITY % flow "%block; | %inline;">

<!!--=================== Document Body ====================================-->

<!!ELEMENT BODY O O (%block;|SCRIPT)+ +(INS|DEL) -- document body -->
<!!ATTLIST BODY
  %attrs;                              -- %coreattrs, %i18n, %events --
  onload          %Script;   #IMPLIED  -- the document has been loaded --
  onunload        %Script;   #IMPLIED  -- the document has been removed --
  >

<!!ELEMENT ADDRESS - - (%inline;)* -- information on author -->
<!!ATTLIST ADDRESS
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT DIV - - (%flow;)*            -- generic language/style container -->
<!!ATTLIST DIV
  %attrs;                              -- %coreattrs, %i18n, %events --
  %reserved;                           -- reserved for possible future use --
  >


<!!--================== The Anchor Element ================================-->

<!!ENTITY % Shape "(rect|circle|poly|default)">
<!!ENTITY % Coords "CDATA" -- comma-separated list of lengths -->

<!!ELEMENT A - - (%inline;)* -(A)       -- anchor -->
<!!ATTLIST A
  %attrs;                              -- %coreattrs, %i18n, %events --
  charset     %Charset;      #IMPLIED  -- char encoding of linked resource --
  type        %ContentType;  #IMPLIED  -- advisory content type --
  name        CDATA          #IMPLIED  -- named link end --
  href        %URI;          #IMPLIED  -- URI for linked resource --
  hreflang    %LanguageCode; #IMPLIED  -- language code --
  rel         %LinkTypes;    #IMPLIED  -- forward link types --
  rev         %LinkTypes;    #IMPLIED  -- reverse link types --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  shape       %Shape;        rect      -- for use with client-side image maps --
  coords      %Coords;       #IMPLIED  -- for use with client-side image maps --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  >

<!!--================== Client-side image maps ============================-->

<!!-- These can be placed in the same document or grouped in a
     separate document although this isn''t yet widely supported -->

<!!ELEMENT MAP - - ((%block;) | AREA)+ -- client-side image map -->
<!!ATTLIST MAP
  %attrs;                              -- %coreattrs, %i18n, %events --
  name        CDATA          #REQUIRED -- for reference by usemap --
  >

<!!ELEMENT AREA - O EMPTY               -- client-side image map area -->
<!!ATTLIST AREA
  %attrs;                              -- %coreattrs, %i18n, %events --
  shape       %Shape;        rect      -- controls interpretation of coords --
  coords      %Coords;       #IMPLIED  -- comma-separated list of lengths --
  href        %URI;          #IMPLIED  -- URI for linked resource --
  nohref      (nohref)       #IMPLIED  -- this region has no action --
  alt         %Text;         #REQUIRED -- short description --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  >

<!!--================== The LINK Element ==================================-->

<!!--
  Relationship values can be used in principle:

   a) for document specific toolbars/menus when used
      with the LINK element in document head e.g.
        start, contents, previous, next, index, end, help
   b) to link to a separate style sheet (rel=stylesheet)
   c) to make a link to a script (rel=script)
   d) by stylesheets to control how collections of
      html nodes are rendered into printed documents
   e) to make a link to a printable version of this document
      e.g. a postscript or pdf version (rel=alternate media=print)
-->

<!!ELEMENT LINK - O EMPTY               -- a media-independent link -->
<!!ATTLIST LINK
  %attrs;                              -- %coreattrs, %i18n, %events --
  charset     %Charset;      #IMPLIED  -- char encoding of linked resource --
  href        %URI;          #IMPLIED  -- URI for linked resource --
  hreflang    %LanguageCode; #IMPLIED  -- language code --
  type        %ContentType;  #IMPLIED  -- advisory content type --
  rel         %LinkTypes;    #IMPLIED  -- forward link types --
  rev         %LinkTypes;    #IMPLIED  -- reverse link types --
  media       %MediaDesc;    #IMPLIED  -- for rendering on these media --
  >

<!!--=================== Images ===========================================-->

<!!-- Length defined in strict DTD for cellpadding/cellspacing -->
<!!ENTITY % Length "CDATA" -- nn for pixels or nn% for percentage length -->
<!!ENTITY % MultiLength "CDATA" -- pixel, percentage, or relative -->

<!![ %HTML.Frameset; [
<!!ENTITY % MultiLengths "CDATA" -- comma-separated list of MultiLength -->
]]>

<!!ENTITY % Pixels "CDATA" -- integer representing length in pixels -->


<!!-- To avoid problems with text-only UAs as well as 
   to make image content understandable and navigable 
   to users of non-visual UAs, you need to provide
   a description with ALT, and avoid server-side image maps -->
<!!ELEMENT IMG - O EMPTY                -- Embedded image -->
<!!ATTLIST IMG
  %attrs;                              -- %coreattrs, %i18n, %events --
  src         %URI;          #REQUIRED -- URI of image to embed --
  alt         %Text;         #REQUIRED -- short description --
  longdesc    %URI;          #IMPLIED  -- link to long description
                                          (complements alt) --
  name        CDATA          #IMPLIED  -- name of image for scripting --
  height      %Length;       #IMPLIED  -- override height --
  width       %Length;       #IMPLIED  -- override width --
  usemap      %URI;          #IMPLIED  -- use client-side image map --
  ismap       (ismap)        #IMPLIED  -- use server-side image map --
  >

<!!-- USEMAP points to a MAP element which may be in this document
  or an external document, although the latter is not widely supported -->

<!!--==================== OBJECT ======================================-->
<!!--
  OBJECT is used to embed objects as part of HTML pages 
  PARAM elements should precede other content. SGML mixed content
  model technicality precludes specifying this formally ...
-->

<!!ELEMENT OBJECT - - (PARAM | %flow;)*
 -- generic embedded object -->
<!!ATTLIST OBJECT
  %attrs;                              -- %coreattrs, %i18n, %events --
  declare     (declare)      #IMPLIED  -- declare but don''t instantiate flag --
  classid     %URI;          #IMPLIED  -- identifies an implementation --
  codebase    %URI;          #IMPLIED  -- base URI for classid, data, archive--
  data        %URI;          #IMPLIED  -- reference to object''s data --
  type        %ContentType;  #IMPLIED  -- content type for data --
  codetype    %ContentType;  #IMPLIED  -- content type for code --
  archive     CDATA          #IMPLIED  -- space-separated list of URIs --
  standby     %Text;         #IMPLIED  -- message to show while loading --
  height      %Length;       #IMPLIED  -- override height --
  width       %Length;       #IMPLIED  -- override width --
  usemap      %URI;          #IMPLIED  -- use client-side image map --
  name        CDATA          #IMPLIED  -- submit as part of form --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  %reserved;                           -- reserved for possible future use --
  >

<!!ELEMENT PARAM - O EMPTY              -- named property value -->
<!!ATTLIST PARAM
  id          ID             #IMPLIED  -- document-wide unique id --
  name        CDATA          #REQUIRED -- property name --
  value       CDATA          #IMPLIED  -- property value --
  valuetype   (DATA|REF|OBJECT) DATA   -- How to interpret value --
  type        %ContentType;  #IMPLIED  -- content type for value
                                          when valuetype=ref --
  >


<!!--=================== Horizontal Rule ==================================-->

<!!ELEMENT HR - O EMPTY -- horizontal rule -->
<!!ATTLIST HR
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--=================== Paragraphs =======================================-->

<!!ELEMENT P - O (%inline;)*            -- paragraph -->
<!!ATTLIST P
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--=================== Headings =========================================-->

<!!--
  There are six levels of headings from H1 (the most important)
  to H6 (the least important).
-->

<!!ELEMENT (%heading;)  - - (%inline;)* -- heading -->
<!!ATTLIST (%heading;)
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--=================== Preformatted Text ================================-->

<!!-- excludes markup for images and changes in font size -->
<!!ENTITY % pre.exclusion "IMG|OBJECT|BIG|SMALL|SUB|SUP">

<!!ELEMENT PRE - - (%inline;)* -(%pre.exclusion;) -- preformatted text -->
<!!ATTLIST PRE
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--===================== Inline Quotes ==================================-->

<!!ELEMENT Q - - (%inline;)*            -- short inline quotation -->
<!!ATTLIST Q
  %attrs;                              -- %coreattrs, %i18n, %events --
  cite        %URI;          #IMPLIED  -- URI for source document or msg --
  >

<!!--=================== Block-like Quotes ================================-->

<!!ELEMENT BLOCKQUOTE - - (%block;|SCRIPT)+ -- long quotation -->
<!!ATTLIST BLOCKQUOTE
  %attrs;                              -- %coreattrs, %i18n, %events --
  cite        %URI;          #IMPLIED  -- URI for source document or msg --
  >

<!!--=================== Inserted/Deleted Text ============================-->


<!!-- INS/DEL are handled by inclusion on BODY -->
<!!ELEMENT (INS|DEL) - - (%flow;)*      -- inserted text, deleted text -->
<!!ATTLIST (INS|DEL)
  %attrs;                              -- %coreattrs, %i18n, %events --
  cite        %URI;          #IMPLIED  -- info on reason for change --
  datetime    %Datetime;     #IMPLIED  -- date and time of change --
  >

<!!--=================== Lists ============================================-->

<!!-- definition lists - DT for term, DD for its definition -->

<!!ELEMENT DL - - (DT|DD)+              -- definition list -->
<!!ATTLIST DL
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT DT - O (%inline;)*           -- definition term -->
<!!ELEMENT DD - O (%flow;)*             -- definition description -->
<!!ATTLIST (DT|DD)
  %attrs;                              -- %coreattrs, %i18n, %events --
  >


<!!ELEMENT OL - - (LI)+                 -- ordered list -->
<!!ATTLIST OL
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!-- Unordered Lists (UL) bullet styles -->
<!!ELEMENT UL - - (LI)+                 -- unordered list -->
<!!ATTLIST UL
  %attrs;                              -- %coreattrs, %i18n, %events --
  >



<!!ELEMENT LI - O (%flow;)*             -- list item -->
<!!ATTLIST LI
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--================ Forms ===============================================-->
<!!ELEMENT FORM - - (%block;|SCRIPT)+ -(FORM) -- interactive form -->
<!!ATTLIST FORM
  %attrs;                              -- %coreattrs, %i18n, %events --
  action      %URI;          #REQUIRED -- server-side form handler --
  method      (get|post)     GET       -- HTTP method used to submit the form--
  enctype     %ContentType;  "application/x-www-form-urlencoded"
  accept      %ContentTypes; #IMPLIED  -- list of MIME types for file upload --
  name        CDATA          #IMPLIED  -- name of form for scripting --
  onsubmit    %Script;       #IMPLIED  -- the form was submitted --
  onreset     %Script;       #IMPLIED  -- the form was reset --
  accept-charset %Charsets;  #IMPLIED  -- list of supported charsets --
  >

<!!-- Each label must not contain more than ONE field -->
<!!ELEMENT LABEL - - (%inline;)* -(LABEL) -- form field label text -->
<!!ATTLIST LABEL
  %attrs;                              -- %coreattrs, %i18n, %events --
  for         IDREF          #IMPLIED  -- matches field ID value --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  >

<!!ENTITY % InputType
  "(text | password | checkbox |
    radio | submit | reset |
    file | hidden | image | button)"
   >

<!!-- attribute name required for all but submit and reset -->
<!!ELEMENT INPUT - O EMPTY              -- form control -->
<!!ATTLIST INPUT
  %attrs;                              -- %coreattrs, %i18n, %events --
  type        %InputType;    TEXT      -- what kind of widget is needed --
  name        CDATA          #IMPLIED  -- submit as part of form --
  value       CDATA          #IMPLIED  -- Specify for radio buttons and checkboxes --
  checked     (checked)      #IMPLIED  -- for radio buttons and check boxes --
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  readonly    (readonly)     #IMPLIED  -- for text and passwd --
  size        CDATA          #IMPLIED  -- specific to each type of field --
  maxlength   NUMBER         #IMPLIED  -- max chars for text fields --
  src         %URI;          #IMPLIED  -- for fields with images --
  alt         CDATA          #IMPLIED  -- short description --
  usemap      %URI;          #IMPLIED  -- use client-side image map --
  ismap       (ismap)        #IMPLIED  -- use server-side image map --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  onselect    %Script;       #IMPLIED  -- some text was selected --
  onchange    %Script;       #IMPLIED  -- the element value was changed --
  accept      %ContentTypes; #IMPLIED  -- list of MIME types for file upload --
  %reserved;                           -- reserved for possible future use --
  >

<!!ELEMENT SELECT - - (OPTGROUP|OPTION)+ -- option selector -->
<!!ATTLIST SELECT
  %attrs;                              -- %coreattrs, %i18n, %events --
  name        CDATA          #IMPLIED  -- field name --
  size        NUMBER         #IMPLIED  -- rows visible --
  multiple    (multiple)     #IMPLIED  -- default is single selection --
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  onchange    %Script;       #IMPLIED  -- the element value was changed --
  %reserved;                           -- reserved for possible future use --
  >

<!!ELEMENT OPTGROUP - - (OPTION)+ -- option group -->
<!!ATTLIST OPTGROUP
  %attrs;                              -- %coreattrs, %i18n, %events --
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  label       %Text;         #REQUIRED -- for use in hierarchical menus --
  >

<!!ELEMENT OPTION - O (#PCDATA)         -- selectable choice -->
<!!ATTLIST OPTION
  %attrs;                              -- %coreattrs, %i18n, %events --
  selected    (selected)     #IMPLIED
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  label       %Text;         #IMPLIED  -- for use in hierarchical menus --
  value       CDATA          #IMPLIED  -- defaults to element content --
  >

<!!ELEMENT TEXTAREA - - (#PCDATA)       -- multi-line text field -->
<!!ATTLIST TEXTAREA
  %attrs;                              -- %coreattrs, %i18n, %events --
  name        CDATA          #IMPLIED
  rows        NUMBER         #REQUIRED
  cols        NUMBER         #REQUIRED
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  readonly    (readonly)     #IMPLIED
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  onselect    %Script;       #IMPLIED  -- some text was selected --
  onchange    %Script;       #IMPLIED  -- the element value was changed --
  %reserved;                           -- reserved for possible future use --
  >

<!!--
  #PCDATA is to solve the mixed content problem,
  per specification only whitespace is allowed there!!
 -->
<!!ELEMENT FIELDSET - - (#PCDATA,LEGEND,(%flow;)*) -- form control group -->
<!!ATTLIST FIELDSET
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT LEGEND - - (%inline;)*       -- fieldset legend -->

<!!ATTLIST LEGEND
  %attrs;                              -- %coreattrs, %i18n, %events --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  >

<!!ELEMENT BUTTON - -
     (%flow;)* -(A|%formctrl;|FORM|FIELDSET)
     -- push button -->
<!!ATTLIST BUTTON
  %attrs;                              -- %coreattrs, %i18n, %events --
  name        CDATA          #IMPLIED
  value       CDATA          #IMPLIED  -- sent to server when submitted --
  type        (button|submit|reset) submit -- for use as form button --
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  %reserved;                           -- reserved for possible future use --
  >

<!!--======================= Tables =======================================-->

<!!-- IETF HTML table standard, see [RFC1942] -->

<!!--
 The BORDER attribute sets the thickness of the frame around the
 table. The default units are screen pixels.

 The FRAME attribute specifies which parts of the frame around
 the table should be rendered. The values are not the same as
 CALS to avoid a name clash with the VALIGN attribute.

 The value "border" is included for backwards compatibility with
 <TABLE BORDER> which yields frame=border and border=implied
 For <TABLE BORDER=1> you get border=1 and frame=implied. In this
 case, it is appropriate to treat this as frame=border for backwards
 compatibility with deployed browsers.
-->
<!!ENTITY % TFrame "(void|above|below|hsides|lhs|rhs|vsides|box|border)">

<!!--
 The RULES attribute defines which rules to draw between cells:

 If RULES is absent then assume:
     "none" if BORDER is absent or BORDER=0 otherwise "all"
-->

<!!ENTITY % TRules "(none | groups | rows | cols | all)">
  
<!!-- horizontal placement of table relative to document -->
<!!ENTITY % TAlign "(left|center|right)">

<!!-- horizontal alignment attributes for cell contents -->
<!!ENTITY % cellhalign
  "align      (left|center|right|justify|char) #IMPLIED
   char       %Character;    #IMPLIED  -- alignment char, e.g. char='':'' --
   charoff    %Length;       #IMPLIED  -- offset for alignment char --"
  >

<!!-- vertical alignment attributes for cell contents -->
<!!ENTITY % cellvalign
  "valign     (top|middle|bottom|baseline) #IMPLIED"
  >

<!!ELEMENT TABLE - -
     (CAPTION?, (COL*|COLGROUP*), THEAD?, TFOOT?, (TBODY|TR+))>
<!!ELEMENT CAPTION  - - (%inline;)*     -- table caption -->
<!!ELEMENT THEAD    - O (TR)+           -- table header -->
<!!ELEMENT TFOOT    - O (TR)+           -- table footer -->
<!!ELEMENT TBODY    O O (TR)+           -- table body -->
<!!ELEMENT COLGROUP - O (COL)*          -- table column group -->
<!!ELEMENT COL      - O EMPTY           -- table column -->
<!!ELEMENT TR       - O (TH|TD)+        -- table row -->
<!!ELEMENT (TH|TD)  - O (%flow;)*       -- table header cell, table data cell-->

<!!ATTLIST TABLE                        -- table element --
  %attrs;                              -- %coreattrs, %i18n, %events --
  summary     %Text;         #IMPLIED  -- purpose/structure for speech output--
  width       %Length;       #IMPLIED  -- table width --
  border      %Pixels;       #IMPLIED  -- controls frame width around table --
  frame       %TFrame;       #IMPLIED  -- which parts of frame to render --
  rules       %TRules;       #IMPLIED  -- rulings between rows and cols --
  cellspacing %Length;       #IMPLIED  -- spacing between cells --
  cellpadding %Length;       #IMPLIED  -- spacing within cells --
  %reserved;                           -- reserved for possible future use --
  datapagesize CDATA         #IMPLIED  -- reserved for possible future use --
  >


<!!ATTLIST CAPTION
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--
COLGROUP groups a set of COL elements. It allows you to group
several semantically related columns together.
-->
<!!ATTLIST COLGROUP
  %attrs;                              -- %coreattrs, %i18n, %events --
  span        NUMBER         1         -- default number of columns in group --
  width       %MultiLength;  #IMPLIED  -- default width for enclosed COLs --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  >

<!!--
 COL elements define the alignment properties for cells in
 one or more columns.

 The WIDTH attribute specifies the width of the columns, e.g.

     width=64        width in screen pixels
     width=0.5*      relative width of 0.5

 The SPAN attribute causes the attributes of one
 COL element to apply to more than one column.
-->
<!!ATTLIST COL                          -- column groups and properties --
  %attrs;                              -- %coreattrs, %i18n, %events --
  span        NUMBER         1         -- COL attributes affect N columns --
  width       %MultiLength;  #IMPLIED  -- column width specification --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  >

<!!--
    Use THEAD to duplicate headers when breaking table
    across page boundaries, or for static headers when
    TBODY sections are rendered in scrolling panel.

    Use TFOOT to duplicate footers when breaking table
    across page boundaries, or for static footers when
    TBODY sections are rendered in scrolling panel.

    Use multiple TBODY sections when rules are needed
    between groups of table rows.
-->
<!!ATTLIST (THEAD|TBODY|TFOOT)          -- table section --
  %attrs;                              -- %coreattrs, %i18n, %events --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  >

<!!ATTLIST TR                           -- table row --
  %attrs;                              -- %coreattrs, %i18n, %events --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  >


<!!-- Scope is simpler than headers attribute for common tables -->
<!!ENTITY % Scope "(row|col|rowgroup|colgroup)">

<!!-- TH is for headers, TD for data, but for cells acting as both use TD -->
<!!ATTLIST (TH|TD)                      -- header or data cell --
  %attrs;                              -- %coreattrs, %i18n, %events --
  abbr        %Text;         #IMPLIED  -- abbreviation for header cell --
  axis        CDATA          #IMPLIED  -- comma-separated list of related headers--
  headers     IDREFS         #IMPLIED  -- list of id''s for header cells --
  scope       %Scope;        #IMPLIED  -- scope covered by header cells --
  rowspan     NUMBER         1         -- number of rows spanned by cell --
  colspan     NUMBER         1         -- number of cols spanned by cell --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  >


<!!--================ Document Head =======================================-->
<!!-- %head.misc; defined earlier on as "SCRIPT|STYLE|META|LINK|OBJECT" -->
<!!ENTITY % head.content "TITLE & BASE?">

<!!ELEMENT HEAD O O (%head.content;) +(%head.misc;) -- document head -->
<!!ATTLIST HEAD
  %i18n;                               -- lang, dir --
  profile     %URI;          #IMPLIED  -- named dictionary of meta info --
  >

<!!-- The TITLE element is not considered part of the flow of text.
       It should be displayed, for example as the page header or
       window title. Exactly one title is required per document.
    -->
<!!ELEMENT TITLE - - (#PCDATA) -(%head.misc;) -- document title -->
<!!ATTLIST TITLE %i18n>


<!!ELEMENT BASE - O EMPTY               -- document base URI -->
<!!ATTLIST BASE
  href        %URI;          #REQUIRED -- URI that acts as base URI --
  >

<!!ELEMENT META - O EMPTY               -- generic metainformation -->
<!!ATTLIST META
  %i18n;                               -- lang, dir, for use with content --
  http-equiv  NAME           #IMPLIED  -- HTTP response header name  --
  name        NAME           #IMPLIED  -- metainformation name --
  content     CDATA          #REQUIRED -- associated information --
  scheme      CDATA          #IMPLIED  -- select form of content --
  >

<!!ELEMENT STYLE - - %StyleSheet        -- style info -->
<!!ATTLIST STYLE
  %i18n;                               -- lang, dir, for use with title --
  type        %ContentType;  #REQUIRED -- content type of style language --
  media       %MediaDesc;    #IMPLIED  -- designed for use with these media --
  title       %Text;         #IMPLIED  -- advisory title --
  >

<!!ELEMENT SCRIPT - - %Script;          -- script statements -->
<!!ATTLIST SCRIPT
  charset     %Charset;      #IMPLIED  -- char encoding of linked resource --
  type        %ContentType;  #REQUIRED -- content type of script language --
  src         %URI;          #IMPLIED  -- URI for an external script --
  defer       (defer)        #IMPLIED  -- UA may defer execution of script --
  event       CDATA          #IMPLIED  -- reserved for possible future use --
  for         %URI;          #IMPLIED  -- reserved for possible future use --
  >

<!!ELEMENT NOSCRIPT - - (%block;)+
  -- alternate content container for non script-based rendering -->
<!!ATTLIST NOSCRIPT
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--================ Document Structure ==================================-->
<!!ENTITY % html.content "HEAD, BODY">

<!!ELEMENT HTML O O (%html.content;)    -- document root element -->
<!!ATTLIST HTML
  %i18n;                               -- lang, dir --
  >
'! !

!Html401Strict methodsFor: 'initialize-release' stamp: 'tb 11/30/2005 22:56'!
initialize

	super initialize.
	self parse.! !

HtmlDTD subclass: #Html401Transitional
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!Html401Transitional class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 09:54'!
defaultUrl

	^'http://www.w3.org/TR/html4/loose.dtd' asUrl! !

!Html401Transitional class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 09:35'!
docType

	^'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">'! !

!Html401Transitional methodsFor: 'resources' stamp: 'tb 1/14/2006 12:39'!
dtd
	^ '<!!--
    This is the HTML 4.01 Transitional DTD, which includes
    presentation attributes and elements that W3C expects to phase out
    as support for style sheets matures. Authors should use the Strict
    DTD when possible, but may use the Transitional DTD when support
    for presentation attribute and elements is required.

    HTML 4 includes mechanisms for style sheets, scripting,
    embedding objects, improved support for right to left and mixed
    direction text, and enhancements to forms for improved
    accessibility for people with disabilities.

          Draft: $Date: 1999/12/24 23:37:48 $

          Authors:
              Dave Raggett <dsr@w3.org>
              Arnaud Le Hors <lehors@w3.org>
              Ian Jacobs <ij@w3.org>

    Further information about HTML 4.01 is available at:

        http://www.w3.org/TR/1999/REC-html401-19991224


    The HTML 4.01 specification includes additional
    syntactic constraints that cannot be expressed within
    the DTDs.

-->
<!!ENTITY % HTML.Version "-//W3C//DTD HTML 4.01 Transitional//EN"
>  <!!-- Typical usage:

    <!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
    <html>
    <head>
    ...
    </head>
    <body>
    ...
    </body>
    </html>

    The URI used as a system identifier with the public identifier allows
    the user agent to download the DTD and entity sets as needed.

    The FPI for the Strict HTML 4.01 DTD is:

        "-//W3C//DTD HTML 4.01//EN"

    This version of the strict DTD is:

        http://www.w3.org/TR/1999/REC-html401-19991224/strict.dtd

    Authors should use the Strict DTD unless they need the
    presentation control for user agents that don''t (adequately)
    support style sheets.

    If you are writing a document that includes frames, use 
    the following FPI:

        "-//W3C//DTD HTML 4.01 Frameset//EN"

    This version of the frameset DTD is:

        http://www.w3.org/TR/1999/REC-html401-19991224/frameset.dtd

    Use the following (relative) URIs to refer to 
    the DTDs and entity definitions of this specification:

    "strict.dtd"
    "loose.dtd"
    "frameset.dtd"
    "HTMLlat1.ent"
    "HTMLsymbol.ent"
    "HTMLspecial.ent"

-->

<!!--================== Imported Names ====================================-->
<!!-- Feature Switch for frameset documents -->
<!!ENTITY % HTML.Frameset "IGNORE">

<!!ENTITY % ContentType "CDATA"
    -- media type, as per [RFC2045]
    -->

<!!ENTITY % ContentTypes "CDATA"
    -- comma-separated list of media types, as per [RFC2045]
    -->

<!!ENTITY % Charset "CDATA"
    -- a character encoding, as per [RFC2045]
    -->

<!!ENTITY % Charsets "CDATA"
    -- a space-separated list of character encodings, as per [RFC2045]
    -->

<!!ENTITY % LanguageCode "NAME"
    -- a language code, as per [RFC1766]
    -->

<!!ENTITY % Character "CDATA"
    -- a single character from [ISO10646] 
    -->

<!!ENTITY % LinkTypes "CDATA"
    -- space-separated list of link types
    -->

<!!ENTITY % MediaDesc "CDATA"
    -- single or comma-separated list of media descriptors
    -->

<!!ENTITY % URI "CDATA"
    -- a Uniform Resource Identifier,
       see [URI]
    -->

<!!ENTITY % Datetime "CDATA" -- date and time information. ISO date format -->


<!!ENTITY % Script "CDATA" -- script expression -->

<!!ENTITY % StyleSheet "CDATA" -- style sheet data -->

<!!ENTITY % FrameTarget "CDATA" -- render in this frame -->


<!!ENTITY % Text "CDATA">


<!!-- Parameter Entities -->

<!!ENTITY % head.misc "SCRIPT|STYLE|META|LINK|OBJECT" -- repeatable head elements -->

<!!ENTITY % heading "H1|H2|H3|H4|H5|H6">

<!!ENTITY % list "UL | OL |  DIR | MENU">

<!!ENTITY % preformatted "PRE">

<!!ENTITY % Color "CDATA" -- a color using sRGB: #RRGGBB as Hex values -->

<!!-- There are also 16 widely known color names with their sRGB values:

    Black  = #000000    Green  = #008000
    Silver = #C0C0C0    Lime   = #00FF00
    Gray   = #808080    Olive  = #808000
    White  = #FFFFFF    Yellow = #FFFF00
    Maroon = #800000    Navy   = #000080
    Red    = #FF0000    Blue   = #0000FF
    Purple = #800080    Teal   = #008080
    Fuchsia= #FF00FF    Aqua   = #00FFFF
 -->

<!!ENTITY % bodycolors "
  bgcolor     %Color;        #IMPLIED  -- document background color --
  text        %Color;        #IMPLIED  -- document text color --
  link        %Color;        #IMPLIED  -- color of links --
  vlink       %Color;        #IMPLIED  -- color of visited links --
  alink       %Color;        #IMPLIED  -- color of selected links --
  ">

<!!--================ Character mnemonic entities =========================-->

<!!ENTITY % HTMLlat1 PUBLIC
   "-//W3C//ENTITIES Latin1//EN//HTML"
   "HTMLlat1.ent">
%HTMLlat1;

<!!ENTITY % HTMLsymbol PUBLIC
   "-//W3C//ENTITIES Symbols//EN//HTML"
   "HTMLsymbol.ent">
%HTMLsymbol;

<!!ENTITY % HTMLspecial PUBLIC
   "-//W3C//ENTITIES Special//EN//HTML"
   "HTMLspecial.ent">
%HTMLspecial;
<!!--=================== Generic Attributes ===============================-->

<!!ENTITY % coreattrs
 "id          ID             #IMPLIED  -- document-wide unique id --
  class       CDATA          #IMPLIED  -- space-separated list of classes --
  style       %StyleSheet;   #IMPLIED  -- associated style info --
  title       %Text;         #IMPLIED  -- advisory title --"
  >

<!!ENTITY % i18n
 "lang        %LanguageCode; #IMPLIED  -- language code --
  dir         (ltr|rtl)      #IMPLIED  -- direction for weak/neutral text --"
  >

<!!ENTITY % events
 "onclick     %Script;       #IMPLIED  -- a pointer button was clicked --
  ondblclick  %Script;       #IMPLIED  -- a pointer button was double clicked--
  onmousedown %Script;       #IMPLIED  -- a pointer button was pressed down --
  onmouseup   %Script;       #IMPLIED  -- a pointer button was released --
  onmouseover %Script;       #IMPLIED  -- a pointer was moved onto --
  onmousemove %Script;       #IMPLIED  -- a pointer was moved within --
  onmouseout  %Script;       #IMPLIED  -- a pointer was moved away --
  onkeypress  %Script;       #IMPLIED  -- a key was pressed and released --
  onkeydown   %Script;       #IMPLIED  -- a key was pressed down --
  onkeyup     %Script;       #IMPLIED  -- a key was released --"
  >

<!!-- Reserved Feature Switch -->
<!!ENTITY % HTML.Reserved "IGNORE">

<!!-- The following attributes are reserved for possible future use -->
<!![ %HTML.Reserved; [
<!!ENTITY % reserved
 "datasrc     %URI;          #IMPLIED  -- a single or tabular Data Source --
  datafld     CDATA          #IMPLIED  -- the property or column name --
  dataformatas (plaintext|html) plaintext -- text or html --"
  >
]]>

<!!ENTITY % reserved "">

<!!ENTITY % attrs "%coreattrs; %i18n; %events;">

<!!ENTITY % align "align (left|center|right|justify)  #IMPLIED"
                   -- default is left for ltr paragraphs, right for rtl --
  >

<!!--=================== Text Markup ======================================-->

<!!ENTITY % fontstyle
 "TT | I | B | U | S | STRIKE | BIG | SMALL">

<!!ENTITY % phrase "EM | STRONG | DFN | CODE |
                   SAMP | KBD | VAR | CITE | ABBR | ACRONYM" >

<!!ENTITY % special
   "A | IMG | APPLET | OBJECT | FONT | BASEFONT | BR | SCRIPT |
    MAP | Q | SUB | SUP | SPAN | BDO | IFRAME">

<!!ENTITY % formctrl "INPUT | SELECT | TEXTAREA | LABEL | BUTTON">

<!!-- %inline; covers inline or "text-level" elements -->
<!!ENTITY % inline "#PCDATA | %fontstyle; | %phrase; | %special; | %formctrl;">

<!!ELEMENT (%fontstyle;|%phrase;) - - (%inline;)*>
<!!ATTLIST (%fontstyle;|%phrase;)
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT (SUB|SUP) - - (%inline;)*    -- subscript, superscript -->
<!!ATTLIST (SUB|SUP)
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT SPAN - - (%inline;)*         -- generic language/style container -->
<!!ATTLIST SPAN
  %attrs;                              -- %coreattrs, %i18n, %events --
  %reserved;			       -- reserved for possible future use --
  >

<!!ELEMENT BDO - - (%inline;)*          -- I18N BiDi over-ride -->
<!!ATTLIST BDO
  %coreattrs;                          -- id, class, style, title --
  lang        %LanguageCode; #IMPLIED  -- language code --
  dir         (ltr|rtl)      #REQUIRED -- directionality --
  >

<!!ELEMENT BASEFONT - O EMPTY           -- base font size -->
<!!ATTLIST BASEFONT
  id          ID             #IMPLIED  -- document-wide unique id --
  size        CDATA          #REQUIRED -- base font size for FONT elements --
  color       %Color;        #IMPLIED  -- text color --
  face        CDATA          #IMPLIED  -- comma-separated list of font names --
  >

<!!ELEMENT FONT - - (%inline;)*         -- local change to font -->
<!!ATTLIST FONT
  %coreattrs;                          -- id, class, style, title --
  %i18n;		               -- lang, dir --
  size        CDATA          #IMPLIED  -- [+|-]nn e.g. size="+1", size="4" --
  color       %Color;        #IMPLIED  -- text color --
  face        CDATA          #IMPLIED  -- comma-separated list of font names --
  >

<!!ELEMENT BR - O EMPTY                 -- forced line break -->
<!!ATTLIST BR
  %coreattrs;                          -- id, class, style, title --
  clear       (left|all|right|none) none -- control of text flow --
  >

<!!--================== HTML content models ===============================-->

<!!--
    HTML has two basic content models:

        %inline;     character level elements and text strings
        %block;      block-like elements e.g. paragraphs and lists
-->

<!!ENTITY % block
     "P | %heading; | %list; | %preformatted; | DL | DIV | CENTER |
      NOSCRIPT | NOFRAMES | BLOCKQUOTE | FORM | ISINDEX | HR |
      TABLE | FIELDSET | ADDRESS">

<!!ENTITY % flow "%block; | %inline;">

<!!--=================== Document Body ====================================-->

<!!ELEMENT BODY O O (%flow;)* +(INS|DEL) -- document body -->
<!!ATTLIST BODY
  %attrs;                              -- %coreattrs, %i18n, %events --
  onload          %Script;   #IMPLIED  -- the document has been loaded --
  onunload        %Script;   #IMPLIED  -- the document has been removed --
  background      %URI;      #IMPLIED  -- texture tile for document
                                          background --
  %bodycolors;                         -- bgcolor, text, link, vlink, alink --
  >

<!!ELEMENT ADDRESS - - ((%inline;)|P)*  -- information on author -->
<!!ATTLIST ADDRESS
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT DIV - - (%flow;)*            -- generic language/style container -->
<!!ATTLIST DIV
  %attrs;                              -- %coreattrs, %i18n, %events --
  %align;                              -- align, text alignment --
  %reserved;                           -- reserved for possible future use --
  >

<!!ELEMENT CENTER - - (%flow;)*         -- shorthand for DIV align=center -->
<!!ATTLIST CENTER
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--================== The Anchor Element ================================-->

<!!ENTITY % Shape "(rect|circle|poly|default)">
<!!ENTITY % Coords "CDATA" -- comma-separated list of lengths -->

<!!ELEMENT A - - (%inline;)* -(A)       -- anchor -->
<!!ATTLIST A
  %attrs;                              -- %coreattrs, %i18n, %events --
  charset     %Charset;      #IMPLIED  -- char encoding of linked resource --
  type        %ContentType;  #IMPLIED  -- advisory content type --
  name        CDATA          #IMPLIED  -- named link end --
  href        %URI;          #IMPLIED  -- URI for linked resource --
  hreflang    %LanguageCode; #IMPLIED  -- language code --
  target      %FrameTarget;  #IMPLIED  -- render in this frame --
  rel         %LinkTypes;    #IMPLIED  -- forward link types --
  rev         %LinkTypes;    #IMPLIED  -- reverse link types --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  shape       %Shape;        rect      -- for use with client-side image maps --
  coords      %Coords;       #IMPLIED  -- for use with client-side image maps --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  >

<!!--================== Client-side image maps ============================-->

<!!-- These can be placed in the same document or grouped in a
     separate document although this isn''t yet widely supported -->

<!!ELEMENT MAP - - ((%block;) | AREA)+ -- client-side image map -->
<!!ATTLIST MAP
  %attrs;                              -- %coreattrs, %i18n, %events --
  name        CDATA          #REQUIRED -- for reference by usemap --
  >

<!!ELEMENT AREA - O EMPTY               -- client-side image map area -->
<!!ATTLIST AREA
  %attrs;                              -- %coreattrs, %i18n, %events --
  shape       %Shape;        rect      -- controls interpretation of coords --
  coords      %Coords;       #IMPLIED  -- comma-separated list of lengths --
  href        %URI;          #IMPLIED  -- URI for linked resource --
  target      %FrameTarget;  #IMPLIED  -- render in this frame --
  nohref      (nohref)       #IMPLIED  -- this region has no action --
  alt         %Text;         #REQUIRED -- short description --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  >

<!!--================== The LINK Element ==================================-->

<!!--
  Relationship values can be used in principle:

   a) for document specific toolbars/menus when used
      with the LINK element in document head e.g.
        start, contents, previous, next, index, end, help
   b) to link to a separate style sheet (rel=stylesheet)
   c) to make a link to a script (rel=script)
   d) by stylesheets to control how collections of
      html nodes are rendered into printed documents
   e) to make a link to a printable version of this document
      e.g. a postscript or pdf version (rel=alternate media=print)
-->

<!!ELEMENT LINK - O EMPTY               -- a media-independent link -->
<!!ATTLIST LINK
  %attrs;                              -- %coreattrs, %i18n, %events --
  charset     %Charset;      #IMPLIED  -- char encoding of linked resource --
  href        %URI;          #IMPLIED  -- URI for linked resource --
  hreflang    %LanguageCode; #IMPLIED  -- language code --
  type        %ContentType;  #IMPLIED  -- advisory content type --
  rel         %LinkTypes;    #IMPLIED  -- forward link types --
  rev         %LinkTypes;    #IMPLIED  -- reverse link types --
  media       %MediaDesc;    #IMPLIED  -- for rendering on these media --
  target      %FrameTarget;  #IMPLIED  -- render in this frame --
  >

<!!--=================== Images ===========================================-->

<!!-- Length defined in strict DTD for cellpadding/cellspacing -->
<!!ENTITY % Length "CDATA" -- nn for pixels or nn% for percentage length -->
<!!ENTITY % MultiLength "CDATA" -- pixel, percentage, or relative -->

<!![ %HTML.Frameset; [
<!!ENTITY % MultiLengths "CDATA" -- comma-separated list of MultiLength -->
]]>

<!!ENTITY % Pixels "CDATA" -- integer representing length in pixels -->

<!!ENTITY % IAlign "(top|middle|bottom|left|right)" -- center? -->

<!!-- To avoid problems with text-only UAs as well as 
   to make image content understandable and navigable 
   to users of non-visual UAs, you need to provide
   a description with ALT, and avoid server-side image maps -->
<!!ELEMENT IMG - O EMPTY                -- Embedded image -->
<!!ATTLIST IMG
  %attrs;                              -- %coreattrs, %i18n, %events --
  src         %URI;          #REQUIRED -- URI of image to embed --
  alt         %Text;         #REQUIRED -- short description --
  longdesc    %URI;          #IMPLIED  -- link to long description
                                          (complements alt) --
  name        CDATA          #IMPLIED  -- name of image for scripting --
  height      %Length;       #IMPLIED  -- override height --
  width       %Length;       #IMPLIED  -- override width --
  usemap      %URI;          #IMPLIED  -- use client-side image map --
  ismap       (ismap)        #IMPLIED  -- use server-side image map --
  align       %IAlign;       #IMPLIED  -- vertical or horizontal alignment --
  border      %Pixels;       #IMPLIED  -- link border width --
  hspace      %Pixels;       #IMPLIED  -- horizontal gutter --
  vspace      %Pixels;       #IMPLIED  -- vertical gutter --
  >

<!!-- USEMAP points to a MAP element which may be in this document
  or an external document, although the latter is not widely supported -->

<!!--==================== OBJECT ======================================-->
<!!--
  OBJECT is used to embed objects as part of HTML pages 
  PARAM elements should precede other content. SGML mixed content
  model technicality precludes specifying this formally ...
-->

<!!ELEMENT OBJECT - - (PARAM | %flow;)*
 -- generic embedded object -->
<!!ATTLIST OBJECT
  %attrs;                              -- %coreattrs, %i18n, %events --
  declare     (declare)      #IMPLIED  -- declare but don''t instantiate flag --
  classid     %URI;          #IMPLIED  -- identifies an implementation --
  codebase    %URI;          #IMPLIED  -- base URI for classid, data, archive--
  data        %URI;          #IMPLIED  -- reference to object''s data --
  type        %ContentType;  #IMPLIED  -- content type for data --
  codetype    %ContentType;  #IMPLIED  -- content type for code --
  archive     CDATA          #IMPLIED  -- space-separated list of URIs --
  standby     %Text;         #IMPLIED  -- message to show while loading --
  height      %Length;       #IMPLIED  -- override height --
  width       %Length;       #IMPLIED  -- override width --
  usemap      %URI;          #IMPLIED  -- use client-side image map --
  name        CDATA          #IMPLIED  -- submit as part of form --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  align       %IAlign;       #IMPLIED  -- vertical or horizontal alignment --
  border      %Pixels;       #IMPLIED  -- link border width --
  hspace      %Pixels;       #IMPLIED  -- horizontal gutter --
  vspace      %Pixels;       #IMPLIED  -- vertical gutter --
  %reserved;                           -- reserved for possible future use --
  >

<!!ELEMENT PARAM - O EMPTY              -- named property value -->
<!!ATTLIST PARAM
  id          ID             #IMPLIED  -- document-wide unique id --
  name        CDATA          #REQUIRED -- property name --
  value       CDATA          #IMPLIED  -- property value --
  valuetype   (DATA|REF|OBJECT) DATA   -- How to interpret value --
  type        %ContentType;  #IMPLIED  -- content type for value
                                          when valuetype=ref --
  >

<!!--=================== Java APPLET ==================================-->
<!!--
  One of code or object attributes must be present.
  Place PARAM elements before other content.
-->
<!!ELEMENT APPLET - - (PARAM | %flow;)* -- Java applet -->
<!!ATTLIST APPLET
  %coreattrs;                          -- id, class, style, title --
  codebase    %URI;          #IMPLIED  -- optional base URI for applet --
  archive     CDATA          #IMPLIED  -- comma-separated archive list --
  code        CDATA          #IMPLIED  -- applet class file --
  object      CDATA          #IMPLIED  -- serialized applet file --
  alt         %Text;         #IMPLIED  -- short description --
  name        CDATA          #IMPLIED  -- allows applets to find each other --
  width       %Length;       #REQUIRED -- initial width --
  height      %Length;       #REQUIRED -- initial height --
  align       %IAlign;       #IMPLIED  -- vertical or horizontal alignment --
  hspace      %Pixels;       #IMPLIED  -- horizontal gutter --
  vspace      %Pixels;       #IMPLIED  -- vertical gutter --
  >

<!!--=================== Horizontal Rule ==================================-->

<!!ELEMENT HR - O EMPTY -- horizontal rule -->
<!!ATTLIST HR
  %attrs;                              -- %coreattrs, %i18n, %events --
  align       (left|center|right) #IMPLIED
  noshade     (noshade)      #IMPLIED
  size        %Pixels;       #IMPLIED
  width       %Length;       #IMPLIED
  >

<!!--=================== Paragraphs =======================================-->

<!!ELEMENT P - O (%inline;)*            -- paragraph -->
<!!ATTLIST P
  %attrs;                              -- %coreattrs, %i18n, %events --
  %align;                              -- align, text alignment --
  >

<!!--=================== Headings =========================================-->

<!!--
  There are six levels of headings from H1 (the most important)
  to H6 (the least important).
-->

<!!ELEMENT (%heading;)  - - (%inline;)* -- heading -->
<!!ATTLIST (%heading;)
  %attrs;                              -- %coreattrs, %i18n, %events --
  %align;                              -- align, text alignment --
  >

<!!--=================== Preformatted Text ================================-->

<!!-- excludes markup for images and changes in font size -->
<!!ENTITY % pre.exclusion "IMG|OBJECT|APPLET|BIG|SMALL|SUB|SUP|FONT|BASEFONT">

<!!ELEMENT PRE - - (%inline;)* -(%pre.exclusion;) -- preformatted text -->
<!!ATTLIST PRE
  %attrs;                              -- %coreattrs, %i18n, %events --
  width       NUMBER         #IMPLIED
  >

<!!--===================== Inline Quotes ==================================-->

<!!ELEMENT Q - - (%inline;)*            -- short inline quotation -->
<!!ATTLIST Q
  %attrs;                              -- %coreattrs, %i18n, %events --
  cite        %URI;          #IMPLIED  -- URI for source document or msg --
  >

<!!--=================== Block-like Quotes ================================-->

<!!ELEMENT BLOCKQUOTE - - (%flow;)*     -- long quotation -->
<!!ATTLIST BLOCKQUOTE
  %attrs;                              -- %coreattrs, %i18n, %events --
  cite        %URI;          #IMPLIED  -- URI for source document or msg --
  >

<!!--=================== Inserted/Deleted Text ============================-->


<!!-- INS/DEL are handled by inclusion on BODY -->
<!!ELEMENT (INS|DEL) - - (%flow;)*      -- inserted text, deleted text -->
<!!ATTLIST (INS|DEL)
  %attrs;                              -- %coreattrs, %i18n, %events --
  cite        %URI;          #IMPLIED  -- info on reason for change --
  datetime    %Datetime;     #IMPLIED  -- date and time of change --
  >

<!!--=================== Lists ============================================-->

<!!-- definition lists - DT for term, DD for its definition -->

<!!ELEMENT DL - - (DT|DD)+              -- definition list -->
<!!ATTLIST DL
  %attrs;                              -- %coreattrs, %i18n, %events --
  compact     (compact)      #IMPLIED  -- reduced interitem spacing --
  >

<!!ELEMENT DT - O (%inline;)*           -- definition term -->
<!!ELEMENT DD - O (%flow;)*             -- definition description -->
<!!ATTLIST (DT|DD)
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!-- Ordered lists (OL) Numbering style

    1   arablic numbers     1, 2, 3, ...
    a   lower alpha         a, b, c, ...
    A   upper alpha         A, B, C, ...
    i   lower roman         i, ii, iii, ...
    I   upper roman         I, II, III, ...

    The style is applied to the sequence number which by default
    is reset to 1 for the first list item in an ordered list.

    This can''t be expressed directly in SGML due to case folding.
-->

<!!ENTITY % OLStyle "CDATA"      -- constrained to: "(1|a|A|i|I)" -->

<!!ELEMENT OL - - (LI)+                 -- ordered list -->
<!!ATTLIST OL
  %attrs;                              -- %coreattrs, %i18n, %events --
  type        %OLStyle;      #IMPLIED  -- numbering style --
  compact     (compact)      #IMPLIED  -- reduced interitem spacing --
  start       NUMBER         #IMPLIED  -- starting sequence number --
  >

<!!-- Unordered Lists (UL) bullet styles -->
<!!ENTITY % ULStyle "(disc|square|circle)">

<!!ELEMENT UL - - (LI)+                 -- unordered list -->
<!!ATTLIST UL
  %attrs;                              -- %coreattrs, %i18n, %events --
  type        %ULStyle;      #IMPLIED  -- bullet style --
  compact     (compact)      #IMPLIED  -- reduced interitem spacing --
  >

<!!ELEMENT (DIR|MENU) - - (LI)+ -(%block;) -- directory list, menu list -->
<!!ATTLIST DIR
  %attrs;                              -- %coreattrs, %i18n, %events --
  compact     (compact)      #IMPLIED -- reduced interitem spacing --
  >
<!!ATTLIST MENU
  %attrs;                              -- %coreattrs, %i18n, %events --
  compact     (compact)      #IMPLIED -- reduced interitem spacing --
  >

<!!ENTITY % LIStyle "CDATA" -- constrained to: "(%ULStyle;|%OLStyle;)" -->

<!!ELEMENT LI - O (%flow;)*             -- list item -->
<!!ATTLIST LI
  %attrs;                              -- %coreattrs, %i18n, %events --
  type        %LIStyle;      #IMPLIED  -- list item style --
  value       NUMBER         #IMPLIED  -- reset sequence number --
  >

<!!--================ Forms ===============================================-->
<!!ELEMENT FORM - - (%flow;)* -(FORM)   -- interactive form -->
<!!ATTLIST FORM
  %attrs;                              -- %coreattrs, %i18n, %events --
  action      %URI;          #REQUIRED -- server-side form handler --
  method      (get|post)     GET       -- HTTP method used to submit the form--
  enctype     %ContentType;  "application/x-www-form-urlencoded"
  accept      %ContentTypes; #IMPLIED  -- list of MIME types for file upload --
  name        CDATA          #IMPLIED  -- name of form for scripting --
  onsubmit    %Script;       #IMPLIED  -- the form was submitted --
  onreset     %Script;       #IMPLIED  -- the form was reset --
  target      %FrameTarget;  #IMPLIED  -- render in this frame --
  accept-charset %Charsets;  #IMPLIED  -- list of supported charsets --
  >

<!!-- Each label must not contain more than ONE field -->
<!!ELEMENT LABEL - - (%inline;)* -(LABEL) -- form field label text -->
<!!ATTLIST LABEL
  %attrs;                              -- %coreattrs, %i18n, %events --
  for         IDREF          #IMPLIED  -- matches field ID value --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  >

<!!ENTITY % InputType
  "(text | password | checkbox |
    radio | submit | reset |
    file | hidden | image | button)"
   >

<!!-- attribute name required for all but submit and reset -->
<!!ELEMENT INPUT - O EMPTY              -- form control -->
<!!ATTLIST INPUT
  %attrs;                              -- %coreattrs, %i18n, %events --
  type        %InputType;    TEXT      -- what kind of widget is needed --
  name        CDATA          #IMPLIED  -- submit as part of form --
  value       CDATA          #IMPLIED  -- Specify for radio buttons and checkboxes --
  checked     (checked)      #IMPLIED  -- for radio buttons and check boxes --
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  readonly    (readonly)     #IMPLIED  -- for text and passwd --
  size        CDATA          #IMPLIED  -- specific to each type of field --
  maxlength   NUMBER         #IMPLIED  -- max chars for text fields --
  src         %URI;          #IMPLIED  -- for fields with images --
  alt         CDATA          #IMPLIED  -- short description --
  usemap      %URI;          #IMPLIED  -- use client-side image map --
  ismap       (ismap)        #IMPLIED  -- use server-side image map --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  onselect    %Script;       #IMPLIED  -- some text was selected --
  onchange    %Script;       #IMPLIED  -- the element value was changed --
  accept      %ContentTypes; #IMPLIED  -- list of MIME types for file upload --
  align       %IAlign;       #IMPLIED  -- vertical or horizontal alignment --
  %reserved;                           -- reserved for possible future use --
  >

<!!ELEMENT SELECT - - (OPTGROUP|OPTION)+ -- option selector -->
<!!ATTLIST SELECT
  %attrs;                              -- %coreattrs, %i18n, %events --
  name        CDATA          #IMPLIED  -- field name --
  size        NUMBER         #IMPLIED  -- rows visible --
  multiple    (multiple)     #IMPLIED  -- default is single selection --
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  onchange    %Script;       #IMPLIED  -- the element value was changed --
  %reserved;                           -- reserved for possible future use --
  >

<!!ELEMENT OPTGROUP - - (OPTION)+ -- option group -->
<!!ATTLIST OPTGROUP
  %attrs;                              -- %coreattrs, %i18n, %events --
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  label       %Text;         #REQUIRED -- for use in hierarchical menus --
  >

<!!ELEMENT OPTION - O (#PCDATA)         -- selectable choice -->
<!!ATTLIST OPTION
  %attrs;                              -- %coreattrs, %i18n, %events --
  selected    (selected)     #IMPLIED
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  label       %Text;         #IMPLIED  -- for use in hierarchical menus --
  value       CDATA          #IMPLIED  -- defaults to element content --
  >

<!!ELEMENT TEXTAREA - - (#PCDATA)       -- multi-line text field -->
<!!ATTLIST TEXTAREA
  %attrs;                              -- %coreattrs, %i18n, %events --
  name        CDATA          #IMPLIED
  rows        NUMBER         #REQUIRED
  cols        NUMBER         #REQUIRED
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  readonly    (readonly)     #IMPLIED
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  onselect    %Script;       #IMPLIED  -- some text was selected --
  onchange    %Script;       #IMPLIED  -- the element value was changed --
  %reserved;                           -- reserved for possible future use --
  >

<!!--
  #PCDATA is to solve the mixed content problem,
  per specification only whitespace is allowed there!!
 -->
<!!ELEMENT FIELDSET - - (#PCDATA,LEGEND,(%flow;)*) -- form control group -->
<!!ATTLIST FIELDSET
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!ELEMENT LEGEND - - (%inline;)*       -- fieldset legend -->
<!!ENTITY % LAlign "(top|bottom|left|right)">

<!!ATTLIST LEGEND
  %attrs;                              -- %coreattrs, %i18n, %events --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  align       %LAlign;       #IMPLIED  -- relative to fieldset --
  >

<!!ELEMENT BUTTON - -
     (%flow;)* -(A|%formctrl;|FORM|ISINDEX|FIELDSET|IFRAME)
     -- push button -->
<!!ATTLIST BUTTON
  %attrs;                              -- %coreattrs, %i18n, %events --
  name        CDATA          #IMPLIED
  value       CDATA          #IMPLIED  -- sent to server when submitted --
  type        (button|submit|reset) submit -- for use as form button --
  disabled    (disabled)     #IMPLIED  -- unavailable in this context --
  tabindex    NUMBER         #IMPLIED  -- position in tabbing order --
  accesskey   %Character;    #IMPLIED  -- accessibility key character --
  onfocus     %Script;       #IMPLIED  -- the element got the focus --
  onblur      %Script;       #IMPLIED  -- the element lost the focus --
  %reserved;                           -- reserved for possible future use --
  >

<!!--======================= Tables =======================================-->

<!!-- IETF HTML table standard, see [RFC1942] -->

<!!--
 The BORDER attribute sets the thickness of the frame around the
 table. The default units are screen pixels.

 The FRAME attribute specifies which parts of the frame around
 the table should be rendered. The values are not the same as
 CALS to avoid a name clash with the VALIGN attribute.

 The value "border" is included for backwards compatibility with
 <TABLE BORDER> which yields frame=border and border=implied
 For <TABLE BORDER=1> you get border=1 and frame=implied. In this
 case, it is appropriate to treat this as frame=border for backwards
 compatibility with deployed browsers.
-->
<!!ENTITY % TFrame "(void|above|below|hsides|lhs|rhs|vsides|box|border)">

<!!--
 The RULES attribute defines which rules to draw between cells:

 If RULES is absent then assume:
     "none" if BORDER is absent or BORDER=0 otherwise "all"
-->

<!!ENTITY % TRules "(none | groups | rows | cols | all)">
  
<!!-- horizontal placement of table relative to document -->
<!!ENTITY % TAlign "(left|center|right)">

<!!-- horizontal alignment attributes for cell contents -->
<!!ENTITY % cellhalign
  "align      (left|center|right|justify|char) #IMPLIED
   char       %Character;    #IMPLIED  -- alignment char, e.g. char='':'' --
   charoff    %Length;       #IMPLIED  -- offset for alignment char --"
  >

<!!-- vertical alignment attributes for cell contents -->
<!!ENTITY % cellvalign
  "valign     (top|middle|bottom|baseline) #IMPLIED"
  >

<!!ELEMENT TABLE - -
     (CAPTION?, (COL*|COLGROUP*), THEAD?, TFOOT?, (TBODY|TR+))>
<!!ELEMENT CAPTION  - - (%inline;)*     -- table caption -->
<!!ELEMENT THEAD    - O (TR)+           -- table header -->
<!!ELEMENT TFOOT    - O (TR)+           -- table footer -->
<!!ELEMENT TBODY    O O (TR)+           -- table body -->
<!!ELEMENT COLGROUP - O (COL)*          -- table column group -->
<!!ELEMENT COL      - O EMPTY           -- table column -->
<!!ELEMENT TR       - O (TH|TD)+        -- table row -->
<!!ELEMENT (TH|TD)  - O (%flow;)*       -- table header cell, table data cell-->

<!!ATTLIST TABLE                        -- table element --
  %attrs;                              -- %coreattrs, %i18n, %events --
  summary     %Text;         #IMPLIED  -- purpose/structure for speech output--
  width       %Length;       #IMPLIED  -- table width --
  border      %Pixels;       #IMPLIED  -- controls frame width around table --
  frame       %TFrame;       #IMPLIED  -- which parts of frame to render --
  rules       %TRules;       #IMPLIED  -- rulings between rows and cols --
  cellspacing %Length;       #IMPLIED  -- spacing between cells --
  cellpadding %Length;       #IMPLIED  -- spacing within cells --
  align       %TAlign;       #IMPLIED  -- table position relative to window --
  bgcolor     %Color;        #IMPLIED  -- background color for cells --
  %reserved;                           -- reserved for possible future use --
  datapagesize CDATA         #IMPLIED  -- reserved for possible future use --
  >

<!!ENTITY % CAlign "(top|bottom|left|right)">

<!!ATTLIST CAPTION
  %attrs;                              -- %coreattrs, %i18n, %events --
  align       %CAlign;       #IMPLIED  -- relative to table --
  >

<!!--
COLGROUP groups a set of COL elements. It allows you to group
several semantically related columns together.
-->
<!!ATTLIST COLGROUP
  %attrs;                              -- %coreattrs, %i18n, %events --
  span        NUMBER         1         -- default number of columns in group --
  width       %MultiLength;  #IMPLIED  -- default width for enclosed COLs --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  >

<!!--
 COL elements define the alignment properties for cells in
 one or more columns.

 The WIDTH attribute specifies the width of the columns, e.g.

     width=64        width in screen pixels
     width=0.5*      relative width of 0.5

 The SPAN attribute causes the attributes of one
 COL element to apply to more than one column.
-->
<!!ATTLIST COL                          -- column groups and properties --
  %attrs;                              -- %coreattrs, %i18n, %events --
  span        NUMBER         1         -- COL attributes affect N columns --
  width       %MultiLength;  #IMPLIED  -- column width specification --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  >

<!!--
    Use THEAD to duplicate headers when breaking table
    across page boundaries, or for static headers when
    TBODY sections are rendered in scrolling panel.

    Use TFOOT to duplicate footers when breaking table
    across page boundaries, or for static footers when
    TBODY sections are rendered in scrolling panel.

    Use multiple TBODY sections when rules are needed
    between groups of table rows.
-->
<!!ATTLIST (THEAD|TBODY|TFOOT)          -- table section --
  %attrs;                              -- %coreattrs, %i18n, %events --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  >

<!!ATTLIST TR                           -- table row --
  %attrs;                              -- %coreattrs, %i18n, %events --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  bgcolor     %Color;        #IMPLIED  -- background color for row --
  >


<!!-- Scope is simpler than headers attribute for common tables -->
<!!ENTITY % Scope "(row|col|rowgroup|colgroup)">

<!!-- TH is for headers, TD for data, but for cells acting as both use TD -->
<!!ATTLIST (TH|TD)                      -- header or data cell --
  %attrs;                              -- %coreattrs, %i18n, %events --
  abbr        %Text;         #IMPLIED  -- abbreviation for header cell --
  axis        CDATA          #IMPLIED  -- comma-separated list of related headers--
  headers     IDREFS         #IMPLIED  -- list of id''s for header cells --
  scope       %Scope;        #IMPLIED  -- scope covered by header cells --
  rowspan     NUMBER         1         -- number of rows spanned by cell --
  colspan     NUMBER         1         -- number of cols spanned by cell --
  %cellhalign;                         -- horizontal alignment in cells --
  %cellvalign;                         -- vertical alignment in cells --
  nowrap      (nowrap)       #IMPLIED  -- suppress word wrap --
  bgcolor     %Color;        #IMPLIED  -- cell background color --
  width       %Length;       #IMPLIED  -- width for cell --
  height      %Length;       #IMPLIED  -- height for cell --
  >

<!!--================== Document Frames ===================================-->

<!!--
  The content model for HTML documents depends on whether the HEAD is
  followed by a FRAMESET or BODY element. The widespread omission of
  the BODY start tag makes it impractical to define the content model
  without the use of a marked section.
-->

<!![ %HTML.Frameset; [
<!!ELEMENT FRAMESET - - ((FRAMESET|FRAME)+ & NOFRAMES?) -- window subdivision-->
<!!ATTLIST FRAMESET
  %coreattrs;                          -- id, class, style, title --
  rows        %MultiLengths; #IMPLIED  -- list of lengths,
                                          default: 100% (1 row) --
  cols        %MultiLengths; #IMPLIED  -- list of lengths,
                                          default: 100% (1 col) --
  onload      %Script;       #IMPLIED  -- all the frames have been loaded  -- 
  onunload    %Script;       #IMPLIED  -- all the frames have been removed -- 
  >
]]>

<!![ %HTML.Frameset; [
<!!-- reserved frame names start with "_" otherwise starts with letter -->
<!!ELEMENT FRAME - O EMPTY              -- subwindow -->
<!!ATTLIST FRAME
  %coreattrs;                          -- id, class, style, title --
  longdesc    %URI;          #IMPLIED  -- link to long description
                                          (complements title) --
  name        CDATA          #IMPLIED  -- name of frame for targetting --
  src         %URI;          #IMPLIED  -- source of frame content --
  frameborder (1|0)          1         -- request frame borders? --
  marginwidth %Pixels;       #IMPLIED  -- margin widths in pixels --
  marginheight %Pixels;      #IMPLIED  -- margin height in pixels --
  noresize    (noresize)     #IMPLIED  -- allow users to resize frames? --
  scrolling   (yes|no|auto)  auto      -- scrollbar or none --
  >
]]>

<!!ELEMENT IFRAME - - (%flow;)*         -- inline subwindow -->
<!!ATTLIST IFRAME
  %coreattrs;                          -- id, class, style, title --
  longdesc    %URI;          #IMPLIED  -- link to long description
                                          (complements title) --
  name        CDATA          #IMPLIED  -- name of frame for targetting --
  src         %URI;          #IMPLIED  -- source of frame content --
  frameborder (1|0)          1         -- request frame borders? --
  marginwidth %Pixels;       #IMPLIED  -- margin widths in pixels --
  marginheight %Pixels;      #IMPLIED  -- margin height in pixels --
  scrolling   (yes|no|auto)  auto      -- scrollbar or none --
  align       %IAlign;       #IMPLIED  -- vertical or horizontal alignment --
  height      %Length;       #IMPLIED  -- frame height --
  width       %Length;       #IMPLIED  -- frame width --
  >

<!![ %HTML.Frameset; [
<!!ENTITY % noframes.content "(BODY) -(NOFRAMES)">
]]>

<!!ENTITY % noframes.content "(%flow;)*">

<!!ELEMENT NOFRAMES - - %noframes.content;
 -- alternate content container for non frame-based rendering -->
<!!ATTLIST NOFRAMES
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--================ Document Head =======================================-->
<!!-- %head.misc; defined earlier on as "SCRIPT|STYLE|META|LINK|OBJECT" -->
<!!ENTITY % head.content "TITLE & ISINDEX? & BASE?">

<!!ELEMENT HEAD O O (%head.content;) +(%head.misc;) -- document head -->
<!!ATTLIST HEAD
  %i18n;                               -- lang, dir --
  profile     %URI;          #IMPLIED  -- named dictionary of meta info --
  >

<!!-- The TITLE element is not considered part of the flow of text.
       It should be displayed, for example as the page header or
       window title. Exactly one title is required per document.
    -->
<!!ELEMENT TITLE - - (#PCDATA) -(%head.misc;) -- document title -->
<!!ATTLIST TITLE %i18n>

<!!ELEMENT ISINDEX - O EMPTY            -- single line prompt -->
<!!ATTLIST ISINDEX
  %coreattrs;                          -- id, class, style, title --
  %i18n;                               -- lang, dir --
  prompt      %Text;         #IMPLIED  -- prompt message -->

<!!ELEMENT BASE - O EMPTY               -- document base URI -->
<!!ATTLIST BASE
  href        %URI;          #IMPLIED  -- URI that acts as base URI --
  target      %FrameTarget;  #IMPLIED  -- render in this frame --
  >

<!!ELEMENT META - O EMPTY               -- generic metainformation -->
<!!ATTLIST META
  %i18n;                               -- lang, dir, for use with content --
  http-equiv  NAME           #IMPLIED  -- HTTP response header name  --
  name        NAME           #IMPLIED  -- metainformation name --
  content     CDATA          #REQUIRED -- associated information --
  scheme      CDATA          #IMPLIED  -- select form of content --
  >

<!!ELEMENT STYLE - - %StyleSheet        -- style info -->
<!!ATTLIST STYLE
  %i18n;                               -- lang, dir, for use with title --
  type        %ContentType;  #REQUIRED -- content type of style language --
  media       %MediaDesc;    #IMPLIED  -- designed for use with these media --
  title       %Text;         #IMPLIED  -- advisory title --
  >

<!!ELEMENT SCRIPT - - %Script;          -- script statements -->
<!!ATTLIST SCRIPT
  charset     %Charset;      #IMPLIED  -- char encoding of linked resource --
  type        %ContentType;  #REQUIRED -- content type of script language --
  language    CDATA          #IMPLIED  -- predefined script language name --
  src         %URI;          #IMPLIED  -- URI for an external script --
  defer       (defer)        #IMPLIED  -- UA may defer execution of script --
  event       CDATA          #IMPLIED  -- reserved for possible future use --
  for         %URI;          #IMPLIED  -- reserved for possible future use --
  >

<!!ELEMENT NOSCRIPT - - (%flow;)*
  -- alternate content container for non script-based rendering -->
<!!ATTLIST NOSCRIPT
  %attrs;                              -- %coreattrs, %i18n, %events --
  >

<!!--================ Document Structure ==================================-->
<!!ENTITY % version "version CDATA #FIXED ''%HTML.Version;''">

<!![ %HTML.Frameset; [
<!!ENTITY % html.content "HEAD, FRAMESET">
]]>

<!!ENTITY % html.content "HEAD, BODY">

<!!ELEMENT HTML O O (%html.content;)    -- document root element -->
<!!ATTLIST HTML
  %i18n;                               -- lang, dir --
  %version;
  >
'! !

!Html401Transitional methodsFor: 'initialize-release' stamp: 'tb 12/1/2005 09:34'!
initialize

	super initialize.
	self parse.! !

!HtmlDTD class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 13:04'!
default

	^self forDocType: self docType! !

!HtmlDTD class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 09:54'!
defaultUrl

	self subclassResponsibility! !

!HtmlDTD class methodsFor: 'as yet unclassified' stamp: 'tb 12/3/2005 15:05'!
docType

	^'abstract'! !

!HtmlDTD class methodsFor: 'as yet unclassified' stamp: 'tb 12/3/2005 15:05'!
forDocType: aDocType

	| dt delims |

	delims := (Character separators copyWith: $<) copyWith: $>.

	dt := aDocType copyWithoutAll: delims.

	Cache isNil ifTrue: [Cache := Dictionary new].

	^Cache at: dt ifAbsentPut: 
	[ 
		(self allSubclasses
			detect: [:ea | (ea docType copyWithoutAll: delims) = dt] 
			ifNone: [Html401Strict]) new.
	]! !

!HtmlDTD class methodsFor: 'as yet unclassified' stamp: 'tb 11/29/2005 20:22'!
on: aString

	^self new content: aString! !

!HtmlDTD class methodsFor: 'as yet unclassified' stamp: 'tb 11/29/2005 20:22'!
onUrl: aStringOrUrl

	^self new url: aStringOrUrl asUrl ! !

!HtmlDTD class methodsFor: 'as yet unclassified' stamp: 'tb 12/2/2005 09:41'!
resetCache

	"HtmlDTD resetCache"
	Cache := nil! !

!HtmlDTD class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 10:16'!
updateFromWeb

	self compileSilently: ('dtd',(Character cr asString), '^',(self defaultUrl retrieveContents contents printString)) classified: 'resources'  ! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/29/2005 21:09'!
addToAttLists: anAttList

	self attLists: (self attLists copyWith: anAttList)! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/29/2005 20:56'!
addToComments: aComment

	self comments: (self comments copyWith: aComment)! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/29/2005 20:59'!
addToElements: anElement

	self elements: (self elements copyWith: anElement)! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/29/2005 21:08'!
addToEntities: anEntity

	self entities: (self entities copyWith: anEntity)! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/29/2005 21:20'!
attLists
	"Answer the value of attLists"

	^ attLists isNil 
		ifTrue:[#()]
		ifFalse:[attLists]! !

!HtmlDTD methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:52'!
attLists: anObject
	"Set the value of attLists"

	attLists := anObject! !

!HtmlDTD methodsFor: 'testing' stamp: 'tb 12/5/2005 12:13'!
attrListForTag: aTag

	^attLists detect:[:ea | ea tagMatches: aTag] ifNone:[nil]! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/29/2005 21:20'!
comments

	^comments isNil 
		ifTrue: [#()]
		ifFalse: [comments]! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/29/2005 20:56'!
comments: anArray

	comments := anArray! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 12/1/2005 09:46'!
content
	"Answer the value of content"

	^ content isNil 
		ifFalse: [content]
		ifTrue: 
		[
			(self respondsTo: #dtd) 
				ifTrue: [content := self dtd]
				ifFalse: [content := self document content]
		]
	! !

!HtmlDTD methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:26'!
content: anObject
	"Set the value of content"

	content := anObject! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 12/1/2005 09:55'!
defaultUrl

	^self class defaultUrl! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/29/2005 20:22'!
document
	"Answer the value of document"

	^ document isNil 
		ifFalse: [document]
		ifTrue: [url isNil ifFalse: [document := url asUrl retrieveContents] ifTrue: [nil]] ! !

!HtmlDTD methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:26'!
document: anObject
	"Set the value of document"

	document := anObject! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/29/2005 20:22'!
dom
	"Answer the value of dom"

	^ dom! !

!HtmlDTD methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:27'!
dom: anObject
	"Set the value of dom"

	dom := anObject! !

!HtmlDTD methodsFor: 'testing' stamp: 'tb 12/5/2005 12:12'!
elementForTag: aTag

	^elements detect:[:ea | ea tagMatches: aTag] ifNone:[nil]! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/29/2005 21:21'!
elements
	"Answer the value of elements"

	^ elements isNil 
		ifTrue:[#()]
		ifFalse:[elements]! !

!HtmlDTD methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:52'!
elements: anObject
	"Set the value of elements"

	elements := anObject! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/29/2005 21:22'!
entities
	"Answer the value of entities"

	^ entities isNil 
		ifTrue:[#()]
		ifFalse: [entities]! !

!HtmlDTD methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:52'!
entities: anObject
	"Set the value of entities"

	entities := anObject! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/29/2005 20:22'!
errors
	"Answer the value of errors"

	^ errors! !

!HtmlDTD methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:28'!
errors: anObject
	"Set the value of errors"

	errors := anObject! !

!HtmlDTD methodsFor: 'private' stamp: 'tb 11/30/2005 18:07'!
expandAllTokens

	self expandElementTokens.
	self expandAttListTokens.! !

!HtmlDTD methodsFor: 'private' stamp: 'tb 11/30/2005 18:06'!
expandAttListTokens

	| expanded changed |

	changed := true.
	expanded := attLists.

	[changed] whileTrue:
	[
		changed := false.
		expanded := expanded collect:
		[:item |
			item collect: 
			[:ea |
				| s |
				s := self expandTokensInLine: ea.
				s = ea ifFalse: [changed := true].
				s
			]
		]
	].
	^attLists := expanded! !

!HtmlDTD methodsFor: 'private' stamp: 'tb 11/30/2005 18:07'!
expandElementTokens

	| expanded changed |

	changed := true.
	expanded := elements.

	[changed] whileTrue:
	[
		changed := false.
		expanded := expanded collect:
		[:ea |
			| s |
			s := self expandTokensInLine: ea.
			s = ea ifFalse: [changed := true].
			s
		]
	].
	^elements := expanded! !

!HtmlDTD methodsFor: 'private' stamp: 'tb 11/30/2005 17:20'!
expandTokensInLine: aString

	| in out s |

	in := ReadStream on: aString.
	out := WriteStream on: (String new: 20).
	[in atEnd] whileFalse:
	[
		s := in upTo: $%.
		out nextPutAll: s.
		in atEnd 
			ifFalse: 
			[ 
				out nextPutAll: 
					(((self tokenDefinition: 
						(in upTo: $;)) findTokens: ' ')joinOn: ' ') 
			]
	].
	^out contents! !

!HtmlDTD methodsFor: 'initialize-release' stamp: 'tb 11/29/2005 20:22'!
initialize

	super initialize.
! !

!HtmlDTD methodsFor: 'testing' stamp: 'tb 12/5/2005 12:06'!
isXML

	^false! !

!HtmlDTD methodsFor: 'private' stamp: 'tb 11/30/2005 21:46'!
objectifyAttLists

	attLists := attLists collect: [:ea | HtmlDTDAttrList fromParsedArray: ea]! !

!HtmlDTD methodsFor: 'private' stamp: 'tb 12/6/2005 09:55'!
objectifyElements

	elements := elements collect: [:ea | HtmlDTDElement fromParsedString: ea].
	elements do: [:ea | ea cacheAllowedElementsForDTD: self].! !

!HtmlDTD methodsFor: 'actions' stamp: 'SebastianSastre 1/15/2012 16:34'!
parse

	| in s |
	
	self reset.
	in := ReadStream on: self content.

	[in atEnd] whileFalse:
	[
		in skipSeparators.
		in upTo: $<.
		s := in upTo: $ .
		(s beginsWith: '!!--') 
		ifTrue: [self readComment: in]
		ifFalse:
		[
			(s beginsWith: '!!ELEMENT') 
			ifTrue: [self readElement: in]
			ifFalse:
			[
				(s beginsWith: '!!ATTLIST')
				ifTrue: [self readAttList: in]
				ifFalse:
				[
					(s beginsWith: '!!ENTITY')
					ifTrue:[self readEntity: in]
					ifFalse:
					[
						(s beginsWith: '!![')
						ifTrue:[self readConditionalElement: in]
						ifFalse:[s trimBoth size > 0 ifTrue: [self halt]]
					] 
				] 
			]
		]
	].

	self expandAllTokens.
	self objectifyAttLists.
	self objectifyElements.
	
	! !

!HtmlDTD methodsFor: 'actions' stamp: 'SebastianSastre 1/15/2012 16:34'!
readAttList: aStream

	| s list |

	list := OrderedCollection new.
	s := (aStream upTo: $>) trimBoth findTokens: Character separators.

	list add: s first.
	s := s copyWithoutFirst joinOn: ' '.
	list add: (self stripCommentsFrom: s).
	self addToAttLists: list asArray.! !

!HtmlDTD methodsFor: 'actions' stamp: 'tb 11/29/2005 21:17'!
readComment: aStream

	| s |

	s := aStream upTo: $>.
	[s endsWith: '--'] whileFalse: [s:= (s, '>',(aStream upTo: $>))].
	self addToComments: s.! !

!HtmlDTD methodsFor: 'actions' stamp: 'tb 11/29/2005 21:31'!
readConditionalElement: aStream

	| s |

	s := aStream upTo: $>.
	[s endsWith: ']]'] whileFalse: [s:= (s, '>',(aStream upTo: $>))].
! !

!HtmlDTD methodsFor: 'actions' stamp: 'SebastianSastre 1/15/2012 16:34'!
readElement: aStream

	| s |

	s := aStream upTo: $>.
	self addToElements: (self stripCommentsFrom: s) trimBoth.! !

!HtmlDTD methodsFor: 'actions' stamp: 'SebastianSastre 1/15/2012 16:33'!
readEntity: aStream

	| s in out |

	out := WriteStream on: (String new: 100).

	s := (self stripCommentsFrom: (aStream upTo: $>)) trimBoth.

	in := ReadStream on: s.
	in upTo: $%.
	out nextPutAll: '% '.

	in skipSeparators.
	[in peek isSeparator]whileFalse:[out nextPut: in next].

	in skipSeparators.
	out nextPut: $ .
	out nextPutAll: in upToEnd.
	self addToEntities: out contents trimBoth.
	! !

!HtmlDTD methodsFor: 'actions' stamp: 'tb 11/29/2005 21:22'!
reset

	entities := attributes := comments := elements := attLists := nil! !

!HtmlDTD methodsFor: 'private' stamp: 'tb 12/2/2005 17:08'!
stripCommentsFrom: aString

	| in out |

	in := ReadStream on: aString.
	out := WriteStream on: (String new: aString size).

	[in atEnd] whileFalse:
	[
		out nextPutAll: (in upToAll: '--').
		in upToAll: '--'.
	].
	^out contents! !

!HtmlDTD methodsFor: 'testing' stamp: 'tb 11/30/2005 23:16'!
tag: aTag allowsAttribute: anAttribute

	| a |
	a := (self attrListForTag: aTag).
	^a isNil 
		ifFalse: [(a attributeNamed: anAttribute) notNil] 
		ifTrue:[false]! !

!HtmlDTD methodsFor: 'testing' stamp: 'tb 12/1/2005 14:27'!
tag: aTag attribute: anAttribute hasValidValue: aValue

	| a adef |
	a := (self attrListForTag: aTag).
	^a isNil 
		ifTrue:[false]
		ifFalse: 
		[
			adef := a attributeNamed: anAttribute.
			adef isNil 
				ifTrue:[false]
				ifFalse:
				[
					adef type isString 
						ifTrue: [true]
						ifFalse: [adef type allowsItem: aValue]
				]
		] 
! !

!HtmlDTD methodsFor: 'testing' stamp: 'tb 12/6/2005 15:52'!
tag: aTag canContainTag: anotherTag

	| element |
		element := self elementForTag: aTag asUppercase.
		^element notNil 
			ifTrue: [element allowsTag: anotherTag asUppercase]
			ifFalse:[false]
		! !

!HtmlDTD methodsFor: 'testing' stamp: 'tb 12/2/2005 10:36'!
tagCloseIsOptional: aTag

	| element |

	element := self elementForTag: aTag.
	^element isNil 
		ifTrue:[false] 
		ifFalse:[element endIsOptional]! !

!HtmlDTD methodsFor: 'testing' stamp: 'tb 12/2/2005 12:22'!
tagIsEmpty: aTag

	| e |

	e := elements detect: [:ea | ea tagMatches: aTag] ifNone: [nil].
	^e notNil ifTrue: [e isEmpty] ifFalse: [false]! !

!HtmlDTD methodsFor: 'testing' stamp: 'tb 11/29/2005 23:34'!
tagIsOptional: aTag

	| decl |
	decl := (self elements detect: [:ea | ea beginsWith: (aTag asUppercase)]).
	^((decl splitOn: ' ') at: 2) = 'O'.! !

!HtmlDTD methodsFor: 'testing' stamp: 'tb 12/2/2005 09:50'!
tagIsReal: aTag

	^(self elementForTag: aTag) notNil! !

!HtmlDTD methodsFor: 'private' stamp: 'tb 12/2/2005 12:48'!
tokenDefinition: aToken

	| def fmt s in |

	fmt := (aToken copyWithout: $%)	copyWithout: $;.
	fmt := ('% ',fmt, ' ').
	def := entities detect: [:ea | ea beginsWith: fmt] ifNone: ['"', aToken, '"'].
	in := ReadStream on: def.
	in upTo: $".
	s := in upTo: $".
	^s	! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/30/2005 23:04'!
url
	"Answer the value of url"

	^ url isNil ifTrue: [url := self defaultUrl]! !

!HtmlDTD methodsFor: 'accessing' stamp: 'tb 11/29/2005 20:22'!
url: anObject
	"Set the value of url"

	url := anObject.
! !

!HtmlDTD methodsFor: 'actions' stamp: 'tb 1/3/2006 05:42'!
validateAttributesOfNode: aNode

	aNode attributes copy keysAndValuesDo:
	[:k :v || attList lck |
		attList := self attrListForTag: aNode dtdTag.
		lck := k asLowercase.
		(attList includesAttribute: lck) ifFalse:
		[
			aNode addError: (HtmlAttributeUnknownError new attribute: k).
		]
		ifTrue:
		[
			(k = lck) 
			ifFalse: 
			[
				aNode addError: (HtmlAttributeNotLowerCaseError new attribute: k).
				aNode attributes at: lck put: v.
				aNode attributes removeKey: k.
			].
			v isNil ifTrue:
			[
				(self isXML or: [((attList attributeNamed: lck) allowsValue: lck) not]) ifTrue:
				[
					aNode addError: (HtmlAttributeValueMissingError new attribute: k).
				]
			]
			ifFalse:
			[
				((attList attributeNamed: lck) allowsValue: v) ifFalse:
				[
					aNode addError: (HtmlAttributeValueNotValidError new attribute: k).
				]
			]
		]					
	]
! !

!HtmlDTD methodsFor: 'actions' stamp: 'tb 12/16/2005 23:29'!
validateChildrenOfNode: aNode

	| element children stream |

	(aNode isComment or: [aNode isCDATA]) ifTrue: [^self].
	element := self elementForTag: aNode dtdTag.
	children := aNode children reject: [:ea | ea isComment].	

	stream := ReadStream on: children.
	(element contentRule validateChildren: stream ofNode: aNode)  
		ifTrue:[]	
		ifFalse:
		[
			stream atEnd ifFalse: 
			[
				(self tag: aNode dtdTag canContainTag: stream peek dtdTag) ifFalse:
				[
					stream peek addError: (HtmlTagImproperlyNestedError new)
				]
			].
		]
! !

HtmlDTD subclass: #XHtmlDTD
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

XHtmlDTD subclass: #XHtml1Strict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!XHtml1Strict class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 09:53'!
defaultUrl

	^'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd' asUrl! !

!XHtml1Strict class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 09:52'!
docType

	^'<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'! !

!XHtml1Strict methodsFor: 'resources' stamp: 'tb 12/3/2005 14:45'!
dtd
	^ '<!!--
   Extensible HTML version 1.0 Strict DTD

   This is the same as HTML 4 Strict except for
   changes due to the differences between XML and SGML.

   Namespace = http://www.w3.org/1999/xhtml

   For further information, see: http://www.w3.org/TR/xhtml1

   Copyright (c) 1998-2002 W3C (MIT, INRIA, Keio),
   All Rights Reserved. 

   This DTD module is identified by the PUBLIC and SYSTEM identifiers:

   PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   SYSTEM "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"

   $Revision: 1.1 $
   $Date: 2002/08/01 13:56:03 $

-->

<!!--================ Character mnemonic entities =========================-->

<!!ENTITY % HTMLlat1 PUBLIC
   "-//W3C//ENTITIES Latin 1 for XHTML//EN"
   "xhtml-lat1.ent">
%HTMLlat1;

<!!ENTITY % HTMLsymbol PUBLIC
   "-//W3C//ENTITIES Symbols for XHTML//EN"
   "xhtml-symbol.ent">
%HTMLsymbol;

<!!ENTITY % HTMLspecial PUBLIC
   "-//W3C//ENTITIES Special for XHTML//EN"
   "xhtml-special.ent">
%HTMLspecial;

<!!--================== Imported Names ====================================-->

<!!ENTITY % ContentType "CDATA">
    <!!-- media type, as per [RFC2045] -->

<!!ENTITY % ContentTypes "CDATA">
    <!!-- comma-separated list of media types, as per [RFC2045] -->

<!!ENTITY % Charset "CDATA">
    <!!-- a character encoding, as per [RFC2045] -->

<!!ENTITY % Charsets "CDATA">
    <!!-- a space separated list of character encodings, as per [RFC2045] -->

<!!ENTITY % LanguageCode "NMTOKEN">
    <!!-- a language code, as per [RFC3066] -->

<!!ENTITY % Character "CDATA">
    <!!-- a single character, as per section 2.2 of [XML] -->

<!!ENTITY % Number "CDATA">
    <!!-- one or more digits -->

<!!ENTITY % LinkTypes "CDATA">
    <!!-- space-separated list of link types -->

<!!ENTITY % MediaDesc "CDATA">
    <!!-- single or comma-separated list of media descriptors -->

<!!ENTITY % URI "CDATA">
    <!!-- a Uniform Resource Identifier, see [RFC2396] -->

<!!ENTITY % UriList "CDATA">
    <!!-- a space separated list of Uniform Resource Identifiers -->

<!!ENTITY % Datetime "CDATA">
    <!!-- date and time information. ISO date format -->

<!!ENTITY % Script "CDATA">
    <!!-- script expression -->

<!!ENTITY % StyleSheet "CDATA">
    <!!-- style sheet data -->

<!!ENTITY % Text "CDATA">
    <!!-- used for titles etc. -->

<!!ENTITY % Length "CDATA">
    <!!-- nn for pixels or nn% for percentage length -->

<!!ENTITY % MultiLength "CDATA">
    <!!-- pixel, percentage, or relative -->

<!!ENTITY % Pixels "CDATA">
    <!!-- integer representing length in pixels -->

<!!-- these are used for image maps -->

<!!ENTITY % Shape "(rect|circle|poly|default)">

<!!ENTITY % Coords "CDATA">
    <!!-- comma separated list of lengths -->

<!!--=================== Generic Attributes ===============================-->

<!!-- core attributes common to most elements
  id       document-wide unique id
  class    space separated list of classes
  style    associated style info
  title    advisory title/amplification
-->
<!!ENTITY % coreattrs
 "id          ID             #IMPLIED
  class       CDATA          #IMPLIED
  style       %StyleSheet;   #IMPLIED
  title       %Text;         #IMPLIED"
  >

<!!-- internationalization attributes
  lang        language code (backwards compatible)
  xml:lang    language code (as per XML 1.0 spec)
  dir         direction for weak/neutral text
-->
<!!ENTITY % i18n
 "lang        %LanguageCode; #IMPLIED
  xml:lang    %LanguageCode; #IMPLIED
  dir         (ltr|rtl)      #IMPLIED"
  >

<!!-- attributes for common UI events
  onclick     a pointer button was clicked
  ondblclick  a pointer button was double clicked
  onmousedown a pointer button was pressed down
  onmouseup   a pointer button was released
  onmousemove a pointer was moved onto the element
  onmouseout  a pointer was moved away from the element
  onkeypress  a key was pressed and released
  onkeydown   a key was pressed down
  onkeyup     a key was released
-->
<!!ENTITY % events
 "onclick     %Script;       #IMPLIED
  ondblclick  %Script;       #IMPLIED
  onmousedown %Script;       #IMPLIED
  onmouseup   %Script;       #IMPLIED
  onmouseover %Script;       #IMPLIED
  onmousemove %Script;       #IMPLIED
  onmouseout  %Script;       #IMPLIED
  onkeypress  %Script;       #IMPLIED
  onkeydown   %Script;       #IMPLIED
  onkeyup     %Script;       #IMPLIED"
  >

<!!-- attributes for elements that can get the focus
  accesskey   accessibility key character
  tabindex    position in tabbing order
  onfocus     the element got the focus
  onblur      the element lost the focus
-->
<!!ENTITY % focus
 "accesskey   %Character;    #IMPLIED
  tabindex    %Number;       #IMPLIED
  onfocus     %Script;       #IMPLIED
  onblur      %Script;       #IMPLIED"
  >

<!!ENTITY % attrs "%coreattrs; %i18n; %events;">

<!!--=================== Text Elements ====================================-->

<!!ENTITY % special.pre
   "br | span | bdo | map">


<!!ENTITY % special
   "%special.pre; | object | img ">

<!!ENTITY % fontstyle "tt | i | b | big | small ">

<!!ENTITY % phrase "em | strong | dfn | code | q |
                   samp | kbd | var | cite | abbr | acronym | sub | sup ">

<!!ENTITY % inline.forms "input | select | textarea | label | button">

<!!-- these can occur at block or inline level -->
<!!ENTITY % misc.inline "ins | del | script">

<!!-- these can only occur at block level -->
<!!ENTITY % misc "noscript | %misc.inline;">

<!!ENTITY % inline "a | %special; | %fontstyle; | %phrase; | %inline.forms;">

<!!-- %Inline; covers inline or "text-level" elements -->
<!!ENTITY % Inline "(#PCDATA | %inline; | %misc.inline;)*">

<!!--================== Block level elements ==============================-->

<!!ENTITY % heading "h1|h2|h3|h4|h5|h6">
<!!ENTITY % lists "ul | ol | dl">
<!!ENTITY % blocktext "pre | hr | blockquote | address">

<!!ENTITY % block
     "p | %heading; | div | %lists; | %blocktext; | fieldset | table">

<!!ENTITY % Block "(%block; | form | %misc;)*">

<!!-- %Flow; mixes block and inline and is used for list items etc. -->
<!!ENTITY % Flow "(#PCDATA | %block; | form | %inline; | %misc;)*">

<!!--================== Content models for exclusions =====================-->

<!!-- a elements use %Inline; excluding a -->

<!!ENTITY % a.content
   "(#PCDATA | %special; | %fontstyle; | %phrase; | %inline.forms; | %misc.inline;)*">

<!!-- pre uses %Inline excluding big, small, sup or sup -->

<!!ENTITY % pre.content
   "(#PCDATA | a | %fontstyle; | %phrase; | %special.pre; | %misc.inline;
      | %inline.forms;)*">

<!!-- form uses %Block; excluding form -->

<!!ENTITY % form.content "(%block; | %misc;)*">

<!!-- button uses %Flow; but excludes a, form and form controls -->

<!!ENTITY % button.content
   "(#PCDATA | p | %heading; | div | %lists; | %blocktext; |
    table | %special; | %fontstyle; | %phrase; | %misc;)*">

<!!--================ Document Structure ==================================-->

<!!-- the namespace URI designates the document profile -->

<!!ELEMENT html (head, body)>
<!!ATTLIST html
  %i18n;
  id          ID             #IMPLIED
  xmlns       %URI;          #FIXED ''http://www.w3.org/1999/xhtml''
  >

<!!--================ Document Head =======================================-->

<!!ENTITY % head.misc "(script|style|meta|link|object)*">

<!!-- content model is %head.misc; combined with a single
     title and an optional base element in any order -->

<!!ELEMENT head (%head.misc;,
     ((title, %head.misc;, (base, %head.misc;)?) |
      (base, %head.misc;, (title, %head.misc;))))>

<!!ATTLIST head
  %i18n;
  id          ID             #IMPLIED
  profile     %URI;          #IMPLIED
  >

<!!-- The title element is not considered part of the flow of text.
       It should be displayed, for example as the page header or
       window title. Exactly one title is required per document.
    -->
<!!ELEMENT title (#PCDATA)>
<!!ATTLIST title 
  %i18n;
  id          ID             #IMPLIED
  >

<!!-- document base URI -->

<!!ELEMENT base EMPTY>
<!!ATTLIST base
  href        %URI;          #REQUIRED
  id          ID             #IMPLIED
  >

<!!-- generic metainformation -->
<!!ELEMENT meta EMPTY>
<!!ATTLIST meta
  %i18n;
  id          ID             #IMPLIED
  http-equiv  CDATA          #IMPLIED
  name        CDATA          #IMPLIED
  content     CDATA          #REQUIRED
  scheme      CDATA          #IMPLIED
  >

<!!--
  Relationship values can be used in principle:

   a) for document specific toolbars/menus when used
      with the link element in document head e.g.
        start, contents, previous, next, index, end, help
   b) to link to a separate style sheet (rel="stylesheet")
   c) to make a link to a script (rel="script")
   d) by stylesheets to control how collections of
      html nodes are rendered into printed documents
   e) to make a link to a printable version of this document
      e.g. a PostScript or PDF version (rel="alternate" media="print")
-->

<!!ELEMENT link EMPTY>
<!!ATTLIST link
  %attrs;
  charset     %Charset;      #IMPLIED
  href        %URI;          #IMPLIED
  hreflang    %LanguageCode; #IMPLIED
  type        %ContentType;  #IMPLIED
  rel         %LinkTypes;    #IMPLIED
  rev         %LinkTypes;    #IMPLIED
  media       %MediaDesc;    #IMPLIED
  >

<!!-- style info, which may include CDATA sections -->
<!!ELEMENT style (#PCDATA)>
<!!ATTLIST style
  %i18n;
  id          ID             #IMPLIED
  type        %ContentType;  #REQUIRED
  media       %MediaDesc;    #IMPLIED
  title       %Text;         #IMPLIED
  xml:space   (preserve)     #FIXED ''preserve''
  >

<!!-- script statements, which may include CDATA sections -->
<!!ELEMENT script (#PCDATA)>
<!!ATTLIST script
  id          ID             #IMPLIED
  charset     %Charset;      #IMPLIED
  type        %ContentType;  #REQUIRED
  src         %URI;          #IMPLIED
  defer       (defer)        #IMPLIED
  xml:space   (preserve)     #FIXED ''preserve''
  >

<!!-- alternate content container for non script-based rendering -->

<!!ELEMENT noscript %Block;>
<!!ATTLIST noscript
  %attrs;
  >

<!!--=================== Document Body ====================================-->

<!!ELEMENT body %Block;>
<!!ATTLIST body
  %attrs;
  onload          %Script;   #IMPLIED
  onunload        %Script;   #IMPLIED
  >

<!!ELEMENT div %Flow;>  <!!-- generic language/style container -->
<!!ATTLIST div
  %attrs;
  >

<!!--=================== Paragraphs =======================================-->

<!!ELEMENT p %Inline;>
<!!ATTLIST p
  %attrs;
  >

<!!--=================== Headings =========================================-->

<!!--
  There are six levels of headings from h1 (the most important)
  to h6 (the least important).
-->

<!!ELEMENT h1  %Inline;>
<!!ATTLIST h1
   %attrs;
   >

<!!ELEMENT h2 %Inline;>
<!!ATTLIST h2
   %attrs;
   >

<!!ELEMENT h3 %Inline;>
<!!ATTLIST h3
   %attrs;
   >

<!!ELEMENT h4 %Inline;>
<!!ATTLIST h4
   %attrs;
   >

<!!ELEMENT h5 %Inline;>
<!!ATTLIST h5
   %attrs;
   >

<!!ELEMENT h6 %Inline;>
<!!ATTLIST h6
   %attrs;
   >

<!!--=================== Lists ============================================-->

<!!-- Unordered list -->

<!!ELEMENT ul (li)+>
<!!ATTLIST ul
  %attrs;
  >

<!!-- Ordered (numbered) list -->

<!!ELEMENT ol (li)+>
<!!ATTLIST ol
  %attrs;
  >

<!!-- list item -->

<!!ELEMENT li %Flow;>
<!!ATTLIST li
  %attrs;
  >

<!!-- definition lists - dt for term, dd for its definition -->

<!!ELEMENT dl (dt|dd)+>
<!!ATTLIST dl
  %attrs;
  >

<!!ELEMENT dt %Inline;>
<!!ATTLIST dt
  %attrs;
  >

<!!ELEMENT dd %Flow;>
<!!ATTLIST dd
  %attrs;
  >

<!!--=================== Address ==========================================-->

<!!-- information on author -->

<!!ELEMENT address %Inline;>
<!!ATTLIST address
  %attrs;
  >

<!!--=================== Horizontal Rule ==================================-->

<!!ELEMENT hr EMPTY>
<!!ATTLIST hr
  %attrs;
  >

<!!--=================== Preformatted Text ================================-->

<!!-- content is %Inline; excluding "img|object|big|small|sub|sup" -->

<!!ELEMENT pre %pre.content;>
<!!ATTLIST pre
  %attrs;
  xml:space (preserve) #FIXED ''preserve''
  >

<!!--=================== Block-like Quotes ================================-->

<!!ELEMENT blockquote %Block;>
<!!ATTLIST blockquote
  %attrs;
  cite        %URI;          #IMPLIED
  >

<!!--=================== Inserted/Deleted Text ============================-->

<!!--
  ins/del are allowed in block and inline content, but its
  inappropriate to include block content within an ins element
  occurring in inline content.
-->
<!!ELEMENT ins %Flow;>
<!!ATTLIST ins
  %attrs;
  cite        %URI;          #IMPLIED
  datetime    %Datetime;     #IMPLIED
  >

<!!ELEMENT del %Flow;>
<!!ATTLIST del
  %attrs;
  cite        %URI;          #IMPLIED
  datetime    %Datetime;     #IMPLIED
  >

<!!--================== The Anchor Element ================================-->

<!!-- content is %Inline; except that anchors shouldn''t be nested -->

<!!ELEMENT a %a.content;>
<!!ATTLIST a
  %attrs;
  %focus;
  charset     %Charset;      #IMPLIED
  type        %ContentType;  #IMPLIED
  name        NMTOKEN        #IMPLIED
  href        %URI;          #IMPLIED
  hreflang    %LanguageCode; #IMPLIED
  rel         %LinkTypes;    #IMPLIED
  rev         %LinkTypes;    #IMPLIED
  shape       %Shape;        "rect"
  coords      %Coords;       #IMPLIED
  >

<!!--===================== Inline Elements ================================-->

<!!ELEMENT span %Inline;> <!!-- generic language/style container -->
<!!ATTLIST span
  %attrs;
  >

<!!ELEMENT bdo %Inline;>  <!!-- I18N BiDi over-ride -->
<!!ATTLIST bdo
  %coreattrs;
  %events;
  lang        %LanguageCode; #IMPLIED
  xml:lang    %LanguageCode; #IMPLIED
  dir         (ltr|rtl)      #REQUIRED
  >

<!!ELEMENT br EMPTY>   <!!-- forced line break -->
<!!ATTLIST br
  %coreattrs;
  >

<!!ELEMENT em %Inline;>   <!!-- emphasis -->
<!!ATTLIST em %attrs;>

<!!ELEMENT strong %Inline;>   <!!-- strong emphasis -->
<!!ATTLIST strong %attrs;>

<!!ELEMENT dfn %Inline;>   <!!-- definitional -->
<!!ATTLIST dfn %attrs;>

<!!ELEMENT code %Inline;>   <!!-- program code -->
<!!ATTLIST code %attrs;>

<!!ELEMENT samp %Inline;>   <!!-- sample -->
<!!ATTLIST samp %attrs;>

<!!ELEMENT kbd %Inline;>  <!!-- something user would type -->
<!!ATTLIST kbd %attrs;>

<!!ELEMENT var %Inline;>   <!!-- variable -->
<!!ATTLIST var %attrs;>

<!!ELEMENT cite %Inline;>   <!!-- citation -->
<!!ATTLIST cite %attrs;>

<!!ELEMENT abbr %Inline;>   <!!-- abbreviation -->
<!!ATTLIST abbr %attrs;>

<!!ELEMENT acronym %Inline;>   <!!-- acronym -->
<!!ATTLIST acronym %attrs;>

<!!ELEMENT q %Inline;>   <!!-- inlined quote -->
<!!ATTLIST q
  %attrs;
  cite        %URI;          #IMPLIED
  >

<!!ELEMENT sub %Inline;> <!!-- subscript -->
<!!ATTLIST sub %attrs;>

<!!ELEMENT sup %Inline;> <!!-- superscript -->
<!!ATTLIST sup %attrs;>

<!!ELEMENT tt %Inline;>   <!!-- fixed pitch font -->
<!!ATTLIST tt %attrs;>

<!!ELEMENT i %Inline;>   <!!-- italic font -->
<!!ATTLIST i %attrs;>

<!!ELEMENT b %Inline;>   <!!-- bold font -->
<!!ATTLIST b %attrs;>

<!!ELEMENT big %Inline;>   <!!-- bigger font -->
<!!ATTLIST big %attrs;>

<!!ELEMENT small %Inline;>   <!!-- smaller font -->
<!!ATTLIST small %attrs;>

<!!--==================== Object ======================================-->
<!!--
  object is used to embed objects as part of HTML pages.
  param elements should precede other content. Parameters
  can also be expressed as attribute/value pairs on the
  object element itself when brevity is desired.
-->

<!!ELEMENT object (#PCDATA | param | %block; | form | %inline; | %misc;)*>
<!!ATTLIST object
  %attrs;
  declare     (declare)      #IMPLIED
  classid     %URI;          #IMPLIED
  codebase    %URI;          #IMPLIED
  data        %URI;          #IMPLIED
  type        %ContentType;  #IMPLIED
  codetype    %ContentType;  #IMPLIED
  archive     %UriList;      #IMPLIED
  standby     %Text;         #IMPLIED
  height      %Length;       #IMPLIED
  width       %Length;       #IMPLIED
  usemap      %URI;          #IMPLIED
  name        NMTOKEN        #IMPLIED
  tabindex    %Number;       #IMPLIED
  >

<!!--
  param is used to supply a named property value.
  In XML it would seem natural to follow RDF and support an
  abbreviated syntax where the param elements are replaced
  by attribute value pairs on the object start tag.
-->
<!!ELEMENT param EMPTY>
<!!ATTLIST param
  id          ID             #IMPLIED
  name        CDATA          #IMPLIED
  value       CDATA          #IMPLIED
  valuetype   (data|ref|object) "data"
  type        %ContentType;  #IMPLIED
  >

<!!--=================== Images ===========================================-->

<!!--
   To avoid accessibility problems for people who aren''t
   able to see the image, you should provide a text
   description using the alt and longdesc attributes.
   In addition, avoid the use of server-side image maps.
   Note that in this DTD there is no name attribute. That
   is only available in the transitional and frameset DTD.
-->

<!!ELEMENT img EMPTY>
<!!ATTLIST img
  %attrs;
  src         %URI;          #REQUIRED
  alt         %Text;         #REQUIRED
  longdesc    %URI;          #IMPLIED
  height      %Length;       #IMPLIED
  width       %Length;       #IMPLIED
  usemap      %URI;          #IMPLIED
  ismap       (ismap)        #IMPLIED
  >

<!!-- usemap points to a map element which may be in this document
  or an external document, although the latter is not widely supported -->

<!!--================== Client-side image maps ============================-->

<!!-- These can be placed in the same document or grouped in a
     separate document although this isn''t yet widely supported -->

<!!ELEMENT map ((%block; | form | %misc;)+ | area+)>
<!!ATTLIST map
  %i18n;
  %events;
  id          ID             #REQUIRED
  class       CDATA          #IMPLIED
  style       %StyleSheet;   #IMPLIED
  title       %Text;         #IMPLIED
  name        NMTOKEN        #IMPLIED
  >

<!!ELEMENT area EMPTY>
<!!ATTLIST area
  %attrs;
  %focus;
  shape       %Shape;        "rect"
  coords      %Coords;       #IMPLIED
  href        %URI;          #IMPLIED
  nohref      (nohref)       #IMPLIED
  alt         %Text;         #REQUIRED
  >

<!!--================ Forms ===============================================-->
<!!ELEMENT form %form.content;>   <!!-- forms shouldn''t be nested -->

<!!ATTLIST form
  %attrs;
  action      %URI;          #REQUIRED
  method      (get|post)     "get"
  enctype     %ContentType;  "application/x-www-form-urlencoded"
  onsubmit    %Script;       #IMPLIED
  onreset     %Script;       #IMPLIED
  accept      %ContentTypes; #IMPLIED
  accept-charset %Charsets;  #IMPLIED
  >

<!!--
  Each label must not contain more than ONE field
  Label elements shouldn''t be nested.
-->
<!!ELEMENT label %Inline;>
<!!ATTLIST label
  %attrs;
  for         IDREF          #IMPLIED
  accesskey   %Character;    #IMPLIED
  onfocus     %Script;       #IMPLIED
  onblur      %Script;       #IMPLIED
  >

<!!ENTITY % InputType
  "(text | password | checkbox |
    radio | submit | reset |
    file | hidden | image | button)"
   >

<!!-- the name attribute is required for all but submit & reset -->

<!!ELEMENT input EMPTY>     <!!-- form control -->
<!!ATTLIST input
  %attrs;
  %focus;
  type        %InputType;    "text"
  name        CDATA          #IMPLIED
  value       CDATA          #IMPLIED
  checked     (checked)      #IMPLIED
  disabled    (disabled)     #IMPLIED
  readonly    (readonly)     #IMPLIED
  size        CDATA          #IMPLIED
  maxlength   %Number;       #IMPLIED
  src         %URI;          #IMPLIED
  alt         CDATA          #IMPLIED
  usemap      %URI;          #IMPLIED
  onselect    %Script;       #IMPLIED
  onchange    %Script;       #IMPLIED
  accept      %ContentTypes; #IMPLIED
  >

<!!ELEMENT select (optgroup|option)+>  <!!-- option selector -->
<!!ATTLIST select
  %attrs;
  name        CDATA          #IMPLIED
  size        %Number;       #IMPLIED
  multiple    (multiple)     #IMPLIED
  disabled    (disabled)     #IMPLIED
  tabindex    %Number;       #IMPLIED
  onfocus     %Script;       #IMPLIED
  onblur      %Script;       #IMPLIED
  onchange    %Script;       #IMPLIED
  >

<!!ELEMENT optgroup (option)+>   <!!-- option group -->
<!!ATTLIST optgroup
  %attrs;
  disabled    (disabled)     #IMPLIED
  label       %Text;         #REQUIRED
  >

<!!ELEMENT option (#PCDATA)>     <!!-- selectable choice -->
<!!ATTLIST option
  %attrs;
  selected    (selected)     #IMPLIED
  disabled    (disabled)     #IMPLIED
  label       %Text;         #IMPLIED
  value       CDATA          #IMPLIED
  >

<!!ELEMENT textarea (#PCDATA)>     <!!-- multi-line text field -->
<!!ATTLIST textarea
  %attrs;
  %focus;
  name        CDATA          #IMPLIED
  rows        %Number;       #REQUIRED
  cols        %Number;       #REQUIRED
  disabled    (disabled)     #IMPLIED
  readonly    (readonly)     #IMPLIED
  onselect    %Script;       #IMPLIED
  onchange    %Script;       #IMPLIED
  >

<!!--
  The fieldset element is used to group form fields.
  Only one legend element should occur in the content
  and if present should only be preceded by whitespace.
-->
<!!ELEMENT fieldset (#PCDATA | legend | %block; | form | %inline; | %misc;)*>
<!!ATTLIST fieldset
  %attrs;
  >

<!!ELEMENT legend %Inline;>     <!!-- fieldset label -->
<!!ATTLIST legend
  %attrs;
  accesskey   %Character;    #IMPLIED
  >

<!!--
 Content is %Flow; excluding a, form and form controls
--> 
<!!ELEMENT button %button.content;>  <!!-- push button -->
<!!ATTLIST button
  %attrs;
  %focus;
  name        CDATA          #IMPLIED
  value       CDATA          #IMPLIED
  type        (button|submit|reset) "submit"
  disabled    (disabled)     #IMPLIED
  >

<!!--======================= Tables =======================================-->

<!!-- Derived from IETF HTML table standard, see [RFC1942] -->

<!!--
 The border attribute sets the thickness of the frame around the
 table. The default units are screen pixels.

 The frame attribute specifies which parts of the frame around
 the table should be rendered. The values are not the same as
 CALS to avoid a name clash with the valign attribute.
-->
<!!ENTITY % TFrame "(void|above|below|hsides|lhs|rhs|vsides|box|border)">

<!!--
 The rules attribute defines which rules to draw between cells:

 If rules is absent then assume:
     "none" if border is absent or border="0" otherwise "all"
-->

<!!ENTITY % TRules "(none | groups | rows | cols | all)">
  
<!!-- horizontal alignment attributes for cell contents

  char        alignment char, e.g. char='':''
  charoff     offset for alignment char
-->
<!!ENTITY % cellhalign
  "align      (left|center|right|justify|char) #IMPLIED
   char       %Character;    #IMPLIED
   charoff    %Length;       #IMPLIED"
  >

<!!-- vertical alignment attributes for cell contents -->
<!!ENTITY % cellvalign
  "valign     (top|middle|bottom|baseline) #IMPLIED"
  >

<!!ELEMENT table
     (caption?, (col*|colgroup*), thead?, tfoot?, (tbody+|tr+))>
<!!ELEMENT caption  %Inline;>
<!!ELEMENT thead    (tr)+>
<!!ELEMENT tfoot    (tr)+>
<!!ELEMENT tbody    (tr)+>
<!!ELEMENT colgroup (col)*>
<!!ELEMENT col      EMPTY>
<!!ELEMENT tr       (th|td)+>
<!!ELEMENT th       %Flow;>
<!!ELEMENT td       %Flow;>

<!!ATTLIST table
  %attrs;
  summary     %Text;         #IMPLIED
  width       %Length;       #IMPLIED
  border      %Pixels;       #IMPLIED
  frame       %TFrame;       #IMPLIED
  rules       %TRules;       #IMPLIED
  cellspacing %Length;       #IMPLIED
  cellpadding %Length;       #IMPLIED
  >

<!!ATTLIST caption
  %attrs;
  >

<!!--
colgroup groups a set of col elements. It allows you to group
several semantically related columns together.
-->
<!!ATTLIST colgroup
  %attrs;
  span        %Number;       "1"
  width       %MultiLength;  #IMPLIED
  %cellhalign;
  %cellvalign;
  >

<!!--
 col elements define the alignment properties for cells in
 one or more columns.

 The width attribute specifies the width of the columns, e.g.

     width=64        width in screen pixels
     width=0.5*      relative width of 0.5

 The span attribute causes the attributes of one
 col element to apply to more than one column.
-->
<!!ATTLIST col
  %attrs;
  span        %Number;       "1"
  width       %MultiLength;  #IMPLIED
  %cellhalign;
  %cellvalign;
  >

<!!--
    Use thead to duplicate headers when breaking table
    across page boundaries, or for static headers when
    tbody sections are rendered in scrolling panel.

    Use tfoot to duplicate footers when breaking table
    across page boundaries, or for static footers when
    tbody sections are rendered in scrolling panel.

    Use multiple tbody sections when rules are needed
    between groups of table rows.
-->
<!!ATTLIST thead
  %attrs;
  %cellhalign;
  %cellvalign;
  >

<!!ATTLIST tfoot
  %attrs;
  %cellhalign;
  %cellvalign;
  >

<!!ATTLIST tbody
  %attrs;
  %cellhalign;
  %cellvalign;
  >

<!!ATTLIST tr
  %attrs;
  %cellhalign;
  %cellvalign;
  >


<!!-- Scope is simpler than headers attribute for common tables -->
<!!ENTITY % Scope "(row|col|rowgroup|colgroup)">

<!!-- th is for headers, td for data and for cells acting as both -->

<!!ATTLIST th
  %attrs;
  abbr        %Text;         #IMPLIED
  axis        CDATA          #IMPLIED
  headers     IDREFS         #IMPLIED
  scope       %Scope;        #IMPLIED
  rowspan     %Number;       "1"
  colspan     %Number;       "1"
  %cellhalign;
  %cellvalign;
  >

<!!ATTLIST td
  %attrs;
  abbr        %Text;         #IMPLIED
  axis        CDATA          #IMPLIED
  headers     IDREFS         #IMPLIED
  scope       %Scope;        #IMPLIED
  rowspan     %Number;       "1"
  colspan     %Number;       "1"
  %cellhalign;
  %cellvalign;
  >


'! !

!XHtml1Strict methodsFor: 'initialize-release' stamp: 'tb 12/1/2005 09:50'!
initialize

	super initialize.
	self parse.! !

XHtmlDTD subclass: #XHtml1Transitional
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!XHtml1Transitional class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 09:51'!
defaultUrl

	^'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd' asUrl! !

!XHtml1Transitional class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 09:48'!
docType

	^'<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'! !

!XHtml1Transitional methodsFor: 'resources' stamp: ''!
dtd
	^ '<!!--
   Extensible HTML version 1.0 Transitional DTD

   This is the same as HTML 4 Transitional except for
   changes due to the differences between XML and SGML.

   Namespace = http://www.w3.org/1999/xhtml

   For further information, see: http://www.w3.org/TR/xhtml1

   Copyright (c) 1998-2002 W3C (MIT, INRIA, Keio),
   All Rights Reserved. 

   This DTD module is identified by the PUBLIC and SYSTEM identifiers:

   PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
   SYSTEM "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"

   $Revision: 1.2 $
   $Date: 2002/08/01 18:37:55 $

-->

<!!--================ Character mnemonic entities =========================-->

<!!ENTITY % HTMLlat1 PUBLIC
   "-//W3C//ENTITIES Latin 1 for XHTML//EN"
   "xhtml-lat1.ent">
%HTMLlat1;

<!!ENTITY % HTMLsymbol PUBLIC
   "-//W3C//ENTITIES Symbols for XHTML//EN"
   "xhtml-symbol.ent">
%HTMLsymbol;

<!!ENTITY % HTMLspecial PUBLIC
   "-//W3C//ENTITIES Special for XHTML//EN"
   "xhtml-special.ent">
%HTMLspecial;

<!!--================== Imported Names ====================================-->

<!!ENTITY % ContentType "CDATA">
    <!!-- media type, as per [RFC2045] -->

<!!ENTITY % ContentTypes "CDATA">
    <!!-- comma-separated list of media types, as per [RFC2045] -->

<!!ENTITY % Charset "CDATA">
    <!!-- a character encoding, as per [RFC2045] -->

<!!ENTITY % Charsets "CDATA">
    <!!-- a space separated list of character encodings, as per [RFC2045] -->

<!!ENTITY % LanguageCode "NMTOKEN">
    <!!-- a language code, as per [RFC3066] -->

<!!ENTITY % Character "CDATA">
    <!!-- a single character, as per section 2.2 of [XML] -->

<!!ENTITY % Number "CDATA">
    <!!-- one or more digits -->

<!!ENTITY % LinkTypes "CDATA">
    <!!-- space-separated list of link types -->

<!!ENTITY % MediaDesc "CDATA">
    <!!-- single or comma-separated list of media descriptors -->

<!!ENTITY % URI "CDATA">
    <!!-- a Uniform Resource Identifier, see [RFC2396] -->

<!!ENTITY % UriList "CDATA">
    <!!-- a space separated list of Uniform Resource Identifiers -->

<!!ENTITY % Datetime "CDATA">
    <!!-- date and time information. ISO date format -->

<!!ENTITY % Script "CDATA">
    <!!-- script expression -->

<!!ENTITY % StyleSheet "CDATA">
    <!!-- style sheet data -->

<!!ENTITY % Text "CDATA">
    <!!-- used for titles etc. -->

<!!ENTITY % FrameTarget "NMTOKEN">
    <!!-- render in this frame -->

<!!ENTITY % Length "CDATA">
    <!!-- nn for pixels or nn% for percentage length -->

<!!ENTITY % MultiLength "CDATA">
    <!!-- pixel, percentage, or relative -->

<!!ENTITY % Pixels "CDATA">
    <!!-- integer representing length in pixels -->

<!!-- these are used for image maps -->

<!!ENTITY % Shape "(rect|circle|poly|default)">

<!!ENTITY % Coords "CDATA">
    <!!-- comma separated list of lengths -->

<!!-- used for object, applet, img, input and iframe -->
<!!ENTITY % ImgAlign "(top|middle|bottom|left|right)">

<!!-- a color using sRGB: #RRGGBB as Hex values -->
<!!ENTITY % Color "CDATA">

<!!-- There are also 16 widely known color names with their sRGB values:

    Black  = #000000    Green  = #008000
    Silver = #C0C0C0    Lime   = #00FF00
    Gray   = #808080    Olive  = #808000
    White  = #FFFFFF    Yellow = #FFFF00
    Maroon = #800000    Navy   = #000080
    Red    = #FF0000    Blue   = #0000FF
    Purple = #800080    Teal   = #008080
    Fuchsia= #FF00FF    Aqua   = #00FFFF
-->

<!!--=================== Generic Attributes ===============================-->

<!!-- core attributes common to most elements
  id       document-wide unique id
  class    space separated list of classes
  style    associated style info
  title    advisory title/amplification
-->
<!!ENTITY % coreattrs
 "id          ID             #IMPLIED
  class       CDATA          #IMPLIED
  style       %StyleSheet;   #IMPLIED
  title       %Text;         #IMPLIED"
  >

<!!-- internationalization attributes
  lang        language code (backwards compatible)
  xml:lang    language code (as per XML 1.0 spec)
  dir         direction for weak/neutral text
-->
<!!ENTITY % i18n
 "lang        %LanguageCode; #IMPLIED
  xml:lang    %LanguageCode; #IMPLIED
  dir         (ltr|rtl)      #IMPLIED"
  >

<!!-- attributes for common UI events
  onclick     a pointer button was clicked
  ondblclick  a pointer button was double clicked
  onmousedown a pointer button was pressed down
  onmouseup   a pointer button was released
  onmousemove a pointer was moved onto the element
  onmouseout  a pointer was moved away from the element
  onkeypress  a key was pressed and released
  onkeydown   a key was pressed down
  onkeyup     a key was released
-->
<!!ENTITY % events
 "onclick     %Script;       #IMPLIED
  ondblclick  %Script;       #IMPLIED
  onmousedown %Script;       #IMPLIED
  onmouseup   %Script;       #IMPLIED
  onmouseover %Script;       #IMPLIED
  onmousemove %Script;       #IMPLIED
  onmouseout  %Script;       #IMPLIED
  onkeypress  %Script;       #IMPLIED
  onkeydown   %Script;       #IMPLIED
  onkeyup     %Script;       #IMPLIED"
  >

<!!-- attributes for elements that can get the focus
  accesskey   accessibility key character
  tabindex    position in tabbing order
  onfocus     the element got the focus
  onblur      the element lost the focus
-->
<!!ENTITY % focus
 "accesskey   %Character;    #IMPLIED
  tabindex    %Number;       #IMPLIED
  onfocus     %Script;       #IMPLIED
  onblur      %Script;       #IMPLIED"
  >

<!!ENTITY % attrs "%coreattrs; %i18n; %events;">

<!!-- text alignment for p, div, h1-h6. The default is
     align="left" for ltr headings, "right" for rtl -->

<!!ENTITY % TextAlign "align (left|center|right|justify) #IMPLIED">

<!!--=================== Text Elements ====================================-->

<!!ENTITY % special.extra
   "object | applet | img | map | iframe">
	
<!!ENTITY % special.basic
	"br | span | bdo">

<!!ENTITY % special
   "%special.basic; | %special.extra;">

<!!ENTITY % fontstyle.extra "big | small | font | basefont">

<!!ENTITY % fontstyle.basic "tt | i | b | u
                      | s | strike ">

<!!ENTITY % fontstyle "%fontstyle.basic; | %fontstyle.extra;">

<!!ENTITY % phrase.extra "sub | sup">
<!!ENTITY % phrase.basic "em | strong | dfn | code | q |
                   samp | kbd | var | cite | abbr | acronym">

<!!ENTITY % phrase "%phrase.basic; | %phrase.extra;">

<!!ENTITY % inline.forms "input | select | textarea | label | button">

<!!-- these can occur at block or inline level -->
<!!ENTITY % misc.inline "ins | del | script">

<!!-- these can only occur at block level -->
<!!ENTITY % misc "noscript | %misc.inline;">

<!!ENTITY % inline "a | %special; | %fontstyle; | %phrase; | %inline.forms;">

<!!-- %Inline; covers inline or "text-level" elements -->
<!!ENTITY % Inline "(#PCDATA | %inline; | %misc.inline;)*">

<!!--================== Block level elements ==============================-->

<!!ENTITY % heading "h1|h2|h3|h4|h5|h6">
<!!ENTITY % lists "ul | ol | dl | menu | dir">
<!!ENTITY % blocktext "pre | hr | blockquote | address | center | noframes">

<!!ENTITY % block
    "p | %heading; | div | %lists; | %blocktext; | isindex |fieldset | table">

<!!-- %Flow; mixes block and inline and is used for list items etc. -->
<!!ENTITY % Flow "(#PCDATA | %block; | form | %inline; | %misc;)*">

<!!--================== Content models for exclusions =====================-->

<!!-- a elements use %Inline; excluding a -->

<!!ENTITY % a.content
   "(#PCDATA | %special; | %fontstyle; | %phrase; | %inline.forms; | %misc.inline;)*">

<!!-- pre uses %Inline excluding img, object, applet, big, small,
     font, or basefont -->

<!!ENTITY % pre.content
   "(#PCDATA | a | %special.basic; | %fontstyle.basic; | %phrase.basic; |
	   %inline.forms; | %misc.inline;)*">

<!!-- form uses %Flow; excluding form -->

<!!ENTITY % form.content "(#PCDATA | %block; | %inline; | %misc;)*">

<!!-- button uses %Flow; but excludes a, form, form controls, iframe -->

<!!ENTITY % button.content
   "(#PCDATA | p | %heading; | div | %lists; | %blocktext; |
      table | br | span | bdo | object | applet | img | map |
      %fontstyle; | %phrase; | %misc;)*">

<!!--================ Document Structure ==================================-->

<!!-- the namespace URI designates the document profile -->

<!!ELEMENT html (head, body)>
<!!ATTLIST html
  %i18n;
  id          ID             #IMPLIED
  xmlns       %URI;          #FIXED ''http://www.w3.org/1999/xhtml''
  >

<!!--================ Document Head =======================================-->

<!!ENTITY % head.misc "(script|style|meta|link|object|isindex)*">

<!!-- content model is %head.misc; combined with a single
     title and an optional base element in any order -->

<!!ELEMENT head (%head.misc;,
     ((title, %head.misc;, (base, %head.misc;)?) |
      (base, %head.misc;, (title, %head.misc;))))>

<!!ATTLIST head
  %i18n;
  id          ID             #IMPLIED
  profile     %URI;          #IMPLIED
  >

<!!-- The title element is not considered part of the flow of text.
       It should be displayed, for example as the page header or
       window title. Exactly one title is required per document.
    -->
<!!ELEMENT title (#PCDATA)>
<!!ATTLIST title 
  %i18n;
  id          ID             #IMPLIED
  >

<!!-- document base URI -->

<!!ELEMENT base EMPTY>
<!!ATTLIST base
  id          ID             #IMPLIED
  href        %URI;          #IMPLIED
  target      %FrameTarget;  #IMPLIED
  >

<!!-- generic metainformation -->
<!!ELEMENT meta EMPTY>
<!!ATTLIST meta
  %i18n;
  id          ID             #IMPLIED
  http-equiv  CDATA          #IMPLIED
  name        CDATA          #IMPLIED
  content     CDATA          #REQUIRED
  scheme      CDATA          #IMPLIED
  >

<!!--
  Relationship values can be used in principle:

   a) for document specific toolbars/menus when used
      with the link element in document head e.g.
        start, contents, previous, next, index, end, help
   b) to link to a separate style sheet (rel="stylesheet")
   c) to make a link to a script (rel="script")
   d) by stylesheets to control how collections of
      html nodes are rendered into printed documents
   e) to make a link to a printable version of this document
      e.g. a PostScript or PDF version (rel="alternate" media="print")
-->

<!!ELEMENT link EMPTY>
<!!ATTLIST link
  %attrs;
  charset     %Charset;      #IMPLIED
  href        %URI;          #IMPLIED
  hreflang    %LanguageCode; #IMPLIED
  type        %ContentType;  #IMPLIED
  rel         %LinkTypes;    #IMPLIED
  rev         %LinkTypes;    #IMPLIED
  media       %MediaDesc;    #IMPLIED
  target      %FrameTarget;  #IMPLIED
  >

<!!-- style info, which may include CDATA sections -->
<!!ELEMENT style (#PCDATA)>
<!!ATTLIST style
  %i18n;
  id          ID             #IMPLIED
  type        %ContentType;  #REQUIRED
  media       %MediaDesc;    #IMPLIED
  title       %Text;         #IMPLIED
  xml:space   (preserve)     #FIXED ''preserve''
  >

<!!-- script statements, which may include CDATA sections -->
<!!ELEMENT script (#PCDATA)>
<!!ATTLIST script
  id          ID             #IMPLIED
  charset     %Charset;      #IMPLIED
  type        %ContentType;  #REQUIRED
  language    CDATA          #IMPLIED
  src         %URI;          #IMPLIED
  defer       (defer)        #IMPLIED
  xml:space   (preserve)     #FIXED ''preserve''
  >

<!!-- alternate content container for non script-based rendering -->

<!!ELEMENT noscript %Flow;>
<!!ATTLIST noscript
  %attrs;
  >

<!!--======================= Frames =======================================-->

<!!-- inline subwindow -->

<!!ELEMENT iframe %Flow;>
<!!ATTLIST iframe
  %coreattrs;
  longdesc    %URI;          #IMPLIED
  name        NMTOKEN        #IMPLIED
  src         %URI;          #IMPLIED
  frameborder (1|0)          "1"
  marginwidth %Pixels;       #IMPLIED
  marginheight %Pixels;      #IMPLIED
  scrolling   (yes|no|auto)  "auto"
  align       %ImgAlign;     #IMPLIED
  height      %Length;       #IMPLIED
  width       %Length;       #IMPLIED
  >

<!!-- alternate content container for non frame-based rendering -->

<!!ELEMENT noframes %Flow;>
<!!ATTLIST noframes
  %attrs;
  >

<!!--=================== Document Body ====================================-->

<!!ELEMENT body %Flow;>
<!!ATTLIST body
  %attrs;
  onload      %Script;       #IMPLIED
  onunload    %Script;       #IMPLIED
  background  %URI;          #IMPLIED
  bgcolor     %Color;        #IMPLIED
  text        %Color;        #IMPLIED
  link        %Color;        #IMPLIED
  vlink       %Color;        #IMPLIED
  alink       %Color;        #IMPLIED
  >

<!!ELEMENT div %Flow;>  <!!-- generic language/style container -->
<!!ATTLIST div
  %attrs;
  %TextAlign;
  >

<!!--=================== Paragraphs =======================================-->

<!!ELEMENT p %Inline;>
<!!ATTLIST p
  %attrs;
  %TextAlign;
  >

<!!--=================== Headings =========================================-->

<!!--
  There are six levels of headings from h1 (the most important)
  to h6 (the least important).
-->

<!!ELEMENT h1  %Inline;>
<!!ATTLIST h1
  %attrs;
  %TextAlign;
  >

<!!ELEMENT h2 %Inline;>
<!!ATTLIST h2
  %attrs;
  %TextAlign;
  >

<!!ELEMENT h3 %Inline;>
<!!ATTLIST h3
  %attrs;
  %TextAlign;
  >

<!!ELEMENT h4 %Inline;>
<!!ATTLIST h4
  %attrs;
  %TextAlign;
  >

<!!ELEMENT h5 %Inline;>
<!!ATTLIST h5
  %attrs;
  %TextAlign;
  >

<!!ELEMENT h6 %Inline;>
<!!ATTLIST h6
  %attrs;
  %TextAlign;
  >

<!!--=================== Lists ============================================-->

<!!-- Unordered list bullet styles -->

<!!ENTITY % ULStyle "(disc|square|circle)">

<!!-- Unordered list -->

<!!ELEMENT ul (li)+>
<!!ATTLIST ul
  %attrs;
  type        %ULStyle;     #IMPLIED
  compact     (compact)     #IMPLIED
  >

<!!-- Ordered list numbering style

    1   arabic numbers      1, 2, 3, ...
    a   lower alpha         a, b, c, ...
    A   upper alpha         A, B, C, ...
    i   lower roman         i, ii, iii, ...
    I   upper roman         I, II, III, ...

    The style is applied to the sequence number which by default
    is reset to 1 for the first list item in an ordered list.
-->
<!!ENTITY % OLStyle "CDATA">

<!!-- Ordered (numbered) list -->

<!!ELEMENT ol (li)+>
<!!ATTLIST ol
  %attrs;
  type        %OLStyle;      #IMPLIED
  compact     (compact)      #IMPLIED
  start       %Number;       #IMPLIED
  >

<!!-- single column list (DEPRECATED) --> 
<!!ELEMENT menu (li)+>
<!!ATTLIST menu
  %attrs;
  compact     (compact)     #IMPLIED
  >

<!!-- multiple column list (DEPRECATED) --> 
<!!ELEMENT dir (li)+>
<!!ATTLIST dir
  %attrs;
  compact     (compact)     #IMPLIED
  >

<!!-- LIStyle is constrained to: "(%ULStyle;|%OLStyle;)" -->
<!!ENTITY % LIStyle "CDATA">

<!!-- list item -->

<!!ELEMENT li %Flow;>
<!!ATTLIST li
  %attrs;
  type        %LIStyle;      #IMPLIED
  value       %Number;       #IMPLIED
  >

<!!-- definition lists - dt for term, dd for its definition -->

<!!ELEMENT dl (dt|dd)+>
<!!ATTLIST dl
  %attrs;
  compact     (compact)      #IMPLIED
  >

<!!ELEMENT dt %Inline;>
<!!ATTLIST dt
  %attrs;
  >

<!!ELEMENT dd %Flow;>
<!!ATTLIST dd
  %attrs;
  >

<!!--=================== Address ==========================================-->

<!!-- information on author -->

<!!ELEMENT address (#PCDATA | %inline; | %misc.inline; | p)*>
<!!ATTLIST address
  %attrs;
  >

<!!--=================== Horizontal Rule ==================================-->

<!!ELEMENT hr EMPTY>
<!!ATTLIST hr
  %attrs;
  align       (left|center|right) #IMPLIED
  noshade     (noshade)      #IMPLIED
  size        %Pixels;       #IMPLIED
  width       %Length;       #IMPLIED
  >

<!!--=================== Preformatted Text ================================-->

<!!-- content is %Inline; excluding 
        "img|object|applet|big|small|sub|sup|font|basefont" -->

<!!ELEMENT pre %pre.content;>
<!!ATTLIST pre
  %attrs;
  width       %Number;      #IMPLIED
  xml:space   (preserve)    #FIXED ''preserve''
  >

<!!--=================== Block-like Quotes ================================-->

<!!ELEMENT blockquote %Flow;>
<!!ATTLIST blockquote
  %attrs;
  cite        %URI;          #IMPLIED
  >

<!!--=================== Text alignment ===================================-->

<!!-- center content -->
<!!ELEMENT center %Flow;>
<!!ATTLIST center
  %attrs;
  >

<!!--=================== Inserted/Deleted Text ============================-->

<!!--
  ins/del are allowed in block and inline content, but its
  inappropriate to include block content within an ins element
  occurring in inline content.
-->
<!!ELEMENT ins %Flow;>
<!!ATTLIST ins
  %attrs;
  cite        %URI;          #IMPLIED
  datetime    %Datetime;     #IMPLIED
  >

<!!ELEMENT del %Flow;>
<!!ATTLIST del
  %attrs;
  cite        %URI;          #IMPLIED
  datetime    %Datetime;     #IMPLIED
  >

<!!--================== The Anchor Element ================================-->

<!!-- content is %Inline; except that anchors shouldn''t be nested -->

<!!ELEMENT a %a.content;>
<!!ATTLIST a
  %attrs;
  %focus;
  charset     %Charset;      #IMPLIED
  type        %ContentType;  #IMPLIED
  name        NMTOKEN        #IMPLIED
  href        %URI;          #IMPLIED
  hreflang    %LanguageCode; #IMPLIED
  rel         %LinkTypes;    #IMPLIED
  rev         %LinkTypes;    #IMPLIED
  shape       %Shape;        "rect"
  coords      %Coords;       #IMPLIED
  target      %FrameTarget;  #IMPLIED
  >

<!!--===================== Inline Elements ================================-->

<!!ELEMENT span %Inline;> <!!-- generic language/style container -->
<!!ATTLIST span
  %attrs;
  >

<!!ELEMENT bdo %Inline;>  <!!-- I18N BiDi over-ride -->
<!!ATTLIST bdo
  %coreattrs;
  %events;
  lang        %LanguageCode; #IMPLIED
  xml:lang    %LanguageCode; #IMPLIED
  dir         (ltr|rtl)      #REQUIRED
  >

<!!ELEMENT br EMPTY>   <!!-- forced line break -->
<!!ATTLIST br
  %coreattrs;
  clear       (left|all|right|none) "none"
  >

<!!ELEMENT em %Inline;>   <!!-- emphasis -->
<!!ATTLIST em %attrs;>

<!!ELEMENT strong %Inline;>   <!!-- strong emphasis -->
<!!ATTLIST strong %attrs;>

<!!ELEMENT dfn %Inline;>   <!!-- definitional -->
<!!ATTLIST dfn %attrs;>

<!!ELEMENT code %Inline;>   <!!-- program code -->
<!!ATTLIST code %attrs;>

<!!ELEMENT samp %Inline;>   <!!-- sample -->
<!!ATTLIST samp %attrs;>

<!!ELEMENT kbd %Inline;>  <!!-- something user would type -->
<!!ATTLIST kbd %attrs;>

<!!ELEMENT var %Inline;>   <!!-- variable -->
<!!ATTLIST var %attrs;>

<!!ELEMENT cite %Inline;>   <!!-- citation -->
<!!ATTLIST cite %attrs;>

<!!ELEMENT abbr %Inline;>   <!!-- abbreviation -->
<!!ATTLIST abbr %attrs;>

<!!ELEMENT acronym %Inline;>   <!!-- acronym -->
<!!ATTLIST acronym %attrs;>

<!!ELEMENT q %Inline;>   <!!-- inlined quote -->
<!!ATTLIST q
  %attrs;
  cite        %URI;          #IMPLIED
  >

<!!ELEMENT sub %Inline;> <!!-- subscript -->
<!!ATTLIST sub %attrs;>

<!!ELEMENT sup %Inline;> <!!-- superscript -->
<!!ATTLIST sup %attrs;>

<!!ELEMENT tt %Inline;>   <!!-- fixed pitch font -->
<!!ATTLIST tt %attrs;>

<!!ELEMENT i %Inline;>   <!!-- italic font -->
<!!ATTLIST i %attrs;>

<!!ELEMENT b %Inline;>   <!!-- bold font -->
<!!ATTLIST b %attrs;>

<!!ELEMENT big %Inline;>   <!!-- bigger font -->
<!!ATTLIST big %attrs;>

<!!ELEMENT small %Inline;>   <!!-- smaller font -->
<!!ATTLIST small %attrs;>

<!!ELEMENT u %Inline;>   <!!-- underline -->
<!!ATTLIST u %attrs;>

<!!ELEMENT s %Inline;>   <!!-- strike-through -->
<!!ATTLIST s %attrs;>

<!!ELEMENT strike %Inline;>   <!!-- strike-through -->
<!!ATTLIST strike %attrs;>

<!!ELEMENT basefont EMPTY>  <!!-- base font size -->
<!!ATTLIST basefont
  id          ID             #IMPLIED
  size        CDATA          #REQUIRED
  color       %Color;        #IMPLIED
  face        CDATA          #IMPLIED
  >

<!!ELEMENT font %Inline;> <!!-- local change to font -->
<!!ATTLIST font
  %coreattrs;
  %i18n;
  size        CDATA          #IMPLIED
  color       %Color;        #IMPLIED
  face        CDATA          #IMPLIED
  >

<!!--==================== Object ======================================-->
<!!--
  object is used to embed objects as part of HTML pages.
  param elements should precede other content. Parameters
  can also be expressed as attribute/value pairs on the
  object element itself when brevity is desired.
-->

<!!ELEMENT object (#PCDATA | param | %block; | form | %inline; | %misc;)*>
<!!ATTLIST object
  %attrs;
  declare     (declare)      #IMPLIED
  classid     %URI;          #IMPLIED
  codebase    %URI;          #IMPLIED
  data        %URI;          #IMPLIED
  type        %ContentType;  #IMPLIED
  codetype    %ContentType;  #IMPLIED
  archive     %UriList;      #IMPLIED
  standby     %Text;         #IMPLIED
  height      %Length;       #IMPLIED
  width       %Length;       #IMPLIED
  usemap      %URI;          #IMPLIED
  name        NMTOKEN        #IMPLIED
  tabindex    %Number;       #IMPLIED
  align       %ImgAlign;     #IMPLIED
  border      %Pixels;       #IMPLIED
  hspace      %Pixels;       #IMPLIED
  vspace      %Pixels;       #IMPLIED
  >

<!!--
  param is used to supply a named property value.
  In XML it would seem natural to follow RDF and support an
  abbreviated syntax where the param elements are replaced
  by attribute value pairs on the object start tag.
-->
<!!ELEMENT param EMPTY>
<!!ATTLIST param
  id          ID             #IMPLIED
  name        CDATA          #REQUIRED
  value       CDATA          #IMPLIED
  valuetype   (data|ref|object) "data"
  type        %ContentType;  #IMPLIED
  >

<!!--=================== Java applet ==================================-->
<!!--
  One of code or object attributes must be present.
  Place param elements before other content.
-->
<!!ELEMENT applet (#PCDATA | param | %block; | form | %inline; | %misc;)*>
<!!ATTLIST applet
  %coreattrs;
  codebase    %URI;          #IMPLIED
  archive     CDATA          #IMPLIED
  code        CDATA          #IMPLIED
  object      CDATA          #IMPLIED
  alt         %Text;         #IMPLIED
  name        NMTOKEN        #IMPLIED
  width       %Length;       #REQUIRED
  height      %Length;       #REQUIRED
  align       %ImgAlign;     #IMPLIED
  hspace      %Pixels;       #IMPLIED
  vspace      %Pixels;       #IMPLIED
  >

<!!--=================== Images ===========================================-->

<!!--
   To avoid accessibility problems for people who aren''t
   able to see the image, you should provide a text
   description using the alt and longdesc attributes.
   In addition, avoid the use of server-side image maps.
-->

<!!ELEMENT img EMPTY>
<!!ATTLIST img
  %attrs;
  src         %URI;          #REQUIRED
  alt         %Text;         #REQUIRED
  name        NMTOKEN        #IMPLIED
  longdesc    %URI;          #IMPLIED
  height      %Length;       #IMPLIED
  width       %Length;       #IMPLIED
  usemap      %URI;          #IMPLIED
  ismap       (ismap)        #IMPLIED
  align       %ImgAlign;     #IMPLIED
  border      %Length;       #IMPLIED
  hspace      %Pixels;       #IMPLIED
  vspace      %Pixels;       #IMPLIED
  >

<!!-- usemap points to a map element which may be in this document
  or an external document, although the latter is not widely supported -->

<!!--================== Client-side image maps ============================-->

<!!-- These can be placed in the same document or grouped in a
     separate document although this isn''t yet widely supported -->

<!!ELEMENT map ((%block; | form | %misc;)+ | area+)>
<!!ATTLIST map
  %i18n;
  %events;
  id          ID             #REQUIRED
  class       CDATA          #IMPLIED
  style       %StyleSheet;   #IMPLIED
  title       %Text;         #IMPLIED
  name        CDATA          #IMPLIED
  >

<!!ELEMENT area EMPTY>
<!!ATTLIST area
  %attrs;
  %focus;
  shape       %Shape;        "rect"
  coords      %Coords;       #IMPLIED
  href        %URI;          #IMPLIED
  nohref      (nohref)       #IMPLIED
  alt         %Text;         #REQUIRED
  target      %FrameTarget;  #IMPLIED
  >

<!!--================ Forms ===============================================-->

<!!ELEMENT form %form.content;>   <!!-- forms shouldn''t be nested -->

<!!ATTLIST form
  %attrs;
  action      %URI;          #REQUIRED
  method      (get|post)     "get"
  name        NMTOKEN        #IMPLIED
  enctype     %ContentType;  "application/x-www-form-urlencoded"
  onsubmit    %Script;       #IMPLIED
  onreset     %Script;       #IMPLIED
  accept      %ContentTypes; #IMPLIED
  accept-charset %Charsets;  #IMPLIED
  target      %FrameTarget;  #IMPLIED
  >

<!!--
  Each label must not contain more than ONE field
  Label elements shouldn''t be nested.
-->
<!!ELEMENT label %Inline;>
<!!ATTLIST label
  %attrs;
  for         IDREF          #IMPLIED
  accesskey   %Character;    #IMPLIED
  onfocus     %Script;       #IMPLIED
  onblur      %Script;       #IMPLIED
  >

<!!ENTITY % InputType
  "(text | password | checkbox |
    radio | submit | reset |
    file | hidden | image | button)"
   >

<!!-- the name attribute is required for all but submit & reset -->

<!!ELEMENT input EMPTY>     <!!-- form control -->
<!!ATTLIST input
  %attrs;
  %focus;
  type        %InputType;    "text"
  name        CDATA          #IMPLIED
  value       CDATA          #IMPLIED
  checked     (checked)      #IMPLIED
  disabled    (disabled)     #IMPLIED
  readonly    (readonly)     #IMPLIED
  size        CDATA          #IMPLIED
  maxlength   %Number;       #IMPLIED
  src         %URI;          #IMPLIED
  alt         CDATA          #IMPLIED
  usemap      %URI;          #IMPLIED
  onselect    %Script;       #IMPLIED
  onchange    %Script;       #IMPLIED
  accept      %ContentTypes; #IMPLIED
  align       %ImgAlign;     #IMPLIED
  >

<!!ELEMENT select (optgroup|option)+>  <!!-- option selector -->
<!!ATTLIST select
  %attrs;
  name        CDATA          #IMPLIED
  size        %Number;       #IMPLIED
  multiple    (multiple)     #IMPLIED
  disabled    (disabled)     #IMPLIED
  tabindex    %Number;       #IMPLIED
  onfocus     %Script;       #IMPLIED
  onblur      %Script;       #IMPLIED
  onchange    %Script;       #IMPLIED
  >

<!!ELEMENT optgroup (option)+>   <!!-- option group -->
<!!ATTLIST optgroup
  %attrs;
  disabled    (disabled)     #IMPLIED
  label       %Text;         #REQUIRED
  >

<!!ELEMENT option (#PCDATA)>     <!!-- selectable choice -->
<!!ATTLIST option
  %attrs;
  selected    (selected)     #IMPLIED
  disabled    (disabled)     #IMPLIED
  label       %Text;         #IMPLIED
  value       CDATA          #IMPLIED
  >

<!!ELEMENT textarea (#PCDATA)>     <!!-- multi-line text field -->
<!!ATTLIST textarea
  %attrs;
  %focus;
  name        CDATA          #IMPLIED
  rows        %Number;       #REQUIRED
  cols        %Number;       #REQUIRED
  disabled    (disabled)     #IMPLIED
  readonly    (readonly)     #IMPLIED
  onselect    %Script;       #IMPLIED
  onchange    %Script;       #IMPLIED
  >

<!!--
  The fieldset element is used to group form fields.
  Only one legend element should occur in the content
  and if present should only be preceded by whitespace.
-->
<!!ELEMENT fieldset (#PCDATA | legend | %block; | form | %inline; | %misc;)*>
<!!ATTLIST fieldset
  %attrs;
  >

<!!ENTITY % LAlign "(top|bottom|left|right)">

<!!ELEMENT legend %Inline;>     <!!-- fieldset label -->
<!!ATTLIST legend
  %attrs;
  accesskey   %Character;    #IMPLIED
  align       %LAlign;       #IMPLIED
  >

<!!--
 Content is %Flow; excluding a, form, form controls, iframe
--> 
<!!ELEMENT button %button.content;>  <!!-- push button -->
<!!ATTLIST button
  %attrs;
  %focus;
  name        CDATA          #IMPLIED
  value       CDATA          #IMPLIED
  type        (button|submit|reset) "submit"
  disabled    (disabled)     #IMPLIED
  >

<!!-- single-line text input control (DEPRECATED) -->
<!!ELEMENT isindex EMPTY>
<!!ATTLIST isindex
  %coreattrs;
  %i18n;
  prompt      %Text;         #IMPLIED
  >

<!!--======================= Tables =======================================-->

<!!-- Derived from IETF HTML table standard, see [RFC1942] -->

<!!--
 The border attribute sets the thickness of the frame around the
 table. The default units are screen pixels.

 The frame attribute specifies which parts of the frame around
 the table should be rendered. The values are not the same as
 CALS to avoid a name clash with the valign attribute.
-->
<!!ENTITY % TFrame "(void|above|below|hsides|lhs|rhs|vsides|box|border)">

<!!--
 The rules attribute defines which rules to draw between cells:

 If rules is absent then assume:
     "none" if border is absent or border="0" otherwise "all"
-->

<!!ENTITY % TRules "(none | groups | rows | cols | all)">
  
<!!-- horizontal placement of table relative to document -->
<!!ENTITY % TAlign "(left|center|right)">

<!!-- horizontal alignment attributes for cell contents

  char        alignment char, e.g. char='':''
  charoff     offset for alignment char
-->
<!!ENTITY % cellhalign
  "align      (left|center|right|justify|char) #IMPLIED
   char       %Character;    #IMPLIED
   charoff    %Length;       #IMPLIED"
  >

<!!-- vertical alignment attributes for cell contents -->
<!!ENTITY % cellvalign
  "valign     (top|middle|bottom|baseline) #IMPLIED"
  >

<!!ELEMENT table
     (caption?, (col*|colgroup*), thead?, tfoot?, (tbody+|tr+))>
<!!ELEMENT caption  %Inline;>
<!!ELEMENT thead    (tr)+>
<!!ELEMENT tfoot    (tr)+>
<!!ELEMENT tbody    (tr)+>
<!!ELEMENT colgroup (col)*>
<!!ELEMENT col      EMPTY>
<!!ELEMENT tr       (th|td)+>
<!!ELEMENT th       %Flow;>
<!!ELEMENT td       %Flow;>

<!!ATTLIST table
  %attrs;
  summary     %Text;         #IMPLIED
  width       %Length;       #IMPLIED
  border      %Pixels;       #IMPLIED
  frame       %TFrame;       #IMPLIED
  rules       %TRules;       #IMPLIED
  cellspacing %Length;       #IMPLIED
  cellpadding %Length;       #IMPLIED
  align       %TAlign;       #IMPLIED
  bgcolor     %Color;        #IMPLIED
  >

<!!ENTITY % CAlign "(top|bottom|left|right)">

<!!ATTLIST caption
  %attrs;
  align       %CAlign;       #IMPLIED
  >

<!!--
colgroup groups a set of col elements. It allows you to group
several semantically related columns together.
-->
<!!ATTLIST colgroup
  %attrs;
  span        %Number;       "1"
  width       %MultiLength;  #IMPLIED
  %cellhalign;
  %cellvalign;
  >

<!!--
 col elements define the alignment properties for cells in
 one or more columns.

 The width attribute specifies the width of the columns, e.g.

     width=64        width in screen pixels
     width=0.5*      relative width of 0.5

 The span attribute causes the attributes of one
 col element to apply to more than one column.
-->
<!!ATTLIST col
  %attrs;
  span        %Number;       "1"
  width       %MultiLength;  #IMPLIED
  %cellhalign;
  %cellvalign;
  >

<!!--
    Use thead to duplicate headers when breaking table
    across page boundaries, or for static headers when
    tbody sections are rendered in scrolling panel.

    Use tfoot to duplicate footers when breaking table
    across page boundaries, or for static footers when
    tbody sections are rendered in scrolling panel.

    Use multiple tbody sections when rules are needed
    between groups of table rows.
-->
<!!ATTLIST thead
  %attrs;
  %cellhalign;
  %cellvalign;
  >

<!!ATTLIST tfoot
  %attrs;
  %cellhalign;
  %cellvalign;
  >

<!!ATTLIST tbody
  %attrs;
  %cellhalign;
  %cellvalign;
  >

<!!ATTLIST tr
  %attrs;
  %cellhalign;
  %cellvalign;
  bgcolor     %Color;        #IMPLIED
  >

<!!-- Scope is simpler than headers attribute for common tables -->
<!!ENTITY % Scope "(row|col|rowgroup|colgroup)">

<!!-- th is for headers, td for data and for cells acting as both -->

<!!ATTLIST th
  %attrs;
  abbr        %Text;         #IMPLIED
  axis        CDATA          #IMPLIED
  headers     IDREFS         #IMPLIED
  scope       %Scope;        #IMPLIED
  rowspan     %Number;       "1"
  colspan     %Number;       "1"
  %cellhalign;
  %cellvalign;
  nowrap      (nowrap)       #IMPLIED
  bgcolor     %Color;        #IMPLIED
  width       %Length;       #IMPLIED
  height      %Length;       #IMPLIED
  >

<!!ATTLIST td
  %attrs;
  abbr        %Text;         #IMPLIED
  axis        CDATA          #IMPLIED
  headers     IDREFS         #IMPLIED
  scope       %Scope;        #IMPLIED
  rowspan     %Number;       "1"
  colspan     %Number;       "1"
  %cellhalign;
  %cellvalign;
  nowrap      (nowrap)       #IMPLIED
  bgcolor     %Color;        #IMPLIED
  width       %Length;       #IMPLIED
  height      %Length;       #IMPLIED
  >

'! !

!XHtml1Transitional methodsFor: 'initialize-release' stamp: 'tb 12/1/2005 09:41'!
initialize

	super initialize.
	self parse.! !

!XHtmlDTD methodsFor: 'private' stamp: 'tb 12/5/2005 12:06'!
isXML

	^true! !

!XHtmlDTD methodsFor: 'private' stamp: 'tb 12/3/2005 15:00'!
objectifyElements

	elements := elements collect: [:ea | XHtmlDTDElement fromParsedString: ea]! !

!XHtmlDTD methodsFor: 'private' stamp: 'tb 12/6/2005 15:52'!
tag: aTag canContainTag: anotherTag

	| element |
		element := self elementForTag: aTag asLowercase.
		^element notNil 
			ifTrue: [element allowsTag: anotherTag asLowercase]
			ifFalse:[false]
		! !

Object subclass: #HtmlDTDConstruct
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

HtmlDTDConstruct subclass: #HtmlDTDAttrList
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDAttrList class methodsFor: 'as yet unclassified' stamp: 'tb 12/3/2005 14:30'!
fromParsedArray: anArray

	| tag attrs list |

	tag := anArray first.
	attrs := anArray copyWithoutFirst.
	list := OrderedCollection new.

	attrs do: 
	[:ea |

		| in attribute type required |

		in := ReadStream on: ea.

		[in atEnd] whileFalse: 
		[
			attribute := self readExpression: in.
			type := self readExpression: in.
			required := self readExpression: in.
			required = '#FIXED' ifTrue: [in upTo: $'. type := ('(',(in upTo: $'),')')].
			in skipSeparators.
			list add: (HtmlDTDAttribute new attribute: attribute;
						type: type; isRequired: required).
		]
	].

	^self new tag: tag; attributes: list asArray
		! !

!HtmlDTDAttrList methodsFor: 'accessing' stamp: 'tb 11/30/2005 19:31'!
addToAttributes: anAttribute

	self attributes: (self attributes copyWith: anAttribute)! !

!HtmlDTDAttrList methodsFor: 'accessing' stamp: 'tb 11/30/2005 23:12'!
attributeNamed: aString

	| nm |
	nm := aString asLowercase.
	^self attributes detect:[:ea | ea attribute = nm] ifNone: [nil]! !

!HtmlDTDAttrList methodsFor: 'accessing' stamp: 'tb 11/30/2005 19:32'!
attributes

	^attributes isNil ifTrue:[attributes := #()] ifFalse: [attributes]! !

!HtmlDTDAttrList methodsFor: 'accessing' stamp: 'tb 11/30/2005 19:52'!
attributes: anArray

	attributes := anArray! !

!HtmlDTDAttrList methodsFor: 'testing' stamp: 'tb 12/1/2005 00:57'!
includesAttribute: anAttribute

	^(self attributeNamed: anAttribute) notNil! !

!HtmlDTDAttrList methodsFor: 'as yet unclassified' stamp: 'tb 11/30/2005 22:58'!
printOn: aStream

	aStream nextPutAll: '@@'; nextPut: $(. 
	tag expression printOn: aStream.
	aStream space.
	self attributes do:
	[:ea | 
		ea printOn: aStream.
		aStream space.
	].
	aStream nextPut: $).! !

!HtmlDTDAttrList methodsFor: 'accessing' stamp: 'tb 12/1/2005 01:01'!
requiredAttributes

	^self attributes select:[:ea | ea isRequired]! !

HtmlDTDConstruct subclass: #HtmlDTDAttribute
	instanceVariableNames: 'attribute type isRequired'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDAttribute methodsFor: 'accessing' stamp: 'tb 12/2/2005 10:39'!
allowsValue: aValue
	
	self type isNil ifTrue:[^true].
	^self type isEnumeration
			ifFalse: [true]
			ifTrue: [self type allowsItem: aValue]! !

!HtmlDTDAttribute methodsFor: 'accessing' stamp: 'tb 11/30/2005 19:27'!
attribute
	"Answer the value of attribute"

	^ attribute! !

!HtmlDTDAttribute methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:52'!
attribute: anObject
	"Set the value of attribute"

	attribute := anObject! !

!HtmlDTDAttribute methodsFor: 'accessing' stamp: 'tb 11/30/2005 19:29'!
isRequired
	"Answer the value of isRequired"

	^ isRequired = '#REQUIRED'! !

!HtmlDTDAttribute methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:52'!
isRequired: anObject
	"Set the value of isRequired"

	isRequired := anObject! !

!HtmlDTDAttribute methodsFor: 'accessing' stamp: 'tb 11/30/2005 21:31'!
printOn: aStream

	aStream nextPut: $@; nextPut:$(.
	attribute printOn: aStream.
	aStream space.
	type printOn: aStream.
	aStream space.
	isRequired printOn: aStream.
	aStream nextPut:$).! !

!HtmlDTDAttribute methodsFor: 'accessing' stamp: 'tb 11/30/2005 19:27'!
type
	"Answer the value of type"

	^ type! !

!HtmlDTDAttribute methodsFor: 'accessing' stamp: 'tb 12/2/2005 13:53'!
type: anObject
	"Set the value of type"

	type := HtmlDTDMatchExpression on: anObject! !

!HtmlDTDConstruct class methodsFor: 'as yet unclassified' stamp: 'tb 11/30/2005 21:50'!
readExpression: in

	| s |

	in skipSeparators.
	^in peek = $( ifTrue:
	[
		s := in upTo: $).
		(s,')',(in upTo: $ ))
	]
	ifFalse:
	[
		in upTo: $ .
	]! !

!HtmlDTDConstruct methodsFor: 'accessing' stamp: 'tb 11/30/2005 21:55'!
tag
	"Answer the value of tag"

	^ tag! !

!HtmlDTDConstruct methodsFor: 'accessing' stamp: 'SebastianSastre 1/15/2012 16:34'!
tag: anObject
	"Set the value of tag"

	tag := HtmlDTDMatchExpression on: anObject trimBoth! !

!HtmlDTDConstruct methodsFor: 'accessing' stamp: 'tb 12/1/2005 14:28'!
tagMatches: anObject

	^tag allowsItem: anObject! !

HtmlDTDConstruct subclass: #HtmlDTDElement
	instanceVariableNames: 'dtd startIsOptional endIsOptional contentRule allowedElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDElement class methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:34'!
fromParsedString: aString

	| in tag start end contents |

	in := ReadStream on: aString.

	tag := self readExpression: in.
	start := self readExpression: in.
	end := self readExpression: in.
	contents := in upToEnd trimBoth.

	^self new tag: tag;
		startIsOptional: start;
		endIsOptional: end;
		contentRule: contents		! !

!HtmlDTDElement methodsFor: 'accessing' stamp: 'tb 12/8/2005 15:25'!
allowsTag: aTag

	^contentRule allowsItem: aTag! !

!HtmlDTDElement methodsFor: 'accessing' stamp: 'tb 12/6/2005 15:27'!
cacheAllowedElementsForDTD: aDTD

	| |

	allowedElements isNil ifTrue:
	[
		allowedElements := Set new.

		allowedElements addAll: self contentRule allowedElements.

		allowedElements copy do: 
		[:ea | 
			ea isLiteral ifTrue: 
			[
				| el |
				el := aDTD elementForTag: ea expression.
				el startIsOptional ifTrue:
					[allowedElements addAll: (el cacheAllowedElementsForDTD: aDTD)]
			]
		]
	].

	^allowedElements! !

!HtmlDTDElement methodsFor: 'accessing' stamp: 'tb 11/30/2005 22:06'!
contentRule
	"Answer the value of contentRule"

	^ contentRule! !

!HtmlDTDElement methodsFor: 'accessing' stamp: 'tb 12/2/2005 08:53'!
contentRule: anObject
	"Set the value of contentRule"

	contentRule := HtmlDTDMatchExpression on: anObject! !

!HtmlDTDElement methodsFor: 'accessing' stamp: 'tb 11/30/2005 22:25'!
endIsOptional
	"Answer the value of endIsOptional"

	^ endIsOptional first = $O! !

!HtmlDTDElement methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:52'!
endIsOptional: anObject
	"Set the value of endIsOptional"

	endIsOptional := anObject! !

!HtmlDTDElement methodsFor: 'accessing' stamp: 'tb 12/1/2005 14:29'!
isEmpty

	^contentRule isEmpty! !

!HtmlDTDElement methodsFor: 'accessing' stamp: 'tb 11/30/2005 22:29'!
printOn: aStream

	aStream nextPutAll: 'E('.
	tag printOn: aStream.
	aStream space; 
	nextPutAll: startIsOptional; space;
	nextPutAll: endIsOptional; space.
	contentRule printOn: aStream.
	aStream nextPut: $)! !

!HtmlDTDElement methodsFor: 'accessing' stamp: 'tb 11/30/2005 22:02'!
startIsOptional
	"Answer the value of startIsOptional"

	^ startIsOptional first = $O! !

!HtmlDTDElement methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:52'!
startIsOptional: anObject
	"Set the value of startIsOptional"

	startIsOptional := anObject! !

HtmlDTDElement subclass: #XHtmlDTDElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!XHtmlDTDElement class methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:42'!
fromParsedString: aString

	| in tag start end contents |

	in := ReadStream on: aString.

	tag := self readExpression: in.
	start := '-'.
	end := '-'.
	contents := in upToEnd trimBoth.

	^self new tag: tag;
		startIsOptional: start;
		endIsOptional: end;
		contentRule: contents		! !

Object subclass: #HtmlDTDMatchExpression
	instanceVariableNames: 'expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDMatchExpression commentStamp: '<historical>' prior: 0!
The expression rules are: 
( ... )
    Delimits a group.
A
    A must occur, one time only.
A+
    A must occur one or more times.
A?
    A must occur zero or one time.
A*
    A may occur zero or more times.
+(A)
    A may occur.
-(A)
    A must not occur.
A | B
    Either A or B must occur, but not both.
A , B
    Both A and B must occur, in that order.
A & B
    Both A and B must occur, in any order. !

HtmlDTDMatchExpression subclass: #HtmlDTDMatchAllow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDMatchAllow class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 22:13'!
on: anObject

	| in | 

	in := anObject isStream 
		ifTrue:[anObject] 
		ifFalse: [ReadStream on: anObject].

	in next = $+ ifFalse: [self error: 'HtmlDTDMatchDeny called with invalid stream state'].

	^self new expression: (HtmlDTDMatchExpression on: in).! !

!HtmlDTDMatchAllow methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 15:25'!
allowedElements

	^expression allowedElements! !

!HtmlDTDMatchAllow methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 14:07'!
allowsItem: anItem

	^self expression allowsItem: anItem! !

!HtmlDTDMatchAllow methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 21:22'!
printOn: aStream

	aStream nextPut: $+.
	expression printOn: aStream.

! !

!HtmlDTDMatchAllow methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 16:44'!
validateChildren: aStream ofNode: aNode

	^expression validateChildren: aStream ofNode: aNode! !

HtmlDTDMatchExpression subclass: #HtmlDTDMatchCDATA
	instanceVariableNames: ''
	classVariableNames: 'CData'
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDMatchCDATA class methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 14:53'!
cdata

	^CData isNil ifTrue: [CData := self new] ifFalse: [CData]! !

!HtmlDTDMatchCDATA methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 15:09'!
allowedElements

	^#()! !

!HtmlDTDMatchCDATA methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 17:35'!
allowsItem: aTag

	^(aTag asUppercase findString: 'CDATA') > 0! !

!HtmlDTDMatchCDATA methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 15:07'!
initialize

	super initialize.
	expression := '#CDATA'! !

!HtmlDTDMatchCDATA methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 17:39'!
printOn: aStream

	aStream nextPutAll: expression! !

!HtmlDTDMatchCDATA methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 17:37'!
validateChildren: aStream ofNode: aNode

	^(aStream atEnd not and: [self allowsItem: aStream peek dtdTag]) 
		ifTrue: [aStream next. true] 
		ifFalse: [false]
! !

HtmlDTDMatchExpression subclass: #HtmlDTDMatchConstraint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDMatchConstraint methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 10:07'!
allowedElements

	^expression allowedElements! !

!HtmlDTDMatchConstraint methodsFor: 'as yet unclassified' stamp: 'tb 12/2/2005 10:32'!
allowsItem: anItem

	^expression allowsItem: anItem! !

HtmlDTDMatchConstraint subclass: #HtmlDTDMatchOneOrMore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDMatchOneOrMore methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 19:39'!
printOn: aStream

	expression printOn: aStream.
	aStream nextPut: $+

	! !

!HtmlDTDMatchOneOrMore methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 12:18'!
validateChildren: aStream ofNode: aNode

	| matchedOne |
	matchedOne := false.
	[expression validateChildren: aStream ofNode: aNode] whileTrue:[matchedOne := true].
	^matchedOne! !

HtmlDTDMatchConstraint subclass: #HtmlDTDMatchZeroOrMore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDMatchZeroOrMore methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 21:20'!
printOn: aStream

	expression printOn: aStream.
	aStream nextPut: $*

	! !

!HtmlDTDMatchZeroOrMore methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 12:17'!
validateChildren: aStream ofNode: aNode

	[expression validateChildren: aStream ofNode: aNode] whileTrue:[].
	^true! !

HtmlDTDMatchConstraint subclass: #HtmlDTDMatchZeroOrOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDMatchZeroOrOne methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 21:20'!
printOn: aStream

	expression printOn: aStream.
	aStream nextPut: $?

	! !

!HtmlDTDMatchZeroOrOne methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 12:19'!
validateChildren: aStream ofNode: aNode

	expression validateChildren: aStream ofNode: aNode.
	^true! !

HtmlDTDMatchExpression subclass: #HtmlDTDMatchDeny
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDMatchDeny class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 22:12'!
on: anObject

	| in | 

	in := anObject isStream 
		ifTrue:[anObject] 
		ifFalse: [ReadStream on: anObject].

	in next = $- ifFalse: [self error: 'HtmlDTDMatchDeny called with invalid stream state'].

	^self new expression: (HtmlDTDMatchExpression on: in).! !

!HtmlDTDMatchDeny methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 10:02'!
allowedElements

	^#()! !

!HtmlDTDMatchDeny methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 14:06'!
allowsItem: anItem

	^(self expression allowsItem: anItem) not! !

!HtmlDTDMatchDeny methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 21:21'!
printOn: aStream

	aStream nextPut: $-.
	expression printOn: aStream.

	! !

!HtmlDTDMatchDeny methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 16:45'!
validateChildren: aStream ofNode: aNode

	^(expression validateChildren: aStream ofNode: aNode) not! !

HtmlDTDMatchExpression subclass: #HtmlDTDMatchEmpty
	instanceVariableNames: ''
	classVariableNames: 'Empty'
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDMatchEmpty class methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 14:50'!
empty

	^Empty isNil ifTrue: [Empty := self new] ifFalse: [Empty]! !

!HtmlDTDMatchEmpty methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 10:02'!
allowedElements

	^#()! !

!HtmlDTDMatchEmpty methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 14:25'!
allowsItem: aTag

	^false! !

!HtmlDTDMatchEmpty methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 15:06'!
initialize

	super initialize.
	expression := 'EMPTY'! !

!HtmlDTDMatchEmpty methodsFor: 'as yet unclassified' stamp: 'tb 12/2/2005 10:41'!
isEmpty

	^true! !

!HtmlDTDMatchEmpty methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 14:26'!
printOn: aStream

	aStream nextPutAll: 'EMPTY'! !

!HtmlDTDMatchEmpty methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 11:51'!
validateChildren: aStream ofNode: aNode

	^(aStream atEnd) 
		ifTrue: [true] 
		ifFalse:
		[
			aNode addError: (HtmlTagMustBeEmptyError new).
			false
		]
! !

!HtmlDTDMatchExpression class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 22:15'!
on: anObject

" 
( ... )
    Delimits a group.
A
    A must occur, one time only.
A+
    A must occur one or more times.
A?
    A must occur zero or one time.
A*
    A may occur zero or more times.
+(A)
    A may occur.
-(A)
    A must not occur.
A | B
    Either A or B must occur, but not both.
A , B
    Both A and B must occur, in that order.
A & B
    Both A and B must occur, in any order. "

	| in seq | 

	in := anObject isStream 
		ifTrue:[anObject] 
		ifFalse: [ReadStream on: anObject].

	seq := OrderedCollection new.	


	[in atEnd] whileFalse:
	[
		in skipSeparators.
		(in peek = $-) 
		ifTrue: [seq add:(HtmlDTDMatchDeny on: in)]
		ifFalse:
		[
			(in peek = $+) 
			ifTrue: [seq add:(HtmlDTDMatchAllow on: in)]
			ifFalse: 
			[
				(in peek = $( ) 
				ifTrue: 
				[
					seq add: 
					(self readConstraintFor:(HtmlDTDMatchGroup on: in) from: in)
				]
				ifFalse: 
				[
					('|),&' includes: in peek) ifTrue: [^seq last]
					ifFalse:
					[
						seq add: 
						(self readConstraintFor:(HtmlDTDMatchLiteral on: in) from: in)
					]
				]
			]	
		]
	].
	^seq size > 1 
		ifTrue:[self new expression: seq] 
		ifFalse:[seq last]
	
! !

!HtmlDTDMatchExpression class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 21:47'!
readConstraintFor: anExpn from: aStream

	| c |

	^('+*?' includes: aStream peek) ifFalse: [anExpn]
	ifTrue:
	[
		c := aStream next.

		c = $+ ifTrue:[HtmlDTDMatchOneOrMore new expression: anExpn] ifFalse: [
		c = $? ifTrue:[HtmlDTDMatchZeroOrOne new expression: anExpn] ifFalse: [
		c = $* ifTrue:[HtmlDTDMatchZeroOrMore new expression: anExpn]]]
	]	! !

!HtmlDTDMatchExpression methodsFor: 'accessing' stamp: 'tb 12/6/2005 10:01'!
allowedElements

	| collection |

	collection := OrderedCollection new.

	expression do: [:ea | collection addAll: ea allowedElements].

	^collection asArray! !

!HtmlDTDMatchExpression methodsFor: 'matching' stamp: 'tb 12/2/2005 10:13'!
allowsItem: anItem

	^(expression detect: [:ea | ea allowsItem: anItem] ifNone: [nil]) notNil! !

!HtmlDTDMatchExpression methodsFor: 'accessing' stamp: 'tb 11/30/2005 19:18'!
expression
	"Answer the value of expression"

	^ expression! !

!HtmlDTDMatchExpression methodsFor: 'accessing' stamp: 'tb 1/13/2006 20:28'!
expression: anObject
	
	expression := anObject! !

!HtmlDTDMatchExpression methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 14:29'!
isEmpty

	^false! !

!HtmlDTDMatchExpression methodsFor: 'matching' stamp: 'tb 12/2/2005 08:55'!
isEnumeration

	^false! !

!HtmlDTDMatchExpression methodsFor: 'matching' stamp: 'tb 12/6/2005 10:13'!
isLiteral

	^false! !

!HtmlDTDMatchExpression methodsFor: 'matching' stamp: 'tb 12/1/2005 23:56'!
matchTagList: aList

	| in |

	in := ReadStream on: aList.
	self match: in.
	^in upToEnd! !

!HtmlDTDMatchExpression methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 22:16'!
printOn: aStream

	expression do: [:ea | ea printOn: aStream. aStream nextPut: $ ]! !

!HtmlDTDMatchExpression methodsFor: 'matching' stamp: 'tb 12/5/2005 16:54'!
validateChildren: aStream ofNode: aNode

	expression do:
	[:ea | 
		
		(ea validateChildren: aStream ofNode: aNode) ifFalse: [^false]
	].
	^true
	! !

HtmlDTDMatchExpression subclass: #HtmlDTDMatchGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

HtmlDTDMatchGroup subclass: #HtmlDTDMatchAND
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDMatchAND methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 17:14'!
separator

	^'&'! !

!HtmlDTDMatchAND methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 12:35'!
validateChildren: aStream ofNode: aNode

	| position matched subexpressions |

	position := aStream position.
	subexpressions := expression.

	[subexpressions isEmpty] whileFalse:
	[
		matched := subexpressions detect:
		[:ea | 
			aStream position: position.		
			(ea validateChildren: aStream ofNode: aNode)
		] ifNone: [nil].
		matched notNil 
			ifFalse: [^false]
			ifTrue: 
			[
				position := aStream position.
				subexpressions := subexpressions copyWithout: matched.
			]
	].
	^true! !

!HtmlDTDMatchGroup class methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 21:09'!
on: aStringOrStream

	| seq in seps | 
	
	in := aStringOrStream isStream
		ifFalse: [ReadStream on: aStringOrStream] 
		ifTrue: [aStringOrStream].

	in skipSeparators.
	seq := OrderedCollection new.
	seps := #().
	(in peek = $() ifFalse: [self error: 'Groups start with $('].

	in next; skipSeparators.

	[in peek = $)] whileFalse:
	[
		in skipSeparators.
		seq add: (HtmlDTDMatchExpression on: in).
		in skipSeparators.
		('|&,' includes: in peek) ifTrue: [seps:= seps copyWith: in next. in skipSeparators]
			ifFalse: [in peek = $) ifFalse: [self error: 'Huh?']]
	].
	in next.
	
	^(seps isEmpty) ifTrue: [seq last]
		ifFalse: [(seps first = $|) ifTrue: [HtmlDTDMatchOR new expression: seq]
		ifFalse:[(seps first = $&) ifTrue: [HtmlDTDMatchAND new expression: seq]
			ifFalse:[(seps first = $,) ifTrue: [HtmlDTDMatchSequence new expression: seq]
				ifFalse:[self error: 'Invalid group separator']]]]
	! !

!HtmlDTDMatchGroup methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 10:07'!
allowedElements

	| collection |

	collection := OrderedCollection new.

	expression do: [:ea | collection addAll: ea allowedElements].

	^collection asArray! !

!HtmlDTDMatchGroup methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 16:01'!
allowsItem: anItem

	^(expression detect:[:ea| ea allowsItem: anItem] ifNone: [nil]) notNil! !

!HtmlDTDMatchGroup methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 17:10'!
expression: aCollection

	super expression: aCollection asArray! !

!HtmlDTDMatchGroup methodsFor: 'as yet unclassified' stamp: 'tb 12/8/2005 22:00'!
printOn: aStream

	aStream nextPut: $(.
	aStream nextPutAll: (expression joinOn: (' ',(self separator asString),' ')).
	aStream nextPut: $)
! !

!HtmlDTDMatchGroup methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 17:11'!
separator

	self subclassResponsibility ! !

HtmlDTDMatchGroup subclass: #HtmlDTDMatchOR
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDMatchOR methodsFor: 'as yet unclassified' stamp: 'tb 12/2/2005 08:55'!
isEnumeration

	^true! !

!HtmlDTDMatchOR methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 17:14'!
separator

	^'|'! !

!HtmlDTDMatchOR methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 12:27'!
validateChildren: aStream ofNode: aNode

	| position matched |

	position := aStream position.

	matched := expression detect:
	[:ea | 
		aStream position: position.		
		(ea validateChildren: aStream ofNode: aNode)
	] ifNone: [nil].
	^matched notNil! !

HtmlDTDMatchGroup subclass: #HtmlDTDMatchSequence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDMatchSequence methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 17:14'!
separator

	^','! !

!HtmlDTDMatchSequence methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 11:35'!
validateChildren: aStream ofNode: aNode

	expression do:
	[:ea | 
		
		(ea validateChildren: aStream ofNode: aNode) ifFalse: [^false]
	].
	^true! !

HtmlDTDMatchExpression subclass: #HtmlDTDMatchLiteral
	instanceVariableNames: ''
	classVariableNames: 'LiteralsByTagAsSymbol'
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlDTDMatchLiteral class methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 15:00'!
expression: aTag

	LiteralsByTagAsSymbol isNil ifTrue: [LiteralsByTagAsSymbol := WeakValueDictionary new].

	^LiteralsByTagAsSymbol at: aTag asSymbol ifAbsentPut: [self new expression: aTag].	! !

!HtmlDTDMatchLiteral class methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 14:52'!
on: aStringOrStream

	| in out delims s |

	in := aStringOrStream isStream 
		ifFalse: [ReadStream on: aStringOrStream]
		ifTrue:[aStringOrStream].

	delims := ' ()|*?+-,&'.
	out := WriteStream on: String new.

	in skipSeparators.
	[in atEnd or: [delims includes: in peek]] whileFalse: [out nextPut: in next].
	s := out contents.
	^s = 'EMPTY' 
		ifTrue: [HtmlDTDMatchEmpty empty]	
		ifFalse: 
		[
			(s asUppercase findString: 'CDATA') > 0 
			ifTrue:[HtmlDTDMatchCDATA cdata]
			ifFalse:[HtmlDTDMatchLiteral new expression: s]
		]! !

!HtmlDTDMatchLiteral methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 15:09'!
allowedElements

	^ Array with: self! !

!HtmlDTDMatchLiteral methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 14:25'!
allowsItem: aTag

	^expression = aTag! !

!HtmlDTDMatchLiteral methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 23:22'!
consumeStream: in

	expression = in peek ifTrue:[in next]! !

!HtmlDTDMatchLiteral methodsFor: 'as yet unclassified' stamp: 'tb 12/6/2005 10:13'!
isLiteral

	^true! !

!HtmlDTDMatchLiteral methodsFor: 'as yet unclassified' stamp: 'tb 12/2/2005 17:28'!
printOn: aStream

	aStream nextPut: $"; nextPutAll: expression; nextPut:$".
	! !

!HtmlDTDMatchLiteral methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 12:48'!
validateChildren: aStream ofNode: aNode

	^(aStream atEnd not and: [expression = aStream peek dtdTag]) 
		ifTrue: [aStream next. true] 
		ifFalse: [false]
! !

Object subclass: #HtmlError
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

HtmlError subclass: #CSSError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

!CSSError methodsFor: 'as yet unclassified' stamp: 'tb 12/31/2005 00:07'!
isCSSError

	^true! !

!CSSError methodsFor: 'as yet unclassified' stamp: 'tb 12/31/2005 00:15'!
printOn: aStream

	super printOn: aStream.
! !

!CSSError methodsFor: 'as yet unclassified' stamp: 'tb 12/31/2005 23:18'!
title

	| tt |
	tt := self class name. 
	^(tt last: tt size - 3) asCapitalizedPhrase.
	! !

CSSError subclass: #CSSImportAfterStyleRuleError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

CSSError subclass: #CSSPropertyError
	instanceVariableNames: 'propertyName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

CSSPropertyError subclass: #CSSColorAndBackgroundColorNotSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

!CSSPropertyError methodsFor: 'accessing' stamp: 'tb 12/31/2005 00:11'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $ ; nextPutAll: self propertyName; nextPut: $ .
	self parent printOn: aStream.! !

!CSSPropertyError methodsFor: 'accessing' stamp: 'tb 12/30/2005 21:53'!
propertyName
	"Answer the value of propertyName"

	^ propertyName! !

!CSSPropertyError methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:07'!
propertyName: anObject
	"Set the value of propertyName"

	propertyName := anObject! !

CSSPropertyError subclass: #CSSPropertyNameNotLowercaseError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

CSSPropertyError subclass: #CSSPropertyUnknownError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

CSSPropertyError subclass: #CSSPropertyValueNotValidError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

CSSError subclass: #CSSSelectorError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

CSSSelectorError subclass: #CSSSelectorElementNotLowercaseError
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

!CSSSelectorElementNotLowercaseError methodsFor: 'accessing' stamp: 'tb 12/30/2005 21:29'!
element
	"Answer the value of element"

	^ element! !

!CSSSelectorElementNotLowercaseError methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:38'!
element: anObject
	"Set the value of element"

	element := anObject! !

CSSSelectorError subclass: #CSSSelectorElementNotValidError
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

!CSSSelectorElementNotValidError methodsFor: 'accessing' stamp: 'tb 12/30/2005 21:45'!
element
	"Answer the value of element"

	^ element! !

!CSSSelectorElementNotValidError methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:38'!
element: anObject
	"Set the value of element"

	element := anObject! !

!CSSSelectorElementNotValidError methodsFor: 'accessing' stamp: 'tb 12/31/2005 01:40'!
printOn: aStream

	self class printOn: aStream.
	aStream nextPut: $ ; nextPutAll: element; nextPut: $ .
	self parent printOn: aStream.! !

!CSSSelectorError methodsFor: 'as yet unclassified' stamp: 'tb 12/31/2005 00:14'!
printOn: aStream

	super printOn: aStream.
	self parent selector printOn: aStream.! !

CSSSelectorError subclass: #CSSSelectorNotValidError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

CSSError subclass: #CSSUnmatchedRuleError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

!CSSUnmatchedRuleError methodsFor: 'as yet unclassified' stamp: 'tb 12/31/2005 00:16'!
printOn: aStream

	super printOn: aStream.
	self parent printOn: aStream.! !

CSSError subclass: #CSSUnterminatedPropertyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

CSSError subclass: #CSSVersion3ConstructFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS-Errors'!

!CSSVersion3ConstructFoundError methodsFor: 'as yet unclassified' stamp: 'tb 1/14/2006 21:42'!
printOn: aStream

	super printOn: aStream.
	self parent printOn: aStream.! !

HtmlError subclass: #HtmlAttributeError
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlAttributeError methodsFor: 'accessing' stamp: 'tb 12/4/2005 21:00'!
attribute
	"Answer the value of attribute"

	^ attribute! !

!HtmlAttributeError methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:55'!
attribute: anObject
	"Set the value of attribute"

	attribute := anObject! !

!HtmlAttributeError methodsFor: 'testing' stamp: 'tb 12/5/2005 00:04'!
isAttributeError

	^true! !

!HtmlAttributeError methodsFor: 'accessing' stamp: 'tb 12/5/2005 00:30'!
position

	^self parent start + (self parent prefix findString: self attribute).! !

!HtmlAttributeError methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 00:34'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: ' Attribute: '.
	self attribute printOn: aStream.
	aStream space.
	self parent prefix printOn: aStream.
	aStream nextPut: $..! !

HtmlAttributeError subclass: #HtmlAttributeMultiplySpecifiedError
	instanceVariableNames: 'value1 value2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlAttributeMultiplySpecifiedError methodsFor: 'accessing' stamp: 'tb 12/8/2005 23:03'!
printOn: aStream

	self attribute printOn: aStream.
	aStream nextPutAll: ' is specified multiple times in '.
	self parent prefix printOn: aStream.
	aStream nextPutAll: '.'! !

!HtmlAttributeMultiplySpecifiedError methodsFor: 'accessing' stamp: 'tb 12/4/2005 21:08'!
value: v1 value: v2

	value1 := v1.
	value2 := v2! !

HtmlAttributeError subclass: #HtmlAttributeNotLowerCaseError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlAttributeNotLowerCaseError methodsFor: 'testing' stamp: 'tb 12/4/2005 22:01'!
isCaseError! !

!HtmlAttributeNotLowerCaseError methodsFor: 'testing' stamp: 'tb 12/8/2005 22:44'!
printOn: aStream

	| |
	self attribute printOn: aStream.
	aStream nextPutAll: ' should be '.
	self attribute asLowercase printOn: aStream.
	aStream nextPutAll: ' in '.
	self parent prefix printOn: aStream" Valid attributes are: '.
	attrList := self parent dtd attrListForTag: self parent dtdTag.
	(attrList attributes collect:[:ea | ea attribute]) printOn: aStream."! !

HtmlAttributeError subclass: #HtmlAttributeUnknownError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlAttributeUnknownError methodsFor: 'as yet unclassified' stamp: 'tb 12/8/2005 22:49'!
printOn: aStream

	| attrList |

	self attribute printOn: aStream.
	aStream nextPutAll: ' in: '.
	self parent prefix printOn: aStream.
	aStream nextPutAll: ' should be one of :'.
	attrList := self parent dtd attrListForTag: self parent dtdTag.
	(attrList attributes collect:[:ea | ea attribute]) printOn: aStream.	! !

HtmlAttributeError subclass: #HtmlAttributeValueMissingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlAttributeValueMissingError methodsFor: 'as yet unclassified' stamp: 'tb 12/8/2005 23:02'!
printOn: aStream

	aStream nextPutAll: 'Value missing for: '.
	self attribute printOn: aStream.
	aStream nextPutAll: ' in '.
	self parent prefix printOn: aStream.
	aStream nextPutAll: '.'.! !

HtmlAttributeError subclass: #HtmlAttributeValueNotQuotedError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlAttributeValueNotQuotedError methodsFor: 'testing' stamp: 'tb 12/5/2005 00:07'!
isSyntaxError

	^true! !

!HtmlAttributeValueNotQuotedError methodsFor: 'as yet unclassified' stamp: 'tb 12/8/2005 22:59'!
printOn: aStream

	aStream nextPutAll: 'Value of: '.
	self attribute printOn: aStream.
	aStream nextPutAll: ' in '.
	self parent prefix printOn: aStream.
	aStream nextPutAll: ' should be quoted.'.! !

HtmlAttributeError subclass: #HtmlAttributeValueNotValidError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlAttributeValueNotValidError methodsFor: 'accessing' stamp: 'tb 12/8/2005 22:55'!
printOn: aStream

	| attrList attr |

	"super printOn: aStream."
	self attribute printOn: aStream.
	aStream nextPutAll: ' in '.
	self parent prefix printOn: aStream.
	aStream nextPutAll: ' must be one of: '.
	attrList := self parent dtd attrListForTag: self parent dtdTag.
	attr := attrList attributeNamed: self attribute.
	attr type asString printOn: aStream.	! !

!HtmlAttributeValueNotValidError methodsFor: 'accessing' stamp: 'tb 12/4/2005 21:39'!
validTypeExpression

	| p attList attr |

	p := self parent.
	attList := p dtd attrListForTag: p dtdTag.
	attr := attList attributeNamed: self attribute.
	^ attr type expression asString.! !

!HtmlError methodsFor: 'testing' stamp: 'tb 12/4/2005 21:58'!
isAttributeError

	^false! !

!HtmlError methodsFor: 'testing' stamp: 'tb 12/31/2005 00:08'!
isCSSError

	^false! !

!HtmlError methodsFor: 'testing' stamp: 'tb 12/4/2005 22:01'!
isCaseError

	^false! !

!HtmlError methodsFor: 'testing' stamp: 'tb 12/4/2005 23:31'!
isFatal

	^false! !

!HtmlError methodsFor: 'testing' stamp: 'tb 12/4/2005 22:02'!
isStructuralError

	^false! !

!HtmlError methodsFor: 'testing' stamp: 'tb 12/4/2005 22:00'!
isSyntaxError

	^false! !

!HtmlError methodsFor: 'testing' stamp: 'tb 12/4/2005 21:58'!
isTagError

	^false! !

!HtmlError methodsFor: 'accessing' stamp: 'tb 12/4/2005 22:10'!
parent
	"Answer the value of parent"

	^ parent isNil ifTrue: [nil] ifFalse: [parent first].! !

!HtmlError methodsFor: 'accessing' stamp: 'tb 12/4/2005 22:10'!
parent: anObject
	"Set the value of parent"

	parent := WeakArray with: anObject! !

!HtmlError methodsFor: 'accessing' stamp: 'tb 12/5/2005 00:29'!
position

	^self parent start! !

!HtmlError methodsFor: 'printing' stamp: 'tb 12/4/2005 23:59'!
printOn: aStream

	self class printOn: aStream. 
	aStream nextPutAll: ': Character: '.
	self position printOn: aStream.
	aStream space.! !

!HtmlError methodsFor: 'accessing' stamp: 'tb 12/5/2005 00:50'!
tag

	^self parent tag.! !

!HtmlError methodsFor: 'accessing' stamp: 'tb 12/31/2005 23:17'!
title

	| tt |
	tt := self class name. 
	^(tt last: tt size - 4) asCapitalizedPhrase.
	! !

!HtmlError methodsFor: 'testing' stamp: 'tb 12/5/2005 01:09'!
uniqueId

	^self parent uniqueId! !

HtmlError subclass: #HtmlFatalError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlFatalError methodsFor: 'as yet unclassified' stamp: 'tb 12/4/2005 23:31'!
isFatal

	^true! !

!HtmlFatalError methodsFor: 'as yet unclassified' stamp: 'tb 12/4/2005 22:59'!
printOn: aStream

	super printOn: aStream.
	'ERROR!!  This page is much too broken to parse.' printOn: aStream.! !

HtmlError subclass: #HtmlMissingDocTypeError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlMissingDocTypeError methodsFor: 'as yet unclassified' stamp: 'tb 1/15/2006 20:09'!
isStructuralError

	^true! !

HtmlError subclass: #HtmlSyntaxError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlSyntaxError methodsFor: 'testing' stamp: 'tb 12/4/2005 21:59'!
isSyntaxError

	^true! !

HtmlSyntaxError subclass: #HtmlUnclosedCommentError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlUnclosedCommentError methodsFor: 'testing' stamp: 'tb 12/4/2005 22:02'!
isStructuralError

	^true! !

!HtmlUnclosedCommentError methodsFor: 'testing' stamp: 'tb 12/8/2005 23:08'!
printOn: aStream

	aStream nextPutAll: 'Comment section not properly terminated.'! !

HtmlSyntaxError subclass: #HtmlUnclosedProcessingDirectiveError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlUnclosedProcessingDirectiveError methodsFor: 'testing' stamp: 'tb 12/11/2005 20:26'!
isStructuralError

	^true! !

!HtmlUnclosedProcessingDirectiveError methodsFor: 'testing' stamp: 'tb 12/11/2005 20:27'!
printOn: aStream

	aStream nextPutAll: 'Processing directive not properly terminated.'! !

HtmlSyntaxError subclass: #HtmlUnclosedXmlCDataSectionError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlUnclosedXmlCDataSectionError methodsFor: 'testing' stamp: 'tb 3/12/2006 14:09'!
isStructuralError

	^true! !

!HtmlUnclosedXmlCDataSectionError methodsFor: 'testing' stamp: 'tb 3/12/2006 14:09'!
printOn: aStream

	aStream nextPutAll: 'CDATA section not properly terminated.'! !

HtmlSyntaxError subclass: #HtmlUncommentedScriptError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlUncommentedScriptError methodsFor: 'testing' stamp: 'tb 12/4/2005 22:07'!
isStructuralError

	^true! !

!HtmlUncommentedScriptError methodsFor: 'as yet unclassified' stamp: 'tb 12/8/2005 23:07'!
printOn: aStream

	'Script should be surrounded by html comments: <!!-- script -->' printOn: aStream.! !

HtmlSyntaxError subclass: #HtmlUnescapedSpecialCharacterError
	instanceVariableNames: 'position'
	classVariableNames: 'CharactersToEntities SpecialCharacters'
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlUnescapedSpecialCharacterError class methodsFor: 'as yet unclassified' stamp: 'tb 12/11/2005 21:58'!
initialize

	"HtmlUnescapedSpecialCharacterError initialize"

	CharactersToEntities := Dictionary new. 

	CharactersToEntities 
		at: $< put: '&lt;';
		at: $> put: '&gt;';
		at: $& put: '&amp;'.

	SpecialCharacters := CharactersToEntities keys! !

!HtmlUnescapedSpecialCharacterError class methodsFor: 'as yet unclassified' stamp: 'tb 12/10/2005 22:51'!
specialCharacters

	^SpecialCharacters! !

!HtmlUnescapedSpecialCharacterError methodsFor: 'accessing' stamp: 'tb 12/10/2005 22:57'!
position

	^position! !

!HtmlUnescapedSpecialCharacterError methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:34'!
position: anObject
	"Set the value of position"

	position := anObject! !

!HtmlUnescapedSpecialCharacterError methodsFor: 'as yet unclassified' stamp: 'tb 12/10/2005 22:52'!
printOn: aStream

	| c |

	c := self parent document content at: self position.

	aStream nextPutAll: 'Character: '.
	c asString printOn: aStream.
	aStream nextPutAll: ' should be '.
	aStream nextPutAll: (CharactersToEntities at: c ifAbsent: ['escaped.']).! !

HtmlError subclass: #HtmlTagError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

HtmlTagError subclass: #HtmlHeadBodyNestingError
	instanceVariableNames: 'nesting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlHeadBodyNestingError methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 02:41'!
isStructuralError

	^true! !

!HtmlHeadBodyNestingError methodsFor: 'accessing' stamp: 'tb 12/4/2005 23:06'!
nesting
	"Answer the value of nesting"

	^ nesting! !

!HtmlHeadBodyNestingError methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:31'!
nesting: anObject
	"Set the value of nesting"

	nesting := anObject! !

!HtmlHeadBodyNestingError methodsFor: 'accessing' stamp: 'tb 12/5/2005 02:43'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $ .
	('Actual tag nesting order found in document is: ', self nesting asString) printOn: aStream.! !

!HtmlTagError methodsFor: 'testing' stamp: 'tb 12/4/2005 21:58'!
isTagError

	^true! !

!HtmlTagError methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 00:48'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: (' Tag: ', self tag)! !

HtmlTagError subclass: #HtmlTagUnknownError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlTagUnknownError methodsFor: 'as yet unclassified' stamp: 'tb 12/8/2005 23:07'!
printOn: aStream

	self parent tag printOn: aStream.
	aStream nextPutAll: ' is not valid within this doctype.  It can probably be replaced with a span and CSS style.'

	! !

HtmlError subclass: #HtmlTagNotLowerCaseError
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlTagNotLowerCaseError methodsFor: 'testing' stamp: 'tb 12/4/2005 22:01'!
isCaseError

	^true! !

!HtmlTagNotLowerCaseError methodsFor: 'as yet unclassified' stamp: 'tb 12/8/2005 22:35'!
printOn: aStream

	self parent rawTag printOn: aStream.
	aStream nextPutAll: ' should probably be '.
	self parent tag printOn: aStream.! !

!HtmlTagNotLowerCaseError methodsFor: 'accessing' stamp: 'tb 12/4/2005 21:22'!
tag
	"Answer the value of tag"

	^ tag! !

!HtmlTagNotLowerCaseError methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:34'!
tag: anObject
	"Set the value of tag"

	tag := anObject! !

HtmlError subclass: #HtmlTagStructureError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

HtmlTagStructureError subclass: #HtmlTagImproperlyNestedError
	instanceVariableNames: 'wrongTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlTagImproperlyNestedError methodsFor: 'as yet unclassified' stamp: 'tb 12/16/2005 23:31'!
printOn: aStream

	| rule |

	self parent tag printOn: aStream.
	aStream nextPutAll: ' found within tag: '.
	self parent parent tag printOn: aStream.

	rule := (self parent dtd elementForTag: self parent parent dtdTag).
	rule notNil ifTrue:
	[
		aStream nextPutAll: '. Tag Rule: '.
		rule contentRule printOn: aStream.
	]
	! !

!HtmlTagImproperlyNestedError methodsFor: 'accessing' stamp: 'tb 12/5/2005 11:46'!
wrongTag
	"Answer the value of wrongTag"

	^ wrongTag! !

!HtmlTagImproperlyNestedError methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:33'!
wrongTag: anObject
	"Set the value of wrongTag"

	wrongTag := anObject! !

HtmlTagStructureError subclass: #HtmlTagMissingEndError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlTagMissingEndError methodsFor: 'testing' stamp: 'tb 12/4/2005 22:03'!
isStructuralError

	^true! !

!HtmlTagMissingEndError methodsFor: 'testing' stamp: 'tb 12/8/2005 19:14'!
printOn: aStream

	aStream nextPutAll: 'No closing tag found for tag: '.
	self parent tag printOn: aStream.
	! !

!HtmlTagMissingEndError methodsFor: 'testing' stamp: 'tb 12/5/2005 01:35'!
uniqueId

	^self parent uniqueId, '-end-missing'! !

HtmlTagStructureError subclass: #HtmlTagMissingStartError
	instanceVariableNames: 'position tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlTagMissingStartError methodsFor: 'testing' stamp: 'tb 12/4/2005 22:04'!
isStructuralError

	^true! !

!HtmlTagMissingStartError methodsFor: 'accessing' stamp: 'tb 12/4/2005 21:14'!
position
	"Answer the value of position"

	^ position! !

!HtmlTagMissingStartError methodsFor: 'accessing' stamp: 'tb 10/30/2008 16:31'!
position: anObject
	"Set the value of position"

	position := anObject.
	"self halt."

! !

!HtmlTagMissingStartError methodsFor: 'accessing' stamp: 'tb 12/8/2005 19:17'!
printOn: aStream

	aStream nextPutAll: 'Closing tag: '.
	self tag printOn: aStream.
	aStream nextPutAll: ' with no start found'! !

!HtmlTagMissingStartError methodsFor: 'accessing' stamp: 'tb 12/4/2005 21:14'!
tag
	"Answer the value of tag"

	^ tag! !

!HtmlTagMissingStartError methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:55'!
tag: anObject
	"Set the value of tag"

	tag := anObject! !

!HtmlTagMissingStartError methodsFor: 'accessing' stamp: 'tb 12/5/2005 01:26'!
uniqueId

	^super uniqueId, '-end'! !

HtmlTagStructureError subclass: #HtmlTagMustBeEmptyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM-Errors'!

!HtmlTagMustBeEmptyError methodsFor: 'as yet unclassified' stamp: 'tb 12/8/2005 23:06'!
printOn: aStream

	self parent tag printOn: aStream.
	aStream nextPutAll: ' must be empty.'! !

!HtmlTagStructureError methodsFor: 'testing' stamp: 'tb 12/5/2005 17:26'!
isStructuralError

	^true! !

Object subclass: #HtmlPListSerializer
	instanceVariableNames: 'stream arrayItemsPerLine dictionaryItemsPerLine indentLevel'
	classVariableNames: 'ReadTranslations WriteTranslations'
	poolDictionaries: ''
	category: 'HTML-PList'!

!HtmlPListSerializer class methodsFor: 'class initialization' stamp: 'tb 8/1/2006 20:36'!
initialize
	"comment stating purpose of message"
	| dict |

	ReadTranslations notNil ifTrue: [^self].

	dict := Dictionary new.
			dict at: $" put: $".
			dict at: $' put: $'.
			dict at: $\ put: $\.
			dict at: $n put: (Character cr).
			dict at: $r put: (Character cr).
			dict at: $t put: (Character tab).
	ReadTranslations := dict.

	dict := Dictionary new.
			dict at: Character tab put: '\t'.
			dict at: Character cr put: '\n'.
			dict at: $" put: '\"'.
			dict at: $' put: ('\', ($' asString)).
			dict at: $\ put: '\\'.
	WriteTranslations := dict
! !

!HtmlPListSerializer class methodsFor: 'instance creation' stamp: 'tb 8/1/2006 21:55'!
on: aStream 
	"Answer an instance of me initialized on a stream."

	self initialize.
	^self basicNew on: aStream! !

!HtmlPListSerializer methodsFor: 'initialize' stamp: 'tb 5/12/2006 10:15'!
close

	stream close.
	stream := nil.! !

!HtmlPListSerializer methodsFor: 'reading' stamp: 'tb 5/12/2006 10:15'!
next
	^self read! !

!HtmlPListSerializer methodsFor: 'reading' stamp: 'tb 5/12/2006 10:15'!
nextPut: anObject

	self write: anObject! !

!HtmlPListSerializer methodsFor: 'initialize' stamp: 'tb 5/12/2006 10:15'!
on: aStream
	"Initialize myself with a stream"

	stream := aStream.
	(stream respondsTo: #ascii) ifTrue: [stream ascii].
	arrayItemsPerLine := 5.
	dictionaryItemsPerLine := 3.
	indentLevel := 0! !

!HtmlPListSerializer methodsFor: 'reading' stamp: 'tb 5/12/2006 10:15'!
read
	"read a complete plist object assembly from the stream and return it"

	| c |

	self skipWhitespace.
	c := stream peek.
		
	 ^(c = ${)  ifTrue: [ self readDictionary ]
		ifFalse: 
		[
			( c = $( ) ifTrue: [ self readArray ]
			ifFalse: 
			[
				( c = $" ) ifTrue: [ self readQuotedString ] 
				ifFalse: [(self readString)]
			]
		]! !

!HtmlPListSerializer methodsFor: 'reading' stamp: 'tb 5/12/2006 10:15'!
readArray
	"read an array"

	| item list |

	self skipWhitespace.

	( stream peek = $( ) 
		ifTrue:
		[
			stream next.
			self skipWhitespace.
			list := OrderedCollection new.
			[stream peek = $) ] whileFalse:
			[
				item := self read.
				list add: item.
				self skipWhitespace.
				(stream peek = $,) ifTrue: [stream next. self skipWhitespace].
			].
			stream next. "consume the trailing paren"
		]
		ifFalse:
		[ 
			"error of some sort here"
		].
		^list! !

!HtmlPListSerializer methodsFor: 'reading' stamp: 'tb 5/12/2006 10:15'!
readDictionary
	"read a dictionary - assumes leading { has already been read"

	| c key value dict |

	self skipWhitespace.

	c := stream next.
	( c = ${ ) 
		ifTrue:
		[
			dict := Dictionary new.
			self skipWhitespace.
			[stream peek = $} ] whileFalse:
			[
				key := self read.
				self skipWhitespace.
				c := stream next.
				( c = $=) ifFalse: [ self error: 'expected = here' ].
				value := self read.
				self skipWhitespace.
				c := stream next.
				( c = $;) ifFalse: [ self error: 'expected ; here' ].
				self skipWhitespace.
				dict at: key put: value.
			].
			stream next.
		]
		ifFalse:
		[ 
			self error: 'not a dictionary'
		].
		^dict! !

!HtmlPListSerializer methodsFor: 'reading' stamp: 'sebastian.sastre 9/19/2010 11:16'!
readQuotedString
	"read a complete plist object assembly from the stream and return it"
	| out c |
	out := WriteStream on: String new.
	self skipWhitespace.
	stream peek = $"
		ifTrue: [stream next.
			[stream peek = $" & stream peek notNil]
				whileFalse: [c := stream next.
					c = $\
						ifTrue: [c := stream next.
							out
								nextPut: (ReadTranslations at: c)]
						ifFalse: [out nextPut: c]].
			stream next].
	^ out contents! !

!HtmlPListSerializer methodsFor: 'reading' stamp: 'tb 5/12/2006 10:15'!
readString
	"read a complete plist object assembly from the stream and return it"

	| out c |

	out := WriteStream on: String new.

	self skipWhitespace.
	[c := stream peek.
		c isAlphaNumeric | ('-_.' includes: c)] whileTrue: [ out nextPut: stream next ].
		
	^out contents.! !

!HtmlPListSerializer methodsFor: 'reading' stamp: 'tb 5/12/2006 10:15'!
skipWhitespace
	"read a dictionary - assumes leading { has already been read"

	[
		| c |
		c := stream peek.
		(c notNil) and: [c isSeparator]
	] whileTrue: [ stream next].
! !

!HtmlPListSerializer methodsFor: 'writing' stamp: 'tb 5/12/2006 10:15'!
write: object
	"write a serialized version of object - either an ordered collection, a dictionary, or something we can convert to a string"

	object isString 
		ifFalse: [ self writeCollection: object]
		ifTrue: [ self writeString: object asString] ! !

!HtmlPListSerializer methodsFor: 'writing' stamp: 'tb 5/12/2006 10:15'!
writeArray: aCollection
	"write a serialized version of the ordered collection"

	| itemsPerLine | 

	itemsPerLine := 0.
	stream nextPutAll: '( '.
	indentLevel := indentLevel + 1.
	aCollection do: 
		[:x | 
			self write: x. 
			stream nextPutAll: ', '. 
			itemsPerLine := itemsPerLine + 1.
			itemsPerLine = arrayItemsPerLine ifTrue:[stream cr. itemsPerLine := 0] 
		].
	indentLevel := indentLevel - 1.
	aCollection isEmpty ifFalse: [ stream position: (stream position-2) ]. "Trim last comma space"
	stream nextPutAll: ')'.! !

!HtmlPListSerializer methodsFor: 'writing' stamp: 'tb 5/12/2006 10:15'!
writeCollection: aCollection
	"write a serialized version of the collection"

	aCollection isSequenceable 
		ifTrue: [ self writeArray: aCollection]
		ifFalse: [ self writeDictionary: aCollection] ! !

!HtmlPListSerializer methodsFor: 'writing' stamp: 'sebastian.sastre 9/6/2010 17:07'!
writeDictionary: aCollection
	"write a serialized version of the ordered collection"

	stream nextPutAll: '{ '; nextPut: Character lf.
	indentLevel := indentLevel + 1.
	aCollection keysAndValuesDo: [:key :value | 
		0 to: indentLevel do: [:ea | stream nextPut: $ ].
		self write: key. 
		stream nextPutAll: ' = '. 
		self write: value.
		stream nextPutAll: '; '; nextPut: Character lf].
	indentLevel := -1.
	stream nextPutAll: '}'.! !

!HtmlPListSerializer methodsFor: 'writing' stamp: 'tb 5/12/2006 10:15'!
writeIndent
	"write the indent"

	0 to: indentLevel do: [:x | stream nextPutAll: '    '] ! !

!HtmlPListSerializer methodsFor: 'writing' stamp: 'tb 5/12/2006 10:15'!
writeString: aString
	"write a string to the stream - quoting and escaping if necessary"

	(aString detect: [:c | ((c isAlphaNumeric) | ('_-.' includes: c)) not] ifNone: [ nil ])
	ifNil: [ stream nextPutAll: aString ]
	ifNotNil: [ stream nextPut: $". 
		aString do: [:c | stream nextPutAll: (WriteTranslations at: c ifAbsent: [ c asString] )]. stream nextPutAll: '" ']! !

Object subclass: #HtmlParseNode
	instanceVariableNames: 'children parent errors start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

HtmlParseNode subclass: #CSSElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSElement commentStamp: '<historical>' prior: 0!
I am a base class for CSS parse nodes.!

CSSElement subclass: #CSSComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSComment methodsFor: 'as yet unclassified' stamp: 'tb 1/6/2006 20:06'!
isAtImportRule

	^false! !

!CSSComment methodsFor: 'as yet unclassified' stamp: 'tb 1/14/2006 15:42'!
parseContents: aStream

	aStream skip: 2.
	[aStream atEnd] whileFalse:
	[
		(aStream peek = $* and: [aStream next. aStream peek = $/]) ifTrue:
		[
			aStream next.
			^self end: aStream position.
		]
		ifFalse:
		[
			aStream next = $\ ifTrue: [aStream next].
		]
	].
	self end: aStream position.! !

!CSSComment methodsFor: 'as yet unclassified' stamp: 'tb 12/19/2005 23:00'!
tag

	^'comment'! !

!CSSElement methodsFor: 'as yet unclassified' stamp: 'tb 1/6/2006 20:06'!
isAtImportRule

	^false! !

!CSSElement methodsFor: 'as yet unclassified' stamp: 'tb 12/19/2005 23:01'!
isCSS

	^true! !

!CSSElement methodsFor: 'as yet unclassified' stamp: 'tb 1/6/2006 13:03'!
isProperty

	^false! !

!CSSElement methodsFor: 'as yet unclassified' stamp: 'tb 12/31/2005 23:05'!
isStyleRule

	^false! !

!CSSElement methodsFor: 'as yet unclassified' stamp: 'tb 12/21/2005 16:13'!
tag
	^'css'! !

!CSSElement methodsFor: 'as yet unclassified' stamp: 'tb 12/20/2005 13:43'!
validateAgainstDTD: aDTD! !

CSSElement subclass: #CSSProperty
	instanceVariableNames: 'propertyName propertyValue propertyString definition important isDerived'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSProperty class methodsFor: 'instance creation' stamp: 'tb 12/18/2005 01:07'!
propertyNamed: aString

	^self new propertyName: aString! !

!CSSProperty methodsFor: 'accessing' stamp: 'SebastianSastre 1/15/2012 16:38'!
definition

	definition isNil ifTrue: 
	[
		definition := CSSPropertyDefinition named: 
			self propertyName asLowercase trimBoth
	].
	^definition! !

!CSSProperty methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:16'!
definition: anObject
	"Set the value of definition"

	definition := anObject! !

!CSSProperty methodsFor: 'accessing' stamp: 'tb 1/4/2006 21:06'!
important
	"Answer the value of important"

	^ important! !

!CSSProperty methodsFor: 'accessing' stamp: 'sebastian.sastre 10/18/2010 11:57'!
important: anObject
	"Set the value of important"

	important := anObject! !

!CSSProperty methodsFor: 'accessing' stamp: 'tb 1/5/2006 08:29'!
isDerived
	"Answer the value of isDerived"

	isDerived isNil ifTrue: [isDerived := false].
	^ isDerived! !

!CSSProperty methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:16'!
isDerived: anObject
	"Set the value of isDerived"

	isDerived := anObject! !

!CSSProperty methodsFor: 'testing' stamp: 'tb 1/5/2006 08:25'!
isProperty

	^true! !

!CSSProperty methodsFor: 'accessing' stamp: 'tb 1/4/2006 21:08'!
parseContents: aStream

	| s pos in |
	aStream skipSeparators.
	pos := aStream position.
	s := aStream upTo: $;.
	(s includes: $}) ifTrue: 
	[
		aStream position: pos. 
		s := aStream upTo: $}.  
		self addError: CSSUnterminatedPropertyError new.
	].
	in := ReadStream on: s.
	self propertyString: (in upTo: $!!).
	self important: (in match: 'important').! !

!CSSProperty methodsFor: 'accessing' stamp: 'tb 1/5/2006 21:21'!
prefix

	^self isDerived ifTrue: 
	[
		| out |
		out := WriteStream on: String new.
		out nextPutAll: '<<';
			nextPutAll: self propertyName;
			nextPutAll: '>>';
			nextPut: $:;
			nextPut: $ .
		self propertyValue do:[:ea | out nextPut: $ ; nextPutAll: ea valueString].
		out nextPut: $;.
		out contents
	]
	ifFalse:
	[
		super prefix
	]! !

!CSSProperty methodsFor: 'accessing' stamp: 'tb 12/20/2005 11:20'!
printOn: aStream

	aStream nextPutAll: self prefix! !

!CSSProperty methodsFor: 'accessing' stamp: 'tb 12/17/2005 22:05'!
propertyName
	"Answer the value of propertyName"

	^ propertyName! !

!CSSProperty methodsFor: 'accessing' stamp: 'sebastian.sastre 10/18/2010 11:56'!
propertyName: anObject
	"Set the value of propertyName"

	propertyName := anObject! !

!CSSProperty methodsFor: 'accessing' stamp: 'tb 12/30/2005 01:44'!
propertyString
	"Answer the value of propertyString"

	^ propertyString! !

!CSSProperty methodsFor: 'accessing' stamp: 'sebastian.sastre 10/18/2010 11:57'!
propertyString: anObject
	"Set the value of propertyString"

	propertyString := anObject! !

!CSSProperty methodsFor: 'accessing' stamp: 'tb 12/17/2005 23:58'!
propertyValue
	"Answer the value of propertyValue"

	^ propertyValue! !

!CSSProperty methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:17'!
propertyValue: anObject
	"Set the value of propertyValue"

	propertyValue := anObject! !

!CSSProperty methodsFor: 'accessing' stamp: 'tb 12/17/2005 23:58'!
tag

	^propertyName! !

!CSSProperty methodsFor: 'accessing' stamp: 'tb 1/6/2006 11:49'!
valueIsValid

	"self propertyName = 'font-family' ifTrue: [self halt]."
	^self definition isNil ifTrue: [false]
	ifFalse: 
	[
		propertyValue isNil ifTrue:
		[
			| list in |
			in := ReadStream on: self propertyString.
			list := OrderedCollection new.
			((self definition valueType addValues: list fromStream: in) and: 
				[in skipSeparators atEnd]) 
			ifTrue: 
			[
				self propertyValue: list.
				list do: [:ea | (ea isString not and: [ea isProperty]) ifTrue: [self parent addProperty: (ea start: self start; end: self end)]]. 
				true
			]
			ifFalse: [false]
		]
		ifFalse: [true]
	].
	! !

CSSElement subclass: #CSSRule
	instanceVariableNames: 'media'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSRule subclass: #CSSAtRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

CSSAtRule subclass: #CSSAtImportRule
	instanceVariableNames: 'urlValue stylesheet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSAtImportRule methodsFor: 'testing' stamp: 'tb 12/30/2005 20:05'!
isAtImportRule

	^true! !

!CSSAtImportRule methodsFor: 'as yet unclassified' stamp: 'tb 1/3/2006 17:02'!
parseContents: aStream

	| s m |

	urlValue := CSSUriValue readFrom: aStream.	
	aStream skipSeparators.
	s := aStream upTo: $;.
	self end: aStream position.
	m := s findTokens: ', '.
	m size > 0 ifTrue: [self media: m].	
! !

!CSSAtImportRule methodsFor: 'accessing' stamp: 'tb 12/31/2005 23:00'!
stylesheet
	"Answer the value of styleSheet"

	stylesheet isNil ifTrue: [ stylesheet := CSSStyleSheet fromUrl: urlValue value parent: self].
	^stylesheet! !

!CSSAtImportRule methodsFor: 'accessing' stamp: 'tb 12/30/2005 14:36'!
stylesheet: anObject
	"Set the value of styleSheet"

	stylesheet := anObject! !

!CSSAtImportRule methodsFor: 'accessing' stamp: 'tb 12/30/2005 14:26'!
urlValue
	"Answer the value of urlValue"

	^ urlValue! !

!CSSAtImportRule methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:15'!
urlValue: anObject
	"Set the value of urlValue"

	urlValue := anObject! !

CSSAtRule subclass: #CSSAtPageRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSAtRule class methodsFor: 'instance creation' stamp: 'tb 1/6/2006 09:46'!
named: aString

	| out cls |

	out := WriteStream on: String new.
	out nextPutAll: 'CSSAt'.
	out nextPut: aString first asUppercase.
	out nextPutAll: (aString last: aString size -1).
	out nextPutAll: 'Rule'.

	cls := Smalltalk at: out contents asSymbol ifAbsent:[nil].

	^cls new.! !

!CSSAtRule methodsFor: 'as yet unclassified' stamp: 'tb 1/3/2006 17:03'!
parseContents: aStream

	| s |

	s := aStream upTo: $;.
	(s includes: ${) ifTrue: [aStream position: self start. aStream upTo: $}].
	self end: aStream position.
	! !

!CSSRule methodsFor: 'testing' stamp: 'tb 12/30/2005 20:05'!
isAtImportRule

	^false! !

!CSSRule methodsFor: 'testing' stamp: 'tb 12/30/2005 20:05'!
isStyleRule

	^false! !

!CSSRule methodsFor: 'accessing' stamp: 'tb 12/20/2005 00:28'!
media
	"Answer the value of media"

	^ media! !

!CSSRule methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:19'!
media: anObject
	"Set the value of media"

	media := anObject! !

CSSRule subclass: #CSSStyleRule
	instanceVariableNames: 'selector properties matchCount keySelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSStyleRule commentStamp: 'tb 12/12/2005 09:05' prior: 0!
I am a parsed CSS rule with selector and dictionary of attributes.

<Foo>
    Value of type Foo. Common types are discussed on the Units page.
Foo
    A keyword that must appear literally (though without case sensitivity). Commas and slashes must also appear literally.
A B C
    A must occur, then B, then C, in that order.
A | B
    A or B must occur.
A || B
    A or B or both must occur, in any order.
[ Foo ]
    Brackets are used to group items together.
Foo*
    Foo is repeated zero or more times.
Foo+
    Foo is repeated one or more times.
Foo?
    Foo is optional.
Foo{A,B}
    Foo must occur at least A times and at most B times. !

CSSStyleRule subclass: #CSSNodeAttributeStyleRule
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSNodeAttributeStyleRule methodsFor: 'as yet unclassified' stamp: 'tb 7/12/2007 11:53'!
content

	^content! !

!CSSNodeAttributeStyleRule methodsFor: 'as yet unclassified' stamp: 'tb 7/12/2007 12:09'!
content: aString

	content := '[style="',aString,'"]{',aString,'}'.
	self start: 1.
	self end: content size.
	self parseContents: (ReadStream on: content)! !

!CSSNodeAttributeStyleRule methodsFor: 'as yet unclassified' stamp: 'tb 7/12/2007 12:16'!
printOn: aStream

	aStream nextPutAll: self content! !

!CSSStyleRule class methodsFor: 'definitions' stamp: 'tb 12/15/2005 02:05'!
allRules

	| dict |

	dict := Dictionary new.

	dict addAll: (self structuredRulesFrom: self boxPropertyRules).
	dict addAll: (self structuredRulesFrom: self classificationRules).
	dict addAll: (self structuredRulesFrom: self colorAndBackgroundRules).
	dict addAll: (self structuredRulesFrom: self fontRules).
	dict addAll: (self structuredRulesFrom: self textPropertyRules).
	^dict! !

!CSSStyleRule class methodsFor: 'definitions' stamp: 'tb 12/12/2005 10:54'!
boxPropertyRules

	^'Top Margin
Syntax: 	margin-top: <value>
Possible Values: 	<length> | <percentage> | auto
Initial Value: 	0
Applies to: 	All elements
Inherited: 	No

The margin-top property sets the top margin of an element by specifying a length or a percentage. Percentage values refer to the parent element''s width. Negative margins are permitted.

For example, the following rule would eliminate the top margin of a document:

BODY { margin-top: 0 }

Note that adjoining vertical margins are collapsed to use the maximum of the margin values.
Right Margin
Syntax: 	margin-right: <value>
Possible Values: 	<length> | <percentage> | auto
Initial Value: 	0
Applies to: 	All elements
Inherited: 	No

The margin-right property sets the right margin of an element by specifying a length or a percentage. Percentage values refer to the parent element''s width. Negative margins are permitted.

Example:

P.narrow { margin-right: 50% }

Note that adjoining horizontal margins are not collapsed.
Bottom Margin
Syntax: 	margin-bottom: <value>
Possible Values: 	<length> | <percentage> | auto
Initial Value: 	0
Applies to: 	All elements
Inherited: 	No

The margin-bottom property sets the bottom margin of an element by specifying a length or a percentage. Percentage values refer to the parent element''s width. Negative margins are permitted.

Example:

DT { margin-bottom: 3em }

Note that adjoining vertical margins are collapsed to use the maximum of the margin values.
Left Margin
Syntax: 	margin-left: <value>
Possible Values: 	<length> | <percentage> | auto
Initial Value: 	0
Applies to: 	All elements
Inherited: 	No

The margin-left property sets the left margin of an element by specifying a length or a percentage. Percentage values refer to the parent element''s width. Negative margins are permitted.

Example:

ADDRESS { margin-left: 50% }

Note that adjoining horizontal margins are not collapsed.
Margin
Syntax: 	margin: <value>
Possible Values: 	[ <length> | <percentage> | auto ]{1,4}
Initial Value: 	Not defined
Applies to: 	All elements
Inherited: 	No

The margin property sets the margins of an element by specifying between one and four values, where each value is a length, a percentage, or auto. Percentage values refer to the parent element''s width. Negative margins are permitted.

If four values are given, they apply to top, right, bottom, and left margin, respectively. If one value is given, it applies to all sides. If two or three values are given, the missing values are taken from the opposite side.

Examples of margin declarations include:

BODY { margin: 5em }             /* all margins 5em */
P    { margin: 2em 4em }         /* top and bottom margins 2em,
                                    left and right margins 4em */
DIV  { margin: 1em 2em 3em 4em } /* top margin 1em,
                                    right margin 2em,
                                    bottom margin 3em,
                                    left margin 4em */

Note that adjoining vertical margins are collapsed to use the maximum of the margin values. Horizontal margins are not collapsed.

Using the margin property allows one to set all margins; alternatively, the properties margin-top, margin-bottom, margin-left, and margin-right may be used.
Top Padding
Syntax: 	padding-top: <value>
Possible Values: 	<length> | <percentage>
Initial Value: 	0
Applies to: 	All elements
Inherited: 	No

The padding-top property describes how much space to put between the top border and the content of the selector. The value is either a length or a percentage. Percentage values refer to the parent element''s width. Negative values are not permitted.
Right Padding
Syntax: 	padding-right: <value>
Possible Values: 	<length> | <percentage>
Initial Value: 	0
Applies to: 	All elements
Inherited: 	No

The padding-right property describes how much space to put between the right border and the content of the selector. The value is either a length or a percentage. Percentage values refer to the parent element''s width. Negative values are not permitted.
Bottom Padding
Syntax: 	padding-bottom: <value>
Possible Values: 	<length> | <percentage>
Initial Value: 	0
Applies to: 	All elements
Inherited: 	No

The padding-bottom property describes how much space to put between the bottom border and the content of the selector. The value is either a length or a percentage. Percentage values refer to the parent element''s width. Negative values are not permitted.
Left Padding
Syntax: 	padding-left: <value>
Possible Values: 	<length> | <percentage>
Initial Value: 	0
Applies to: 	All elements
Inherited: 	No

The padding-left property describes how much space to put between the left border and the content of the selector. The value is either a length or a percentage. Percentage values refer to the parent element''s width. Negative values are not permitted.
Padding
Syntax: 	padding: <value>
Possible Values: 	[ <length> | <percentage> ]{1,4}
Initial Value: 	0
Applies to: 	All elements
Inherited: 	No

The padding property is a shorthand for the padding-top, padding-right, padding-bottom, and padding-left properties.

An element''s padding is the amount of space between the border and the content of the element. Between one and four values are given, where each value is either a length or a percentage. Percentage values refer to the parent element''s width. Negative values are not permitted.

If four values are given, they apply to top, right, bottom, and left padding, respectively. If one value is given, it applies to all sides. If two or three values are given, the missing values are taken from the opposite side.

For example, the following rule sets the top padding to 2em, the right padding to 4em, the bottom padding to 5em, and the left padding to 4em:

BLOCKQUOTE { padding: 2em 4em 5em }

Top Border Width
Syntax: 	border-top-width: <value>
Possible Values: 	thin | medium | thick | <length>
Initial Value: 	medium
Applies to: 	All elements
Inherited: 	No

The border-top-width property is used to specify the width of an element''s top border. The value may be one of three keywords, which are not affected by font size, or a length, which can be used to achieve relative widths. Negative values are not allowed.

One may also use the border-top, border-width, or border shorthand properties.
Right Border Width
Syntax: 	border-right-width: <value>
Possible Values: 	thin | medium | thick | <length>
Initial Value: 	medium
Applies to: 	All elements
Inherited: 	No

The border-right-width property is used to specify the width of an element''s right border. The value may be one of three keywords, which are not affected by font size, or a length, which can be used to achieve relative widths. Negative values are not allowed.

One may also use the border-right, border-width, or border shorthand properties.
Bottom Border Width
Syntax: 	border-bottom-width: <value>
Possible Values: 	thin | medium | thick | <length>
Initial Value: 	medium
Applies to: 	All elements
Inherited: 	No

The border-bottom-width property is used to specify the width of an element''s bottom border. The value may be one of three keywords, which are not affected by font size, or a length, which can be used to achieve relative widths. Negative values are not allowed.

One may also use the border-bottom, border-width, or border shorthand properties.
Left Border Width
Syntax: 	border-left-width: <value>
Possible Values: 	thin | medium | thick | <length>
Initial Value: 	medium
Applies to: 	All elements
Inherited: 	No

The border-left-width property is used to specify the width of an element''s left border. The value may be one of three keywords, which are not affected by font size, or a length, which can be used to achieve relative widths. Negative values are not allowed.

One may also use the border-left, border-width, or border shorthand properties.
Border Width
Syntax: 	border-width: <value>
Possible Values: 	[ thin | medium | thick | <length> ]{1,4}
Initial Value: 	Not defined
Applies to: 	All elements
Inherited: 	No

The border-width property is used to set the border width of an element by specifying between one and four values, where each value is a keyword or a length. Negative lengths are not permitted.

If four values are given, they apply to top, right, bottom, and left border width, respectively. If one value is given, it applies to all sides. If two or three values are given, the missing values are taken from the opposite side.

This property is a shorthand for the border-top-width, border-right-width, border-bottom-width, and border-left-width properties.

One may also use the border shorthand property.
Border Color
Syntax: 	border-color: <value>
Possible Values: 	<color>{1,4}
Initial Value: 	The value of the color property
Applies to: 	All elements
Inherited: 	No

The border-color property sets the color of an element''s border. Between one and four color values are specified. If four values are given, they apply to top, right, bottom, and left border color, respectively. If one value is given, it applies to all sides. If two or three values are given, the missing values are taken from the opposite side.

One may also use the border shorthand property.
Border Style
Syntax: 	border-style: <value>
Possible Values: 	[ none | dotted | dashed | solid | double | groove | ridge | inset | outset ]{1,4}
Initial Value: 	none
Applies to: 	All elements
Inherited: 	No

The border-style property sets the style of an element''s border. This property must be specified for the border to be visible.

Between one and four keywords are specified. If four values are given, they apply to top, right, bottom, and left border style, respectively. If one value is given, it applies to all sides. If two or three values are given, the missing values are taken from the opposite side.

One may also use the border shorthand property.
Top Border
Syntax: 	border-top: <value>
Possible Values: 	<border-top-width> || <border-style> || <color>
Initial Value: 	Not defined
Applies to: 	All elements
Inherited: 	No

The border-top property is a shorthand for setting the width, style, and color of an element''s top border.

Note that only one border-style value may be given.

One may also use the border shorthand property.
Right Border
Syntax: 	border-right: <value>
Possible Values: 	<border-right-width> || <border-style> || <color>
Initial Value: 	Not defined
Applies to: 	All elements
Inherited: 	No

The border-right property is a shorthand for setting the width, style, and color of an element''s right border.

Note that only one border-style value may be given.

One may also use the border shorthand property.
Bottom Border
Syntax: 	border-bottom: <value>
Possible Values: 	<border-bottom-width> || <border-style> || <color>
Initial Value: 	Not defined
Applies to: 	All elements
Inherited: 	No

The border-bottom property is a shorthand for setting the width, style, and color of an element''s bottom border.

Note that only one border-style value may be given.

One may also use the border shorthand property.
Left Border
Syntax: 	border-left: <value>
Possible Values: 	<border-left-width> || <border-style> || <color>
Initial Value: 	Not defined
Applies to: 	All elements
Inherited: 	No

The border-left property is a shorthand for setting the width, style, and color of an element''s left border.

Note that only one border-style value may be given.

One may also use the border shorthand property.
Border
Syntax: 	border: <value>
Possible Values: 	<border-width> || <border-style> || <color>
Initial Value: 	Not defined
Applies to: 	All elements
Inherited: 	No

The border property is a shorthand for setting the width, style, and color of an element''s border.

Examples of border declarations include:

H2        { border: groove 3em }
A:link    { border: solid blue }
A:visited { border: thin dotted #800080 }
A:active  { border: thick double red }

The border property can only set all four borders; only one border width and border style may be given. To give different values to an element''s four borders, an author must use one or more of the border-top, border-right, border-bottom, border-left, border-color, border-width, border-style, border-top-width, border-right-width, border-bottom-width, or border-left-width properties.
Width
Syntax: 	width: <value>
Possible Values: 	<length> | <percentage> | auto
Initial Value: 	auto
Applies to: 	Block-level and replaced elements
Inherited: 	No

Each block-level or replaced element can be given a width, specified as a length, a percentage, or as auto. (A replaced element is one for which only the intrinsic dimensions are known; HTML replaced elements include IMG, INPUT, TEXTAREA, SELECT, and OBJECT.) The initial value for the width property is auto, which results in the element''s intrinsic width (i.e., the width of the element itself, for example the width of an image). Percentages refer to the parent element''s width. Negative values are not allowed.

This property could be used to give common widths to some INPUT elements, such as submit and reset buttons:

INPUT.button { width: 10em }

Height
Syntax: 	height: <value>
Possible Values: 	<length> | auto
Initial Value: 	auto
Applies to: 	Block-level and replaced elements
Inherited: 	No

Each block-level or replaced element can be given a height, specified as a length or as auto. (A replaced element is one for which only the intrinsic dimensions are known; HTML replaced elements include IMG, INPUT, TEXTAREA, SELECT, and OBJECT.) The initial value for the height property is auto, which results in the element''s intrinsic height (i.e., the height of the element itself, for example the height of an image). Negative lengths are not allowed.

As with the width property, height can be used to scale an image:

IMG.foo { width: 40px; height: 40px }

In most cases, authors are advised to scale the image in an image editing program, since browsers will not likely scale images with high quality, and since scaling down causes the user to download an unnecessarily large file. However, scaling through the width and height properties is a useful option for user-defined style sheets in order to overcome vision problems.
Float
Syntax: 	float: <value>
Possible Values: 	left | right | none
Initial Value: 	none
Applies to: 	All elements
Inherited: 	No

The float property allows authors to wrap text around an element. This is identical in purpose to HTML 3.2''s ALIGN=left and ALIGN=right for the IMG element, but CSS1 allows all elements to "float," not just the images and tables that HTML 3.2 allows.
Clear
Syntax: 	clear: <value>
Possible Values: 	none | left | right | both
Initial Value: 	none
Applies to: 	All elements
Inherited: 	No

The clear property specifies if an element allows floating elements to its sides. A value of left moves the element below any floating element on its left; right acts similarly for floating elements on the right. Other values are none, which is the initial value, and both, which moves the element below floating elements on both of its sides. This property is similar in function to HTML 3.2''s <BR CLEAR=left|right|all|none>, but it can be applied to all elements.'! !

!CSSStyleRule class methodsFor: 'definitions' stamp: 'tb 12/15/2005 03:18'!
classNameFromProperty: aString

	| in s nm |
	
	in := ReadStream on: aString.
	nm := ''.

	[in atEnd] whileFalse:
	[
		s := in upTo: $-.
		s := ((s first: 1) asUppercase),(s last: (s size -1)).
		nm := nm,s. 
	].

	^'CSS',nm,'Property'
	! !

!CSSStyleRule class methodsFor: 'definitions' stamp: 'tb 12/12/2005 10:56'!
classificationRules

	^'Display
Syntax: 	display: <value>
Possible Values: 	block | inline | list-item | none
Initial Value: 	block
Applies to: 	All elements
Inherited: 	No

The display property is used to define an element with one of four values:

    * block (a line break before and after the element)
    * inline (no line break before and after the element)
    * list-item (same as block except a list-item marker is added)
    * none (no display)

Each element typically is given a default display value by the browser, based on suggested rendering in the HTML specification.

The display property can be dangerous because of its ability to display elements in what would otherwise be an improper format. The use of the value none will turn off display of the element to which it is assigned, including any children elements!!
Whitespace
Syntax: 	white-space: <value>
Possible Values: 	normal | pre | nowrap
Initial Value: 	normal
Applies to: 	All elements
Inherited: 	Yes

The white-space property will determine how spaces within the element are treated. This property takes one of three values:

    * normal (collapses multiple spaces into one)
    * pre (does not collapse multiple spaces)
    * nowrap (does not allow line wrapping without a <BR> tag)

List Style Type
Syntax: 	list-style-type: <value>
Possible Values: 	disc | circle | square | decimal | lower-roman | upper-roman | lower-alpha | upper-alpha | none
Initial Value: 	disc
Applies to: 	Elements with display value list-item
Inherited: 	Yes

The list-style-type property specifies the type of list-item marker, and is used if list-style-image is none or if image loading is turned off.

Examples:

LI.square { list-style-type: square }
UL.plain  { list-style-type: none }
OL        { list-style-type: upper-alpha }  /* A B C D E etc. */
OL OL     { list-style-type: decimal }      /* 1 2 3 4 5 etc. */
OL OL OL  { list-style-type: lower-roman }  /* i ii iii iv v etc. */

List Style Image
Syntax: 	list-style-image: <value>
Possible Values: 	<url> | none
Initial Value: 	none
Applies to: 	Elements with display value list-item
Inherited: 	Yes

The list-style-image property specifies the image that will be used as list-item marker when image loading is turned on, replacing the marker specified in the list-style-type property.

Examples:

UL.check { list-style-image: url(/LI-markers/checkmark.gif) }
UL LI.x  { list-style-image: url(x.png) }

List Style Position
Syntax: 	list-style-position: <value>
Possible Values: 	inside | outside
Initial Value: 	outside
Applies to: 	Elements with display value list-item
Inherited: 	Yes

The list-style-position property takes the value inside or outside, with outside being the default. This property determines where the marker is placed in regard to the list item. If the value inside is used, the lines will wrap under the marker instead of being indented. An example rendering is:

Outside rendering:
 * List item 1
   second line of list item

Inside rendering:
   * List item 1
   second line of list item

List Style
Syntax: 	list-style: <value>
Possible Values: 	<list-style-type> || <list-style-position> || <url>
Initial Value: 	Not defined
Applies to: 	Elements with display value list-item
Inherited: 	Yes

The list-style property is a shorthand for the list-style-type, list-style-position, and list-style-image properties.

Examples:

LI.square { list-style: square inside }
UL.plain  { list-style: none }
UL.check  { list-style: url(/LI-markers/checkmark.gif) circle }
OL        { list-style: upper-alpha }
OL OL     { list-style: lower-roman inside }'! !

!CSSStyleRule class methodsFor: 'definitions' stamp: 'tb 12/12/2005 09:20'!
colorAndBackgroundRules

	^'Color
Syntax: 	color: <color>
Initial Value: 	Determined by browser
Applies to: 	All elements
Inherited: 	Yes

The color property allows authors to specify the color of an element. See the Units section for color value descriptions. Some example color rules include:

H1 { color: blue }
H2 { color: #000080 }
H3 { color: #0c0 }

To help avoid conflicts with user style sheets, background and color properties should always be specified together.
Background Color
Syntax: 	background-color: <value>
Possible Values: 	<color> | transparent
Initial Value: 	transparent
Applies to: 	All elements
Inherited: 	No

The background-color property sets the background color of an element. For example:

BODY { background-color: white }
H1   { background-color: #000080 }

To help avoid conflicts with user style sheets, background-image should be specified whenever background-color is used. In most cases, background-image: none is suitable.

Authors may also use the shorthand background property, which is currently better supported than the background-color property.
Background Image
Syntax: 	background-image: <value>
Possible Values: 	<url> | none
Initial Value: 	none
Applies to: 	All elements
Inherited: 	No

The background-image property sets the background image of an element. For example:

BODY { background-image: url(/images/foo.gif) }
P    { background-image: url(http://www.htmlhelp.com/bg.png) }

When a background image is defined, a similar background color should also be defined for those not loading images.

Authors may also use the shorthand background property, which is currently better supported than the background-image property.
Background Repeat
Syntax: 	background-repeat: <value>
Possible Values: 	repeat | repeat-x | repeat-y | no-repeat
Initial Value: 	repeat
Applies to: 	All elements
Inherited: 	No

The background-repeat property determines how a specified background image is repeated. The repeat-x value will repeat the image horizontally while the repeat-y value will repeat the image vertically. For example:

BODY { background: white url(candybar.gif);
       background-repeat: repeat-x }

In the above example, the image will only be tiled horizontally.

Authors may also use the shorthand background property, which is currently better supported than the background-repeat property.
Background Attachment
Syntax: 	background-attachment: <value>
Possible Values: 	scroll | fixed
Initial Value: 	scroll
Applies to: 	All elements
Inherited: 	No

The background-attachment property determines if a specified background image will scroll with the content or be fixed with regard to the canvas. For example, the following specifies a fixed background image:

BODY { background: white url(candybar.gif);
       background-attachment: fixed }

Authors may also use the shorthand background property, which is currently better supported than the background-attachment property.
Background Position
Syntax: 	background-position: <value>
Possible Values: 	[<percentage> | <length>]{1,2} | [top | center | bottom] || [left | center | right]
Initial Value: 	0% 0%
Applies to: 	Block-level and replaced elements
Inherited: 	No

The background-position property gives the initial position of a specified background image. This property may only be applied to block-level elements and replaced elements. (A replaced element is one for which only the intrinsic dimensions are known; HTML replaced elements include IMG, INPUT, TEXTAREA, SELECT, and OBJECT.)

The easiest way to assign a background position is with keywords:

    * Horizontal keywords (left, center, right)
    * Vertical keywords (top, center, bottom)

Percentages and lengths may also be used to assign the position of the background image. Percentages are relative to the size of the element. Although lengths are allowed, they are not recommended due to their inherent weakness in dealing with differing display resolutions.

When using percentages or lengths, the horizontal position is specified first, followed by the vertical position. A value such as 20% 65% specifies that the point 20% across and 65% down the image be placed at the point 20% across and 65% down the element. A value such as 5px 10px specifies that the upper left corner of the image be placed 5 pixels to the right of and 10 pixels below the upper left corner of the element.

If only the horizontal value is given, the vertical position will be 50%. Combinations of lengths and percentages are allowed, as are negative positions. For example, 10% -2cm is permitted. However, percentages and lengths cannot be combined with keywords.

The keywords are interpreted as follows:

    * top left = left top = 0% 0%
    * top = top center = center top = 50% 0%
    * right top = top right = 100% 0%
    * left = left center = center left = 0% 50%
    * center = center center = 50% 50%
    * right = right center = center right = 100% 50%
    * bottom left = left bottom = 0% 100%
    * bottom = bottom center = center bottom = 50% 100%
    * bottom right = right bottom = 100% 100%

If the background image is fixed with regard to the canvas, the image is placed relative to the canvas instead of the element.

Authors may also use the shorthand background property, which is currently better supported than the background-position property.
Background
Syntax: 	background: <value>
Possible Values: 	<background-color> || <background-image> || <background-repeat> || <background-attachment> || <background-position>
Initial Value: 	Not defined
Applies to: 	All elements
Inherited: 	No

The background property is a shorthand for the more specific background-related properties. Some examples of background declarations follow:

BODY       { background: white url(http://www.htmlhelp.com/foo.gif) }
BLOCKQUOTE { background: #7fffd4 }
P          { background: url(../backgrounds/pawn.png) #f0f8ff fixed }
TABLE      { background: #0c0 url(leaves.jpg) no-repeat bottom right }

A value not specified will receive its initial value. For example, in the first three rules above, the background-position property will be set to 0% 0%.

To help avoid conflicts with user style sheets, background and color properties should always be specified together.'! !

!CSSStyleRule class methodsFor: 'definitions' stamp: 'tb 12/12/2005 09:18'!
fontRules

	^'Syntax:  	font-family: [[<family-name> | <generic-family>],]* [<family-name> | <generic-family>]
Possible Values: 	<family-name>

    * Any font family name may be used

<generic-family>

    * serif (e.g., Times)
    * sans-serif (e.g., Arial or Helvetica)
    * cursive (e.g., Zapf-Chancery)
    * fantasy (e.g., Western)
    * monospace (e.g., Courier)

Initial Value: 	Determined by browser
Applies to: 	All elements
Inherited: 	Yes

Font families may be assigned by a specific font name or a generic font family. Obviously, defining a specific font will not be as likely to match as a generic font family. Multiple family assignments can be made, and if a specific font assignment is made it should be followed by a generic family name in case the first choice is not present.

A sample font-family declaration might look like this:

P { font-family: "New Century Schoolbook", Times, serif }

Notice that the first two assignments are specific type faces: New Century Schoolbook and Times. However, since both of them are serif fonts, the generic font family is listed as a backup in case the system does not have either of these but has another serif font which meets the qualifications.

Any font name containing whitespace must be quoted, with either single or double quotes.

The font family may also be given with the font property.
Font Style
Syntax: 	font-style: <value>
Possible Values: 	normal | italic | oblique
Initial Value: 	normal
Applies to: 	All elements
Inherited: 	Yes

The font-style property defines that the font be displayed in one of three ways: normal, italic or oblique (slanted). A sample style sheet with font-style declarations might look like this:

H1 { font-style: oblique }
P  { font-style: normal }

Font Variant
Syntax: 	font-variant: <value>
Possible Values: 	normal | small-caps
Initial Value: 	normal
Applies to: 	All elements
Inherited: 	Yes

The font-variant property determines if the font is to display in normal or small-caps. Small-caps are displayed when all the letters of the word are in capitals with uppercase characters slightly larger than lowercase. Later versions of CSS may support additional variants such as condensed, expanded, small-caps numerals or other custom variants. An example of a font-variant assignment would be:

SPAN { font-variant: small-caps }

Font Weight
Syntax: 	font-weight: <value>
Possible Values: 	normal | bold | bolder | lighter | 100 | 200 | 300 | 400 | 500 | 600 | 700 | 800 | 900
Initial Value: 	normal
Applies to: 	All elements
Inherited: 	Yes

The font-weight property is used to specify the weight of the font. The bolder and lighter values are relative to the inherited font weight, while the other values are absolute font weights.

Note: Since not all fonts have nine possible display weights some of the weights may be grouped together in assignment. If the specified weight is not available, an alternate will be chosen on the following basis:

    * 500 may be switched with 400, and vice versa
    * 100-300 may be assigned to the next lighter weight, if any, or the next darker weight otherwise
    * 600-900 may be assigned to the next darker weight, if any, or the next lighter weight otherwise

Some example font-weight assignments would be:

H1 { font-weight: 800 }
P  { font-weight: normal }

Font Size
Syntax: 	font-size: <absolute-size> | <relative-size> | <length> | <percentage>
Possible Values: 	

    * <absolute-size>
          o xx-small | x-small | small | medium | large | x-large | xx-large
    * <relative-size>
          o larger | smaller
    * <length>
    * <percentage> (in relation to parent element) 


Initial Value: 	medium
Applies to: 	All elements
Inherited: 	Yes

The font-size property is used to modify the size of the displayed font. Absolute lengths (using units like pt and in) should be used sparingly due to their weakness in adapting to different browsing environments. Fonts with absolute lengths can very easily be too small or too large for a user.

Some example size assignments would be:

H1     { font-size: large }
P      { font-size: 12pt }
LI     { font-size: 90% }
STRONG { font-size: larger }

Authors should be aware that Microsoft Internet Explorer 3.x incorrectly treats em and ex units as pixels, which can easily make text using these units unreadable. The browser also incorrectly applies percentage values relative to its default font size for the selector, rather than relative to the parent element''s font size. This makes rules like

H1 { font-size: 200% }

dangerous in that the size will be twice IE''s default font size for level-one headings, rather than twice the parent element''s font size. In this case, BODY would most likely be the parent element, and it would likely define a medium font size, whereas the default level-one heading font size imposed by IE would probably be considered xx-large.

Given these bugs, authors should take care in using percentage values for font-size, and should probably avoid em and ex units for this property.
Font
Syntax: 	font: <value>
Possible Values: 	[ <font-style> || <font-variant> || <font-weight> ]? <font-size> [ / <line-height> ]? <font-family>
Initial Value: 	Not defined
Applies to: 	All elements
Inherited: 	Yes

The font property may be used as a shorthand for the various font properties, as well as the line height. For example,

P { font: italic bold 12pt/14pt Times, serif }

specifies paragraphs with a bold and italic Times or serif font with a size of 12 points and a line height of 14 points.'! !

!CSSStyleRule class methodsFor: 'definitions' stamp: 'SebastianSastre 1/15/2012 16:39'!
fromString: aString

	| in sel attrString pairs rules |

	rules := OrderedCollection new.
	in := ReadStream on: aString.
	
	[in atEnd] whileFalse:
	[
		| rule |
		sel := (in upTo: ${) trimBoth.
		(in atEnd not and: [sel size > 0]) ifTrue:
		[
			rule:= self new selector: sel.
			rules add: rule.
			attrString := (in upTo: $}) trimBoth.
			pairs := attrString findTokens: ';'.	
			pairs do: 
			[:ea || k v p |  
				p := ea splitOn: ':'. 
				k := p first trimBoth.
				v := p last trimBoth.
				rule properties at: k put: v. 
			]
		]
	].
	^rules! !

!CSSStyleRule class methodsFor: 'definitions' stamp: 'SebastianSastre 1/15/2012 16:39'!
structuredRulesFrom: aString

	| current style dict | 

	dict := Dictionary new.

	aString linesDo: 
	[:ea |  
		(ea beginsWith: 'Syntax:') ifTrue: 
		[
			current := Dictionary new.
			style := (ea findTokens: ':') second trimBoth.
			dict at: style put: current.
		]
		ifFalse:
		[
			(ea beginsWith: 'Possible Values:') ifTrue: 
			[
				current at: 'possibleValues' 
					put: (ea last: (ea size - 'Possible Values:' size)) trimBoth.
			]
			ifFalse:
			[
				(ea beginsWith: 'Initial Value:') ifTrue:
				[
					current at: 'initialValue' 
						put: (ea last: (ea size - 'Initial Value:' size)) trimBoth.
				]
				ifFalse:
				[
					(ea beginsWith: 'Applies to:') ifTrue:
					[
						current at: 'appliesTo' 
							put: (ea last: (ea size - 'Applies to:' size)) trimBoth.
					]
					ifFalse:
					[
						(ea beginsWith: 'Inherited:') ifTrue: 
						[
							current at: 'inherited' 
								put: (ea last: (ea size - 'Inherited:' size)) trimBoth.
						]
					]
				]
			]
		]
	].
	^ dict
! !

!CSSStyleRule class methodsFor: 'definitions' stamp: 'tb 12/12/2005 09:22'!
textPropertyRules

	^'Word Spacing
Syntax: 	word-spacing: <value>
Possible Values: 	normal | <length>
Initial Value: 	normal
Applies to: 	All elements
Inherited: 	Yes

The word-spacing property defines an additional amount of space between words. The value must be in the length format; negative values are permitted.

Examples:

P EM   { word-spacing: 0.4em }
P.note { word-spacing: -0.2em }

Letter Spacing
Syntax: 	letter-spacing: <value>
Possible Values: 	normal | <length>
Initial Value: 	normal
Applies to: 	All elements
Inherited: 	Yes

The letter-spacing property defines an additional amount of space between characters. The value must be in the length format; negative values are permitted. A setting of 0 will prevent justification.

Examples:

H1     { letter-spacing: 0.1em }
P.note { letter-spacing: -0.1em }

Text Decoration
Syntax: 	text-decoration: <value>
Possible Values: 	none | [ underline || overline || line-through || blink ]
Initial Value: 	none
Applies to: 	All elements
Inherited: 	No

The text-decoration property allows text to be decorated through one of five properties: underline, overline, line-through, blink, or the default, none.

For example, one can suggest that links not be underlined with

A:link, A:visited, A:active { text-decoration: none }

Vertical Alignment
Syntax: 	vertical-align: <value>
Possible Values: 	baseline | sub | super | top | text-top | middle | bottom | text-bottom | <percentage>
Initial Value: 	baseline
Applies to: 	Inline elements
Inherited: 	No

The vertical-align property may be used to alter the vertical positioning of an inline element, relative to its parent element or to the element''s line. (An inline element is one which has no line break before and after it, for example, EM, A, and IMG in HTML.)

The value may be a percentage relative to the element''s line-height property, which would raise the element''s baseline the specified amount above the parent''s baseline. Negative values are permitted.

The value may also be a keyword. The following keywords affect the positioning relative to the parent element:

    * baseline (align baselines of element and parent)
    * middle (align vertical midpoint of element with baseline plus half the x-height--the height of the letter "x"--of the parent)
    * sub (subscript)
    * super (superscript)
    * text-top (align tops of element and parent''s font)
    * text-bottom (align bottoms of element and parent''s font)

The keywords affecting the positioning relative to the element''s line are

    * top (align top of element with tallest element on the line)
    * bottom (align bottom of element with lowest element on the line)

The vertical-align property is particularly useful for aligning images. Some examples follow:

IMG.middle { vertical-align: middle }
IMG        { vertical-align: 50% }
.exponent  { vertical-align: super }

Text Transformation
Syntax: 	text-transform: <value>
Possible Values: 	none | capitalize | uppercase | lowercase
Initial Value: 	none
Applies to: 	All elements
Inherited: 	Yes

The text-transform property allows text to be transformed by one of four properties:

    * capitalize (capitalizes first character of each word)
    * uppercase (capitalizes all characters of each word)
    * lowercase (uses small letters for all characters of each word)
    * none (the initial value)

Examples:

H1 { text-transform: uppercase }
H2 { text-transform: capitalize }

The text-transform property should only be used to express a stylistic desire. It would be inappropriate, for example, to use text-transform to capitalize a list of countries or names.
Text Alignment
Syntax: 	text-align: <value>
Possible Values: 	left | right | center | justify
Initial Value: 	Determined by browser
Applies to: 	Block-level elements
Inherited: 	Yes

The text-align property can be applied to block-level elements (P, H1, etc.) to give the alignment of the element''s text. This property is similar in function to HTML''s ALIGN attribute on paragraphs, headings, and divisions.

Some examples follow:

H1          { text-align: center }
P.newspaper { text-align: justify }

Text Indentation
Syntax: 	text-indent: <value>
Possible Values: 	<length> | <percentage>
Initial Value: 	0
Applies to: 	Block-level elements
Inherited: 	Yes

The text-indent property can be applied to block-level elements (P, H1, etc.) to define the amount of indentation that the first line of the element should receive. The value must be a length or a percentage; percentages refer to the parent element''s width. A common use of text-indent would be to indent a paragraph:

P { text-indent: 5em }

Line Height
Syntax: 	line-height: <value>
Possible Values: 	normal | <number> | <length> | <percentage>
Initial Value: 	normal
Applies to: 	All elements
Inherited: 	Yes

The line-height property will accept a value to control the spacing between baselines of text. When the value is a number, the line height is calculated by multiplying the element''s font size by the number. Percentage values are relative to the element''s font size. Negative values are not permitted.

Line height may also be given in the font property along with a font size.

The line-height property could be used to double space text:

P { line-height: 200% }

Microsoft Internet Explorer 3.x incorrectly treats number values and values with em or ex units as pixel values. This bug can easily make pages unreadable, and so authors should avoid provoking it wherever possible; percentage units are often a good choice.'! !

!CSSStyleRule class methodsFor: 'definitions' stamp: 'tb 12/12/2005 10:57'!
unitRules

	^'Length Units

A length value is formed by an optional + or -, followed by a number, followed by a two-letter abbreviation that indicates the unit. There are no spaces in a length value; e.g., 1.3 em is not a valid length value, but 1.3em is valid. A length of 0 does not require the two-letter unit identifier.

Both relative and absolute length units are supported in CSS1. Relative units give a length relative to another length property, and are preferred since they will better adjust to different media. The following relative units are available:

    * em (ems, the height of the element''s font)
    * ex (x-height, the height of the letter "x")
    * px (pixels, relative to the canvas resolution)

Absolute length units are highly dependent on the output medium, and so are less useful than relative units. The following absolute units are available:

    * in (inches; 1in=2.54cm)
    * cm (centimeters; 1cm=10mm)
    * mm (millimeters)
    * pt (points; 1pt=1/72in)
    * pc (picas; 1pc=12pt)

Percentage Units

A percentage value is formed by an optional + or -, followed by a number, followed by %. There are no spaces in a percentage value.

Percentage values are relative to other values, as defined for each property. Most often the percentage value is relative to the element''s font size.
Color Units

A color value is a keyword or a numerical RGB specification.

The 16 keywords are taken from the Windows VGA palette: aqua, black, blue, fuchsia, gray, green, lime, maroon, navy, olive, purple, red, silver, teal, white, and yellow.

RGB colors are given in one of four ways:

    * #rrggbb (e.g., #00cc00)
    * #rgb (e.g., #0c0)
    * rgb(x,x,x) where x is an integer between 0 and 255 inclusive (e.g., rgb(0,204,0))
    * rgb(y%,y%,y%) where y is a number between 0.0 and 100.0 inclusive (e.g., rgb(0%,80%,0%))

The examples above all specify the same color.

Douglas R. Jacobson has also developed a handy quick reference RGB Color Chart (61 kB).
URLs

A URL value is given by url(foo), where foo is the URL. The URL may be optionally quoted with either single ('') or double (") quotes and may contain whitespace before or after the (optionally quoted) URL.

Parentheses, commas, spaces, single quotes, or double quotes in the URL must be escaped with a backslash. Partial URLs are interpreted relative to the style sheet source, not to the HTML source.

Note that Netscape Navigator 4.x incorrectly interprets partial URLs relative to the HTML source. Given this bug, authors may wish to use full URLs where possible.

Examples:

BODY { background: url(stripe.gif) }
BODY { background: url(http://www.htmlhelp.com/stripe.gif) }
BODY { background: url( stripe.gif ) }
BODY { background: url("stripe.gif") }
BODY { background: url(\"Ulalume\".png) } /* quotes in URL escaped */'! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'j.c 6/20/2007 09:39'!
addProperty: anObject
	
	self properties: (self properties copyWith: anObject).
	anObject parent: self.
! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'tb 1/18/2006 23:53'!
addToRuleSet: aRuleSet

	| keys |

	keys := self selector keySelectors.

	keys do:
	[:k |
		k idSelector isNil ifFalse:
		[
			(aRuleSet idSelectors at: k idSelector value ifAbsentPut: [OrderedCollection new]) 
				add: self.			
		]
		ifTrue:
		[
			| classes |
			classes := k classSelectors.
			classes isEmpty ifFalse:
			[
				classes do:
				[:cls |
					(aRuleSet classSelectors at: cls value ifAbsentPut: [OrderedCollection new])
						add: self.
				]
			]
			ifTrue:
			[
				k element isNil ifFalse:
				[
					(aRuleSet tagSelectors at: k element asLowercase ifAbsentPut: [OrderedCollection new])
						add: self.
				]
				ifTrue:
				[
					self selector isValid ifTrue: [aRuleSet otherSelectors add: self].
				]
			]
		]
	].

	(keys isEmpty and: [self selector isValid]) ifTrue: 
	[
		aRuleSet otherSelectors add: self
	]! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'tb 12/18/2005 00:25'!
end
	"Answer the value of end"

	^ end! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'sebastian.sastre 10/18/2010 11:57'!
end: anObject
	"Set the value of end"

	end := anObject! !

!CSSStyleRule methodsFor: 'initialize-release' stamp: 'tb 12/7/2005 15:47'!
initialize

	super initialize.
	attributes := Dictionary new.! !

!CSSStyleRule methodsFor: 'testing' stamp: 'tb 12/30/2005 20:04'!
isStyleRule

	^true! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'tb 1/3/2006 04:27'!
keySelector
	"Answer the value of keySelectors"

	keySelector isNil ifTrue:
	[
		| ks |

		ks := self selector keySelectors.
		ks size = 0 ifTrue: [keySelector := self selector]
		ifFalse:
		[
			ks size = 1 
				ifTrue: [keySelector := ks first]
				ifFalse: [keySelector := CSSOrSelector new selectors: ks asSet]
		]
	].
	^ keySelector! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'tb 1/3/2006 02:10'!
matchCount
	"Answer the value of matchCount"

	^ matchCount! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:21'!
matchCount: anObject
	"Set the value of matchCount"

	matchCount := anObject! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'spd 12/7/2010 21:53'!
matchingNodes

	^self document nodesSelect:[:ea | selector matches: ea]! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'tb 12/20/2005 10:28'!
media
	"Answer the value of media"

	^ media! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'sebastian.sastre 10/18/2010 11:56'!
media: anObject
	"Set the value of media"

	media := anObject! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'SebastianSastre 1/15/2012 16:39'!
parseContents: aStream

	| pString in pos |
	aStream skipSeparators.
	self selector: (CSSSelector fromString: (aStream upTo: ${) trimBoth).
	
	pos := aStream position.
	pString := aStream upTo: $}.

	in := ReadStream on: pString.
	in skipSeparators.
	[in atEnd] whileFalse:
	[
		| property npos |
		in skipSeparators.
		npos := in position.
		(in peek = $/ and: [in next. in peek = $*]) ifTrue: "Don't keep comments in properties"
		[
			"| child |
			in back.
			child := (CSSComment new start: in position).
			self addProperty: child.
			child parseContents: in."
			in upToAll: '*/'.			
		]
		ifFalse:
		[
			property := (in upTo: $:) trimBoth.
			(property notNil and: [property size > 0])
			ifTrue:
			[
				| child |
				child := (CSSProperty propertyNamed: property) start: pos + npos.
				self addProperty: child.
				child parseContents: in.
				child end: pos + in position.
			]
		] 
	].
	self end: aStream position.! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'tb 1/3/2006 17:36'!
printOn: aStream

	aStream nextPutAll: self prefix; nextPutAll: self innerContents; nextPutAll: self suffix.
	! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'tb 12/21/2005 15:42'!
properties
	"Answer the value of properties"

	^properties isNil ifTrue: [#()] ifFalse:[properties]
	! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'sebastian.sastre 10/18/2010 11:56'!
properties: anObject
	"Set the value of properties"

	properties := anObject! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'tb 12/7/2005 15:48'!
selector
	"Answer the value of selector"

	^ selector! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'sebastian.sastre 10/18/2010 11:56'!
selector: anObject
	"Set the value of selector"

	selector := anObject! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'tb 12/18/2005 00:25'!
start
	"Answer the value of start"

	^ start! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'sebastian.sastre 10/18/2010 11:56'!
start: anObject
	"Set the value of start"

	start := anObject! !

!CSSStyleRule methodsFor: 'accessing' stamp: 'tb 12/21/2005 16:14'!
tag

	^'css-style'! !

CSSElement subclass: #CSSStyleSheet
	instanceVariableNames: 'imports content url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-CSS'!

!CSSStyleSheet commentStamp: 'tb 12/21/2005 11:45' prior: 0!
I represent a collection of CSS style rules!

!CSSStyleSheet class methodsFor: 'class initialization' stamp: 'tb 1/4/2006 08:18'!
fromUrl: aStringOrUrl

	| doc url |

	url := aStringOrUrl asString.

	doc := HTTPSocket httpGetDocument: url args: nil accept: 'text/css' request: ''.
	^doc isString ifFalse: "life is good"
	[
		self new content: doc content; start: 0; end: doc content size; url: url		
	]
	ifTrue:
	[
		nil
	]

! !

!CSSStyleSheet class methodsFor: 'class initialization' stamp: 'tb 1/4/2006 08:19'!
fromUrl: aStringOrUrl parent: aDOMNode

	| doc href url |

	href := aStringOrUrl asString.
	((href beginsWith: 'http:') or: [(href beginsWith: 'https:') or:[href beginsWith: 'ftp:']]) 
	ifFalse:
	[
		url := (Url combine: aDOMNode document responseUrl asString withRelative: href).
	]
	ifTrue: [url := href].

	doc := HTTPSocket httpGetDocument: url args: nil accept: 'text/css' request: ''.
	^doc isString ifFalse: "life is good"
	[
		self new 
			content: doc content; 
			start: 0; end: doc content size; 
			parent: aDOMNode; 
			url: url;
			parseContents: (ReadStream on: doc content)		
	]
	ifTrue:
	[
		nil
	]

! !

!CSSStyleSheet methodsFor: 'accessing' stamp: 'tb 12/17/2005 23:43'!
addImportedStyleSheet: anObject
	"Set the value of imports"

	self imports: (self imports copyWith: anObject)! !

!CSSStyleSheet methodsFor: 'accessing' stamp: 'tb 1/3/2006 17:07'!
addImportedUrl: aUrl

	| doc ss |

	doc := aUrl asUrl retrieveContents.
	ss := CSSStyleSheet new content: doc content; start: 0; end: doc content size.
	self addImportedStyleSheet: ss.
	ss parseContents: (ReadStream on: ss content).! !

!CSSStyleSheet methodsFor: 'accessing' stamp: 'tb 12/17/2005 23:40'!
content
	"Answer the value of content"

	^content isNil 
		ifTrue: [self document content] 
		ifFalse: [content]! !

!CSSStyleSheet methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:22'!
content: anObject
	"Set the value of content"

	content := anObject! !

!CSSStyleSheet methodsFor: 'accessing' stamp: 'tb 1/4/2006 14:37'!
docType

	^'Content-Type: text/css'! !

!CSSStyleSheet methodsFor: 'accessing' stamp: 'tb 1/4/2006 14:43'!
endTagMissing

	^false! !

!CSSStyleSheet methodsFor: 'accessing' stamp: 'tb 12/17/2005 23:36'!
imports
	"Answer the value of imports"

	imports isNil ifTrue:[imports := #()].
	^ imports! !

!CSSStyleSheet methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:22'!
imports: anObject
	"Set the value of imports"

	imports := anObject! !

!CSSStyleSheet methodsFor: 'testing' stamp: 'tb 12/20/2005 13:33'!
isComment

	^false! !

!CSSStyleSheet methodsFor: 'testing' stamp: 'tb 1/4/2006 08:23'!
isInline

	^url isNil! !

!CSSStyleSheet methodsFor: 'testing' stamp: 'tb 12/17/2005 22:25'!
isStyleSheet

	^true! !

!CSSStyleSheet methodsFor: 'accessing' stamp: 'tb 12/30/2005 14:50'!
media

	^(self parent attributes at: 'media' ifAbsent: ['all']) findTokens: ', '! !

!CSSStyleSheet methodsFor: 'parsing' stamp: 'tb 1/6/2006 09:43'!
parseAtRule: aStream media: anArray

	| label child s |
	label := WriteStream on: String new.
	aStream peek = $@ 
	ifFalse:[self halt]
	ifTrue:
	[
		s := aStream position.
		aStream next.
		aStream skipSeparators.
		aStream peek isLetter 
			ifTrue: [label nextPut: aStream next]
			ifFalse: [self halt].
		[aStream peek isLetter or: [aStream peek isDigit or:['-_' includes: aStream peek]]] 
			whileTrue: [label nextPut: aStream next].

		label contents asLowercase = 'media' ifTrue:
		[
			| media array |

			media := aStream upTo: ${.
			array := (media findTokens: ', ') asArray.
			self parseStyles: aStream media: array.
		]
		ifFalse:
		[
			child := (CSSAtRule named: label contents) start: s; media: anArray.		
			self addChild: child.
			child parseContents: aStream.
		]
	]! !

!CSSStyleSheet methodsFor: 'parsing' stamp: 'tb 1/3/2006 17:04'!
parseContents: aStream

	| in  |
	
	aStream upToAll: '<!!--'.
	aStream position >= self end 
		ifTrue: 
		[
			in := ReadStream on: (aStream reset next: self end).
			in position: self start.
		]
		ifFalse: 
		[
			| styleEnd |
			aStream position: self end-1. 
			[(aStream position > start) and: [aStream peek ~= $>]] whileTrue: [aStream back].
			((aStream position > start) and: [aStream peek = $>]) ifTrue: [aStream back].
			[(aStream position > start) and: [aStream peek = $-]] whileTrue: [aStream back].
			styleEnd := aStream position.
			in := ReadStream on: (aStream reset next: styleEnd).
			in position: self start.
			in upToAll: '<!!--'.			
		].
	
	in skipSeparators. 
	self parseStyles: in media: self media.
	! !

!CSSStyleSheet methodsFor: 'parsing' stamp: 'tb 1/3/2006 17:07'!
parseStyles: aStream media: anArray

	aStream skipSeparators.
	[aStream atEnd] whileFalse: 
	[
		aStream skipSeparators.
		aStream peek = $} ifTrue: [aStream next. ^self]. "End of media block"
		(aStream peek = $/ and: [aStream next. aStream peek = $*]) 
		ifTrue: 
		[
			| child |
			aStream back. 
			child := CSSComment new start: aStream position.
			self addChild: child.
			child parseContents: aStream.
		]
		ifFalse:
		[	
			(aStream peek = $@) 
			ifTrue: "Read the imports"
			[
				self parseAtRule: aStream media: anArray.
			]
			ifFalse:
			[
				aStream atEnd ifFalse:
				[
					| child |

					child := CSSStyleRule new start: aStream position; media: anArray.
					self addChild: child.
					child parseContents: aStream.
				]
			]
		]
	]! !

!CSSStyleSheet methodsFor: 'accessing' stamp: 'tb 12/20/2005 13:17'!
tag

	^'css-stylesheet'! !

!CSSStyleSheet methodsFor: 'accessing' stamp: 'tb 1/4/2006 08:22'!
url
	"Answer the value of url"

	^ url isNil ifTrue: [self document url] ifFalse: [url]! !

!CSSStyleSheet methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:23'!
url: anObject
	"Set the value of url"

	url := anObject! !

HtmlParseNode subclass: #HtmlDOMNode
	instanceVariableNames: 'attributes hasTrailingSlash tag isImplied dtd endTagMissing styles id classes'
	classVariableNames: 'DefaultRules HTML401'
	poolDictionaries: ''
	category: 'HTML-DOM'!

HtmlDOMNode subclass: #HtmlABBRNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlABBRNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'abbr'! !

HtmlDOMNode subclass: #HtmlACRONYMNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlACRONYMNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'acronym'! !

HtmlDOMNode subclass: #HtmlADDRESSNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlADDRESSNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'address'! !

HtmlDOMNode subclass: #HtmlANode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlANode methodsFor: 'as yet unclassified' stamp: 'gk 11/13/2007 14:39'!
href
	^self attributes at: 'href' ifAbsent: ''! !

!HtmlANode methodsFor: 'accessing' stamp: ''!
tag
	^ 'a'! !

HtmlDOMNode subclass: #HtmlAPPLETNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlAPPLETNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'applet'! !

HtmlDOMNode subclass: #HtmlAREANode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlAREANode methodsFor: 'accessing' stamp: ''!
tag
	^ 'area'! !

HtmlDOMNode subclass: #HtmlBASEFONTNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlBASEFONTNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'basefont'! !

HtmlDOMNode subclass: #HtmlBASENode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlBASENode methodsFor: 'accessing' stamp: ''!
tag
	^ 'base'! !

HtmlDOMNode subclass: #HtmlBDONode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlBDONode methodsFor: 'accessing' stamp: ''!
tag
	^ 'bdo'! !

HtmlDOMNode subclass: #HtmlBIGNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlBIGNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'big'! !

HtmlDOMNode subclass: #HtmlBLOCKQUOTENode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlBLOCKQUOTENode methodsFor: 'accessing' stamp: ''!
tag
	^ 'blockquote'! !

HtmlDOMNode subclass: #HtmlBNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlBNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'b'! !

HtmlDOMNode subclass: #HtmlBODYNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlBODYNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'body'! !

HtmlDOMNode subclass: #HtmlBRNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlBRNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'br'! !

HtmlDOMNode subclass: #HtmlBUTTONNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlBUTTONNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'button'! !

HtmlDOMNode subclass: #HtmlCAPTIONNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlCAPTIONNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'caption'! !

HtmlDOMNode subclass: #HtmlCDATANode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlCDATANode class methodsFor: 'as yet unclassified' stamp: 'tb 12/8/2005 11:58'!
start: s end: e

	^self new start: s; end: e! !

!HtmlCDATANode methodsFor: 'accessing' stamp: 'tb 1/3/2006 17:36'!
asString

	^self innerContents

! !

!HtmlCDATANode methodsFor: 'accessing' stamp: 'tb 3/1/2006 15:36'!
checkForUnescapedCharacters

	| str |

	self parent isComment ifTrue: [^self].
	str := self innerContents.

	str withIndexDo: 	
	[:ea :idx |
		(HtmlUnescapedSpecialCharacterError specialCharacters includes: ea) ifTrue: 
		[
		
			ea = $& ifFalse:
			[
				self addError: 
					(HtmlUnescapedSpecialCharacterError new position: self start + idx)
			]
			ifTrue:
			[
				(str size > idx and: [(str at: idx+1) = $#]) ifFalse:
				[
					| strm s |

					strm := ReadStream on: str.
					strm position: idx.
					s := strm upTo: $;.
					((s includes: $ ) or: [s size > 6 or:[s size < 3]]) ifTrue:
					[
						(s = 'lt' or: [s = 'gt']) ifFalse:
						[
							self addError: 
							(HtmlUnescapedSpecialCharacterError new position: self start + idx)						
						]
					]					
				]
			]
		]	
	]! !

!HtmlCDATANode methodsFor: 'accessing' stamp: 'j.c 6/6/2007 14:02'!
initialize

	super initialize.
	endTagMissing := false.
	! !

!HtmlCDATANode methodsFor: 'accessing' stamp: 'tb 1/4/2006 15:05'!
innerContents

	^self rawContent! !

!HtmlCDATANode methodsFor: 'accessing' stamp: 'tb 12/2/2005 09:13'!
isCDATA

	^true! !

!HtmlCDATANode methodsFor: 'accessing' stamp: 'tb 12/8/2005 12:02'!
prefix

	^''! !

!HtmlCDATANode methodsFor: 'accessing' stamp: 'tb 12/8/2005 12:02'!
suffix

	^''! !

!HtmlCDATANode methodsFor: 'accessing' stamp: ''!
tag
	^ 'cdata'! !

HtmlDOMNode subclass: #HtmlCENTERNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlCENTERNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'center'! !

HtmlDOMNode subclass: #HtmlCITENode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlCITENode methodsFor: 'accessing' stamp: ''!
tag
	^ 'cite'! !

HtmlDOMNode subclass: #HtmlCODENode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlCODENode methodsFor: 'accessing' stamp: ''!
tag
	^ 'code'! !

HtmlDOMNode subclass: #HtmlCOLGROUPNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlCOLGROUPNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'colgroup'! !

HtmlDOMNode subclass: #HtmlCOLNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlCOLNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'col'! !

HtmlDOMNode subclass: #HtmlCommentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlCommentNode methodsFor: 'as yet unclassified' stamp: 'tb 12/2/2005 09:12'!
isComment

	^true! !

!HtmlCommentNode methodsFor: 'as yet unclassified' stamp: 'tb 1/14/2006 13:57'!
parseContents: aStream

	| c s allowBrackets |

	allowBrackets := false.
	aStream upTo: $!!.
	s := aStream position.
	[aStream atEnd] whileFalse:
	[
		((c := aStream next) = $- and: [aStream peek = $-]) ifTrue:
		[
			aStream next.
			allowBrackets := allowBrackets not.			
		]
		ifFalse:
		[
			(c = $> and: [allowBrackets not]) ifTrue:
			[
				self end: aStream position.
				self addChild: (HtmlCDATANode start: s end: aStream position -1).
				^self
			]
			ifFalse:
			[
				(c = $- and: [aStream peek = $>]) ifTrue:
				[
					self addChild: (HtmlCDATANode start: s end: aStream position).
					aStream next.
					self end: aStream position.
					self endTagMissing: allowBrackets.
					^self
				]	
			]
		]
	].
	self endTagMissing: true.
	self end: aStream position.! !

!HtmlCommentNode methodsFor: 'as yet unclassified' stamp: 'tb 11/29/2005 14:55'!
tag

	^'comment'! !

HtmlCommentNode subclass: #HtmlXMLCDataNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlXMLCDataNode methodsFor: 'as yet unclassified' stamp: 'tb 3/12/2006 15:08'!
parseContents: aStream

	| cdStart out |

	out := WriteStream on: String new.
	aStream skipSeparators.
	('<!![CDATA[' size) timesRepeat: [out nextPut: aStream next].

	(out contents beginsWith: '<!![CDATA[') 
		ifTrue: [cdStart := aStream position]
		ifFalse: [self halt]. "I musta messed up something here"

	[(out contents endsWith: ']]>') or: [aStream atEnd]] whileFalse: [out nextPut: aStream next].

	(out contents endsWith: ']]>') ifFalse: 
	[
		aStream position: cdStart.
		aStream upTo: $>.
		self addChild: (HtmlCDATANode start: cdStart end: aStream position -1).
		self endTagMissing: true.
	]
	ifTrue:
	[
		self end: aStream position.
		self addChild: (HtmlCDATANode start: cdStart end: aStream position - ( ']]>' size)).		
		self endTagMissing: false.
	]
! !

HtmlDOMNode subclass: #HtmlDDNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlDDNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'dd'! !

HtmlDOMNode subclass: #HtmlDELNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlDELNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'del'! !

HtmlDOMNode subclass: #HtmlDFNNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlDFNNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'dfn'! !

HtmlDOMNode subclass: #HtmlDIRNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlDIRNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'dir'! !

HtmlDOMNode subclass: #HtmlDIVNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlDIVNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'div'! !

HtmlDOMNode subclass: #HtmlDLNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlDLNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'dl'! !

!HtmlDOMNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.sastre 9/5/2010 14:25'!
fromStream: aStream

	| s doctype html |

	doctype := nil.
	aStream skipSeparators.
	s := aStream upTo: $<.
	s := aStream upTo: $>.
	s size = 0 ifTrue: [aStream reset. ^nil].
	(s asUppercase beginsWith: '!!DOCTYPE') ifTrue:
	[
		doctype := s.		
		s := aStream upTo: $<.
		s := aStream upTo: $>.
	].
	
	html := (self tagContents: s) start: (aStream position - s size - 2); parseContents: aStream.			
	^html docType: doctype.! !

!HtmlDOMNode class methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:40'!
newForTag: aTag 

	| node className cls tag |

	tag := aTag trimBoth.
	node := nil.

	className := ('Html',tag asUppercase,'Node') asSymbol.

	cls := Smalltalk at: className ifAbsent: [HtmlDOMNode].

	node := cls new tag: tag;
			hasTrailingSlash: false; 
			attributes: Dictionary new.

	tag asLowercase = tag ifFalse: 
	[
		node addError: (HtmlTagNotLowerCaseError new tag: tag).
	].

	^node.	
! !

!HtmlDOMNode class methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:41'!
tagContents: aTag 

	| node className cls tag in out trimmedTag endsWithSlash |

	trimmedTag := aTag trimBoth.
	node := nil.
	in := ReadStream on: aTag.
	out := WriteStream on: (String new:20).

	in skipSeparators.
	[in atEnd not and: [in peek isAlphaNumeric]] whileTrue: [out nextPut: in next].

	tag := out contents.

	className := ('Html',tag asUppercase,'Node') asSymbol.

	cls := Smalltalk at: className ifAbsent: [HtmlDOMNode].

	endsWithSlash := (trimmedTag last = $/) ifTrue:
	[
		(trimmedTag detect:[:ea | ea isSeparator] ifNone: [nil]) isNil or:
			[(trimmedTag at: ((trimmedTag size -1))) isSeparator]
	]
	ifFalse: [false ].

	node := cls new tag: tag;
			hasTrailingSlash: endsWithSlash; 
			parseAttributes: (trimmedTag last: (trimmedTag size - tag size)).

	tag asLowercase = tag ifFalse: 
	[
		node addError: (HtmlTagNotLowerCaseError new tag: tag).
	].

	^node.	
! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'j.c 6/14/2007 12:24'!
addStyle: aStyleRule
	self styles: (self styles copyWith: aStyleRule)! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'gk 11/19/2007 11:52'!
anchors
	"Find children tags of given class."

	^self tagsOfClass: HtmlANode! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 11/30/2005 12:26'!
attributes
	"Answer the value of attributes"

	^ attributes ifNil: [attributes:=Dictionary new]! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 7/12/2007 11:04'!
attributes: anObject
	"Set the value of attributes"

	| cstr |

	attributes := anObject.
	id := (attributes at: 'id' ifAbsent: [nil]).
	cstr := attributes at: 'class' ifAbsent: [nil].
	classes := cstr isNil ifTrue: [#()] ifFalse: [cstr findTokens: ' '].! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/1/2005 09:11'!
childDTDTags

	^((self children collect: [:ea | ea dtdTag]) reject:[:ea | ea = 'COMMENT']) asArray! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/1/2005 09:12'!
childTags

	^((self children collect: [:ea | ea tag]) reject:[:ea | ea = 'comment']) asArray! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 1/4/2006 13:52'!
classes
	
	^classes isNil ifTrue: [#()] ifFalse: [classes]! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'tb 12/2/2005 09:30'!
closeTagIsOptional

	^self dtd tagCloseIsOptional: self dtdTag! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/3/2005 16:14'!
closeTagMissing
	

	^self endTagMissing! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/20/2005 10:21'!
content

	^self parent content! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'tb 11/30/2005 12:39'!
createImpliedNodes

	self children do:[:ea | ea createImpliedNodes]! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/2/2005 09:43'!
dtd

	dtd isNil ifTrue: [self parent notNil ifTrue: [dtd := self parent dtd]].
	dtd isNil ifTrue: [self halt].
	^dtd! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/1/2005 10:39'!
dtd: aDTD

	dtd := aDTD! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/5/2005 12:07'!
dtdTag

	^self dtd isXML ifFalse: [self tag asUppercase] ifTrue: [self tag]! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/5/2005 12:02'!
endTagMissing
	"Answer the value of endTagMissing"

	^self hasTrailingSlash 
		ifTrue:[false] 
		ifFalse:
		[
			endTagMissing isNil ifTrue: [endTagMissing := false].
			endTagMissing
		]! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:53'!
endTagMissing: anObject
	"Set the value of endTagMissing"

	endTagMissing := anObject! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 17:29'!
hasTrailingSlash

	^hasTrailingSlash isNil ifTrue: [false] ifFalse: [hasTrailingSlash] ! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:53'!
hasTrailingSlash: anObject
	"Set the value of hasTrailingSlash"

	hasTrailingSlash := anObject! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 7/12/2007 11:07'!
id

	^id! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'tb 12/2/2005 09:13'!
isCDATA

	^false! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'tb 12/19/2005 23:03'!
isCSS

	^false! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'tb 12/2/2005 09:12'!
isComment

	^false! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'gk 11/12/2007 12:35'!
isDOMNode

	^true! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'tb 12/2/2005 12:26'!
isDocument

	^false! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 11/30/2005 12:21'!
isImplied
	
	^isImplied isNil ifTrue: [^false] ifFalse: [isImplied]! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 11/30/2005 12:21'!
isImplied: trueOrFalse
	
	isImplied := trueOrFalse! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/2/2005 09:34'!
isSelfContained

	^self hasTrailingSlash or: [self dtd tagIsEmpty: self dtdTag]! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'tb 12/17/2005 22:26'!
isStyleSheet

	^false! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 1/8/2006 10:03'!
loader

	^self document loader! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'tb 12/5/2005 22:08'!
mayContainTag: aTag

	^self isComment 
		ifTrue:[false] 
		ifFalse:[self dtd tag: self dtdTag canContainTag: aTag]! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'gk 11/19/2007 23:24'!
name
	^self attributes at: 'name' ifAbsent: ['']! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:40'!
parseAttributes: attrString

	| attrs in s |
	attrs := Dictionary new. 

	s := attrString trimBoth.
	(s endsWith: '/') ifTrue: [ s:= s first: (s size-1) ].

	in := ReadStream on: s trimBoth.

	[in atEnd] whileFalse:
	[
		| k v pos |
		in skipSeparators.
		pos := in position.
		v := nil.
		k := in upTo: $=.
		k := k trimBoth.
		(k includes: $ ) ifTrue: "Looks like there is no value. "
		[			
			in position: pos. 
			k:= in upTo: $ . 
		]
		ifFalse:
		[
			in skipSeparators.
			in atEnd ifFalse:
			[
				(in next = $") ifTrue: [v := in upTo: $"]
				ifFalse:
				[
					in back.
					(in next = $') ifTrue: [v := in upTo: $']
					ifFalse:
					[
						in back.
						v := in upTo: $ .
						self addError: (HtmlAttributeValueNotQuotedError new attribute: k).
					]
				]		 
			]
		].

		attrs at: k ifPresent:
		[:val | 
			self addError: (HtmlAttributeMultiplySpecifiedError new 
				attribute: k; value: v value: val).
		].
		attrs at: k put: v.
	].
	self attributes: attrs.! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'SebastianSastre 1/15/2012 16:40'!
parseContents: aStream

	"tagParent: parent contents: aString stream: aStream"

	| s |

	self isSelfContained ifTrue: [^self end: aStream position; endTagMissing: true].

	[self end isNil and:[aStream atEnd not]] whileTrue:
	[
		aStream skipSeparators.

		s := aStream upTo: $<.
		s size > 0 ifTrue: 
		[
			self addChild: (HtmlCDATANode start: self startForNextElement 
								end: (aStream atEnd ifFalse:[aStream position-1] ifTrue: [aStream position]))

		].

		s := aStream upTo: $>.	

		(s size > 0 and:[s first = $!! or: [(s first = $?) & (s last = $?)]]) ifTrue: 
		[
			s first = $? ifTrue:
			[
				"blow off the processing directive"
				"aStream skip: (s size+2)negated. 
				self addChild: (HtmlDOMNode parseProcessingDirective: aStream)."
			]
			ifFalse:
			[
				| child |
				aStream skip: (s size+2)negated. 
				(self dtd isXML and: [s beginsWith: '<!![CDATA[']) ifFalse:
				[
					child := (HtmlCommentNode new) start: aStream position.
				]
				ifTrue:
				[
					child := (HtmlXMLCDataNode new) start: aStream position.
				].
				self addChild: child.
				child parseContents: aStream.
			]
		]
		ifFalse: "It is a tag"
		[
			(s includes: $<) ifTrue: [s := self recoverFromLTIn: s stream: aStream]. 			
			(s trimBoth beginsWith: '/') ifTrue: 
			[
				| closeTag |
				closeTag := (s findTokens: ('/',Character separators)) first asLowercase.
				closeTag = self tag ifTrue: 
				[
					self end: aStream position; endTagMissing: false.
					^self
				]
				ifFalse:
				[
					(self hasAncestor: closeTag) ifTrue:
					[
						self addError: (HtmlTagMissingEndError new).
						aStream skip: (s size + 2) negated.
						^self end: (aStream position); endTagMissing: true.
					]
					ifFalse:
					[
						| child |
						child := (HtmlDOMNode newForTag: s) 
							start: (aStream position - (s size) - 2); end: (aStream position).
							self addChild: child.
							child addError: (HtmlTagMissingStartError new 
								position: (aStream position - (s size) - 1); 
								tag: s).
					]
				]
			]
			ifFalse: "Nested Tag Found"
			[
				"Does the new tag imply termination?"
				| short |
				short := (s findTokens: ('/',Character separators)).
				short := short size > 0 ifTrue: [short first] ifFalse: [short].
				"The above hack and aStream atEnd guards against input underflow"
				(aStream atEnd or:[((self mayContainTag: short) not 
					and: [self closeTagIsOptional])
					and:
					[
						| likelyParent |
						likelyParent := self detectAncestor:[:p | p mayContainTag: short]. 
						(likelyParent level > 0 and: [(self level - likelyParent level) < 3])
							or: [short = self tag] "siblings"
					]
				])
				ifTrue:
				"Fake a termination"
				[
					self end: (aStream atEnd ifFalse: [aStream position - s size - 2] ifTrue: [aStream position]); 
						endTagMissing: true.
					aStream atEnd ifFalse: [aStream skip: (s size + 2) negated].
					^self
				]
				ifFalse:
				[
					(short size > 0 and: [short first isLetter]) ifTrue:
					[
						| child |
						child := (HtmlDOMNode tagContents: s) start: (aStream position - s size - 2).
						self addChild: child.
						child parseContents: aStream.
					]
					ifFalse:
					[
						self addChild: (HtmlCDATANode start: self startForNextElement 
								end: aStream position)
					]
				]
			]
		]
	].
	(aStream atEnd and:[end isNil]) ifTrue: 
	[
		self end: aStream position.
		self endTagMissing: true.
	].
! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/2/2005 20:33'!
rawTag

	^tag! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'tb 12/10/2005 21:41'!
recoverFromLTIn: aString stream: in

	| s  |

	in skip: (aString size - (aString lastIndexOf: $<)) negated-1.

	((self children isEmpty not) and: [self children last isCDATA]) ifTrue:
	[
		self children last end: in position -1.
	]
	ifFalse: 
	[
		self addChild:
				(HtmlCDATANode start: self startForNextElement
								end: in position-1)		
	].
	s := in upTo: $>.
	^s! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/30/2005 20:08'!
styles

	^styles isNil ifTrue: [#()] ifFalse: [styles]! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/30/2005 20:08'!
styles: anArray

	styles := anArray! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/2/2005 10:47'!
tag
	"Answer the value of tag"

	^ tag isNil ifFalse: [tag asLowercase] ifTrue: [tag]! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/2/2005 20:31'!
tag: anObject
	"Set the value of tag"

	tag := anObject.! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'gk 11/19/2007 12:44'!
tagOfClass: aClass
	"Find children tags of given class."

	self nodesDo: [:ea | ea class = aClass ifTrue: [^ea]].
	^nil! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'gk 11/19/2007 12:03'!
tagWithClass: aClass
	"Find children tags of given class."

	self nodesDo: [:ea | (ea isDOMNode and: [ea classes includes: aClass]) ifTrue: [^ea]].
	^nil! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'gk 11/12/2007 23:35'!
tagWithId: anId
	"Find the first tag with given id."

	self nodesDo: [:ea | (ea isDOMNode and: [ea id = anId]) ifTrue: [^ea]].
	^nil! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'gk 11/12/2007 23:35'!
tagWithId: anId class: aClass
	"Find the first tag with given id and class."

	self nodesDo: [:ea |
		(ea class = aClass and: [ea isDOMNode and: [ea id = anId]]) ifTrue: [^ea]].
	^nil! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'gk 11/19/2007 21:54'!
tagWithName: aName
	"Find the first tag with given name."

	self nodesDo: [:ea | (ea isDOMNode and: [ea name = aName]) ifTrue: [^ea]].
	^nil! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/4/2015 00:30'!
tagsNamed: aName
	"Find all children tags with given name."

	^ self nodesCollect: [ :ea | ea isDOMNode and: [ ea name = aName ] ]! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'gk 11/19/2007 11:51'!
tagsOfClass: aClass
	"Find children tags of given class."

	^self nodesCollect: [:ea | ea class = aClass]! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'gk 11/19/2007 12:03'!
tagsWithClass: aClass
	"Find children tags of given class."

	^self nodesCollect: [:ea | ea isDOMNode and: [ea classes includes: aClass]]! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'gk 11/12/2007 12:39'!
tagsWithId: anId
	"Find all children tags with given id."

	^self nodesCollect:[:ea | ea isDOMNode and: [ea id = anId]]! !

!HtmlDOMNode methodsFor: 'as yet unclassified' stamp: 'gk 7/3/2009 22:39'!
tagsWithIdBegins: aString
	"Find all children tags with given id prefix."

	^self nodesCollect:[:ea | ea isDOMNode and: [ea id notNil and: [ea id beginsWith: aString]]]! !

!HtmlDOMNode methodsFor: 'accessing' stamp: 'tb 12/3/2005 13:52'!
uniqueId

	^(self parent uniqueId, '.', ((self parent children indexOf: self) asString))! !

HtmlDOMNode subclass: #HtmlDTNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlDTNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'dt'! !

HtmlDOMNode subclass: #HtmlDocument
	instanceVariableNames: 'docType content requestUrl responseUrl dtdIsImplied loader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlDocument methodsFor: 'parsing' stamp: 'tb 12/30/2005 20:49'!
allStyles

	| rules |

	rules := OrderedCollection new.
	self stylesheets do: [:sheet | rules addAll: (sheet children select:[:ea | ea isStyleRule])].
	^rules asArray! !

!HtmlDocument methodsFor: 'parsing' stamp: 'tb 7/12/2007 12:55'!
applyStyles

	"TODO: Optimize this based on information described at " 	"http://weblogs.mozillazine.org/hyatt/archives/2005_05.html#007507"

	| rules set |

	rules := self allStyles.
	rules do:[:ea | ea matchCount: 0].
	rules := rules reject:[:ea | ea selector isValid not].
	set := CSSRuleSet new.
	rules do: [:ea | ea addToRuleSet: set].

	self nodesDo:
	[:ea | 
		ea isCSS 
			ifFalse: 
			[
				(set candidateRulesForNode: ea) do: 
				[:rule | 
					(rule selector matches: ea) 
						ifTrue: [ea addStyle: rule. rule matchCount: rule matchCount + 1]
				].
				(ea attributes includesKey: 'style') ifTrue: 
				[
					|  styleRule style |
					style := (ea attributes at: 'style').
					styleRule := (CSSNodeAttributeStyleRule new content: style).
					ea addStyle: styleRule.
				].
			]
	]. ! !

!HtmlDocument methodsFor: 'accessing' stamp: 'tb 12/2/2005 20:38'!
content
	"Answer the value of content"

	^ content! !

!HtmlDocument methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:31'!
content: anObject
	"Set the value of content"

	content := anObject! !

!HtmlDocument methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 00:24'!
createImpliedNodes

	(self children detect: [:ea | ea tag = 'html'] ifNone:[nil]) ifNil: 
	[self children: 
		(Array with: 
			(HtmlHTMLNode new children: self children; 
				start: self start; 
				end: self end; 
				isImplied: true))
	].
	super createImpliedNodes.! !

!HtmlDocument methodsFor: 'accessing' stamp: 'tb 12/1/2005 10:45'!
docType
	"Answer the value of docType"

	docType isNil ifTrue: [docType := Html401Strict docType].
	^docType! !

!HtmlDocument methodsFor: 'accessing' stamp: 'tb 12/3/2005 14:11'!
docType: anObject
	"Set the value of docType"

	docType := anObject.
	self dtd: (HtmlDTD forDocType: anObject).! !

!HtmlDocument methodsFor: 'accessing' stamp: 'tb 12/2/2005 20:35'!
document

	^self! !

!HtmlDocument methodsFor: 'as yet unclassified' stamp: 'tb 12/2/2005 09:39'!
dtd

	^dtd isNil 
		ifTrue: [dtd:=HtmlDTD forDocType: self docType] 
		ifFalse: [dtd]! !

!HtmlDocument methodsFor: 'accessing' stamp: 'tb 1/4/2006 10:47'!
dtdIsImplied
	"Answer the value of dtdIsImplied"

	^ dtdIsImplied! !

!HtmlDocument methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:53'!
dtdIsImplied: anObject
	"Set the value of dtdIsImplied"

	dtdIsImplied := anObject! !

!HtmlDocument methodsFor: 'as yet unclassified' stamp: 'tb 12/2/2005 12:27'!
isDocument

	^true! !

!HtmlDocument methodsFor: 'accessing' stamp: 'tb 1/10/2006 08:50'!
loader
	"Answer the value of loader"

	^ loader isNil ifTrue: [loader := HtmlCache new] ifFalse: [loader]! !

!HtmlDocument methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:51'!
loader: anObject
	"Set the value of loader"

	loader := anObject! !

!HtmlDocument methodsFor: 'as yet unclassified' stamp: 'tb 12/2/2005 11:02'!
mayContainTag: aTag

	^true! !

!HtmlDocument methodsFor: 'parsing' stamp: 'SebastianSastre 1/15/2012 16:35'!
parseContents: aStream

	"tagParent: parent contents: aString stream: aStream"

	| s docTypeFound hasXMLDirective |

	docTypeFound := false.
	hasXMLDirective := false.

	self start: aStream position.

	content := aStream contents.

	[aStream atEnd not] whileTrue:
	[
		| p |
		p := aStream position.
		
		"If we skip separatos, we will be neglecting spaces WTF?!!
		aStream skipSeparators."
		
		s := aStream upTo: $<.
		s size > 0 ifTrue: 
		[
			| pos |
			pos := aStream atEnd ifTrue: [aStream position] ifFalse: [aStream position-1].
			self addChild: 
				(HtmlCDATANode start: p 
								end: (pos max: p))
		].
		s := aStream upTo: $>.	

		(s size > 0 and:[s first = $!! or: [(s first = $?) & (s last = $?)]]) ifTrue: 
		[
			s first = $? ifTrue:
			[
				hasXMLDirective := true.
				self parseProcessingDirective: s
			]
			ifFalse:
			[
				(s asUppercase beginsWith: '!!DOCTYPE') ifTrue:
				[
					self docType: s.
					docTypeFound := true.
				]
				ifFalse:
				[
					| child |
					aStream skip: (s size+2)negated. 
					child := (HtmlCommentNode new) start: aStream position.
					self addChild: child.
					child parseContents: aStream.
				]
			]
		]
		ifFalse: "It is a tag"
		[
			(docType isNil and: [hasXMLDirective]) ifTrue:
			[
				self docType: XHtml1Transitional docType.
			]
			ifFalse:
			[
				docType isNil ifTrue: [self docType: Html401Strict docType].
			].
			s := s trimBoth.
			(s size > 0) ifTrue:
			[
				(s first = $/) ifTrue: "stray close tag I think"
				[
					| child |
					child := (HtmlDOMNode newForTag: s) 
							start: (aStream position - (s size) - 2); end: (aStream position).
					self addChild: child.
					child addError: (HtmlTagMissingStartError new 
							position: (aStream position - (s size) - 1); 
							tag: s).
				]
				ifFalse: "Nested Tag Found"
				[
					| child |
					child := (HtmlDOMNode tagContents: s) start: (aStream position - s size - 2).
					self addChild: child.
					child parseContents: aStream.
				]
			]
		]
	].
	self end: aStream position.
	"self createImpliedNodes."
	self dtdIsImplied: docTypeFound not.
	docTypeFound ifFalse: 
	[
		self dtdIsImplied: true.
		self addError: HtmlMissingDocTypeError new
	].
	
! !

!HtmlDocument methodsFor: 'parsing' stamp: 'tb 12/11/2005 21:10'!
parseProcessingDirective: aString

	| in |
	in := ReadStream on: aString.
	in upTo: $?.
	in skipSeparators.
	[Character separators includes: in peek] whileFalse: [in next].
	in skipSeparators.
	self parseAttributes: (in upTo: $?).	
! !

!HtmlDocument methodsFor: 'accessing' stamp: 'tb 12/17/2005 22:54'!
requestUrl
	"Answer the value of requestUrl"

	^ requestUrl! !

!HtmlDocument methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:51'!
requestUrl: anObject
	"Set the value of requestUrl"

	requestUrl := anObject! !

!HtmlDocument methodsFor: 'accessing' stamp: 'tb 12/17/2005 22:54'!
responseUrl
	"Answer the value of responseUrl"

	^ responseUrl! !

!HtmlDocument methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:52'!
responseUrl: anObject
	"Set the value of responseUrl"

	responseUrl := anObject! !

!HtmlDocument methodsFor: 'accessing' stamp: 'tb 12/30/2005 17:37'!
stylesheets

	| stylesheets |

	stylesheets := OrderedCollection new.

	self nodesDo:
	[:ea |
		((ea respondsTo: #stylesheet)and:[ea stylesheet notNil]) 
			ifTrue: [stylesheets add: ea stylesheet].
	].
	^stylesheets
	! !

!HtmlDocument methodsFor: 'accessing' stamp: 'tb 11/30/2005 11:52'!
tag

	^'document'! !

!HtmlDocument methodsFor: 'accessing' stamp: 'tb 12/3/2005 13:52'!
uniqueId

	^'D'! !

!HtmlDocument methodsFor: 'accessing' stamp: 'tb 1/4/2006 14:35'!
url

	^self responseUrl! !

HtmlDOMNode subclass: #HtmlEMNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlEMNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'em'! !

HtmlDOMNode subclass: #HtmlFIELDSETNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlFIELDSETNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'fieldset'! !

HtmlDOMNode subclass: #HtmlFONTNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlFONTNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'font'! !

HtmlDOMNode subclass: #HtmlFORMNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlFORMNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'form'! !

HtmlDOMNode subclass: #HtmlFRAMENode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlFRAMENode methodsFor: 'accessing' stamp: ''!
tag
	^ 'frame'! !

HtmlDOMNode subclass: #HtmlFRAMESETNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlFRAMESETNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'frameset'! !

HtmlDOMNode subclass: #HtmlH1Node
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlH1Node methodsFor: 'accessing' stamp: ''!
tag
	^ 'h1'! !

HtmlDOMNode subclass: #HtmlH2Node
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlH2Node methodsFor: 'accessing' stamp: ''!
tag
	^ 'h2'! !

HtmlDOMNode subclass: #HtmlH3Node
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlH3Node methodsFor: 'accessing' stamp: ''!
tag
	^ 'h3'! !

HtmlDOMNode subclass: #HtmlH4Node
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlH4Node methodsFor: 'accessing' stamp: ''!
tag
	^ 'h4'! !

HtmlDOMNode subclass: #HtmlH5Node
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlH5Node methodsFor: 'accessing' stamp: ''!
tag
	^ 'h5'! !

HtmlDOMNode subclass: #HtmlH6Node
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlH6Node methodsFor: 'accessing' stamp: ''!
tag
	^ 'h6'! !

HtmlDOMNode subclass: #HtmlHEADNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlHEADNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'head'! !

HtmlDOMNode subclass: #HtmlHRNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlHRNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'hr'! !

HtmlDOMNode subclass: #HtmlHTMLNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlHTMLNode methodsFor: 'as yet unclassified' stamp: 'tb 12/1/2005 09:12'!
createImpliedNodes

	| dtags |
	dtags := self childDTDTags.
	((dtags includes: 'HEAD') and: [dtags includes: 'BODY'])
	ifFalse: "one or both is missing"
	[
		(dtags includes: 'HEAD') ifTrue: "everything after head goes in body"
		[
			| head bodyParts |
			head := self children detect:[:ea | ea tag = 'head'].
			bodyParts := self children copyAfter: head.
			self children: (self children copyWithoutAll: bodyParts).
			self addChild: (HtmlBODYNode new children: bodyParts; 
				start: head end; 
				end: self end; 
				isImplied: true).
		]
		ifFalse: "No head - is there a body?"
		[
			(dtags includes: 'BODY') ifTrue:
			[
				| headParts body |
				body := self children detect:[:ea | ea tag = 'body'].
				headParts := self children copyUpTo: body.
				self children: (self children copyWithoutAll: headParts). 
				self children:
					(self children copyWithFirst:
						(HtmlHEADNode new children: headParts;
							start: self start;
							end: body start;
							isImplied: true)).
			]
			ifFalse: "Neither are found"
			[
				| kids |
				kids := self children.
				self children: #().
				self addChild: (HtmlHEADNode new 
							start: self start;
							end: self start;
							isImplied: true).
				self addChild: (HtmlBODYNode new children: kids; 
				start: self start; 
				end: self end; 
				isImplied: true).
			]
		]
	]! !

!HtmlHTMLNode methodsFor: 'accessing' stamp: 'tb 11/29/2005 09:19'!
tag

	^'html'! !

HtmlDOMNode subclass: #HtmlIFRAMENode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlIFRAMENode methodsFor: 'accessing' stamp: ''!
tag
	^ 'iframe'! !

HtmlDOMNode subclass: #HtmlIMGNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlIMGNode methodsFor: 'accessing' stamp: 'CAs 6/25/2012 10:16'!
src
	^self attributes at: 'src' ifAbsent: ''! !

!HtmlIMGNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'img'! !

HtmlDOMNode subclass: #HtmlINPUTNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlINPUTNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'input'! !

HtmlDOMNode subclass: #HtmlINSNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlINSNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'ins'! !

HtmlDOMNode subclass: #HtmlINode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlINode methodsFor: 'accessing' stamp: ''!
tag
	^ 'i'! !

HtmlDOMNode subclass: #HtmlISINDEXNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlISINDEXNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'isindex'! !

HtmlDOMNode subclass: #HtmlKBDNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlKBDNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'kbd'! !

HtmlDOMNode subclass: #HtmlLABELNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlLABELNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'label'! !

HtmlDOMNode subclass: #HtmlLEGENDNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlLEGENDNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'legend'! !

HtmlDOMNode subclass: #HtmlLINKNode
	instanceVariableNames: 'stylesheet href'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlLINKNode commentStamp: '<historical>' prior: 0!
<LINK rel="stylesheet" type="text/css" name="anyname" href="url">!

!HtmlLINKNode methodsFor: 'accessing' stamp: 'tb 1/10/2006 15:01'!
href
	"Answer the value of href"

	^ href! !

!HtmlLINKNode methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:32'!
href: anObject
	"Set the value of href"

	href := anObject! !

!HtmlLINKNode methodsFor: 'parsing' stamp: 'tb 1/10/2006 19:53'!
parseContents: aStream

	| rel |

	rel := self attributes keys detect: [:ea | ea asLowercase = 'rel'] ifNone: [nil].
	(rel notNil and: [((self attributes at: rel) asLowercase findTokens: ' ') includes: 'stylesheet']) 
	ifTrue: 
	[
		href := self attributes keys detect: [:ea | ea asLowercase = 'href'] ifNone: [nil].
		href isNil ifFalse: 
		[
			href := self attributes at: href.
			(href notNil and:[href size > 0]) ifTrue:
			[
				self loader queueUrl: href. "Start download in another thread"
			]
			ifFalse: [href := nil].
		]
	].
	super parseContents: aStream! !

!HtmlLINKNode methodsFor: 'accessing' stamp: 'tb 1/17/2008 15:01'!
stylesheet
	"Answer the value of stylesheet"

	| |

	(stylesheet isNil and: [href notNil])
	ifTrue:
	[
		| doc |
		doc := self loader documentForUrl: self href.
		stylesheet := CSSStyleSheet new parent: self; 
			start: 0; 
			content: doc content; 
			end: doc content size;
 			url: self href; 
			parseContents: (ReadStream on: doc content)
	].	
	^ stylesheet! !

!HtmlLINKNode methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:32'!
stylesheet: anObject
	"Set the value of stylesheet"

	stylesheet := anObject! !

!HtmlLINKNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'link'! !

HtmlDOMNode subclass: #HtmlLINode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlLINode methodsFor: 'accessing' stamp: ''!
tag
	^ 'li'! !

HtmlDOMNode subclass: #HtmlMAPNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlMAPNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'map'! !

HtmlDOMNode subclass: #HtmlMENUNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlMENUNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'menu'! !

HtmlDOMNode subclass: #HtmlMETANode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlMETANode methodsFor: 'accessing' stamp: ''!
tag
	^ 'meta'! !

HtmlDOMNode subclass: #HtmlNOBRNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlNOBRNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'nobr'! !

HtmlDOMNode subclass: #HtmlNOFRAMESNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlNOFRAMESNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'noframes'! !

HtmlDOMNode subclass: #HtmlNOSCRIPTNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlNOSCRIPTNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'noscript'! !

HtmlDOMNode subclass: #HtmlOBJECTNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlOBJECTNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'object'! !

HtmlDOMNode subclass: #HtmlOLNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlOLNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'ol'! !

HtmlDOMNode subclass: #HtmlOPTGROUPNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlOPTGROUPNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'optgroup'! !

HtmlDOMNode subclass: #HtmlOPTIONNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlOPTIONNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'option'! !

HtmlDOMNode subclass: #HtmlPARAMNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlPARAMNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'param'! !

HtmlDOMNode subclass: #HtmlPNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlPNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'p'! !

HtmlDOMNode subclass: #HtmlPRENode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlPRENode methodsFor: 'accessing' stamp: ''!
tag
	^ 'pre'! !

HtmlDOMNode subclass: #HtmlProcessingDirectiveNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

HtmlDOMNode subclass: #HtmlQNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlQNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'q'! !

HtmlDOMNode subclass: #HtmlSAMPNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlSAMPNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'samp'! !

HtmlDOMNode subclass: #HtmlSCRIPTNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlSCRIPTNode methodsFor: 'accessing' stamp: 'CAs 7/9/2012 02:20'!
parseContents: aStream

	| str spos script |

	self hasTrailingSlash ifTrue: [^self end: aStream position; endTagMissing: true].

	spos := aStream position.
	str := aStream upTo: $>.
	
	[(str asLowercase endsWith: ('</',self tag)) or: [aStream atEnd]] 
		whileFalse: [str := (str, '>', (aStream upTo: $>))].

	self end: aStream position.
	script := (str first: (str size - (self tag size + 2))) trimBoth.

	(script trimBoth size > 0) ifTrue:
	[ 
		((script beginsWith: '<!!--') and: [script endsWith: '-->']) ifFalse:
		[
			(self dtd isXML and: [(script beginsWith: '<!![CDATA[') and:[script endsWith:']]>']]) 
			ifTrue:
			[
				| child  |
				self addChild: (child:= HtmlXMLCDataNode new start: spos).
				aStream position: spos.
				child parseContents: aStream.
				aStream upTo: $>.
				self end: aStream position. 
			]
			ifFalse:
			[
				self addChild: (HtmlCDATANode  
					start: spos end: (aStream position - (self tag size + 3))).
				self addError:(HtmlUncommentedScriptError new).
			]
		]
		ifTrue:
		[
			| child in cend |
			cend := (aStream position - (self tag size + 3)).
			in := ReadStream on: (aStream contents first: cend).
			in position: spos.
			child := HtmlCommentNode new start: spos.
			self addChild: child.
			child parseContents: in. 
		]
	].
	self end: aStream position.
	self endTagMissing: (str asLowercase endsWith: ('</',self tag)) not.
	! !

!HtmlSCRIPTNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'script'! !

HtmlDOMNode subclass: #HtmlSELECTNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlSELECTNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'select'! !

HtmlDOMNode subclass: #HtmlSMALLNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlSMALLNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'small'! !

HtmlDOMNode subclass: #HtmlSNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlSNode methodsFor: 'accessing' stamp: ''!
tag
	^ 's'! !

HtmlDOMNode subclass: #HtmlSPANNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlSPANNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'span'! !

HtmlDOMNode subclass: #HtmlSTRIKENode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlSTRIKENode methodsFor: 'accessing' stamp: ''!
tag
	^ 'strike'! !

HtmlDOMNode subclass: #HtmlSTRONGNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlSTRONGNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'strong'! !

HtmlDOMNode subclass: #HtmlSTYLENode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlSTYLENode methodsFor: 'accessing' stamp: 'tb 12/20/2005 13:45'!
isCSS

	^true! !

!HtmlSTYLENode methodsFor: 'accessing' stamp: 'tb 1/3/2006 17:10'!
parseContents: aStream

	| str  child |

	str := aStream upTo: $>.
	
	[(str asLowercase endsWith: ('</',self tag)) or: [aStream atEnd]] 
		whileFalse: [str := (str, '>', (aStream upTo: $>))].

	self end: aStream position.
	self endTagMissing: (str asLowercase endsWith: ('</',self tag)) not.
	child := CSSStyleSheet start: self startForNextElement end: (aStream position - (self tag size + 3)).
	self addChild: child.
	aStream position: child start.
	child parseContents: aStream.
	aStream position: self end.
	
! !

!HtmlSTYLENode methodsFor: 'accessing' stamp: 'tb 12/30/2005 17:36'!
stylesheet

	^self children first! !

!HtmlSTYLENode methodsFor: 'accessing' stamp: ''!
tag
	^ 'style'! !

!HtmlSTYLENode methodsFor: 'accessing' stamp: 'tb 12/20/2005 13:51'!
validateAgainstDTD: aDTD! !

HtmlDOMNode subclass: #HtmlSUBNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlSUBNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'sub'! !

HtmlDOMNode subclass: #HtmlSUPNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlSUPNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'sup'! !

HtmlDOMNode subclass: #HtmlTABLENode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlTABLENode methodsFor: 'accessing' stamp: ''!
tag
	^ 'table'! !

HtmlDOMNode subclass: #HtmlTBODYNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlTBODYNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'tbody'! !

HtmlDOMNode subclass: #HtmlTDNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlTDNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'td'! !

HtmlDOMNode subclass: #HtmlTEXTAREANode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlTEXTAREANode methodsFor: 'accessing' stamp: ''!
tag
	^ 'textarea'! !

HtmlDOMNode subclass: #HtmlTFOOTNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlTFOOTNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'tfoot'! !

HtmlDOMNode subclass: #HtmlTHEADNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlTHEADNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'thead'! !

HtmlDOMNode subclass: #HtmlTHNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlTHNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'th'! !

HtmlDOMNode subclass: #HtmlTITLENode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlTITLENode methodsFor: 'accessing' stamp: ''!
tag
	^ 'title'! !

HtmlDOMNode subclass: #HtmlTRNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlTRNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'tr'! !

HtmlDOMNode subclass: #HtmlTTNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlTTNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'tt'! !

HtmlDOMNode subclass: #HtmlULNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlULNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'ul'! !

HtmlDOMNode subclass: #HtmlUNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlUNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'u'! !

HtmlDOMNode subclass: #HtmlVARNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-DOM'!

!HtmlVARNode methodsFor: 'accessing' stamp: ''!
tag
	^ 'var'! !

!HtmlParseNode class methodsFor: 'as yet unclassified' stamp: 'tb 1/3/2006 16:47'!
start: s end: e

	^self new start: s; end: e! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
addChild: aNode

	self children: (self children copyWith: aNode).
	aNode parent: self.! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
addError: anError

	anError parent: self.
	self errors: (self errors copyWith: anError)! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
allErrors

	| collection |

	self errors do:[:ea | ea position isNil ifTrue: [ea position: self start]].
	collection := OrderedCollection new.
	collection addAll: (self errors).
	self children do:[:ea | collection addAll: ea allErrors].
	^collection asArray! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/4/2006 10:46'!
allErrorsMatching: aBlock

	| errs |

	errs := OrderedCollection new.

	self nodesDo: [:ea | ea errors do:[:er | (aBlock value: er) ifTrue: [errs add: er]]].

	^errs asArray! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 17:36'!
asString

	| |

	^(self prefix, self innerContents, self suffix)
		! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
children
	"Answer the value of children"

	^ children isNil ifTrue: [#()] ifFalse: [children]! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:53'!
children: anObject
	"Set the value of children"

	children := anObject.
	children do:[:ea | ea parent: self]! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 7/12/2007 11:48'!
content

	^self parent ifNil: [''] ifNotNil: [self parent content]! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
detectAncestor: aBlock

	| p |

	p := self.
	[p notNil] whileTrue: [(aBlock value: p) ifTrue: [^p]. p := p parent].
	^p

	! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
document

	^self parent document! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
end
	"Answer the value of end"

	^ end! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:53'!
end: anObject
	"Set the value of end"

	end := anObject! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
errors
	"Answer the value of errors"

	^ errors isNil ifTrue: [#()] ifFalse: [errors]! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:53'!
errors: anObject
	"Set the value of errors"

	errors := anObject! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
firstAncestor: aString

	| p |

	p := self parent.
	[p notNil] whileTrue: [p tag = aString ifTrue: [^p]. p := p parent].
	^p

	! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
hasAncestor: aString

	^(self firstAncestor: aString) notNil! !

!HtmlParseNode methodsFor: 'testing' stamp: 'tb 1/3/2006 17:35'!
innerContents

	| in | 

	^self children isEmpty 
		ifTrue: ['']
		ifFalse: 
		[
			in := ReadStream on: self content.
			in position: self children first start.
			in next: (self children last end - self children first start).
		]! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 17:30'!
innerId

	^(self uniqueId, '-inner')! !

!HtmlParseNode methodsFor: 'testing' stamp: 'tb 1/3/2006 16:47'!
isCDATA

	^false! !

!HtmlParseNode methodsFor: 'testing' stamp: 'tb 1/3/2006 16:47'!
isCSS

	^false! !

!HtmlParseNode methodsFor: 'testing' stamp: 'tb 1/3/2006 16:47'!
isComment

	^false! !

!HtmlParseNode methodsFor: 'testing' stamp: 'gk 11/12/2007 12:35'!
isDOMNode

	^false! !

!HtmlParseNode methodsFor: 'testing' stamp: 'tb 1/3/2006 16:47'!
isDocument

	^false! !

!HtmlParseNode methodsFor: 'testing' stamp: 'tb 1/3/2006 17:01'!
isHTML

	^false! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:57'!
isImplied
	
	^false! !

!HtmlParseNode methodsFor: 'testing' stamp: 'tb 1/3/2006 16:47'!
isStyleSheet

	^false! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
level

	| level p |
	level := 0.
	p := self.
	[p notNil] whileTrue: [p := p parent. p notNil ifTrue:[level := level + 1]].
	^level! !

!HtmlParseNode methodsFor: 'iterating' stamp: 'tb 1/3/2006 16:47'!
nodesCollect: aBlock

	| col |

	col := OrderedCollection new.
	self nodesDo:[:ea | (aBlock value: ea) ifTrue: [col add: ea]].
	^col asArray! !

!HtmlParseNode methodsFor: 'iterating' stamp: 'tb 1/3/2006 16:47'!
nodesDo: aBlock

	aBlock value: self.
	self children do:[:ea | ea nodesDo: aBlock].! !

!HtmlParseNode methodsFor: 'iterating' stamp: 'spd 12/7/2010 21:53'!
nodesSelect: aBlock

	| col |

	col := OrderedCollection new.
	self nodesDo:[:ea | (aBlock value: ea) ifTrue: [col add: ea]].
	^col asArray! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
parent
	"Answer the value of parent"

	^ parent isNil ifTrue: [nil] ifFalse: [parent first]! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:53'!
parent: anObject
	"Set the value of parent"

	parent := WeakArray with: anObject! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'gk 11/13/2007 14:45'!
parentWithClass: aClass
	"Find parent tag of given class."

	self parent ifNil: [^self].
	^self parent class = aClass
		ifTrue: [self parent]
		ifFalse: [self parent parentWithClass: aClass]
	! !

!HtmlParseNode methodsFor: 'parsing' stamp: 'tb 1/3/2006 17:15'!
parseContents: aStream

	self subclassResponsibility! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
prefix

	| in theEnd |

	in := ReadStream on: self content.
	in position: self start.	
	theEnd := self children isEmpty ifTrue:[self end] ifFalse:[self children first start].

	^in next: (theEnd - self start)! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
prefixId

	^self uniqueId! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
rawContent

	| in |

	in := ReadStream on: self document content.
	in position: self start.	
	^in next: (self end - self start)! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
start
	"Answer the value of start"

	^ start! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:52'!
start: anObject
	"Set the value of start"

	start := anObject! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
startForNextElement

	^self children isEmpty ifTrue:
	[
		| in |
		in := ReadStream on: self document content.
		in position: start.
		in upTo: $>.
		in position
	]
	ifFalse:
	[
		self children last end
	]! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/4/2006 17:50'!
suffix

	| in theStart |

	in := ReadStream on: self content.

	theStart := self children isEmpty ifTrue:[self end] ifFalse:[self children last end].
	in position: theStart.	
	^in next: (0 max: (self end - theStart))! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
suffixId

	^(self uniqueId, '-end')! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
tag
	"Answer the value of tag"

	^ tag isNil ifFalse: [tag asLowercase] ifTrue: [tag]! !

!HtmlParseNode methodsFor: 'accessing' stamp: 'tb 1/3/2006 16:47'!
uniqueId

	^(self parent uniqueId, '.', ((self parent children indexOf: self) asString))! !

Object subclass: #HtmlValidator
	instanceVariableNames: 'url document errors dom content loader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Validator'!

!HtmlValidator commentStamp: 'tb 4/14/2006 21:59' prior: 0!
I validate html for correctness.  I am the usual entry point into this library.  Typical usage for simply obtaining a DOM of a webpage might be (HtmlValidator onUrl: 'http://www.amazon.com' asUrl) dom.  If you want the DOM decorated with errors, then call validate.  

Author: Todd Blanchard, 2006.  tblanchard@mac.com

Free for any use that does not involve providing QA software packages or services for websites on a commercial or non-commercial basis.!

!HtmlValidator class methodsFor: 'as yet unclassified' stamp: 'tb 11/28/2005 17:34'!
on: aString

	^self new content: aString! !

!HtmlValidator class methodsFor: 'as yet unclassified' stamp: 'tb 11/28/2005 10:35'!
onUrl: aStringOrUrl

	^self new url: aStringOrUrl asUrl ! !

!HtmlValidator methodsFor: 'actions' stamp: 'tb 12/4/2005 23:01'!
bruteForceAnalyze

	"Maybe add more as I think of things"


	^self checkHtmlHeadBody! !

!HtmlValidator methodsFor: 'actions' stamp: 'tb 1/15/2006 19:26'!
checkHtmlHeadBody

	| structure in tags pos tag patterns |

	structure := OrderedCollection new.
	patterns := #( "These are the only valid combinations"
				#( '<html' '<head' '</head' '<body' '</body' '</html')
				#( '<html' '<body' '</body' '</html')
				#( '<html' '<head' '</head' '</html')
				#( '<html' '</html')
				#( '<body' '</body')
				#( '<head' '</head' )
				#( )
			).
	tags := 	patterns first.

	in := ReadStream on: self content asLowercase.

	[in atEnd] whileFalse:
	[
		| min locs |
		pos := in position.

		locs := (tags collect: [:ea | in position: pos; upToAll: ea; position]). 	
		(locs reject:[:ea | locs first = ea])	isEmpty ifFalse:
		[
			min := locs min.
			tag := tags at: (locs indexOf: min).

			structure add: tag.
			in position: min.
			in atEnd ifFalse: [in skip: 1].
		]
		ifTrue: [in upToEnd].
	].
	structure := structure asArray.
	((patterns detect: [:ea | structure = ea] ifNone: [nil]) notNil) ifFalse:  
	[
		self dom addError: (HtmlHeadBodyNestingError new nesting: structure asArray). 
	]
	ifTrue:
	[
		(dom children size > 1 and: 
			[(dom children detect:[:ea | ea tag = 'html'] ifNone:[nil]) notNil]) ifTrue:
		[
			dom children do:
			[:ea | 
				(ea isComment or: [ea tag = 'html']) ifFalse: 
				[
					ea addError:(HtmlTagImproperlyNestedError new).
				]
			]
		]
	]
	! !

!HtmlValidator methodsFor: 'accessing' stamp: 'tb 11/28/2005 17:35'!
content
	"Answer the value of content"

	^ content isNil 
		ifFalse: [content]
		ifTrue: [content := self document content]
	! !

!HtmlValidator methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:51'!
content: anObject
	"Set the value of content"

	content := anObject! !

!HtmlValidator methodsFor: 'accessing' stamp: 'tb 1/13/2006 18:42'!
cssErrors

	| list |
	list := OrderedCollection new.
	self stylesheets do:
	[:ss |
		list addAll: (ss allErrorsMatching: [:ea | ea isCSSError])
	].
	^list asArray! !

!HtmlValidator methodsFor: 'accessing' stamp: 'sebastian.sastre 10/18/2010 11:56'!
document
	"Answer the value of document"

	document isNil ifTrue: 
	[
		url isNil 
			ifTrue: [nil]
			ifFalse: 
			[
				document := self loader documentForUrl: self url.
				loader url: document url.
			] 
	].
	^document ! !

!HtmlValidator methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:35'!
document: anObject
	"Set the value of document"

	document := anObject! !

!HtmlValidator methodsFor: 'accessing' stamp: 'tb 4/14/2006 21:55'!
dom
	"Answer the value of dom"

	dom isNil ifTrue: [self parse].
	^ dom! !

!HtmlValidator methodsFor: 'accessing' stamp: 'sebastian.sastre 9/20/2010 11:53'!
dom: anObject
	"Set the value of dom"

	dom := anObject! !

!HtmlValidator methodsFor: 'accessing' stamp: 'tb 11/28/2005 10:38'!
errors
	"Answer the value of errors"

	^ errors! !

!HtmlValidator methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:36'!
errors: anObject
	"Set the value of errors"

	errors := anObject! !

!HtmlValidator methodsFor: 'accessing' stamp: 'tb 1/4/2006 11:40'!
htmlErrors

	^self dom allErrorsMatching: [:ea | ea isCSSError not ].! !

!HtmlValidator methodsFor: 'initialize-release' stamp: 'tb 11/28/2005 10:37'!
initialize

	super initialize.
! !

!HtmlValidator methodsFor: 'accessing' stamp: 'tb 1/10/2006 19:34'!
loader
	"Answer the value of loader"

	^ loader isNil ifTrue: [loader := HtmlCache new url: self url] ifFalse: [loader]! !

!HtmlValidator methodsFor: 'accessing' stamp: 'PK 10/18/2010 22:36'!
loader: anObject
	"Set the value of loader"

	loader := anObject! !

!HtmlValidator methodsFor: 'actions' stamp: 'tb 1/10/2006 19:48'!
parse

	| in |
	
	in := ReadStream on: self content.
	self dom: (HtmlDocument new loader: self loader;
			requestUrl: self url; 
			responseUrl: (self document isNil ifTrue: [nil] ifFalse: [self document url]); 
			parseContents: in)
! !

!HtmlValidator methodsFor: 'actions' stamp: 'tb 1/10/2006 19:50'!
parseStylesheets

	self dom stylesheets
! !

!HtmlValidator methodsFor: 'accessing' stamp: 'tb 12/30/2005 18:52'!
stylesheets

	^self dom stylesheets! !

!HtmlValidator methodsFor: 'accessing' stamp: 'tb 11/28/2005 10:37'!
url
	"Answer the value of url"

	^ url! !

!HtmlValidator methodsFor: 'accessing' stamp: 'tb 1/10/2006 15:07'!
url: anObject
	"Set the value of url"

	url := anObject asUrl.
! !

!HtmlValidator methodsFor: 'actions' stamp: 'tb 1/10/2006 19:47'!
validate

	| dtd |
	
	self parse.
	self checkHtmlHeadBody.
	dtd := HtmlDTD forDocType: self dom docType.
	self dom applyStyles.
	self validateAgainstDTD: dtd.
	self validateCSSImports.
	self validateCSSAgainstDTD: dtd! !

!HtmlValidator methodsFor: 'actions' stamp: 'tb 1/14/2006 14:04'!
validateAgainstDTD: dtd

	self dom nodesDo:
	[:ea |
		(ea isComment or: [ea isCDATA or: [ea isDocument or: [ea isCSS]]]) ifFalse:
		[
			(dtd tagIsReal: ea dtdTag) 
			ifFalse: [ea addError: (HtmlTagUnknownError new)]	
			ifTrue:
			[
				dtd validateChildrenOfNode: ea.
			 	dtd validateAttributesOfNode: ea.
			]
		]
		ifTrue:
		[
			(ea isCDATA) ifTrue: [ea checkForUnescapedCharacters]
			ifFalse: 
			[
				(ea isComment) ifTrue: 
				[
					ea endTagMissing ifTrue: 
					[
						ea addError: HtmlUnclosedCommentError new
					]
				]
			]
		]
	]! !

!HtmlValidator methodsFor: 'actions' stamp: 'tb 1/14/2006 21:39'!
validateCSSAgainstDTD: dtd

	| rules  color backgroundColor |

	rules := dom allStyles.
	rules do:
	[:ea |
		ea selector isValid ifFalse: [ea addError: CSSSelectorNotValidError new]
		ifTrue:
		[
			ea selector isCSS3 ifTrue: [ea addError: CSSVersion3ConstructFoundError new].
			ea selector typeSelectors do:
			[:sel |
				sel element = sel element asLowercase ifFalse:
				[
					ea addError: (CSSSelectorElementNotLowercaseError new element: sel element).
				].
				(dtd tagIsReal: (dtd isXML 
					ifTrue: [sel element asLowercase] 
					ifFalse:[sel element asUppercase])) 
				ifFalse:
				[
					ea addError: (CSSSelectorElementNotValidError new element: sel element)
				]
			].
			(ea matchCount = 0 and: [ea selector isValid]) ifTrue:
			[
				ea addError: CSSUnmatchedRuleError new.		
			].
			ea properties do:
			[:prop |
				| lcname |
				lcname := prop propertyName asLowercase.
				prop propertyName = lcname ifFalse: 
				[
					ea addError:
					(CSSPropertyNameNotLowercaseError new propertyName: prop propertyName).
					prop propertyName: lcname.
				].
 
				prop definition isNil ifTrue:
				[
					ea addError: 
					(CSSPropertyUnknownError new propertyName: prop propertyName)
				]
				ifFalse:
				[
					prop valueIsValid ifFalse:
					[
						ea addError: 
						(CSSPropertyValueNotValidError new propertyName: prop propertyName)					
					]
				]
			].

			color := backgroundColor := nil.

			ea properties do:
			[:prop |
				prop propertyName = 'color' ifTrue: [ color:= prop].
				prop propertyName = 'background-color' ifTrue: [backgroundColor := prop].

			].

			color = backgroundColor ifFalse:
			[
				color isNil ifTrue: 
				[
					ea addError: 
					(CSSColorAndBackgroundColorNotSet new propertyName: 'color')
				]
				ifFalse:
				[
					backgroundColor isNil ifTrue:
					[
						ea addError: 
					(CSSColorAndBackgroundColorNotSet new propertyName: 'background-color')
					]
				]
			]
		]
	]
	! !

!HtmlValidator methodsFor: 'actions' stamp: 'tb 1/6/2006 17:31'!
validateCSSImports

	| ss styleFound |
	ss := dom stylesheets.
	ss do:
	[:ea |
		styleFound := false.
		ea children do:
		[:rule |
			styleFound ifFalse:
			[
				rule isStyleRule ifTrue:[ styleFound := true]
			]
			ifTrue:
			[
				rule isAtImportRule ifTrue:
				[
					rule addError: (CSSImportAfterStyleRuleError new)
				]
			]
		]


	]
! !
CSSPropertyDefinition initialize!
HtmlUnescapedSpecialCharacterError initialize!
HtmlPListSerializer initialize!
